! gdi32.f90
! Public domain 2010-2011 James Van Buskirk
! Compiled with:
! gfortran -Wall -c gdi32.f90

module gdi32
   use ISO_C_BINDING
   use win32_types
   implicit none
   private

   public GetStockObject
   interface
      function GetStockObject(fnObject) &
         bind(C,name='GetStockObject')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetStockObject
         integer(HGDIOBJ) GetStockObject
         integer(C_INT),value :: fnObject
      end function GetStockObject
   end interface

   public MoveToEx
   interface
      function MoveToEx(hdc_,X,Y,lpPoint) bind(C,name='MoveToEx')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: MoveToEx
         integer(BOOL) MoveToEx
         integer(HDC),value :: hdc_
         integer(C_INT),value :: X
         integer(C_INT),value :: Y
         type(POINT_T) lpPoint
      end function MoveToEx
   end interface

   public LineTo
   interface
      function LineTo(hdc_,nXEnd,nYEnd) bind(C,name='LineTo')
         import
!GCC$ ATTRIBUTES STDCALL :: LineTo
         integer(BOOL) LineTo
         integer(HDC),value :: hdc_
         integer(C_INT),value :: nXEnd
         integer(C_INT),value :: nYEnd
      end function LineTo
   end interface

   public ChoosePixelFormat
   interface
      function ChoosePixelFormat(hdc_,ppfd) &
         bind(C,name='ChoosePixelFormat')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: ChoosePixelFormat
         integer(C_INT) ChoosePixelFormat
         integer(HDC),value :: hdc_
         type(PIXELFORMATDESCRIPTOR_T),intent(in) :: ppfd
      end function ChoosePixelFormat
   end interface

   public DescribePixelFormat
   interface
      function DescribePixelFormat(hdc_,iPixelFormat,nBytes,ppfd) &
         bind(C,name='DescribePixelFormat')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DescribePixelFormat
         integer(C_INT) DescribePixelFormat
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iPixelFormat
         integer(UINT),value :: nBytes
         type(PIXELFORMATDESCRIPTOR_T) ppfd
      end function DescribePixelFormat
   end interface

   public GetEnhMetaFilePixelFormat
   interface
      function GetEnhMetaFilePixelFormat(hemf,cbBuffer,ppfd) &
         bind(C,name='GetEnhMetaFilePixelFormat')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetEnhMetaFilePixelFormat
         integer(UINT) GetEnhMetaFilePixelFormat
         integer(HENHMETAFILE),value :: hemf
         integer(DWORD),value :: cbBuffer
         type(PIXELFORMATDESCRIPTOR_T),intent(in) :: ppfd
      end function GetEnhMetaFilePixelFormat
   end interface

   public GetPixelFormat
   interface
      function GetPixelFormat(hdc_) &
         bind(C,name='GetPixelFormat')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetPixelFormat
         integer(C_INT) GetPixelFormat
         integer(HDC),value :: hdc_
      end function GetPixelFormat
   end interface

   public SetPixelFormat
   interface
      function SetPixelFormat(hdc_,iPixelFormat,ppfd) &
         bind(C,name='SetPixelFormat')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetPixelFormat
         integer(BOOL) SetPixelFormat
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iPixelFormat
         type(PIXELFORMATDESCRIPTOR_T),intent(in) :: ppfd
      end function SetPixelFormat
   end interface

   public SwapBuffers
   interface
      function SwapBuffers(hdc_) &
         bind(C,name='SwapBuffers')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SwapBuffers
         integer(BOOL) SwapBuffers
         integer(HDC),value :: hdc_
      end function SwapBuffers
   end interface

   public CreateFont
   interface
      function CreateFont(nHeight,nWidth,nEscapement, &
         nOrientation,fnWeight,fdwItalic,fdwUnderline, &
         fdwStrikeOut,fdwCharSet,fdwOutputPrecision, &
         fdwClipPrecision,fdwQuality,fdwPitchAndFamily, &
         lpszFace) bind(C,name='CreateFontA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateFont
         integer(HFONT) CreateFont
         integer(C_INT),value :: nHeight
         integer(C_INT),value :: nWidth
         integer(C_INT),value :: nEscapement
         integer(C_INT),value :: nOrientation
         integer(C_INT),value :: fnWeight
         integer(DWORD),value :: fdwItalic
         integer(DWORD),value :: fdwUnderline
         integer(DWORD),value :: fdwStrikeOut
         integer(DWORD),value :: fdwCharSet
         integer(DWORD),value :: fdwOutputPrecision
         integer(DWORD),value :: fdwClipPrecision
         integer(DWORD),value :: fdwQuality
         integer(DWORD),value :: fdwPitchAndFamily
         character(kind=C_CHAR) lpszFace(*)
      end function CreateFont
   end interface

   public GetDeviceCaps
   interface
      function GetDeviceCaps(hdc_,nIndex) &
         bind(C,name='GetDeviceCaps')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetDeviceCaps
         integer(C_INT) GetDeviceCaps
         integer(HDC),value :: hdc_
         integer(C_INT),value :: nIndex
      end function GetDeviceCaps
   end interface

   public SelectObject
   interface
      function SelectObject(hdc_,hgdiobj_) &
         bind(C,name='SelectObject')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SelectObject
         integer(HGDIOBJ) SelectObject
         integer(HDC),value :: hdc_
         integer(HGDIOBJ),value :: hgdiobj_
      end function SelectObject
   end interface

   public DeleteObject
   interface
      function DeleteObject(hObject) &
         bind(C,name='DeleteObject')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DeleteObject
         integer(BOOL) DeleteObject
         integer(HGDIOBJ),value :: hObject
      end function DeleteObject
   end interface

   public RealizePalette
   interface
      function RealizePalette(hdc_) bind(C,name='RealizePalette')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: RealizePalette
         integer(UINT) RealizePalette
         integer(HDC),value :: hdc_
      end function RealizePalette
   end interface

   public UpdateColors
   interface
      function UpdateColors(hdc_) bind(C,name='UpdateColors')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: UpdateColors
         integer(BOOL) UpdateColors
         integer(HDC),value :: hdc_
      end function UpdateColors
   end interface

   public CreatePalette
   interface
      function CreatePalette(lplgpl) bind(C,name='CreatePalette')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreatePalette
         integer(HPALETTE) CreatePalette
         type(LOGPALETTE_T),intent(in) :: lplgpl
      end function CreatePalette
   end interface

   public SelectPalette
   interface
     function SelectPalette(hdc_,hpal,bForceBackground) &
        bind(C,name='SelectPalette')
        import
        implicit none
!GCC$ ATTRIBUTES STDCALL :: SelectPalette
        integer(HPALETTE) SelectPalette
        integer(HDC),value :: hdc_
        integer(HPALETTE),value :: hpal
        integer(BOOL),value :: bForceBackground
     end function SelectPalette
   end interface

   public CreateSolidBrush
   interface
      function CreateSolidBrush(crColor) &
         bind(C,name='CreateSolidBrush')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateSolidBrush
         integer(HBRUSH) CreateSolidBrush
         integer(COLORREF),value :: crColor
      end function CreateSolidBrush
   end interface

   public CreateDC
   interface
      function CreateDC(lpszDriver,lpszDevice,lpszOutput, &
         lpInitData) bind(C,name='CreateDCA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateDC
         integer(HDC) CreateDC
         character(kind=C_CHAR) lpszDriver(*)
         character(kind=C_CHAR) lpszDevice(*)
         character(kind=C_CHAR) lpszOutput(*)
         type(C_PTR),value :: lpInitData
      end function CreateDC
   end interface

   public Escape
   interface
      function Escape(hdc_,nEscape,cbInput,lpvInData, &
         lpvOutData) bind(C,name='Escape')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Escape
         integer(C_INT) Escape
         integer(HDC),value :: hdc_
         integer(C_INT),value :: nEscape
         integer(C_INT),value :: cbInput
         character(kind=C_CHAR) lpvInData(*)
         type(C_PTR),value :: lpvOutData
      end function Escape
   end interface

   public TextOut
   interface
      function TextOut(hdc_,nXStart,nYStart,lpString, &
         cchString) bind(C,name='TextOutA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: TextOut
         integer(BOOL) TextOut
         integer(HDC),value :: hdc_
         integer(C_INT),value :: nXStart
         integer(C_INT),value :: nYStart
         character(kind=C_CHAR) lpString(*)
         integer(C_INT),value :: cchString
      end function
   end interface

   public DeleteDC
   interface
      function DeleteDC(hdc_) bind(C,name='DeleteDC')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DeleteDC
         integer(BOOL) DeleteDC
         integer(HANDLE),value :: hdc_
      end function DeleteDC
   end interface

   public StartDoc
   interface
      function StartDoc(hdc_,lpdi) bind(C,name='StartDocA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: StartDoc
         integer(C_INT) StartDoc
         integer(HDC),value :: hdc_
         type(DOCINFO_T) lpdi
      end function StartDoc
   end interface

   public StartPage
   interface
      function StartPage(hdc_) bind(C,name='StartPage')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: StartPage
         integer(C_INT) StartPage
         integer(HDC),value :: hdc_
      end function StartPage
   end interface

   public EndPage
   interface
      function EndPage(hdc_) bind(C,name='EndPage')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EndPage
         integer(C_INT) EndPage
         integer(HDC),value :: hdc_
      end function EndPage
   end interface

   public EndDoc
   interface
      function EndDoc(hdc_) bind(C,name='EndDoc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EndDoc
         integer(C_INT) EndDoc
         integer(HDC),value :: hdc_
      end function EndDoc
   end interface

   public CreateEnhMetaFile
   interface
      function CreateEnhMetaFile(hdcRef,lpFilename,lpRect, &
         lpDescription) bind(C,name='CreateEnhMetaFileA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateEnhMetaFile
         integer(HDC) CreateEnhMetaFile
         integer(HDC),value :: hdcRef
         character(kind=C_CHAR) lpFilename(*)
         type(RECT_T) lpRect
         character(kind=C_CHAR) lpDescription(*)
      end function CreateEnhMetaFile
   end interface

   public CloseEnhMetaFile
   interface
      function CloseEnhMetaFile(hdc_) &
         bind(C,name='CloseEnhMetaFile')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CloseEnhMetaFile
         integer(HENHMETAFILE) CloseEnhMetaFile
         integer(HDC),value :: hdc_
      end function CloseEnhMetaFile
   end interface

   public PlayEnhMetaFile
   interface
      function PlayEnhMetaFile(hdc_,hemf,lpRect) &
         bind(C,name='PlayEnhMetaFile')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: PlayEnhMetaFile
         integer(BOOL) PlayEnhMetaFile
         integer(HDC),value :: hdc_
         integer(HENHMETAFILE),value :: hemf
         type(RECT_T) lpRect
      end function PlayEnhMetaFile
   end interface

   public DeleteEnhMetaFile
   interface
      function DeleteEnhMetaFile(hemf) &
         bind(C,name='DeleteEnhMetaFile')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DeleteEnhMetaFile
         integer(BOOL) DeleteEnhMetaFile
         integer(HENHMETAFILE),value :: hemf
      end function DeleteEnhMetaFile
   end interface

   public CreateCompatibleBitmap
   interface
      function CreateCompatibleBitmap(hdc_,nWidth,nHeight) &
         bind(C,name='CreateCompatibleBitmap')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateCompatibleBitmap
         integer(HBITMAP) CreateCompatibleBitmap
         integer(HDC),value :: hdc_
         integer(C_INT),value :: nWidth
         integer(C_INT),value :: nHeight
      end function CreateCompatibleBitmap
   end interface

   public CreateCompatibleDC
   interface
      function CreateCompatibleDC(hdc_) &
         bind(C,name='CreateCompatibleDC')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateCompatibleDC
         integer(HDC) CreateCompatibleDC
         integer(HDC),value :: hdc_
      end function CreateCompatibleDC
   end interface

   public BitBlt
   interface
      function BitBlt(hdcDest,nXDest,nYDest,nWidth,nHeight, &
         hdcSrc,nXSrc,nYSrc,dwRop) bind(C,name='BitBlt')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: BitBlt
         integer(BOOL) BitBlt
         integer(HDC),value :: hdcDest
         integer(C_INT),value :: nXDest
         integer(C_INT),value :: nyDest
         integer(C_INT),value :: nWidth
         integer(C_INT),value :: nHeight
         integer(HDC),value :: hdcSrc
         integer(C_INT),value :: nXSrc
         integer(C_INT),value :: nYSrc
         integer(C_INT),value :: dwRop
      end function BitBlt
   end interface

   public AngleArc
   interface
      function AngleArc(hdc_,X,Y,dwRadius,eStartAngle,eSweepAngle) &
         bind(C,name='AngleArc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: AngleArc
         integer(BOOL) AngleArc
         integer(HDC),value :: hdc_
         integer(C_INT),value :: X
         integer(C_INT),value :: Y
         integer(DWORD),value :: dwRadius
         real(C_FLOAT),value :: eStartAngle
         real(C_FLOAT),value :: eSweepAngle
      end function AngleArc
   end interface

   public CreateDIBSection
   interface
      function CreateDIBSection(hdc_,pbmi,iUsage,ppvBits, &
         hSection,dwOffset) bind(C,name='CreateDIBSection')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateDIBSection
         integer(HBITMAP) CreateDIBSection
         integer(HDC),value :: hdc_
         type(BITMAPINFO_T) pbmi
         integer(UINT),value :: iUsage
         type(C_PTR) ppvBits
         integer(HANDLE),value :: hSection
         integer(DWORD),value :: dwOffset
      end function CreateDIBSection
   end interface

   public GetBkMode
   interface
      function GetBkMode(hdc_) &
         bind(C,name='GetBkMode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetBkMode
         integer(C_INT) GetBkMode
         integer(HDC),value :: hdc_
      end function GetBkMode
   end interface

   public SetBkMode
   interface
      function SetBkMode(hdc_,iBkMode) &
         bind(C,name='SetBkMode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetBkMode
         integer(C_INT) SetBkMode
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iBkMode
      end function SetBkMode
   end interface

   public EnumFonts
   interface
      function EnumFonts(hdc_,lpFaceName,lpFontFunc,lParam_) &
         bind(C,name='EnumFontsA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EnumFonts
         integer(C_INT) EnumFonts
         integer(HDC),value :: hdc_
         character(kind=C_CHAR),intent(in) :: lpFaceName
         procedure(EnumFontsProc) lpFontFunc
         integer(LPARAM),value :: lParam_
      end function EnumFonts
   end interface

   public EnumFontFamilies
   interface
      function EnumFontFamilies(hdc_,lpszFamily,lpEnumFontFamProc, &
         lParam_) bind(C,name='EnumFontFamiliesA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EnumFontFamilies
         integer(C_INT) EnumFontFamilies
         integer(HDC),value :: hdc_
         character(kind=C_CHAR),intent(in) :: lpszFamily
         procedure(EnumFontFamProc) lpEnumFontFamProc
         integer(LPARAM),value :: lParam_
      end function EnumFontFamilies
   end interface

   public EnumFontFamiliesEx
   interface
      function EnumFontFamiliesEx(hdc_,lpLogFont, &
         lpEnumFontFamExProc,lParam_,dwFlags) &
         bind(C,name='EnumFontFamiliesExA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EnumFontFamiliesEx
         integer(C_INT) EnumFontFamiliesEx
         integer(HDC),value :: hdc_
         type(LOGFONT_T),intent(in) :: lpLogFont
         procedure(EnumFontFamExProc) lpEnumFontFamExProc
         integer(LPARAM),value :: lParam_
         integer(DWORD),value :: dwFlags
      end function EnumFontFamiliesEx
   end interface

   public SetGraphicsMode
   interface
      function SetGraphicsMode(hdc_,iMode) &
         bind(C,name='SetGraphicsMode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetGraphicsMode
         integer(C_INT) SetGraphicsMode
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iMode
      end function SetGraphicsMode
   end interface
end module gdi32
