! kernel32.f90
! Public domain 2010-2011 James Van Buskirk
! Compiled with:
! gfortran -Wall -c kernel32.f90

module kernel32
   use ISO_C_BINDING
   use win32_types
   implicit none
   private

   public GetModuleHandle
   interface
      function GetModuleHandle(lpModuleName) &
         bind(C,name='GetModuleHandleA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetModuleHandle
         integer(HMODULE) GetModuleHandle
         character(kind=C_CHAR),intent(in) :: lpModuleName(*)
      end function GetModuleHandle
   end interface

   public GetCommandLine
   interface
      function GetCommandLine() &
         bind(C,name='GetCommandLineA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetCommandLine
         type(C_PTR) GetCommandLine
      end function GetCommandLine
   end interface

   public ExitProcess
   interface
      subroutine ExitProcess(uExitCode) bind(C,name='ExitProcess')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: ExitProcess
         integer(UINT), value :: uExitCode
      end subroutine ExitProcess
   end interface

   public GetLastError
   interface
      function GetLastError() bind(C,name='GetLastError')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetLastError
         integer(DWORD) GetLastError
      end function GetLastError
   end interface

   public WinSleep
   interface
      subroutine WinSleep(dwMilliseconds) bind(C,name='Sleep')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WinSleep
         integer(DWORD),value :: dwMilliseconds
      end subroutine WinSleep
   end interface

   public AllocConsole
   interface
      function AllocConsole() bind(C,name='AllocConsole')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: AllocConsole
         integer(BOOL) AllocConsole
      end function AllocConsole
   end interface

   public CreateFile
   interface
      function CreateFile(lpFileName,dwDesiredAccess,dwSharedMode, &
         lpSecurityAttributes,dwCreationDisposition,dwFlagsAndAttributes, &
         hTemplateFile) bind(C,name='CreateFileA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateFile
         integer(HANDLE) CreateFile
         character(kind=C_CHAR) lpFileName(*)
         integer(DWORD),value :: dwDesiredAccess
         integer(DWORD),value :: dwSharedMode
         type(SECURITY_ATTRIBUTES_T) lpSecurityAttributes
         integer(DWORD),value :: dwCreationDisposition
         integer(DWORD),value :: dwFlagsAndAttributes
         integer(HANDLE),value :: hTemplateFile
      end function CreateFile
   end interface

   public SetStdHandle
   interface
      function SetStdHandle(nStdHandle,hHandle) bind(C,name='SetStdHandle')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetStdHandle
         integer(BOOL) SetStdHandle
         integer(DWORD),value :: nStdHandle
         integer(HANDLE),value :: hHandle
      end function SetStdHandle
   end interface

   public WriteConsole
   interface
      function WriteConsole(hConsoleOutput,lpBuffer, &
         nNumberOfCharsToWrite,nNumberOfCharsWritten, &
         lpReserved) bind(C,name='WriteConsoleA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteConsole
         integer(BOOL) WriteConsole
         integer(HANDLE),value :: hConsoleOutput
         character(kind=C_CHAR) lpBuffer(*)
         integer(DWORD),value :: nNumberOfCharsToWrite
         integer(DWORD) nNumberOfCharsWritten
         type(C_PTR),value :: lpReserved
      end function WriteConsole
   end interface

   public GetStdHandle
   interface
      function GetStdHandle(nStdHandle) bind(C,name='GetStdHandle')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetStdHandle
         integer(HANDLE) GetStdHandle
         integer(DWORD),value :: nStdHandle
      end function GetStdHandle
   end interface

   public MulDiv
   interface
      function MulDiv(nNumber,nNumerator,nDenominator) &
         bind(C,name='MulDiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: MulDiv
         integer(C_INT) MulDiv
         integer(C_INT),value :: nNumber
         integer(C_INT),value :: nNumerator
         integer(C_INT),value :: nDenominator
      end function MulDiv
   end interface

   public lstrlen
   interface
      function lstrlen(lpString) bind(C,name='lstrlenA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lstrlen
         integer(C_INT) lstrlen
         character(kind=C_CHAR) lpString(*)
      end function lstrlen
   end interface

   public lstrcpyn
   interface
      function lstrcpyn(lpString1,lpString2,iMaxLength) &
         bind(C,name='lstrcpynA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lstrcpyn
         type(C_PTR) lstrcpyn
         character(kind=C_CHAR) lpString1(*)
         character(kind=C_CHAR) lpString2(*)
         integer(C_INT), value :: iMaxLength
      end function lstrcpyn
   end interface

   public lstrcpy
   interface
      function lstrcpy(lpString1,lpString2) &
         bind(C,name='lstrcpyA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lstrcpy
         type(C_PTR) lstrcpy
         character(kind=C_CHAR) lpString1(*)
         character(kind=C_CHAR) lpString2(*)
      end function lstrcpy
   end interface

   public lstrcmpi
   interface
      function lstrcmpi(lpString1,lpString2) &
         bind(C,name='lstrcmpiA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lstrcmpi
         integer(C_INT) lstrcmpi
         character(kind=C_CHAR) lpString1(*)
         character(kind=C_CHAR) lpString2(*)
      end function lstrcmpi
   end interface

   public lstrcmp
   interface
      function lstrcmp(lpString1,lpString2) &
         bind(C,name='lstrcmpA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lstrcmp
         integer(C_INT) lstrcmp
         character(kind=C_CHAR) lpString1(*)
         character(kind=C_CHAR) lpString2(*)
      end function lstrcmp
   end interface

   public lstrcat
   interface
      function lstrcat(lpString1,lpString2) &
         bind(C,name='lstrcatA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lstrcat
         type(C_PTR) lstrcat
         character(kind=C_CHAR) lpString1(*)
         character(kind=C_CHAR) lpString2(*)
      end function lstrcat
   end interface

   public OpenFile
   interface
      function OpenFile(lpFileName,lpReOpenBuff,uStyle) bind(C,name='OpenFile')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: OpenFile
         integer(HFILE) OpenFile
         character(kind=C_CHAR) lpFileName(*)
         type(OFSTRUCT_T) lpReOpenBuff
         integer(UINT),value :: uStyle
      end function OpenFile
   end interface

   public lopen
   interface
      function lopen(lpPathName,iReadWrite) &
         bind(C,name='_lopen')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lopen
         integer(HFILE) lopen
         character(kind=C_CHAR) lpPathName(*)
         integer(C_INT), value :: iReadWrite
      end function lopen
   end interface

   public lcreat
   interface
      function lcreat(lpszFileName, fnAttribute) &
         bind(C,name='_lcreat')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lcreat
         integer(HFILE) lcreat
         character(kind=C_CHAR) lpszFileName(*)
         integer(C_INT), value :: fnAttribute
      end function lcreat
   end interface

   public lread
   interface
      function lread(hFile_,lpBuffer,uBytes) &
         bind(C,name='_lread')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lread
         integer(UINT) lread
         integer(HFILE), value :: hFile_
         character(kind=C_CHAR) lpBuffer(*)
         integer(UINT), value :: uBytes
      end function lread
   end interface

   public lwrite
   interface
      function lwrite(hFile_,lpBuffer,uBytes) &
         bind(C,name='_lwrite')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: lwrite
         integer(LONG) lwrite
         integer(HFILE), value :: hFile_
         character(kind=C_CHAR) lpBuffer(*)
         integer(UINT), value :: uBytes
      end function lwrite
   end interface

   public hread
   interface
      function hread(hFile_,lpBuffer,lBytes) &
         bind(C,name='_hread')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: hread
         integer(UINT) hread
         integer(HFILE), value :: hFile_
         character(kind=C_CHAR) lpBuffer(*)
         integer(C_LONG), value :: lBytes
      end function hread
   end interface

   public hwrite
   interface
      function hwrite(hFile_,lpBuffer,lBytes) &
         bind(C,name='_hwrite')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: hwrite
         integer(LONG) hwrite
         integer(HFILE), value :: hFile_
         character(kind=C_CHAR) lpBuffer(*)
         integer(C_LONG), value :: lBytes
      end function hwrite
   end interface

   public llseek
   interface
      function llseek(hFile_,lOffset,nOrigin) &
         bind(C,name='_llseek')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: llseek
         integer(LONG) llseek
         integer(HFILE), value :: hFile_
         integer(LONG), value :: lOffset
         integer(C_INT), value :: nOrigin
      end function llseek
   end interface

   public IsTextUnicode
   interface
      function IsTextUnicode(lpv,iSize,lpiResult) bind(C,name='IsTextUnicode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: IsTextUnicode
         integer(BOOL) IsTextUnicode
         type(C_PTR),value :: lpv
         integer(C_INT),value :: iSize
         integer(C_INT) lpiResult
      end function IsTextUnicode
   end interface

   public WriteFileEx
   interface
      function WriteFileEx(hFile,lpBuffer, &
         nNumberOfBytesToWrite,lpOverlapped, &
         lpCompletionRoutine) bind(C,name='WriteFileEx')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteFileEx
         integer(BOOL) WriteFileEx
         integer(HANDLE), value :: hFile
         type(C_PTR), value :: lpBuffer
         integer(DWORD), value :: nNumberOfBytesToWrite
         type(OVERLAPPED_T) lpOverlapped
         type(C_FUNPTR), value :: lpCompletionRoutine
      end function WriteFileEx
   end interface

   public WriteFile
   interface
      function WriteFile(hFile,lpBuffer, &
         nNumberOfBytesToWrite,lpNumberOfBytesWritten, &
         lpOverlapped) bind(C,name='WriteFile')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteFile
         integer(BOOL) WriteFile
         integer(HANDLE), value :: hFile
         type(C_PTR), value :: lpBuffer
         integer(DWORD), value :: nNumberOfBytesToWrite
         integer(DWORD) lpNumberOfBytesWritten
         type(OVERLAPPED_T) lpOverlapped
      end function WriteFile
   end interface

   public WriteConsoleOutputCharacter
   interface
      function WriteConsoleOutputCharacter(hConsoleOutput, &
         lpCharacter,nLength,dwWriteCoord,lpNumberOfCharsWritten) &
         bind(C,name='WriteConsoleOutputCharacterA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteConsoleOutputCharacter
         integer(BOOL) WriteConsoleOutputCharacter
         integer(HANDLE), value :: hConsoleOutput
         character(kind=C_CHAR) lpCharacter(*)
         integer(DWORD), value :: nLength
         type(COORD_T), value :: dwWriteCoord
         integer(DWORD) lpNumberOfCharsWritten
      end function WriteConsoleOutputCharacter
   end interface

   public WriteConsoleOutputAttribute
   interface
      function WriteConsoleOutputAttribute(hConsoleOutput, &
         lpAttribute,nLength,dwWriteCoord,lpNumberOfAttrsWritten) &
         bind(C,name='WriteConsoleOutputAttribute')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteConsoleOutputAttribute
         integer(BOOL) WriteConsoleOutputAttribute
         integer(HANDLE), value :: hConsoleOutput
         integer(WORD) lpAttribute(*)
         integer(DWORD), value :: nLength
         type(COORD_T), value :: dwWriteCoord
         integer(DWORD) lpNumberOfAttrsWritten
      end function WriteConsoleOutputAttribute
   end interface

   public WriteConsoleOutput
   interface
      function WriteConsoleOutput(hConsoleOutput, &
         lpBuffer,dwBufferSize,dwBufferCoord,lpWriteRegion) &
         bind(C,name='WriteConsoleOutputA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteConsoleOutput
         integer(BOOL) WriteConsoleOutput
         integer(HANDLE), value :: hConsoleOutput
         type(CHAR_INFO_T) lpBuffer(*)
         type(COORD_T), value :: dwBufferSize
         type(COORD_T), value :: dwBufferCoord
         type(SMALL_RECT_T) lpWriteRegion
      end function WriteConsoleOutput
   end interface

   public WriteConsoleInput
   interface
      function WriteConsoleInput(hConsoleInput, &
         lpBuffer,nLength,lpNumberOfEventsWritten) &
         bind(C,name='WriteConsoleInputA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteConsoleInput
         integer(BOOL) WriteConsoleInput
         integer(HANDLE), value :: hConsoleInput
         type(INPUT_RECORD_T) lpBuffer(*)
         integer(DWORD), value :: nLength
         integer(DWORD) lpNumberOfEventsWritten
      end function WriteConsoleInput
   end interface

   public WinExec
   interface
      function WinExec(lpCmdLine,uCmdShow) &
         bind(C,name='WinExec')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WinExec
         integer(UINT) WinExec
         character(kind=C_CHAR) lpCmdLine(*)
         integer(UINT), value :: uCmdShow
      end function WinExec
   end interface

   public GetModuleFileName
   interface
      function GetModuleFileName(hModule_,lpFilename,nSize) &
         bind(C,name='GetModuleFileNameA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetModuleFileName
         integer(DWORD) GetModuleFileName
         integer(HMODULE),value :: hModule_
         character(kind=C_CHAR) lpFilename(*)
         integer(DWORD),value :: nSize
      end function GetModuleFileName
   end interface

   public GlobalAlloc
   interface
      function GlobalAlloc(uFlags,dwBytes) bind(C,name='GlobalAlloc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GlobalAlloc
         integer(HGLOBAL) GlobalAlloc
         integer(UINT),value :: uFlags
         integer(SIZE_T),value :: dwBytes
      end function GlobalAlloc
   end interface

   public GlobalLock
   interface
      function GlobalLock(hMem) bind(C,name='GlobalLock')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GlobalLock
         type(C_PTR) GlobalLock
         integer(HGLOBAL),value :: hMem
      end function GlobalLock
   end interface

   public GlobalUnlock
   interface
      function GlobalUnlock(hMem) bind(C,name='GlobalUnlock')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GlobalUnlock
         integer(BOOL) GlobalUnlock
         integer(HGLOBAL),value :: hMem
      end function GlobalUnlock
   end interface

   public GlobalFree
   interface
      function GlobalFree(hMem) bind(C,name='GlobalFree')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GlobalFree
         integer(HGLOBAL) GlobalFree
         integer(HGLOBAL),value :: hMem
      end function GlobalFree
   end interface

   public GetProcessHeap
   interface
      function GetProcessHeap() bind(C,name='GetProcessHeap')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetProcessHeap
         integer(HANDLE) GetProcessHeap
      end function GetProcessHeap
   end interface

   public HeapAlloc
   interface
      function HeapAlloc(hHeap,dwFlags,dwBytes) &
         bind(C,name='HeapAlloc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: HeapAlloc
         type(C_PTR) HeapAlloc
         integer(HANDLE),value :: hHeap
         integer(DWORD),value :: dwFlags
         integer(SIZE_T),value :: dwBytes
      end function HeapAlloc
   end interface

   public CopyMemory
   interface
      subroutine CopyMemory(Destination,Source,Length) &
         bind(C,name='RtlCopyMemory')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CopyMemory
         type(C_PTR),value :: Destination
         type(C_PTR),value :: Source
         integer(SIZE_T),value :: Length
      end subroutine CopyMemory
   end interface

   public QueryPerformanceCounter
   interface
      function QueryPerformanceCounter(lpPerformanceCount) &
         bind(C,name='QueryPerformanceCounter')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: QueryPerformanceCounter
         integer(BOOL) QueryPerformanceCounter
         integer(LARGE_INTEGER) lpPerformanceCount
      end function QueryPerformanceCounter
   end interface

   public QueryPerformanceFrequency
   interface
      function QueryPerformanceFrequency(lpFrequency) &
         bind(C,name='QueryPerformanceFrequency')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: QueryPerformanceFrequency
         integer(BOOL) QueryPerformanceFrequency
         integer(LARGE_INTEGER) lpFrequency
      end function QueryPerformanceFrequency
   end interface

   public FormatMessage
   interface
      function FormatMessage(dwFlags,lpSource,dwMessageId,dwLanguageId, &
         lpBuffer,nSize,Arguments) bind(C,name='FormatMessageA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: FormatMessage
         integer(DWORD) FormatMessage
         integer(DWORD),value :: dwFlags
         type(C_PTR),value :: lpSource
         integer(DWORD),value :: dwMessageId
         integer(DWORD),value :: dwLanguageId
         character(kind=C_CHAR) lpBuffer(*)
         integer(DWORD),value :: nSize
         type(C_PTR),value :: Arguments
      end function FormatMessage
   end interface

   public LocalFree
   interface
      function LocalFree(hMem) bind(C,name='LocalFree')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LocalFree
         integer(HLOCAL) LocalFree
         integer(HLOCAL),value :: hMem
      end function LocalFree
   end interface

   public SetLastError
   interface
      subroutine SetLastError(dwErrCode) bind(C,name='SetLastError')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetLastError
         integer(DWORD),value :: dwErrCode
      end subroutine SetLastError
   end interface

   public ZombifyActCtx
   interface
      function ZombifyActCtx(hActCtx) &
         bind(C,name='ZombifyActCtx')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: ZombifyActCtx
         integer(BOOL) ZombifyActCtx
         integer(HANDLE), value :: hActCtx
      end function ZombifyActCtx
   end interface

   public WriteTapemark
   interface
      function WriteTapemark(hDevice,dwTapemarkType, &
         dwTapemarkCount,bImmediate) &
         bind(C,name='WriteTapemark')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteTapemark
         integer(DWORD) WriteTapemark
         integer(HANDLE), value :: hDevice
         integer(DWORD), value :: dwTapemarkType
         integer(DWORD), value :: dwTapemarkCount
         integer(BOOL), value :: bImmediate
      end function WriteTapemark
   end interface

   public WriteProfileString
   interface
      function WriteProfileString(lpAppName, &
         lpKeyName,lpString) &
         bind(C,name='WriteProfileStringA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteProfileString
         integer(BOOL) WriteProfileString
         character(kind=C_CHAR) lpAppName(*)
         character(kind=C_CHAR) lpKeyName(*)
         character(kind=C_CHAR) lpString(*)
      end function WriteProfileString
   end interface

   public WriteProfileSection
   interface
      function WriteProfileSection(lpAppName,lpString) &
         bind(C,name='WriteProfileSectionA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteProfileSection
         integer(BOOL) WriteProfileSection
         character(kind=C_CHAR) lpAppName(*)
         character(kind=C_CHAR) lpString(*)
      end function WriteProfileSection
   end interface

   public WriteProcessMemory
   interface
      function WriteProcessMemory(hProcess,lpBaseAddress, &
         lpBuffer,nSize,lpNumberOfBytesWritten) &
         bind(C,name='WriteProcessMemory')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteProcessMemory
         integer(BOOL) WriteProcessMemory
         integer(HANDLE), value :: hProcess
         type(C_PTR) lpBaseAddress ! Not sure about value
         type(C_PTR), value :: lpBuffer
         integer(C_SIZE_T), value :: nSize
         integer(C_SIZE_T) lpNumberOfBytesWritten
      end function WriteProcessMemory
   end interface

   public WritePrivateProfileStruct
   interface
      function WritePrivateProfileStruct(lpszSection, &
         lpszKey,lpStruct,uSizeStruct,szFile) &
         bind(C,name='WritePrivateProfileStructA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WritePrivateProfileStruct
         integer(BOOL) WritePrivateProfileStruct
         character(kind=C_CHAR) lpszSection(*)
         character(kind=C_CHAR) lpszKey(*)
         type(C_PTR), value :: lpStruct
         integer(UINT), value :: uSizeStruct
         character(kind=C_CHAR) szFile(*)
      end function WritePrivateProfileStruct
   end interface

   public WritePrivateProfileString
   interface
      function WritePrivateProfileString(lpAppName, &
         lpKeyName,lpString,lpFileName) &
         bind(C,name='WritePrivateProfileStringA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WritePrivateProfileString
         integer(BOOL) WritePrivateProfileString
         character(kind=C_CHAR) lpAppName(*)
         character(kind=C_CHAR) lpKeyName(*)
         character(kind=C_CHAR) lpString(*)
         character(kind=C_CHAR) lpFileName(*)
      end function WritePrivateProfileString
   end interface

   public WritePrivateProfileSection
   interface
      function WritePrivateProfileSection(lpAppName, &
         lpString,lpFileName) &
         bind(C,name='WritePrivateProfileSectionA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WritePrivateProfileSection
         integer(BOOL) WritePrivateProfileSection
         character(kind=C_CHAR) lpAppName(*)
         character(kind=C_CHAR) lpString(*)
         character(kind=C_CHAR) lpFileName(*)
      end function WritePrivateProfileSection
   end interface

   public WriteFileGather
   interface
      function WriteFileGather(hFile,aSegmentArray, &
         nNumberOfBytesToWrite,lpReserved,lpOverlapped) &
         bind(C,name='WriteFileGather')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WriteFileGather
         integer(BOOL) WriteFileGather
         integer(HANDLE), value :: hFile
         integer(ULONGLONG) aSegmentArray(*)
         integer(DWORD), value :: nNumberOfBytesToWrite
         type(C_PTR), value :: lpReserved
         type(OVERLAPPED_T) lpOverlapped
      end function WriteFileGather
   end interface

   public Wow64SuspendThread
   interface
      function Wow64SuspendThread(hthread) &
         bind(C,name='Wow64SuspendThread')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Wow64SuspendThread
         integer(DWORD) Wow64SuspendThread
         integer(HANDLE), value :: hThread
      end function Wow64SuspendThread
   end interface

   public Wow64SetThreadContext
   interface
      function Wow64SetThreadContext(hthread,lpContext) &
         bind(C,name='Wow64SetThreadContext')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Wow64SetThreadContext
         integer(BOOL) Wow64SetThreadContext
         integer(HANDLE), value :: hThread
         type(WOW64_CONTEXT_T) lpContext
      end function Wow64SetThreadContext
   end interface

   public Wow64RevertWow64FsRedirection
   interface
      function Wow64RevertWow64FsRedirection(OldValue) &
         bind(C,name='Wow64RevertWow64FsRedirection')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Wow64RevertWow64FsRedirection
         integer(BOOL) Wow64RevertWow64FsRedirection
         type(C_PTR), value :: OldValue
      end function Wow64RevertWow64FsRedirection
   end interface

   public Wow64GetThreadSelectorEntry
   interface
      function Wow64GetThreadSelectorEntry(hThread, &
         dwSelector,lpSelectorEntry) &
         bind(C,name='Wow64GetThreadSelectorEntry')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Wow64GetThreadSelectorEntry
         integer(BOOL) Wow64GetThreadSelectorEntry
         integer(HANDLE), value :: hThread
         integer(DWORD), value :: dwSelector
         type(WOW64_LDT_ENTRY_T) lpSelectorEntry
      end function Wow64GetThreadSelectorEntry
   end interface

   public Wow64GetThreadContext
   interface
      function Wow64GetThreadContext(hthread,lpContext) &
         bind(C,name='Wow64GetThreadContext')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Wow64GetThreadContext
         integer(BOOL) Wow64GetThreadContext
         integer(HANDLE), value :: hThread
         type(WOW64_CONTEXT_T) lpContext
      end function Wow64GetThreadContext
   end interface

   public Wow64EnableWow64FsRedirection
   interface
      function Wow64EnableWow64FsRedirection( &
         Wow64FsEnabledRedirection) &
         bind(C,name='Wow64EnableWow64FsRedirection')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Wow64EnableWow64FsRedirection
         integer(BOOLEAN) Wow64EnableWow64FsRedirection
         integer(BOOLEAN), value :: Wow64FsEnabledRedirection
      end function Wow64EnableWow64FsRedirection
   end interface

   public Wow64DisableWow64FsRedirection
   interface
      function Wow64DisableWow64FsRedirection(OldValue) &
         bind(C,name='Wow64DisableWow64FsRedirection')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: Wow64DisableWow64FsRedirection
         integer(BOOLEAN) Wow64DisableWow64FsRedirection
         type(C_PTR) OldValue
      end function Wow64DisableWow64FsRedirection
   end interface

   public WideCharToMultiByte
   interface
      function WideCharToMultiByte(CodePage,dwFlags, &
         lpWideCharStr,cchWideChar,lpMultiByteStr, &
         cbMultiByte,lpDefaultChar,lpUsedDefaultChar) &
         bind(C,name='WideCharToMultiByte')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: WideCharToMultiByte
         integer(C_INT) WideCharToMultiByte
         integer(UINT), value :: CodePage
         integer(DWORD), value :: dwFlags
         type(C_PTR), value :: lpWideCharStr ! No wide char type
         integer(C_INT), value :: cchWideChar
         character(kind=C_CHAR) lpMultiByteStr(*)
         integer(C_INT), value :: cbMultiByte
         character(kind=C_CHAR) lpDefaultChar
         integer(BOOL) lpUsedDefaultChar
      end function WideCharToMultiByte
   end interface

   public LoadLibrary
   interface
      function LoadLibrary(lpFileName) bind(C,name='LoadLibraryA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadLibrary
         integer(HMODULE) LoadLibrary
         character(kind=C_CHAR) lpFileName(*)
      end function LoadLibrary
   end interface

   public SetErrorMode
   interface
      function SetErrorMode(uMode) bind(C,name='SetErrorMode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetErrorMode
         integer(UINT) SetErrorMode
         integer(UINT),value :: uMode
      end function SetErrorMode
   end interface

   public GetProcAddress
   interface
      function GetProcAddress(hModule_,lpProcName) bind(C,name='GetProcAddress')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetProcAddress
         type(C_FUNPTR) GetProcAddress
         integer(HMODULE),value :: hModule_
         character(kind=C_CHAR) lpProcName(*)
      end function GetProcAddress
   end interface

   public FindResource
   interface
      function FindResource(hModule_,lpName,lpType) bind(C,name='FindResourceA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: FindResource
         integer(HRSRC) FindResource
         integer(HMODULE),value :: hModule_
         character(kind=C_CHAR) lpName(*)
         character(kind=C_CHAR) lpType(*)
      end function FindResource
   end interface

   public LoadResource
   interface
      function LoadResource(hModule_,hResInfo) &
         bind(C,name='LoadResource')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadResource
         integer(HGLOBAL) LoadResource
         integer(HMODULE),value :: hModule_
         integer(HRSRC),value :: hResInfo
      end function LoadResource
   end interface

   public LockResource
   interface
      function LockResource(hResData) bind(C,name='LockResource')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LockResource
         type(C_PTR) LockResource
         integer(HGLOBAL),value :: hResData
      end function LockResource
   end interface

   public SizeofResource
   interface
      function SizeofResource(hModule_,hResInfo) &
         bind(C,name='SizeofResource')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SizeofResource
         integer(DWORD) SizeofResource
         integer(HMODULE),value :: hModule_
         integer(HRSRC),value :: hResInfo
      end function SizeofResource
   end interface

   public CreateProcess
   interface
      function CreateProcess(lpApplicationName,lpCommandLine, &
         lpProcessAttributes,lpThreadAttributes,bInheritHandles, &
         dwCreationFlags,lpEnvironment,lpCurrentDirectory, &
         lpStartupInfo,lpProcessInformation) bind(C,name='CreateProcessA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateProcess
         integer(BOOL) CreateProcess
         character(kind=C_CHAR) lpApplicationName(*)
         character(kind=C_CHAR) lpCommandLine(*)
         type(SECURITY_ATTRIBUTES_T) lpProcessAttributes
         type(SECURITY_ATTRIBUTES_T) lpThreadAttributes
         integer(BOOL),value :: bInheritHandles
         integer(DWORD),value :: dwCreationFlags
         type(C_PTR),value :: lpEnvironment
         character(kind=C_CHAR) lpCurrentDirectory(*)
         type(STARTUPINFO_T) lpStartupInfo
         type(PROCESS_INFORMATION_T) lpProcessInformation
      end function CreateProcess
   end interface

   public FindFirstFile
   interface
      function FindFirstFile(lpFileName,lpFindFileData) &
         bind(C,name='FindFirstFileA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: FindFirstFile
         integer(HANDLE) FindFirstFile
         character(kind=C_CHAR) lpFileName(*)
         type(WIN32_FIND_DATA_T) lpFindFileData
      end function FIndFirstFile
   end interface

   public FindNextFile
   interface
      function FindNextFile(hFindFile,lpFindFileData) &
         bind(C,name='FindNextFileA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: FindNextFile
         integer(BOOL) FindNextFile
         integer(HANDLE),value :: hFindFile
         type(WIN32_FIND_DATA_T) lpFindFileData
      end function FindNextFile
   end interface

   public FindClose
   interface
      function FindClose(hFindFile) bind(C,name='FindClose')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: FindClose
         integer(BOOL) FindClose
         integer(HANDLE),value :: hFindFile
      end function FindClose
   end interface

   public MoveFile
   interface
      function MoveFile(lpExistingFileName,lpNewFileName) &
         bind(C,name='MoveFileA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: MoveFile
         integer(BOOL) MoveFile
         character(kind=C_CHAR) lpExistingFileName(*)
         character(kind=C_CHAR) lpNewFileName(*)
      end function MoveFile
   end interface

   public GetCurrentDirectory
   interface
      function GetCurrentDirectory(nBufferLength,lpBuffer) &
         bind(C,name='GetCurrentDirectoryA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetCurrentDirectory
         integer(DWORD) GetCurrentDirectory
         integer(DWORD),value :: nBufferLength
         character(kind=C_CHAR) lpBuffer(*)
      end function GetCurrentDirectory
   end interface

   public IsWow64Process
   interface
      function IsWow64Process(hProcess,Wow64Process) &
         bind(C,name='IsWow64Process')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: IsWow64Process
         integer(BOOL) IsWow64Process
         integer(HANDLE),value :: hProcess
         integer(BOOL) Wow64Process
      end function IsWow64Process
   end interface

   public GetCurrentProcess
   interface
      function GetCurrentProcess() &
         bind(C,name='GetCurrentProcess')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetCurrentProcess
         integer(HANDLE) GetCurrentProcess
      end function GetCurrentProcess
   end interface
end module kernel32
