! user32.f90
! Public domain 2010-2011 James Van Buskirk
! Compiled with:
! gfortran -Wall -c user32.f90

module user32
   use ISO_C_BINDING
   use win32_types
   implicit none
   private

   public DefWindowProc
   interface
      function DefWindowProc(hwnd_,Msg,wParam_,lParam_) &
         bind(C,name='DefWindowProcA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DefWindowProc
         integer(LRESULT) DefWindowProc
         integer(HWND),value :: hwnd_
         integer(UINT),value :: Msg
         integer(WPARAM),value :: wParam_
         integer(LPARAM),value :: lParam_
      end function DefWindowProc
   end interface

   public LoadIcon
   interface
      function LoadIcon(hInstance_,lpIconName) &
         bind(C,name='LoadIconA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadIcon
         integer(HICON) LoadIcon
         integer(HINSTANCE),value :: hInstance_
         character(kind=C_CHAR),intent(in) :: lpIconName(*)
      end function LoadIcon
   end interface

   public LoadCursor
   interface
      function LoadCursor(hInstance_,lpCursorName) &
         bind(C,name='LoadCursorA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadCursor
         integer(HCURSOR) LoadCursor
         integer(HINSTANCE),value :: hInstance_
         character(kind=C_CHAR),intent(in) :: lpCursorName(*)
      end function LoadCursor
   end interface

   public RegisterClassEx
   interface
      function RegisterClassEx(lpwcx) &
         bind(C,name='RegisterClassExA')
         use win32_types
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: RegisterClassEx
         integer(ATOM) RegisterClassEx
         type(WNDCLASSEX_T),intent(in) :: lpwcx
      end function RegisterClassEx
   end interface

   public CreateWindowEx
   interface
      function CreateWindowEx(dwExStyle,lpClassName, &
         lpWindowName, dwStyle, x, y, nWidth, nHeight, &
         hwndParent, hMenu_, hInstance_, lpParam) &
         bind(C,name='CreateWindowExA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateWindowEx
         integer(HWND) CreateWindowEx
         integer(DWORD),value :: dwExStyle
         character(kind=C_CHAR),intent(in) :: lpClassName(*)
         character(kind=C_CHAR),intent(in) :: lpWindowName(*)
         integer(DWORD),value :: dwStyle
         integer(C_INT),value :: x
         integer(C_INT),value :: y
         integer(C_INT),value :: nWidth
         integer(C_INT),value :: nHeight
         integer(HWND),value :: hWndParent
         integer(HMENU),value :: hMenu_
         integer(HINSTANCE),value :: hInstance_
         type(C_PTR),value :: lpParam
      end function CreateWindowEx
   end interface

   public ShowWindow
   interface
      function ShowWindow(hWnd_,nCmdShow) bind(C,name='ShowWindow')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: ShowWindow
         integer(BOOL) ShowWindow
         integer(HWND),value :: hWnd_
         integer(C_INT),value :: nCmdShow
      end function ShowWindow
   end interface

   public UpdateWindow
   interface
      function UpdateWindow(hWnd_) bind(C,name='UpdateWindow')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: UpdateWindow
         integer(BOOL) UpdateWindow
         integer(HWND),value :: hWnd_
      end function UpdateWindow
   end interface

   public GetMessage
   interface
      function GetMessage(lpMsg,hWnd_,wMsgFilterMin,wMsgFilterMax) &
         bind(C,name='GetMessageA')
         use win32_types
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetMessage
         integer(BOOL) GetMessage
         type(MSG_T) lpMsg
         integer(HWND),value :: hWnd_
         integer(UINT),value :: wMsgFilterMin
         integer(UINT),value :: wMsgFilterMax
      end function GetMessage
   end interface

   public TranslateMessage
   interface
      function TranslateMessage(lpMsg) bind(C,name='TranslateMessage')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: TranslateMessage
         integer(BOOL) TranslateMessage
         type(MSG_T) lpMsg
      end function TranslateMessage
   end interface

   public DispatchMessage
   interface
      function DispatchMessage(lpMsg) bind(C,name='DispatchMessageA')
         use ISO_C_BINDING
         use win32_types
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DispatchMessage
         integer(LRESULT) DispatchMessage
         type(MSG_T),intent(in) :: lpMsg
      end function DispatchMessage
   end interface

   public BeginPaint
   interface
      function BeginPaint(hwnd_,lpPaint) bind(C,name='BeginPaint')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: BeginPaint
         integer(HDC) BeginPaint
         integer(HWND),value :: hwnd_
         type(PAINTSTRUCT_T) lpPaint
      end function BeginPaint
   end interface

   public GetClientRect
   interface
      function GetClientRect(hwnd_,lpRect) bind(C,name='GetClientRect')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetClientRect
         integer(BOOL) GetClientRect
         integer(HWND),value :: hwnd_
         type(RECT_T) lpRect
      end function GetClientRect
   end interface

   public DrawText
   interface
      function DrawText(hdc_,lpString,nCount,lpRect, &
         uFormat) bind(C,name='DrawTextA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DrawText
         integer(C_INT) DrawText
         integer(HDC),value :: hdc_
         character(kind=C_CHAR) lpString(*)
         integer(C_INT),value :: nCount
         type(RECT_T) lpRect
         integer(UINT),value :: uFormat
      end function DrawText
   end interface

   public EndPaint
   interface
      function EndPaint(hwnd_,lpPaint) bind(C,name='EndPaint')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EndPaint
         integer(BOOL) EndPaint
         integer(HWND),value :: hwnd_
         type(PAINTSTRUCT_T),intent(in) :: lpPaint
      end function EndPaint
   end interface

   public PostQuitMessage
   interface
      subroutine PostQuitMessage(nExitCode) bind(C,name='PostQuitMessage')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: PostQuitMessage
         integer(C_INT), value :: nExitCode
      end subroutine PostQuitMessage
   end interface

   public MessageBox
   interface
      function MessageBox(hWnd_,lpText,lpCaption,uType) &
         bind(C,name='MessageBoxA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: MessageBox
         integer(C_INT) MessageBox
         integer(HWND),value :: hWnd_
         character(kind=C_CHAR),intent(in) :: lpText(*)
         character(kind=C_CHAR),intent(in) :: lpCaption(*)
         integer(UINT),value :: uType
      end function MessageBox
   end interface

   public FillRect
   interface
      function FillRect(hdc_,lprc,hbr) bind(C,name='FillRect')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: FillRect
         integer(C_INT) FillRect
         integer(HDC),value :: hdc_
         type(RECT_T),intent(in) :: lprc
         integer(HBRUSH),value :: hbr
      end function FillRect
   end interface

   public DestroyWindow
   interface
      function DestroyWindow(hWnd_) bind(C,name='DestroyWindow')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DestroyWindow
         integer(BOOL) DestroyWindow
         integer(HWND),value :: hWnd_
      end function DestroyWindow
   end interface

   public InvalidateRect
   interface
      function InvalidateRect(hWnd_,lpRect,bErase) &
         bind(C,name='InvalidateRect')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: InvalidateRect
         integer(BOOL) InvalidateRect
         integer(HWND),value :: hWnd_
         type(RECT_T),intent(in) :: lpRect
         integer(BOOL),value :: bErase
      end function InvalidateRect
   end interface

   public MonitorFromPoint
   interface
      function MonitorFromPoint(pt,dwFlags) &
         bind(C,name='MonitorFromPoint')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: MonitorFromPoint
         integer(HMONITOR) MonitorFromPoint
         type(POINT_T),value :: pt
         integer(DWORD),value :: dwFlags
      end function MonitorFromPoint
   end interface

   public GetMonitorInfo
   interface
      function GetMonitorInfo(hMonitor_,lpmi) &
         bind(C,name='GetMonitorInfoA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetMonitorInfo
         integer(BOOL) GetMonitorInfo
         integer(HMONITOR),value :: hMonitor_
         type(MONITORINFO_T) lpmi
      end function GetMonitorInfo
   end interface

   public PeekMessage
   interface
      function PeekMessage(lpMsg,hWnd_,wMsgFilterMax,wMsgFilterMin,wRemoveMsg) &
         bind(C,name='PeekMessageA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: PeekMessage
         integer(BOOL) PeekMessage
         type(MSG_T) lpMsg
         integer(HWND),value :: hWnd_
         integer(UINT),value :: wMsgFilterMax
         integer(UINT),value :: wMsgFilterMin
         integer(UINT),value :: wRemoveMsg
      end function PeekMessage
   end interface

   public GetQueueStatus
   interface
      function GetQueueStatus(flags) &
         bind(C,name='GetQueueStatus')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetQueueStatus
         integer(DWORD) GetQueueStatus
         integer(UINT),value :: flags
      end function GetQueueStatus
   end interface

   public ReleaseDC
   interface
      function ReleaseDC(hWnd_,hDC_) &
         bind(C,name='ReleaseDC')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: ReleaseDC
         integer(C_INT) ReleaseDC
         integer(HWND),value :: hWnd_
         integer(HDC),value :: hDC_
      end function ReleaseDC
   end interface

   public GetDC
   interface
      function GetDC(hWnd_) &
         bind(C,name='GetDC')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetDC
         integer(HDC) GetDC
         integer(HWND),value :: hWnd_
      end function GetDC
   end interface

   public SetTimer
   interface
      function SetTimer(hWnd_,nIDEvent,uElapse,lpTimerFunc) &
         bind(C,name='SetTimer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetTimer
         integer(UINT_PTR) SetTimer
         integer(HWND),value :: hWnd_
         integer(UINT_PTR),value :: nIDEvent
         integer(UINT),value :: uElapse
         type(C_FUNPTR),value :: lpTimerFunc
      end function SetTimer
   end interface

   public KillTimer
   interface
      function KillTimer(hWnd_,uIDEvent) &
         bind(C,name='KillTimer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: KillTimer
         integer(BOOL) KillTimer
         integer(HWND),value :: hWnd_
         integer(UINT_PTR),value :: uIDEvent
      end function KillTimer
   end interface

   public InvalidateRgn
   interface
      function InvalidateRgn(hWnd_,hRgn_,bErase) &
         bind(C,name='InvalidateRgn')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: InvalidateRgn
         integer(BOOL) InvalidateRgn
         integer(HWND),value :: hWnd_
         integer(HRGN),value :: hRgn_
         integer(BOOL),value :: bErase
      end function InvalidateRgn
   end interface

   public ValidateRgn
   interface
      function ValidateRgn(hWnd_,hRgn_) &
         bind(C,name='ValidateRgn')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: ValidateRgn
         integer(BOOL) ValidateRgn
         integer(HWND),value :: hWnd_
         integer(HRGN),value :: hRgn_
      end function ValidateRgn
   end interface

   public SendMessage
   interface
      function SendMessage(hWnd_,Msg,wParam_,lParam_) &
         bind(C,name='SendMessageA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SendMessage
         integer(LRESULT) SendMessage
         integer(HWND),value :: hWnd_
         integer(UINT),value :: Msg
         integer(WPARAM),value :: wParam_
         integer(LPARAM),value :: lParam_
      end function SendMessage
   end interface

   public GetSubMenu
   interface
      function GetSubMenu(hMenu_,nPos) &
         bind(C,name='GetSubMenu')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetSubMenu
         integer(LRESULT) GetSubMenu
         integer(hMenu),value :: hMenu_
         integer(C_INT),value :: nPos
      end function GetSubMenu
   end interface

   public LoadMenu
   interface
      function LoadMenu(hInstance_,lpMenuName) &
         bind(C,name='LoadMenuA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadMenu
         integer(HMENU) LoadMenu
         integer(HINSTANCE),value :: hInstance_
         character(kind=C_CHAR) lpMenuName(*)
      end function LoadMenu
   end interface

   public LoadAccelerators
   interface
      function LoadAccelerators(hInstance_,lpTableName) &
         bind(C,name='LoadAcceleratorsA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadAccelerators
         integer(HACCEL) LoadAccelerators
         integer(HINSTANCE),value :: hInstance_
         character(kind=C_CHAR) lpTableName(*)
      end function LoadAccelerators
   end interface

   public CheckMenuItem
   interface
      function CheckMenuItem(hmenu_,uIDCheckItem,uCheck) &
         bind(C,name='CheckMenuItem')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL ::CheckMenuItem
         integer(BOOL) CheckMenuItem
         integer(HMENU),value :: hmenu_
         integer(UINT),value :: uIDCheckItem
         integer(UINT),value :: uCheck
      end function CheckMenuItem
   end interface

   public DialogBoxParam
   interface
      function DialogBoxParam(hInstance_,lpTemplateName, &
         hWndParent,lpDialogFunc,dwInitParam) &
         bind(C,name='DialogBoxParamA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DialogBoxParam
         integer(INT_PTR) DialogBoxParam
         integer(HINSTANCE),value :: hInstance_
         character(kind=C_CHAR) lpTemplateName(*)
         integer(HWND),value :: hWndParent
         procedure(DLGPROC) lpDialogFunc
         integer(LPARAM),value :: dwInitParam
      end function DialogBoxParam
   end interface

   public GetWindowRect
   interface
      function GetWindowRect(hWnd_,lpRect) &
         bind(C,name='GetWindowRect')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetWindowRect
         integer(BOOL) GetWindowRect
         integer(HWND),value :: hWnd_
         type(RECT_T) lpRect
      end function GetWindowRect
   end interface

   public SetWindowPos
   interface
      function SetWindowPos(hWnd_,hWndInsertAfter,X,Y, &
         cx,cy,uFlags) bind(C,name='SetWindowPos')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetWindowPos
         integer(BOOL) SetWindowPos
         integer(HWND),value :: hWnd_
         integer(HWND),value :: hWndInsertAfter
         integer(C_INT),value :: X
         integer(C_INT),value :: Y
         integer(C_INT),value :: cx
         integer(C_INT),value :: cy
         integer(UINT),value :: uFlags
      end function SetWindowPos
   end interface

   public GetWindow
   interface
      function GetWindow(hWnd_,uCmd) bind(C,name='GetWindow')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetWindow
         integer(HWND) GetWindow
         integer(HWND),value :: hWnd_
         integer(UINT),value :: uCmd
      end function GetWindow
   end interface

   public GetDlgItemText
   interface
      function GetDlgItemText(hDlg,nIDDlgItem,lpString, &
         nMaxCount) bind(C,name='GetDlgItemTextA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetDlgItemText
         integer(UINT) GetDlgItemText
         integer(HWND),value :: hDlg
         integer(C_INT),value :: nIDDlgItem
         character(kind=C_CHAR) lpString(*)
         integer(C_INT),value :: nMaxCount
      end function GetDlgItemText
   end interface

   public SetDlgItemText
   interface
      function SetDlgItemText(hDlg,nIDDlgItem,lpString) &
         bind(C,name='SetDlgItemTextA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetDlgItemText
         integer(BOOL) SetDlgItemText
         integer(HWND),value :: hDlg
         integer(C_INT),value :: nIDDlgItem
         character(kind=C_CHAR) lpString(*)
      end function SetDlgItemText
   end interface

   public GetDlgItem
   interface
      function GetDlgItem(hDlg,nIDDlgItem) bind(C,name='GetDlgItem')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetDlgItem
         integer(HWND) GetDlgItem
         integer(HWND),value :: hDlg
         integer(C_INT),value :: nIDDlgItem
      end function GetDlgItem
   end interface

   public EndDialog
   interface
      function EndDialog(hDlg,nResult) bind(C,name='EndDialog')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EndDialog
         integer(BOOL) EndDialog
         integer(HWND),value :: hDlg
         integer(INT_PTR),value :: nResult
      end function EndDialog
   end interface

   public SetWindowText
   interface
      function SetWindowText(hWnd_,lpString) &
         bind(C,name='SetWindowTextA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetWindowText
         integer(BOOL) SetWindowText
         integer(HWND),value :: hWnd_
         character(kind=C_CHAR) lpString(*)
      end function SetWindowText
   end interface

   public TranslateAccelerator
   interface
      function TranslateAccelerator(hWnd_,hAccTable,lpMsg) &
         bind(C,name='TranslateAcceleratorA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: TranslateAccelerator
         integer(C_INT) TranslateAccelerator
         integer(HWND),value :: hWnd_
         integer(HACCEL),value :: hAccTable
         type(MSG_T) lpMsg
      end function TranslateAccelerator
   end interface

   public DialogBox
   interface
      function DialogBox(hInstance_,lpTemplate,hWndParent, &
         lpDialogFunc) bind(C,name='DialogBoxA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DialogBox
         integer(INT_PTR) DialogBox
         integer(HINSTANCE),value :: hInstance_
         character(kind=C_CHAR) lpTemplate(*)
         integer(HWND),value :: hWndParent
         procedure(DLGPROC) lpDialogFunc
      end function DialogBox
   end interface

   public LoadString
   interface
      function LoadString(hInstance_,uID,lpBuffer,nBufferMax) &
         bind(C,name='LoadStringA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadString
         integer(C_INT) LoadString
         integer(HINSTANCE),value :: hInstance_
         integer(UINT),value :: uID
         character(kind=C_CHAR) lpBuffer(*)
         integer(C_INT),value :: nBufferMax
      end function LoadString
   end interface

   public CopyAcceleratorTable
   interface
      function CopyAcceleratorTable(hAccelSrc,lpAccelDst, &
         cAccelEntries) bind(C,name='CopyAcceleratorTableA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CopyAcceleratorTable
         integer(C_INT) CopyAcceleratorTable
         integer(HACCEL),value :: hAccelSrc
         type(ACCEL_T) lpAccelDst(*)
         integer(C_INT),value :: cAccelEntries
      end function CopyAcceleratorTable
   end interface

   public CreateAcceleratorTable
   interface
      function CreateAcceleratorTable(lpaccl,cEntries) &
         bind(C,name='CreateAcceleratorTableA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateAcceleratorTable
         integer(HACCEL) CreateAcceleratorTable
         type(ACCEL_T) lpaccl(*)
         integer(C_INT),value :: cEntries
      end function CreateAcceleratorTable
   end interface

   public DestroyAcceleratorTable
   interface
      function DestroyAcceleratorTable(hAccel_) &
         bind(C,name='DestroyAcceleratorTable')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DestroyAcceleratorTable
         integer(BOOL) DestroyAcceleratorTable
         integer(HACCEL),value :: hAccel_
      end function DestroyAcceleratorTable
   end interface

   public LoadBitmap
   interface
      function LoadBitmap(hInstance_,lpBitmapName) &
         bind(C,name='LoadBitmapA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadBitmap
         integer(HBITMAP) LoadBitmap
         integer(HINSTANCE),value :: hInstance_
         character(kind=C_CHAR) lpBitmapName(*)
      end function LoadBitmap
   end interface

   public LoadImage
   interface
      function LoadImage(hinst,lpszName,uType,cxDesired, &
         cyDesired,fuLoad) bind(C,name='LoadImageA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadImage
         integer(HANDLE) LoadImage
         integer(HINSTANCE),value :: hinst
         character(kind=C_CHAR) lpszName(*)
         integer(UINT),value :: uType
         integer(C_INT),value :: cxDesired
         integer(C_INT),value :: cyDesired
         integer(UINT),value :: fuLoad
      end function LoadImage
   end interface

   public DestroyCursor
   interface
      function DestroyCursor(hCursor_) bind(C,name='DestroyCursor')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DestroyCursor
         integer(BOOL) DestroyCursor
         integer(HCURSOR),value :: hCursor_
      end function DestroyCursor
   end interface

   public LoadCursorFromFile
   interface
      function LoadCursorFromFile(lpFileName) &
         bind(C,name='LoadCursorFromFileA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LoadCursorFromFile
         integer(HCURSOR) LoadCursorFromFile
         character(kind=C_CHAR) lpFileName(*)
      end function LoadCursorFromFile
   end interface

   public CopyImage
   interface
      function CopyImage(hImage,uType,cxDesired,cyDesired, &
         fuFlags) bind(C,name='CopyImage')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CopyImage
         integer(HANDLE) CopyImage
         integer(HANDLE),value :: hImage
         integer(UINT),value :: uType
         integer(C_INT),value :: cxDesired
         integer(C_INT),value :: cyDesired
         integer(UINT),value :: fuFlags
      end function CopyImage
   end interface

   public DestroyIcon
   interface
      function DestroyIcon(hIcon_) bind(C,name='DestroyIcon')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DestroyIcon
         integer(BOOL) DestroyIcon
         integer(HICON),value :: hIcon_
      end function DestroyIcon
   end interface

   public CreateIconIndirect
   interface
      function CreateIconIndirect(piconinfo) bind(C,name='CreateIconIndirect')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateIconIndirect
         integer(HICON) CreateIconIndirect
         type(ICONINFO_T) piconinfo
      end function CreateIconIndirect
   end interface

   public CopyIcon
   interface
      function CopyIcon(hIcon_) bind(C,name='CopyIcon')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CopyIcon
         integer(HICON) CopyIcon
         integer(HICON),value :: hIcon_
      end function CopyIcon
   end interface

   public DrawIcon
   interface
      function DrawIcon(hDC_,X,Y,hIcon_) bind(C,name='DrawIcon')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DrawIcon
         integer(BOOL) DrawIcon
         integer(HDC),value :: hDC_
         integer(C_INT),value :: X
         integer(C_INT),value :: Y
         integer(HICON),value :: hIcon_
      end function DrawIcon
   end interface

   public GetSystemMetrics
   interface
      function GetSystemMetrics(nIndex) &
         bind(C,name='GetSystemMetrics')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetSystemMetrics
         integer(C_INT) GetSystemMetrics
         integer(C_INT),value :: nIndex
      end function GetSystemMetrics
   end interface

   public CreateIconFromResource
   interface
      function CreateIconFromResource(presbits,dwResSize, &
         fIcon,dwVer) bind(C,name='CreateIconFromResource')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateIconFromResource
         integer(HICON) CreateIconFromResource
         integer(BYTE) presbits(*)
         integer(DWORD),value :: dwResSize
         integer(BOOL),value :: fIcon
         integer(DWORD),value :: dwVer
      end function CreateIconFromResource
   end interface

   public DestroyMenu
   interface
      function DestroyMenu(hMenu_) bind(C,name='DestroyMenu')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DestroyMenu
         integer(BOOL) DestroyMenu
         integer(HMENU),value :: hMenu_
      end function DestroyMenu
   end interface

   public CreateMenu
   interface
      function CreateMenu() bind(C,name='CreateMenu')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: CreateMenu
         integer(HMENU) CreateMenu
      end function CreateMenu
   end interface

   public DeleteMenu
   interface
      function DeleteMenu(hMenu_,uPosition,uFlags) &
         bind(C,name='DeleteMenu')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DeleteMenu
         integer(BOOL) DeleteMenu
         integer(HMENU),value :: hMenu_
         integer(UINT),value :: uPosition
         integer(UINT),value :: uFlags
      end function DeleteMenu
   end interface

   public RemoveMenu
   interface
      function RemoveMenu(hMenu_,uPosition,uFlags) &
         bind(C,name='RemoveMenu')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: RemoveMenu
         integer(BOOL) RemoveMenu
         integer(HMENU),value :: hMenu_
         integer(UINT),value :: uPosition
         integer(UINT),value :: uFlags
      end function RemoveMenu
   end interface

   public SetMenuItemInfo
   interface
      function SetMenuItemInfo(hMenu_,uItem,fByPosition,lpmii) &
         bind(C,name='SetMenuItemInfoA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: SetMenuItemInfo
         integer(BOOL) SetMenuItemInfo
         integer(HMENU),value :: hMenu_
         integer(UINT),value :: uItem
         integer(BOOL),value :: fByPosition
         type(MENUITEMINFO_T) lpmii
      end function SetMenuItemInfo
   end interface

   public GetMenuItemInfo
   interface
      function GetMenuItemInfo(hMenu_,uItem,fByPosition,lpmii) &
         bind(C,name='GetMenuItemInfoA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GetMenuItemInfo
         integer(BOOL) GetMenuItemInfo
         integer(HMENU),value :: hMenu_
         integer(UINT),value :: uItem
         integer(BOOL),value :: fByPosition
         type(MENUITEMINFO_T) lpmii
      end function GetMenuItemInfo
   end interface

   public AdjustWindowRect
   interface
      function AdjustWindowRect(lpRect,dwStyle,bMenu) &
         bind(C,name='AdjustWindowRect')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: AdjustWindowRect
         integer(BOOL) AdjustWindowRect
         type(RECT_T) lpRect
         integer(DWORD),value :: dwStyle
         integer(BOOL),value :: bMenu
      end function AdjustWindowRect
   end interface
end module user32
