! wgl.f90
! Public domain 2010-2011 James Van Buskirk
! Compiled with:
! gfortran -Wall -c wgl.f90

module wgl
   use win32_types
   use ISO_C_BINDING
   implicit none
   private
   integer, parameter, public :: HGLRC = HANDLE

   integer, parameter, public :: WGL_SWAP_MAIN_PLANE = int(Z'00000001')
   integer, parameter, public :: WGL_SWAP_OVERLAY1 = int(Z'00000002')
   integer, parameter, public :: WGL_SWAP_OVERLAY2 = int(Z'00000004')
   integer, parameter, public :: WGL_SWAP_OVERLAY3 = int(Z'00000008')
   integer, parameter, public :: WGL_SWAP_OVERLAY4 = int(Z'00000010')
   integer, parameter, public :: WGL_SWAP_OVERLAY5 = int(Z'00000020')
   integer, parameter, public :: WGL_SWAP_OVERLAY6 = int(Z'00000040')
   integer, parameter, public :: WGL_SWAP_OVERLAY7 = int(Z'00000080')
   integer, parameter, public :: WGL_SWAP_OVERLAY8 = int(Z'00000100')
   integer, parameter, public :: WGL_SWAP_OVERLAY9 = int(Z'00000200')
   integer, parameter, public :: WGL_SWAP_OVERLAY10 = int(Z'00000400')
   integer, parameter, public :: WGL_SWAP_OVERLAY11 = int(Z'00000800')
   integer, parameter, public :: WGL_SWAP_OVERLAY12 = int(Z'00001000')
   integer, parameter, public :: WGL_SWAP_OVERLAY13 = int(Z'00002000')
   integer, parameter, public :: WGL_SWAP_OVERLAY14 = int(Z'00004000')
   integer, parameter, public :: WGL_SWAP_OVERLAY15 = int(Z'00008000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY1 = int(Z'00010000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY2 = int(Z'00020000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY3 = int(Z'00040000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY4 = int(Z'00080000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY5 = int(Z'00100000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY6 = int(Z'00200000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY7 = int(Z'00400000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY8 = int(Z'00800000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY9 = int(Z'01000000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY10 = int(Z'02000000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY11 = int(Z'04000000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY12 = int(Z'08000000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY13 = int(Z'10000000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY14 = int(Z'20000000')
   integer, parameter, public :: WGL_SWAP_UNDERLAY15 = int(Z'40000000')

! Documented in msdn
   public wglCopyContext
   interface
      function wglCopyContext(hglrcSrc,hglrcDst,mask) &
         bind(C,name='wglCopyContext')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglCopyContext
         integer(BOOL) wglCopyContext
         integer(HGLRC),value :: hglrcSrc
         integer(HGLRC),value :: hglrcDst
         integer(UINT),value :: mask
      end function wglCopyContext
   end interface

! Documented in msdn
   public wglCreateContext
   interface
      function wglCreateContext(hdc_) &
         bind(C,name='wglCreateContext')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglCreateContext
         integer(HGLRC) wglCreateContext
         integer(HDC),value :: hdc_
      end function wglCreateContext
   end interface

! Documented in msdn
   public wglCreateLayerContext
   interface
      function wglCreateLayerContext(hdc_,iLayerPlane) &
         bind(C,name='wglCreateLayerContext')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglCreateLayerContext
         integer(HGLRC) wglCreateLayerContext
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iLayerPlane
      end function wglCreateLayerContext
   end interface

! Documented in msdn
   public wglDeleteContext
   interface
      function wglDeleteContext(hglrc_) &
         bind(C,name='wglDeleteContext')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglDeleteContext
         integer(BOOL) wglDeleteContext
         integer(HGLRC),value :: hglrc_
      end function wglDeleteContext
   end interface

! Documented in msdn
   public wglDescribeLayerPlane
   interface
      function wglDescribeLayerPlane(hdc_,iPixelFormat,iLayerPlane,nBytes,plpd) &
         bind(C,name='wglDescribeLayerPlane')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglDescribeLayerPlane
         integer(BOOL) wglDescribeLayerPlane
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iPixelFormat
         integer(C_INT),value :: iLayerPlane
         integer(UINT),value :: nBytes
         type(LAYERPLANEDESCRIPTOR_T) plpd
      end function wglDescribeLayerPlane
   end interface

! Documented in msdn
   public wglGetCurrentContext
   interface
      function wglGetCurrentContext() &
         bind(C,name='wglGetCurrentContext')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglGetCurrentContext
         integer(HGLRC) wglGetCurrentContext
      end function wglGetCurrentContext
   end interface

! Documented in msdn
   public wglGetCurrentDC
   interface
      function wglGetCurrentDC() &
         bind(C,name='wglGetCurrentDC')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglGetCurrentDC
         integer(HDC) wglGetCurrentDC
      end function wglGetCurrentDC
   end interface

! Documented in msdn
   public wglGetLayerPaletteEntries
   interface
      function wglGetLayerPaletteEntries(hdc_,iLayerPlane,iStart,cEntries,pcr) &
         bind(C,name='wglGetLayerPaletteEntries')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglGetLayerPaletteEntries
         integer(C_INT) wglGetLayerPaletteEntries
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iLayerPlane
         integer(C_INT),value :: iStart
         integer(C_INT),value :: cEntries
         integer(COLORREF) pcr(*)
      end function wglGetLayerPaletteEntries
   end interface

! Documented in msdn
   public wglGetProcAddress
   interface
      function wglGetProcAddress(lpszProc) &
         bind(C,name='wglGetProcAddress')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglGetProcAddress
         type(C_FUNPTR) wglGetProcAddress
         character(kind=C_CHAR) lpszProc(*)
      end function wglGetProcAddress
   end interface

! Documented in msdn
   public wglMakeCurrent
   interface
      function wglMakeCurrent(hdc_,hglrc_) &
         bind(C,name='wglMakeCurrent')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglMakeCurrent
         integer(BOOL) wglMakeCurrent
         integer(HDC),value :: hdc_
         integer(HGLRC),value :: hglrc_
      end function wglMakeCurrent
   end interface

! Documented in msdn
   public wglRealizeLayerPalette
   interface
      function wglRealizeLayerPalette(hdc_,iLayerPlane,bRealize) &
         bind(C,name='wglRealizeLayerPalette')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglRealizeLayerPalette
         integer(BOOL) wglRealizeLayerPalette
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iLayerPlane
         integer(BOOL),value :: bRealize
      end function wglRealizeLayerPalette
   end interface

! Documented in msdn
   public wglSetLayerPaletteEntries
   interface
      function wglSetLayerPaletteEntries(hdc_,iLayerPlane,iStart,cEntries,pcr) &
         bind(C,name='wglSetLayerPaletteEntries')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglSetLayerPaletteEntries
         integer(C_INT) wglSetLayerPaletteEntries
         integer(HDC),value :: hdc_
         integer(C_INT),value :: iLayerPlane
         integer(C_INT),value :: iStart
         integer(C_INT),value :: cEntries
         integer(COLORREF),intent(in) :: pcr(*)
      end function wglSetLayerPaletteEntries
   end interface

! Documented in msdn
   public wglShareLists
   interface
      function wglShareLists(hglrc1,hglrc2) &
         bind(C,name='wglShareLists')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglShareLists
         integer(BOOL) wglShareLists
         integer(HGLRC),value :: hglrc1
         integer(HGLRC),value :: hglrc2
      end function wglShareLists
   end interface

! Documented in msdn
   public wglSwapLayerBuffers
   interface
      function wglSwapLayerBuffers(hdc_,fuPlanes) &
         bind(C,name='wglSwapLayerBuffers')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglSwapLayerBuffers
         integer(BOOL) wglSwapLayerBuffers
         integer(HDC),value :: hdc_
         integer(UINT),value :: fuPlanes
      end function wglSwapLayerBuffers
   end interface

! Documented in msdn
   public wglUseFontBitmaps
   interface
      function wglUseFontBitmaps(hdc_,first,count,listBase) &
         bind(C,name='wglUseFontBitmapsA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglUseFontBitmaps
         integer(BOOL) wglUseFontBitmaps
         integer(HDC),value :: hdc_
         integer(DWORD),value :: first
         integer(DWORD),value :: count
         integer(DWORD),value :: listBase
      end function wglUseFontBitmaps
   end interface

! Documented in msdn
   public wglUseFontOutlines
   interface
      function wglUseFontOutlines(hdc_,first,count,listBase,deviation,extrusion,format,lpgmf) &
         bind(C,name='wglUseFontOutlinesA')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: wglUseFontOutlines
         integer(BOOL) wglUseFontOutlines
         integer(HDC),value :: hdc_
         integer(DWORD),value :: first
         integer(DWORD),value :: count
         integer(DWORD),value :: listBase
         real(C_FLOAT),value :: deviation
         real(C_FLOAT),value :: extrusion
         integer(C_INT),value :: format
         type(GLYPHMETRICSFLOAT_T) lpgmf(*)
      end function wglUseFontOutlines
   end interface
end module wgl
