! Opengl32.f90
! Public domain 2010-2011 James Van Buskirk
! Compiled with:
! gfortran -Wall -fno-range-check -c Opengl32.f90

module glu_primitive
   use ISO_C_BINDING, only: GLUnurbs=>C_PTR, &
      GLUquadric=>C_PTR, GLUtesselator=>C_PTR, &
      GLUfuncptr=>C_FUNPTR
   implicit none
   private
   public GLUnurbs, GLUquadric, GLUtesselator, GLUfuncptr
end module glu_primitive

module opengl_types
   use ISO_C_BINDING
!   use glu_primitive ! Fails.  Workaround is next line:
   use glu_primitive, only: GLUnurbs, GLUquadric, &
      GLUtesselator, GLUfuncptr
   use glu_primitive, only: GLUnurbsObj=>GLUnurbs, &
      GLUquadricObj=>GLUquadric, GLUtesselatorObj=>GLUtesselator, &
      GLUtriangulatorObj=>GLUtesselator
   implicit none
   private
   public GLUnurbs, GLUquadric, GLUtesselator, GLUnurbsObj, &
      GLUquadricObj, GLUtesselatorObj, GLUtriangulatorObj, &
      GLUfuncptr

   integer, parameter, public :: GLenum = C_INT
   integer, parameter, public :: GLboolean = C_SIGNED_CHAR
   integer, parameter, public :: GLbitfield = C_INT
   integer, parameter, public :: GLbyte = C_SIGNED_CHAR
   integer, parameter, public :: GLshort = C_SHORT
   integer, parameter, public :: GLint = C_INT
   integer, parameter, public :: GLsizei = C_INT
   integer, parameter, public :: GLubyte = C_SIGNED_CHAR
   integer, parameter, public :: GLushort = C_SHORT
   integer, parameter, public :: GLuint = C_INT
   integer, parameter, public :: GLfloat = C_FLOAT
   integer, parameter, public :: GLclampf = C_FLOAT
   integer, parameter, public :: GLdouble = C_DOUBLE
   integer, parameter, public :: GLclampd = C_DOUBLE
!   integer, parameter, public :: GLvoid = C_INTPTR_T ! Maybe for void*
! GLvoid usually ends up being type(C_PTR)
   integer, parameter, public :: GL_VERSION_1_1 = 1

   integer(GLenum), parameter, public :: GL_ACCUM = int(Z'0100',GLenum)
   integer(GLenum), parameter, public :: GL_LOAD = int(Z'0101',GLenum)
   integer(GLenum), parameter, public :: GL_RETURN = int(Z'0102',GLenum)
   integer(GLenum), parameter, public :: GL_MULT = int(Z'0103',GLenum)
   integer(GLenum), parameter, public :: GL_ADD = int(Z'0104',GLenum)

   integer(GLenum), parameter, public :: GL_NEVER = int(Z'0200',GLenum)
   integer(GLenum), parameter, public :: GL_LESS = int(Z'0201',GLenum)
   integer(GLenum), parameter, public :: GL_EQUAL = int(Z'0202',GLenum)
   integer(GLenum), parameter, public :: GL_LEQUAL = int(Z'0203',GLenum)
   integer(GLenum), parameter, public :: GL_GREATER = int(Z'0204',GLenum)
   integer(GLenum), parameter, public :: GL_NOTEQUAL = int(Z'0205',GLenum)
   integer(GLenum), parameter, public :: GL_GEQUAL = int(Z'0206',GLenum)
   integer(GLenum), parameter, public :: GL_ALWAYS = int(Z'0207',GLenum)

   integer(GLbitfield), parameter, public :: GL_CURRENT_BIT = int(Z'00000001',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_POINT_BIT = int(Z'00000002',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_LINE_BIT = int(Z'00000004',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_POLYGON_BIT = int(Z'00000008',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_POLYGON_STIPPLE_BIT = int(Z'00000010',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_PIXEL_MODE_BIT = int(Z'00000020',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_LIGHTING_BIT = int(Z'00000040',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_FOG_BIT = int(Z'00000080',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_DEPTH_BUFFER_BIT = int(Z'00000100',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_ACCUM_BUFFER_BIT = int(Z'00000200',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_STENCIL_BUFFER_BIT = int(Z'00000400',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_VIEWPORT_BIT = int(Z'00000800',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_TRANSFORM_BIT = int(Z'00001000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_ENABLE_BIT = int(Z'00002000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_COLOR_BUFFER_BIT = int(Z'00004000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_HINT_BIT = int(Z'00008000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_EVAL_BIT = int(Z'00010000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_LIST_BIT = int(Z'00020000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_TEXTURE_BIT = int(Z'00040000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_SCISSOR_BIT = int(Z'00080000',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_ALL_ATTRIB_BITS = int(Z'000fffff',GLbitfield)

   integer(GLenum), parameter, public :: GL_POINTS = int(Z'0000',GLenum)
   integer(GLenum), parameter, public :: GL_LINES = int(Z'0001',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_LOOP = int(Z'0002',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_STRIP = int(Z'0003',GLenum)
   integer(GLenum), parameter, public :: GL_TRIANGLES = int(Z'0004',GLenum)
   integer(GLenum), parameter, public :: GL_TRIANGLE_STRIP = int(Z'0005',GLenum)
   integer(GLenum), parameter, public :: GL_TRIANGLE_FAN = int(Z'0006',GLenum)
   integer(GLenum), parameter, public :: GL_QUADS = int(Z'0007',GLenum)
   integer(GLenum), parameter, public :: GL_QUAD_STRIP = int(Z'0008',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON = int(Z'0009',GLenum)

   integer(GLenum), parameter, public :: GL_ZERO = 0_GLenum
   integer(GLenum), parameter, public :: GL_ONE = 1_GLenum
   integer(GLenum), parameter, public :: GL_SRC_COLOR = int(Z'0300',GLenum)
   integer(GLenum), parameter, public :: GL_ONE_MINUS_SRC_COLOR = int(Z'0301',GLenum)
   integer(GLenum), parameter, public :: GL_SRC_ALPHA = int(Z'0302',GLenum)
   integer(GLenum), parameter, public :: GL_ONE_MINUS_SRC_ALPHA = int(Z'0303',GLenum)
   integer(GLenum), parameter, public :: GL_DST_ALPHA = int(Z'0304',GLenum)
   integer(GLenum), parameter, public :: GL_ONE_MINUS_DST_ALPHA = int(Z'0305',GLenum)

   integer(GLenum), parameter, public :: GL_DST_COLOR = int(Z'0306',GLenum)
   integer(GLenum), parameter, public :: GL_ONE_MINUS_DST_COLOR = int(Z'0307',GLenum)
   integer(GLenum), parameter, public :: GL_SRC_ALPHA_SATURATE = int(Z'0308',GLenum)

   integer(GLboolean), parameter, public :: GL_TRUE = 1_GLboolean
   integer(GLboolean), parameter, public :: GL_FALSE = 0_GLboolean

   integer(GLenum), parameter, public :: GL_CLIP_PLANE0 = int(Z'3000',GLenum)
   integer(GLenum), parameter, public :: GL_CLIP_PLANE1 = int(Z'3001',GLenum)
   integer(GLenum), parameter, public :: GL_CLIP_PLANE2 = int(Z'3002',GLenum)
   integer(GLenum), parameter, public :: GL_CLIP_PLANE3 = int(Z'3003',GLenum)
   integer(GLenum), parameter, public :: GL_CLIP_PLANE4 = int(Z'3004',GLenum)
   integer(GLenum), parameter, public :: GL_CLIP_PLANE5 = int(Z'3005',GLenum)

   integer(GLenum), parameter, public :: GL_BYTE = int(Z'1400',GLenum)
   integer(GLenum), parameter, public :: GL_UNSIGNED_BYTE = int(Z'1401',GLenum)
   integer(GLenum), parameter, public :: GL_SHORT = int(Z'1402',GLenum)
   integer(GLenum), parameter, public :: GL_UNSIGNED_SHORT = int(Z'1403',GLenum)
   integer(GLenum), parameter, public :: GL_INT = int(Z'1404',GLenum)
   integer(GLenum), parameter, public :: GL_UNSIGNED_INT = int(Z'1405',GLenum)
   integer(GLenum), parameter, public :: GL_FLOAT = int(Z'1406',GLenum)
   integer(GLenum), parameter, public :: GL_2_BYTES = int(Z'1407',GLenum)
   integer(GLenum), parameter, public :: GL_3_BYTES = int(Z'1408',GLenum)
   integer(GLenum), parameter, public :: GL_4_BYTES = int(Z'1409',GLenum)
   integer(GLenum), parameter, public :: GL_DOUBLE = int(Z'140A',GLenum)

   integer(GLenum), parameter, public :: GL_NONE = 0_GLenum
   integer(GLenum), parameter, public :: GL_FRONT_LEFT = int(Z'0400',GLenum)
   integer(GLenum), parameter, public :: GL_FRONT_RIGHT = int(Z'0401',GLenum)
   integer(GLenum), parameter, public :: GL_BACK_LEFT = int(Z'0402',GLenum)
   integer(GLenum), parameter, public :: GL_BACK_RIGHT = int(Z'0403',GLenum)
   integer(GLenum), parameter, public :: GL_FRONT = int(Z'0404',GLenum)
   integer(GLenum), parameter, public :: GL_BACK = int(Z'0405',GLenum)
   integer(GLenum), parameter, public :: GL_LEFT = int(Z'0406',GLenum)
   integer(GLenum), parameter, public :: GL_RIGHT = int(Z'0407',GLenum)
   integer(GLenum), parameter, public :: GL_FRONT_AND_BACK = int(Z'0408',GLenum)
   integer(GLenum), parameter, public :: GL_AUX0 = int(Z'0409',GLenum)
   integer(GLenum), parameter, public :: GL_AUX1 = int(Z'040A',GLenum)
   integer(GLenum), parameter, public :: GL_AUX2 = int(Z'040B',GLenum)
   integer(GLenum), parameter, public :: GL_AUX3 = int(Z'040C',GLenum)

   integer(GLenum), parameter, public :: GL_NO_ERROR = 0_GLenum
   integer(GLenum), parameter, public :: GL_INVALID_ENUM = int(Z'0500',GLenum)
   integer(GLenum), parameter, public :: GL_INVALID_VALUE = int(Z'0501',GLenum)
   integer(GLenum), parameter, public :: GL_INVALID_OPERATION = int(Z'0502',GLenum)
   integer(GLenum), parameter, public :: GL_STACK_OVERFLOW = int(Z'0503',GLenum)
   integer(GLenum), parameter, public :: GL_STACK_UNDERFLOW = int(Z'0504',GLenum)
   integer(GLenum), parameter, public :: GL_OUT_OF_MEMORY = int(Z'0505',GLenum)

   integer(GLenum), parameter, public :: GL_2D = int(Z'0600',GLenum)
   integer(GLenum), parameter, public :: GL_3D = int(Z'0601',GLenum)
   integer(GLenum), parameter, public :: GL_3D_COLOR = int(Z'0602',GLenum)
   integer(GLenum), parameter, public :: GL_3D_COLOR_TEXTURE = int(Z'0603',GLenum)
   integer(GLenum), parameter, public :: GL_4D_COLOR_TEXTURE = int(Z'0604',GLenum)

   real, parameter, public :: GL_PASS_THROUGH_TOKEN = int(Z'0700')
   real, parameter, public :: GL_POINT_TOKEN = int(Z'0701')
   real, parameter, public :: GL_LINE_TOKEN = int(Z'0702')
   real, parameter, public :: GL_POLYGON_TOKEN = int(Z'0703')
   real, parameter, public :: GL_BITMAP_TOKEN = int(Z'0704')
   real, parameter, public :: GL_DRAW_PIXEL_TOKEN = int(Z'0705')
   real, parameter, public :: GL_COPY_PIXEL_TOKEN = int(Z'0706')
   real, parameter, public :: GL_LINE_RESET_TOKEN = int(Z'0707')

   real, parameter, public :: GL_EXP = int(Z'0800')
   real, parameter, public :: GL_EXP2 = int(Z'0801')

   integer(GLenum), parameter, public :: GL_CW = int(Z'0900',GLenum)
   integer(GLenum), parameter, public :: GL_CCW = int(Z'0901',GLenum)

   integer(GLenum), parameter, public :: GL_COEFF = int(Z'0A00',GLenum)
   integer(GLenum), parameter, public :: GL_ORDER = int(Z'0A01',GLenum)
   integer(GLenum), parameter, public :: GL_DOMAIN = int(Z'0A02',GLenum)

   integer(GLenum), parameter, public :: GL_CURRENT_COLOR = int(Z'0B00',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_INDEX = int(Z'0B01',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_NORMAL = int(Z'0B02',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_TEXTURE_COORDS = int(Z'0B03',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_RASTER_COLOR = int(Z'0B04',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_RASTER_INDEX = int(Z'0B05',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_RASTER_TEXTURE_COORDS = int(Z'0B06',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_RASTER_POSITION = int(Z'0B07',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_RASTER_POSITION_VALID = int(Z'0B08',GLenum)
   integer(GLenum), parameter, public :: GL_CURRENT_RASTER_DISTANCE = int(Z'0B09',GLenum)
   integer(GLenum), parameter, public :: GL_POINT_SMOOTH = int(Z'0B10',GLenum)
   integer(GLenum), parameter, public :: GL_POINT_SIZE = int(Z'0B11',GLenum)
   integer(GLenum), parameter, public :: GL_POINT_SIZE_RANGE = int(Z'0B12',GLenum)
   integer(GLenum), parameter, public :: GL_POINT_SIZE_GRANULARITY = int(Z'0B13',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_SMOOTH = int(Z'0B20',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_WIDTH = int(Z'0B21',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_WIDTH_RANGE = int(Z'0B22',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_WIDTH_GRANULARITY = int(Z'0B23',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_STIPPLE = int(Z'0B24',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_STIPPLE_PATTERN = int(Z'0B25',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_STIPPLE_REPEAT = int(Z'0B26',GLenum)
   integer(GLenum), parameter, public :: GL_LIST_MODE = int(Z'0B30',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_LIST_NESTING = int(Z'0B31',GLenum)
   integer(GLenum), parameter, public :: GL_LIST_BASE = int(Z'0B32',GLenum)
   integer(GLenum), parameter, public :: GL_LIST_INDEX = int(Z'0B33',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_MODE = int(Z'0B40',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_SMOOTH = int(Z'0B41',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_STIPPLE = int(Z'0B42',GLenum)
   integer(GLenum), parameter, public :: GL_EDGE_FLAG = int(Z'0B43',GLenum)
   integer(GLenum), parameter, public :: GL_CULL_FACE = int(Z'0B44',GLenum)
   integer(GLenum), parameter, public :: GL_CULL_FACE_MODE = int(Z'0B45',GLenum)
   integer(GLenum), parameter, public :: GL_FRONT_FACE = int(Z'0B46',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHTING = int(Z'0B50',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT_MODEL_LOCAL_VIEWER = int(Z'0B51',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT_MODEL_TWO_SIDE = int(Z'0B52',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT_MODEL_AMBIENT = int(Z'0B53',GLenum)
   integer(GLenum), parameter, public :: GL_SHADE_MODEL = int(Z'0B54',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_MATERIAL_FACE = int(Z'0B55',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_MATERIAL_PARAMETER = int(Z'0B56',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_MATERIAL = int(Z'0B57',GLenum)
   integer(GLenum), parameter, public :: GL_FOG = int(Z'0B60',GLenum)
   integer(GLenum), parameter, public :: GL_FOG_INDEX = int(Z'0B61',GLenum)
   integer(GLenum), parameter, public :: GL_FOG_DENSITY = int(Z'0B62',GLenum)
   integer(GLenum), parameter, public :: GL_FOG_START = int(Z'0B63',GLenum)
   integer(GLenum), parameter, public :: GL_FOG_END = int(Z'0B64',GLenum)
   integer(GLenum), parameter, public :: GL_FOG_MODE = int(Z'0B65',GLenum)
   integer(GLenum), parameter, public :: GL_FOG_COLOR = int(Z'0B66',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_RANGE = int(Z'0B70',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_TEST = int(Z'0B71',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_WRITEMASK = int(Z'0B72',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_CLEAR_VALUE = int(Z'0B73',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_FUNC = int(Z'0B74',GLenum)
   integer(GLenum), parameter, public :: GL_ACCUM_CLEAR_VALUE = int(Z'0B80',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_TEST = int(Z'0B90',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_CLEAR_VALUE = int(Z'0B91',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_FUNC = int(Z'0B92',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_VALUE_MASK = int(Z'0B93',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_FAIL = int(Z'0B94',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_PASS_DEPTH_FAIL = int(Z'0B95',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_PASS_DEPTH_PASS = int(Z'0B96',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_REF = int(Z'0B97',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_WRITEMASK = int(Z'0B98',GLenum)
   integer(GLenum), parameter, public :: GL_MATRIX_MODE = int(Z'0BA0',GLenum)
   integer(GLenum), parameter, public :: GL_NORMALIZE = int(Z'0BA1',GLenum)
   integer(GLenum), parameter, public :: GL_VIEWPORT = int(Z'0BA2',GLenum)
   integer(GLenum), parameter, public :: GL_MODELVIEW_STACK_DEPTH = int(Z'0BA3',GLenum)
   integer(GLenum), parameter, public :: GL_PROJECTION_STACK_DEPTH = int(Z'0BA4',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_STACK_DEPTH = int(Z'0BA5',GLenum)
   integer(GLenum), parameter, public :: GL_MODELVIEW_MATRIX = int(Z'0BA6',GLenum)
   integer(GLenum), parameter, public :: GL_PROJECTION_MATRIX = int(Z'0BA7',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_MATRIX = int(Z'0BA8',GLenum)
   integer(GLenum), parameter, public :: GL_ATTRIB_STACK_DEPTH = int(Z'0BB0',GLenum)
   integer(GLenum), parameter, public :: GL_CLIENT_ATTRIB_STACK_DEPTH = int(Z'0BB1',GLenum)
   integer(GLenum), parameter, public :: GL_ALPHA_TEST = int(Z'0BC0',GLenum)
   integer(GLenum), parameter, public :: GL_ALPHA_TEST_FUNC = int(Z'0BC1',GLenum)
   integer(GLenum), parameter, public :: GL_ALPHA_TEST_REF = int(Z'0BC2',GLenum)
   integer(GLenum), parameter, public :: GL_DITHER = int(Z'0BD0',GLenum)
   integer(GLenum), parameter, public :: GL_BLEND_DST = int(Z'0BE0',GLenum)
   integer(GLenum), parameter, public :: GL_BLEND_SRC = int(Z'0BE1',GLenum)
   integer(GLenum), parameter, public :: GL_BLEND = int(Z'0BE2',GLenum)
   integer(GLenum), parameter, public :: GL_LOGIC_OP_MODE = int(Z'0BF0',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_LOGIC_OP = int(Z'0BF1',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_LOGIC_OP = int(Z'0BF2',GLenum)
   integer(GLenum), parameter, public :: GL_AUX_BUFFERS = int(Z'0C00',GLenum)
   integer(GLenum), parameter, public :: GL_DRAW_BUFFER = int(Z'0C01',GLenum)
   integer(GLenum), parameter, public :: GL_READ_BUFFER = int(Z'0C02',GLenum)
   integer(GLenum), parameter, public :: GL_SCISSOR_BOX = int(Z'0C10',GLenum)
   integer(GLenum), parameter, public :: GL_SCISSOR_TEST = int(Z'0C11',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_CLEAR_VALUE = int(Z'0C20',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_WRITEMASK = int(Z'0C21',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_CLEAR_VALUE = int(Z'0C22',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_WRITEMASK = int(Z'0C23',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_MODE = int(Z'0C30',GLenum)
   integer(GLenum), parameter, public :: GL_RGBA_MODE = int(Z'0C31',GLenum)
   integer(GLenum), parameter, public :: GL_DOUBLEBUFFER = int(Z'0C32',GLenum)
   integer(GLenum), parameter, public :: GL_STEREO = int(Z'0C33',GLenum)
   integer(GLenum), parameter, public :: GL_RENDER_MODE = int(Z'0C40',GLenum)
   integer(GLenum), parameter, public :: GL_PERSPECTIVE_CORRECTION_HINT = int(Z'0C50',GLenum)
   integer(GLenum), parameter, public :: GL_POINT_SMOOTH_HINT = int(Z'0C51',GLenum)
   integer(GLenum), parameter, public :: GL_LINE_SMOOTH_HINT = int(Z'0C52',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_SMOOTH_HINT = int(Z'0C53',GLenum)
   integer(GLenum), parameter, public :: GL_FOG_HINT = int(Z'0C54',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_GEN_S = int(Z'0C60',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_GEN_T = int(Z'0C61',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_GEN_R = int(Z'0C62',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_GEN_Q = int(Z'0C63',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_I = int(Z'0C70',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_S_TO_S = int(Z'0C71',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_R = int(Z'0C72',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_G = int(Z'0C73',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_B = int(Z'0C74',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_A = int(Z'0C75',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_R_TO_R = int(Z'0C76',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_G_TO_G = int(Z'0C77',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_B_TO_B = int(Z'0C78',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_A_TO_A = int(Z'0C79',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_I_SIZE = int(Z'0CB0',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_S_TO_S_SIZE = int(Z'0CB1',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_R_SIZE = int(Z'0CB2',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_G_SIZE = int(Z'0CB3',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_B_SIZE = int(Z'0CB4',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_I_TO_A_SIZE = int(Z'0CB5',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_R_TO_R_SIZE = int(Z'0CB6',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_G_TO_G_SIZE = int(Z'0CB7',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_B_TO_B_SIZE = int(Z'0CB8',GLenum)
   integer(GLenum), parameter, public :: GL_PIXEL_MAP_A_TO_A_SIZE = int(Z'0CB9',GLenum)
   integer(GLenum), parameter, public :: GL_UNPACK_SWAP_BYTES = int(Z'0CF0',GLenum)
   integer(GLenum), parameter, public :: GL_UNPACK_LSB_FIRST = int(Z'0CF1',GLenum)
   integer(GLenum), parameter, public :: GL_UNPACK_ROW_LENGTH = int(Z'0CF2',GLenum)
   integer(GLenum), parameter, public :: GL_UNPACK_SKIP_ROWS = int(Z'0CF3',GLenum)
   integer(GLenum), parameter, public :: GL_UNPACK_SKIP_PIXELS = int(Z'0CF4',GLenum)
   integer(GLenum), parameter, public :: GL_UNPACK_ALIGNMENT = int(Z'0CF5',GLenum)
   integer(GLenum), parameter, public :: GL_PACK_SWAP_BYTES = int(Z'0D00',GLenum)
   integer(GLenum), parameter, public :: GL_PACK_LSB_FIRST = int(Z'0D01',GLenum)
   integer(GLenum), parameter, public :: GL_PACK_ROW_LENGTH = int(Z'0D02',GLenum)
   integer(GLenum), parameter, public :: GL_PACK_SKIP_ROWS = int(Z'0D03',GLenum)
   integer(GLenum), parameter, public :: GL_PACK_SKIP_PIXELS = int(Z'0D04',GLenum)
   integer(GLenum), parameter, public :: GL_PACK_ALIGNMENT = int(Z'0D05',GLenum)
   integer(GLenum), parameter, public :: GL_MAP_COLOR = int(Z'0D10',GLenum)
   integer(GLenum), parameter, public :: GL_MAP_STENCIL = int(Z'0D11',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_SHIFT = int(Z'0D12',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_OFFSET = int(Z'0D13',GLenum)
   integer(GLenum), parameter, public :: GL_RED_SCALE = int(Z'0D14',GLenum)
   integer(GLenum), parameter, public :: GL_RED_BIAS = int(Z'0D15',GLenum)
   integer(GLenum), parameter, public :: GL_ZOOM_X = int(Z'0D16',GLenum)
   integer(GLenum), parameter, public :: GL_ZOOM_Y = int(Z'0D17',GLenum)
   integer(GLenum), parameter, public :: GL_GREEN_SCALE = int(Z'0D18',GLenum)
   integer(GLenum), parameter, public :: GL_GREEN_BIAS = int(Z'0D19',GLenum)
   integer(GLenum), parameter, public :: GL_BLUE_SCALE = int(Z'0D1A',GLenum)
   integer(GLenum), parameter, public :: GL_BLUE_BIAS = int(Z'0D1B',GLenum)
   integer(GLenum), parameter, public :: GL_ALPHA_SCALE = int(Z'0D1C',GLenum)
   integer(GLenum), parameter, public :: GL_ALPHA_BIAS = int(Z'0D1D',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_SCALE = int(Z'0D1E',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_BIAS = int(Z'0D1F',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_EVAL_ORDER = int(Z'0D30',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_LIGHTS = int(Z'0D31',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_CLIP_PLANES = int(Z'0D32',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_TEXTURE_SIZE = int(Z'0D33',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_PIXEL_MAP_TABLE = int(Z'0D34',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_ATTRIB_STACK_DEPTH = int(Z'0D35',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_MODELVIEW_STACK_DEPTH = int(Z'0D36',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_NAME_STACK_DEPTH = int(Z'0D37',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_PROJECTION_STACK_DEPTH = int(Z'0D38',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_TEXTURE_STACK_DEPTH = int(Z'0D39',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_VIEWPORT_DIMS = int(Z'0D3A',GLenum)
   integer(GLenum), parameter, public :: GL_MAX_CLIENT_ATTRIB_STACK_DEPTH = int(Z'0D3B',GLenum)
   integer(GLenum), parameter, public :: GL_SUBPIXEL_BITS = int(Z'0D50',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_BITS = int(Z'0D51',GLenum)
   integer(GLenum), parameter, public :: GL_RED_BITS = int(Z'0D52',GLenum)
   integer(GLenum), parameter, public :: GL_GREEN_BITS = int(Z'0D53',GLenum)
   integer(GLenum), parameter, public :: GL_BLUE_BITS = int(Z'0D54',GLenum)
   integer(GLenum), parameter, public :: GL_ALPHA_BITS = int(Z'0D55',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_BITS = int(Z'0D56',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_BITS = int(Z'0D57',GLenum)
   integer(GLenum), parameter, public :: GL_ACCUM_RED_BITS = int(Z'0D58',GLenum)
   integer(GLenum), parameter, public :: GL_ACCUM_GREEN_BITS = int(Z'0D59',GLenum)
   integer(GLenum), parameter, public :: GL_ACCUM_BLUE_BITS = int(Z'0D5A',GLenum)
   integer(GLenum), parameter, public :: GL_ACCUM_ALPHA_BITS = int(Z'0D5B',GLenum)
   integer(GLenum), parameter, public :: GL_NAME_STACK_DEPTH = int(Z'0D70',GLenum)
   integer(GLenum), parameter, public :: GL_AUTO_NORMAL = int(Z'0D80',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_COLOR_4 = int(Z'0D90',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_INDEX = int(Z'0D91',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_NORMAL = int(Z'0D92',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_TEXTURE_COORD_1 = int(Z'0D93',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_TEXTURE_COORD_2 = int(Z'0D94',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_TEXTURE_COORD_3 = int(Z'0D95',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_TEXTURE_COORD_4 = int(Z'0D96',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_VERTEX_3 = int(Z'0D97',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_VERTEX_4 = int(Z'0D98',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_COLOR_4 = int(Z'0DB0',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_INDEX = int(Z'0DB1',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_NORMAL = int(Z'0DB2',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_TEXTURE_COORD_1 = int(Z'0DB3',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_TEXTURE_COORD_2 = int(Z'0DB4',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_TEXTURE_COORD_3 = int(Z'0DB5',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_TEXTURE_COORD_4 = int(Z'0DB6',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_VERTEX_3 = int(Z'0DB7',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_VERTEX_4 = int(Z'0DB8',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_GRID_DOMAIN = int(Z'0DD0',GLenum)
   integer(GLenum), parameter, public :: GL_MAP1_GRID_SEGMENTS = int(Z'0DD1',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_GRID_DOMAIN = int(Z'0DD2',GLenum)
   integer(GLenum), parameter, public :: GL_MAP2_GRID_SEGMENTS = int(Z'0DD3',GLenum)
   integer(Glenum), parameter, public :: GL_TEXTURE_1D = int(Z'0DE0',GLenum)
   integer(Glenum), parameter, public :: GL_TEXTURE_2D = int(Z'0DE1',GLenum)
   integer(GLenum), parameter, public :: GL_FEEDBACK_BUFFER_POINTER = int(Z'0DF0',GLenum)
   integer(GLenum), parameter, public :: GL_FEEDBACK_BUFFER_SIZE = int(Z'0DF1',GLenum)
   integer(GLenum), parameter, public :: GL_FEEDBACK_BUFFER_TYPE = int(Z'0DF2',GLenum)
   integer(GLenum), parameter, public :: GL_SELECTION_BUFFER_POINTER = int(Z'0DF3',GLenum)
   integer(GLenum), parameter, public :: GL_SELECTION_BUFFER_SIZE = int(Z'0DF4',GLenum)

   integer(Glenum), parameter, public :: GL_TEXTURE_WIDTH = int(Z'1000',GLenum)
   integer(Glenum), parameter, public :: GL_TEXTURE_HEIGHT = int(Z'1001',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_INTERNAL_FORMAT = int(Z'1003',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_BORDER_COLOR = int(Z'1004',GLenum)
   integer(Glenum), parameter, public :: GL_TEXTURE_BORDER = int(Z'1005',GLenum)

   integer(Glenum), parameter, public :: GL_DONT_CARE = int(Z'1100',GLenum)
   integer(Glenum), parameter, public :: GL_FASTEST = int(Z'1101',GLenum)
   integer(Glenum), parameter, public :: GL_NICEST = int(Z'1102',GLenum)

   integer(GLenum), parameter, public :: GL_LIGHT0 = int(Z'4000',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT1 = int(Z'4001',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT2 = int(Z'4002',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT3 = int(Z'4003',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT4 = int(Z'4004',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT5 = int(Z'4005',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT6 = int(Z'4006',GLenum)
   integer(GLenum), parameter, public :: GL_LIGHT7 = int(Z'4007',GLenum)

   integer(GLenum), parameter, public :: GL_AMBIENT = int(Z'1200',GLenum)
   integer(GLenum), parameter, public :: GL_DIFFUSE = int(Z'1201',GLenum)
   integer(GLenum), parameter, public :: GL_SPECULAR = int(Z'1202',GLenum)
   integer(GLenum), parameter, public :: GL_POSITION = int(Z'1203',GLenum)
   integer(GLenum), parameter, public :: GL_SPOT_DIRECTION = int(Z'1204',GLenum)
   integer(GLenum), parameter, public :: GL_SPOT_EXPONENT = int(Z'1205',GLenum)
   integer(GLenum), parameter, public :: GL_SPOT_CUTOFF = int(Z'1206',GLenum)
   integer(GLenum), parameter, public :: GL_CONSTANT_ATTENUATION = int(Z'1207',GLenum)
   integer(GLenum), parameter, public :: GL_LINEAR_ATTENUATION = int(Z'1208',GLenum)
   integer(GLenum), parameter, public :: GL_QUADRATIC_ATTENUATION = int(Z'1209',GLenum)

   integer(GLenum), parameter, public :: GL_COMPILE = int(Z'1300',GLenum)
   integer(GLenum), parameter, public :: GL_COMPILE_AND_EXECUTE = int(Z'1301',GLenum)

   integer(GLenum), parameter, public :: GL_CLEAR = int(Z'1500',GLenum)
   integer(GLenum), parameter, public :: GL_AND = int(Z'1501',GLenum)
   integer(GLenum), parameter, public :: GL_AND_REVERSE = int(Z'1502',GLenum)
   integer(GLenum), parameter, public :: GL_COPY = int(Z'1503',GLenum)
   integer(GLenum), parameter, public :: GL_AND_INVERTED = int(Z'1504',GLenum)
   integer(GLenum), parameter, public :: GL_NOOP = int(Z'1505',GLenum)
   integer(GLenum), parameter, public :: GL_XOR = int(Z'1506',GLenum)
   integer(GLenum), parameter, public :: GL_OR = int(Z'1507',GLenum)
   integer(GLenum), parameter, public :: GL_NOR = int(Z'1508',GLenum)
   integer(GLenum), parameter, public :: GL_EQUIV = int(Z'1509',GLenum)
   integer(GLenum), parameter, public :: GL_INVERT = int(Z'150A',GLenum)
   integer(GLenum), parameter, public :: GL_OR_REVERSE = int(Z'150B',GLenum)
   integer(GLenum), parameter, public :: GL_COPY_INVERTED = int(Z'150C',GLenum)
   integer(GLenum), parameter, public :: GL_OR_INVERTED = int(Z'150D',GLenum)
   integer(GLenum), parameter, public :: GL_NAND = int(Z'150E',GLenum)
   integer(GLenum), parameter, public :: GL_SET = int(Z'150F',GLenum)

   integer(GLenum), parameter, public :: GL_EMISSION = int(Z'1600',GLenum)
   integer(GLenum), parameter, public :: GL_SHININESS = int(Z'1601',GLenum)
   integer(GLenum), parameter, public :: GL_AMBIENT_AND_DIFFUSE = int(Z'1602',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_INDEXES = int(Z'1603',GLenum)

   integer(GLenum), parameter, public :: GL_MODELVIEW = int(Z'1700',GLenum)
   integer(GLenum), parameter, public :: GL_PROJECTION = int(Z'1701',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE = int(Z'1702',GLenum)

   integer(GLenum), parameter, public :: GL_COLOR = int(Z'1800',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH = int(Z'1801',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL = int(Z'1802',GLenum)

   integer(GLenum), parameter, public :: GL_COLOR_INDEX = int(Z'1900',GLenum)
   integer(GLenum), parameter, public :: GL_STENCIL_INDEX = int(Z'1901',GLenum)
   integer(GLenum), parameter, public :: GL_DEPTH_COMPONENT = int(Z'1902',GLenum)
   integer(GLenum), parameter, public :: GL_RED = int(Z'1903',GLenum)
   integer(GLenum), parameter, public :: GL_GREEN = int(Z'1904',GLenum)
   integer(GLenum), parameter, public :: GL_BLUE = int(Z'1905',GLenum)
   integer(GLenum), parameter, public :: GL_ALPHA = int(Z'1906',GLenum)
   integer(GLenum), parameter, public :: GL_RGB = int(Z'1907',GLenum)
   integer(GLenum), parameter, public :: GL_RGBA = int(Z'1908',GLenum)
   integer(GLenum), parameter, public :: GL_LUMINANCE = int(Z'1909',GLenum)
   integer(GLenum), parameter, public :: GL_LUMINANCE_ALPHA = int(Z'190A',GLenum)

   integer(GLenum), parameter, public :: GL_BITMAP = int(Z'1A00',GLenum)

   integer(GLenum), parameter, public :: GL_POINT = int(Z'1B00',GLenum)
   integer(GLenum), parameter, public :: GL_LINE = int(Z'1B01',GLenum)
   integer(GLenum), parameter, public :: GL_FILL = int(Z'1B02',GLenum)

   integer(GLenum), parameter, public :: GL_RENDER = int(Z'1C00',GLenum)
   integer(GLenum), parameter, public :: GL_FEEDBACK = int(Z'1C01',GLenum)
   integer(GLenum), parameter, public :: GL_SELECT = int(Z'1C02',GLenum)

   integer(GLenum), parameter, public :: GL_FLAT = int(Z'1D00',Glenum)
   integer(GLenum), parameter, public :: GL_SMOOTH = int(Z'1D01',GLenum)

   integer(GLenum), parameter, public :: GL_KEEP = int(Z'1E00',GLenum)
   integer(GLenum), parameter, public :: GL_REPLACE = int(Z'1E01',GLenum)
   integer(GLenum), parameter, public :: GL_INCR = int(Z'1E02',GLenum)
   integer(GLenum), parameter, public :: GL_DECR = int(Z'1E03',GLenum)

   integer(GLenum), parameter, public :: GL_VENDOR = int(Z'1F00',GLenum)
   integer(GLenum), parameter, public :: GL_RENDERER = int(Z'1F01',GLenum)
   integer(GLenum), parameter, public :: GL_VERSION = int(Z'1F02',GLenum)
   integer(GLenum), parameter, public :: GL_EXTENSIONS = int(Z'1F03',GLenum)

   integer(GLenum), parameter, public :: GL_S = int(Z'2000',GLenum)
   integer(GLenum), parameter, public :: GL_T = int(Z'2001',GLenum)
   integer(GLenum), parameter, public :: GL_R = int(Z'2002',GLenum)
   integer(GLenum), parameter, public :: GL_Q = int(Z'2003',GLenum)

   integer(GLenum), parameter, public :: GL_MODULATE = int(Z'2100',GLenum)
   integer(GLenum), parameter, public :: GL_DECAL = int(Z'2101',GLenum)

   integer(GLenum), parameter, public :: GL_TEXTURE_ENV_MODE = int(Z'2200',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_ENV_COLOR = int(Z'2201',GLenum)

   integer(GLenum), parameter, public :: GL_TEXTURE_ENV = int(Z'2300',GLenum)

   integer(GLint), parameter, public :: GL_EYE_LINEAR = int(Z'2400',GLint)
   integer(GLint), parameter, public :: GL_OBJECT_LINEAR = int(Z'2401',GLint)
   integer(GLint), parameter, public :: GL_SPHERE_MAP = int(Z'2402',GLint)

   integer(GLenum), parameter, public :: GL_TEXTURE_GEN_MODE = int(Z'2500',GLenum)
   integer(GLenum), parameter, public :: GL_OBJECT_PLANE = int(Z'2501',GLenum)
   integer(GLenum), parameter, public :: GL_EYE_PLANE = int(Z'2502',GLenum)

   integer(GLenum), parameter, public :: GL_NEAREST = int(Z'2600',GLenum)
   integer(GLenum), parameter, public :: GL_LINEAR = int(Z'2601',GLenum)

   integer(GLenum), parameter, public :: GL_NEAREST_MIPMAP_NEAREST = int(Z'2700',GLenum)
   integer(GLenum), parameter, public :: GL_LINEAR_MIPMAP_NEAREST = int(Z'2701',GLenum)
   integer(GLenum), parameter, public :: GL_NEAREST_MIPMAP_LINEAR = int(Z'2702',GLenum)
   integer(GLenum), parameter, public :: GL_LINEAR_MIPMAP_LINEAR = int(Z'2703',GLenum)

   integer(GLenum), parameter, public :: GL_TEXTURE_MAG_FILTER = int(Z'2800',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_MIN_FILTER = int(Z'2801',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_WRAP_S = int(Z'2802',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_WRAP_T = int(Z'2803',GLenum)

   integer, parameter, public :: GL_CLAMP = int(Z'2900')
   integer, parameter, public :: GL_REPEAT = int(Z'2901')

   integer(GLbitfield), parameter, public :: GL_CLIENT_PIXEL_STORE_BIT = int(Z'00000001',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_CLIENT_VERTEX_ARRAY_BIT = int(Z'00000002',GLbitfield)
   integer(GLbitfield), parameter, public :: GL_CLIENT_ALL_ATTRIB_BITS = int(Z'ffffffff',GLbitfield)

   integer(GLenum), parameter, public :: GL_POLYGON_OFFSET_FACTOR = int(Z'8038',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_OFFSET_UNITS = int(Z'2A00',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_OFFSET_POINT = int(Z'2A01',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_OFFSET_LINE = int(Z'2A02',GLenum)
   integer(GLenum), parameter, public :: GL_POLYGON_OFFSET_FILL = int(Z'8037',GLenum)

   integer, parameter, public :: GL_ALPHA4 = int(Z'803B')
   integer, parameter, public :: GL_ALPHA8 = int(Z'803C')
   integer, parameter, public :: GL_ALPHA12 = int(Z'803D')
   integer, parameter, public :: GL_ALPHA16 = int(Z'803E')
   integer, parameter, public :: GL_LUMINANCE4 = int(Z'803F')
   integer, parameter, public :: GL_LUMINANCE8 = int(Z'8040')
   integer, parameter, public :: GL_LUMINANCE12 = int(Z'8041')
   integer, parameter, public :: GL_LUMINANCE16 = int(Z'8042')
   integer, parameter, public :: GL_LUMINANCE4_ALPHA4 = int(Z'8043')
   integer, parameter, public :: GL_LUMINANCE6_ALPHA2 = int(Z'8044')
   integer, parameter, public :: GL_LUMINANCE8_ALPHA8 = int(Z'8045')
   integer, parameter, public :: GL_LUMINANCE12_ALPHA4 = int(Z'8046')
   integer, parameter, public :: GL_LUMINANCE12_ALPHA12 = int(Z'8047')
   integer, parameter, public :: GL_LUMINANCE16_ALPHA16 = int(Z'8048')
   integer, parameter, public :: GL_INTENSITY = int(Z'8049')
   integer, parameter, public :: GL_INTENSITY4 = int(Z'804A')
   integer, parameter, public :: GL_INTENSITY8 = int(Z'804B')
   integer, parameter, public :: GL_INTENSITY12 = int(Z'804C')
   integer, parameter, public :: GL_INTENSITY16 = int(Z'804D')
   integer, parameter, public :: GL_R3_G3_B2 = int(Z'2A10')
   integer, parameter, public :: GL_RGB4 = int(Z'804F')
   integer, parameter, public :: GL_RGB5 = int(Z'8050')
   integer, parameter, public :: GL_RGB8 = int(Z'8051')
   integer, parameter, public :: GL_RGB10 = int(Z'8052')
   integer, parameter, public :: GL_RGB12 = int(Z'8053')
   integer, parameter, public :: GL_RGB16 = int(Z'8054')
   integer, parameter, public :: GL_RGBA2 = int(Z'8055')
   integer, parameter, public :: GL_RGBA4 = int(Z'8056')
   integer, parameter, public :: GL_RGB5_A1 = int(Z'8057')
   integer, parameter, public :: GL_RGBA8 = int(Z'8058')
   integer, parameter, public :: GL_RGB10_A2 = int(Z'8059')
   integer, parameter, public :: GL_RGBA12 = int(Z'805A')
   integer, parameter, public :: GL_RGBA16 = int(Z'805B')
   integer, parameter, public :: GL_TEXTURE_RED_SIZE = int(Z'805C')
   integer, parameter, public :: GL_TEXTURE_GREEN_SIZE = int(Z'805D')
   integer, parameter, public :: GL_TEXTURE_BLUE_SIZE = int(Z'805E')
   integer, parameter, public :: GL_TEXTURE_ALPHA_SIZE = int(Z'805F')
   integer, parameter, public :: GL_TEXTURE_LUMINANCE_SIZE = int(Z'8060')
   integer, parameter, public :: GL_TEXTURE_INTENSITY_SIZE = int(Z'8061')
   integer, parameter, public :: GL_PROXY_TEXTURE_1D = int(Z'8063')
   integer, parameter, public :: GL_PROXY_TEXTURE_2D = int(Z'8064')

   integer, parameter, public :: GL_TEXTURE_PRIORITY = int(Z'8066')
   integer, parameter, public :: GL_TEXTURE_RESIDENT = int(Z'8067')
   integer, parameter, public :: GL_TEXTURE_BINDING_1D = int(Z'8068')
   integer, parameter, public :: GL_TEXTURE_BINDING_2D = int(Z'8069')

   integer, parameter, public :: GL_VERTEX_ARRAY = int(Z'8074')
   integer, parameter, public :: GL_NORMAL_ARRAY = int(Z'8075')
   integer(GLenum), parameter, public :: GL_COLOR_ARRAY = int(Z'8076',GLenum)
   integer, parameter, public :: GL_INDEX_ARRAY = int(Z'8077')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY = int(Z'8078')
   integer, parameter, public :: GL_EDGE_FLAG_ARRAY = int(Z'8079')
   integer, parameter, public :: GL_VERTEX_ARRAY_SIZE = int(Z'807A')
   integer, parameter, public :: GL_VERTEX_ARRAY_TYPE = int(Z'807B')
   integer, parameter, public :: GL_VERTEX_ARRAY_STRIDE = int(Z'807C')
   integer, parameter, public :: GL_NORMAL_ARRAY_TYPE = int(Z'807E')
   integer, parameter, public :: GL_NORMAL_ARRAY_STRIDE = int(Z'807F')
   integer(GLenum), parameter, public :: GL_COLOR_ARRAY_SIZE = int(Z'8081',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_ARRAY_TYPE = int(Z'8082',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_ARRAY_STRIDE = int(Z'8083',GLenum)
   integer, parameter, public :: GL_INDEX_ARRAY_TYPE = int(Z'8085')
   integer, parameter, public :: GL_INDEX_ARRAY_STRIDE = int(Z'8086')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_SIZE = int(Z'8088')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_TYPE = int(Z'8089')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_STRIDE = int(Z'808A')
   integer, parameter, public :: GL_EDGE_FLAG_ARRAY_STRIDE = int(Z'808C')
   integer(GLenum), parameter, public :: GL_VERTEX_ARRAY_POINTER = int(Z'808E',GLenum)
   integer(GLenum), parameter, public :: GL_NORMAL_ARRAY_POINTER = int(Z'808F',GLenum)
   integer(GLenum), parameter, public :: GL_COLOR_ARRAY_POINTER = int(Z'8090',GLenum)
   integer(GLenum), parameter, public :: GL_INDEX_ARRAY_POINTER = int(Z'8091',GLenum)
   integer(GLenum), parameter, public :: GL_TEXTURE_COORD_ARRAY_POINTER = int(Z'8092',GLenum)
   integer(GLenum), parameter, public :: GL_EDGE_FLAG_ARRAY_POINTER = int(Z'8093',GLenum)
   integer, parameter, public :: GL_V2F = int(Z'2A20')
   integer, parameter, public :: GL_V3F = int(Z'2A21')
   integer, parameter, public :: GL_C4UB_V2F = int(Z'2A22')
   integer, parameter, public :: GL_C4UB_V3F = int(Z'2A23')
   integer, parameter, public :: GL_C3F_V3F = int(Z'2A24')
   integer, parameter, public :: GL_N3F_V3F = int(Z'2A25')
   integer, parameter, public :: GL_C4F_N3F_V3F = int(Z'2A26')
   integer, parameter, public :: GL_T2F_V3F = int(Z'2A27')
   integer, parameter, public :: GL_T4F_V4F = int(Z'2A28')
   integer, parameter, public :: GL_T2F_C4UB_V3F = int(Z'2A29')
   integer, parameter, public :: GL_T2F_C3F_V3F = int(Z'2A2A')
   integer, parameter, public :: GL_T2F_N3F_V3F = int(Z'2A2B')
   integer, parameter, public :: GL_T2F_C4F_N3F_V3F = int(Z'2A2C')
   integer, parameter, public :: GL_T4F_C4F_N3F_V4F = int(Z'2A2D')

!   integer, parameter, public :: GL_EXT_vertex_array = 1
!   integer, parameter, public :: GL_EXT_bgra = 1
!   integer, parameter, public :: GL_EXT_paletted_texture = 1
   integer, parameter, public :: GL_WIN_swap_hint = 1
   integer, parameter, public :: GL_WIN_draw_range_elements = 1

   integer, parameter, public :: GL_VERTEX_ARRAY_EXT = int(Z'8074')
   integer, parameter, public :: GL_NORMAL_ARRAY_EXT = int(Z'8075')
   integer, parameter, public :: GL_COLOR_ARRAY_EXT = int(Z'8076')
   integer, parameter, public :: GL_INDEX_ARRAY_EXT = int(Z'8077')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_EXT = int(Z'8078')
   integer, parameter, public :: GL_EDGE_FLAG_ARRAY_EXT = int(Z'8079')
   integer, parameter, public :: GL_VERTEX_ARRAY_SIZE_EXT = int(Z'807A')
   integer, parameter, public :: GL_VERTEX_ARRAY_TYPE_EXT = int(Z'807B')
   integer, parameter, public :: GL_VERTEX_ARRAY_STRIDE_EXT = int(Z'807C')
   integer, parameter, public :: GL_VERTEX_ARRAY_COUNT_EXT = int(Z'807D')
   integer, parameter, public :: GL_NORMAL_ARRAY_TYPE_EXT = int(Z'807E')
   integer, parameter, public :: GL_NORMAL_ARRAY_STRIDE_EXT = int(Z'807F')
   integer, parameter, public :: GL_NORMAL_ARRAY_COUNT_EXT = int(Z'8080')
   integer, parameter, public :: GL_COLOR_ARRAY_SIZE_EXT = int(Z'8081')
   integer, parameter, public :: GL_COLOR_ARRAY_TYPE_EXT = int(Z'8082')
   integer, parameter, public :: GL_COLOR_ARRAY_STRIDE_EXT = int(Z'8083')
   integer, parameter, public :: GL_COLOR_ARRAY_COUNT_EXT = int(Z'8084')
   integer, parameter, public :: GL_INDEX_ARRAY_TYPE_EXT = int(Z'8085')
   integer, parameter, public :: GL_INDEX_ARRAY_STRIDE_EXT = int(Z'8086')
   integer, parameter, public :: GL_INDEX_ARRAY_COUNT_EXT = int(Z'8087')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_SIZE_EXT = int(Z'8088')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_TYPE_EXT = int(Z'8089')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_STRIDE_EXT = int(Z'808A')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_COUNT_EXT = int(Z'808B')
   integer, parameter, public :: GL_EDGE_FLAG_ARRAY_STRIDE_EXT = int(Z'808C')
   integer, parameter, public :: GL_EDGE_FLAG_ARRAY_COUNT_EXT = int(Z'808D')
   integer, parameter, public :: GL_VERTEX_ARRAY_POINTER_EXT = int(Z'808E')
   integer, parameter, public :: GL_NORMAL_ARRAY_POINTER_EXT = int(Z'808F')
   integer, parameter, public :: GL_COLOR_ARRAY_POINTER_EXT = int(Z'8090')
   integer, parameter, public :: GL_INDEX_ARRAY_POINTER_EXT = int(Z'8091')
   integer, parameter, public :: GL_TEXTURE_COORD_ARRAY_POINTER_EXT = int(Z'8092')
   integer, parameter, public :: GL_EDGE_FLAG_ARRAY_POINTER_EXT = int(Z'8093')
   integer, parameter, public :: GL_DOUBLE_EXT = GL_DOUBLE

   integer, parameter, public :: GL_BGR_EXT = int(Z'80E0')
   integer, parameter, public :: GL_BGRA_EXT = int(Z'80E1')

   integer, parameter, public :: GL_COLOR_TABLE_FORMAT_EXT = int(Z'80D8')
   integer, parameter, public :: GL_COLOR_TABLE_WIDTH_EXT = int(Z'80D9')
   integer, parameter, public :: GL_COLOR_TABLE_RED_SIZE_EXT = int(Z'80DA')
   integer, parameter, public :: GL_COLOR_TABLE_GREEN_SIZE_EXT = int(Z'80DB')
   integer, parameter, public :: GL_COLOR_TABLE_BLUE_SIZE_EXT = int(Z'80DC')
   integer, parameter, public :: GL_COLOR_TABLE_ALPHA_SIZE_EXT = int(Z'80DD')
   integer, parameter, public :: GL_COLOR_TABLE_LUMINANCE_SIZE_EXT = int(Z'80DE')
   integer, parameter, public :: GL_COLOR_TABLE_INTENSITY_SIZE_EXT = int(Z'80DF')

   integer, parameter, public :: GL_COLOR_INDEX1_EXT = int(Z'80E2')
   integer, parameter, public :: GL_COLOR_INDEX2_EXT = int(Z'80E3')
   integer, parameter, public :: GL_COLOR_INDEX4_EXT = int(Z'80E4')
   integer, parameter, public :: GL_COLOR_INDEX8_EXT = int(Z'80E5')
   integer, parameter, public :: GL_COLOR_INDEX12_EXT = int(Z'80E6')
   integer, parameter, public :: GL_COLOR_INDEX16_EXT = int(Z'80E7')

   integer, parameter, public :: GL_MAX_ELEMENTS_VERTICES_WIN = int(Z'80E8')
   integer, parameter, public :: GL_MAX_ELEMENTS_INDICES_WIN = int(Z'80E9')

   integer, parameter, public :: GL_PHONG_WIN = int(Z'80EA')
   integer, parameter, public :: GL_PHONG_HINT_WIN = int(Z'80EB')

   integer, parameter, public :: GL_FOG_SPECULAR_TEXTURE_WIN = int(Z'80EC')

   integer(GLenum), parameter, public :: GL_LOGIC_OP = GL_INDEX_LOGIC_OP
   integer(GLenum), parameter, public :: GL_TEXTURE_COMPONENTS = GL_TEXTURE_INTERNAL_FORMAT

   public GLUquadricErrorProc
   abstract interface
      subroutine GLUquadricErrorProc(errno) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUquadricErrorProc
         integer(GLenum),value :: errno
      end subroutine GLUquadricErrorProc
   end interface

   public GLUtessBeginProc
   abstract interface
      subroutine GLUtessBeginProc(type) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessBeginProc
         integer(GLenum),value :: type
      end subroutine GLUtessBeginProc
   end interface

   public GLUtessEdgeFlagProc
   abstract interface
      subroutine GLUtessEdgeFlagProc(flag) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessEdgeFlagProc
         integer(GLboolean),value :: flag
      end subroutine GLUtessEdgeFlagProc
   end interface

   public GLUtessVertexProc
   abstract interface
      subroutine GLUtessVertexProc(vertex_data) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessVertexProc
         type(C_PTR),value :: vertex_data
      end subroutine GLUtessVertexProc
   end interface

   public GLUtessEndProc
   abstract interface
      subroutine GLUtessEndProc() bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessEndProc
      end subroutine GLUtessEndProc
   end interface

   public GLUtessErrorProc
   abstract interface
      subroutine GLUtessErrorProc(errno) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessErrorProc
         integer(GLenum),value :: errno
      end subroutine GLUtessErrorProc
   end interface

   public GLUtessCombineProc
   abstract interface
      subroutine GLUtessCombineProc(coords,vertex_data,weight,outData) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessCombineProc
         real(GLdouble) coords(3)
         type(C_PTR) vertex_data(4)
         real(GLfloat) weight(4)
         type(C_PTR) outData
      end subroutine GLUtessCombineProc
   end interface

   public GLUtessBeginDataProc
   abstract interface
      subroutine GLUtessBeginDataProc(type,polygon_data) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessBeginDataProc
         integer(GLenum),value :: type
         type(C_PTR),value :: polygon_data
      end subroutine GLUtessBeginDataProc
   end interface

   public GLUtessEdgeFlagDataProc
   abstract interface
      subroutine GLUtessEdgeFlagDataProc(flag,polygon_data) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessEdgeFlagDataProc
         integer(GLboolean),value :: flag
         type(C_PTR),value :: polygon_data
      end subroutine GLUtessEdgeFlagDataProc
   end interface

   public GLUtessVertexDataProc
   abstract interface
      subroutine GLUtessVertexDataProc(vertex_data,polygon_data) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessVertexDataProc
         type(C_PTR),value :: vertex_data
         type(C_PTR),value :: polygon_data
      end subroutine GLUtessVertexDataProc
   end interface

   public GLUtessEndDataProc
   abstract interface
      subroutine GLUtessEndDataProc(polygon_data) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessEndDataProc
         type(C_PTR),value :: polygon_data
      end subroutine GLUtessEndDataProc
   end interface

   public GLUtessErrorDataProc
   abstract interface
      subroutine GLUtessErrorDataProc(errno,polygon_data) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessErrorDataProc
         integer(GLenum),value :: errno
         type(C_PTR),value :: polygon_data
      end subroutine GLUtessErrorDataProc
   end interface

   public GLUtessCombineDataProc
   abstract interface
      subroutine GLUtessCombineDataProc(coords,vertex_data,weight,outData,polygon_data) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUtessCombineDataProc
         real(GLdouble) coords(3)
         type(C_PTR) vertex_data(4)
         real(GLfloat) weight(4)
         type(C_PTR) outData
         type(C_PTR),value :: polygon_data
      end subroutine GLUtessCombineDataProc
   end interface

   public GLUnurbsErrorProc
   abstract interface
      subroutine GLUnurbsErrorProc(errno) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: GLUnurbsErrorProc
         integer(GLenum),value :: errno
      end subroutine GLUnurbsErrorProc
   end interface

   integer, parameter, public :: GLU_VERSION_1_1 = 1
   integer, parameter, public :: GLU_VERSION_1_2 = 1

   integer(GLenum), parameter, public :: GLU_INVALID_ENUM = 100900
   integer(GLenum), parameter, public :: GLU_INVALID_VALUE = 100901
   integer(GLenum), parameter, public :: GLU_OUT_OF_MEMORY = 100902
   integer(GLenum), parameter, public :: GLU_INCOMPATIBLE_GL_VERSION = 100903

   integer, parameter, public :: GLU_VERSION = 100800
   integer, parameter, public :: GLU_EXTENSIONS = 100801

   integer, parameter, public :: GLU_TRUE = GL_TRUE
   integer, parameter, public :: GLU_FALSE = GL_FALSE

   integer(GLenum), parameter, public :: GLU_SMOOTH = 100000
   integer(GLenum), parameter, public :: GLU_FLAT = 100001
   integer(GLenum), parameter, public :: GLU_NONE = 100002

   integer(GLenum), parameter, public :: GLU_POINT = 100010
   integer(GLenum), parameter, public :: GLU_LINE = 100011
   integer(GLenum), parameter, public :: GLU_FILL = 100012
   integer(GLenum), parameter, public :: GLU_SILHOUETTE = 100013

   integer(GLenum), parameter, public :: GLU_OUTSIDE = 100020
   integer(GLenum), parameter, public :: GLU_INSIDE = 100021

   real(GLdouble), parameter, public :: GLU_TESS_MAX_COORD = 1.0e150_GLdouble

   integer(GLenum), parameter, public :: GLU_TESS_WINDING_RULE = 100140
   integer(GLenum), parameter, public :: GLU_TESS_BOUNDARY_ONLY = 100141
   integer(GLenum), parameter, public :: GLU_TESS_TOLERANCE = 100142

   integer, parameter, public :: GLU_TESS_WINDING_ODD = 100130
   integer, parameter, public :: GLU_TESS_WINDING_NONZERO = 100131
   integer, parameter, public :: GLU_TESS_WINDING_POSITIVE = 100132
   integer, parameter, public :: GLU_TESS_WINDING_NEGATIVE = 100133
   integer, parameter, public :: GLU_TESS_WINDING_ABS_GEQ_TWO = 100134

   integer(GLenum), parameter, public :: GLU_TESS_BEGIN = 100100
   integer(GLenum), parameter, public :: GLU_TESS_VERTEX = 100101
   integer(GLenum), parameter, public :: GLU_TESS_END = 100102
   integer(GLenum), parameter, public :: GLU_TESS_ERROR = 100103
   integer(GLenum), parameter, public :: GLU_TESS_EDGE_FLAG = 100104
   integer(GLenum), parameter, public :: GLU_TESS_COMBINE = 100105
   integer(GLenum), parameter, public :: GLU_TESS_BEGIN_DATA = 100106
   integer(GLenum), parameter, public :: GLU_TESS_VERTEX_DATA = 100107
   integer(GLenum), parameter, public :: GLU_TESS_END_DATA = 100108
   integer(GLenum), parameter, public :: GLU_TESS_ERROR_DATA = 100109
   integer(GLenum), parameter, public :: GLU_TESS_EDGE_FLAG_DATA = 100110
   integer(GLenum), parameter, public :: GLU_TESS_COMBINE_DATA = 100111

   integer(GLenum), parameter, public :: GLU_TESS_ERROR1 = 100151
   integer(GLenum), parameter, public :: GLU_TESS_ERROR2 = 100152
   integer(GLenum), parameter, public :: GLU_TESS_ERROR3 = 100153
   integer(GLenum), parameter, public :: GLU_TESS_ERROR4 = 100154
   integer(GLenum), parameter, public :: GLU_TESS_ERROR5 = 100155
   integer(GLenum), parameter, public :: GLU_TESS_ERROR6 = 100156
   integer(GLenum), parameter, public :: GLU_TESS_ERROR7 = 100157
   integer(GLenum), parameter, public :: GLU_TESS_ERROR8 = 100158

   integer(GLenum), parameter, public :: GLU_TESS_MISSING_BEGIN_POLYGON = GLU_TESS_ERROR1
   integer(GLenum), parameter, public :: GLU_TESS_MISSING_BEGIN_CONTOUR = GLU_TESS_ERROR2
   integer(GLenum), parameter, public :: GLU_TESS_MISSING_END_POLYGON = GLU_TESS_ERROR3
   integer(GLenum), parameter, public :: GLU_TESS_MISSING_END_CONTOUR = GLU_TESS_ERROR4
   integer(GLenum), parameter, public :: GLU_TESS_COORD_TOO_LARGE = GLU_TESS_ERROR5
   integer(GLenum), parameter, public :: GLU_TESS_NEED_COMBINE_CALLBACK = GLU_TESS_ERROR6

   integer(GLenum), parameter, public :: GLU_AUTO_LOAD_MATRIX = 100200
   integer(GLenum), parameter, public :: GLU_CULLING = 100201
   integer(GLenum), parameter, public :: GLU_SAMPLING_TOLERANCE = 100203
   integer(GLenum), parameter, public :: GLU_DISPLAY_MODE = 100204
   integer(GLenum), parameter, public :: GLU_PARAMETRIC_TOLERANCE = 100202
   integer(GLenum), parameter, public :: GLU_SAMPLING_METHOD = 100205
   integer(GLenum), parameter, public :: GLU_U_STEP = 100206
   integer(GLenum), parameter, public :: GLU_V_STEP = 100207

   real(GLfloat), parameter, public :: GLU_PATH_LENGTH = 100215
   real(GLfloat), parameter, public :: GLU_PARAMETRIC_ERROR = 100216
   real(GLfloat), parameter, public :: GLU_DOMAIN_DISTANCE = 100217

   integer(GLenum), parameter, public :: GLU_MAP1_TRIM_2 = 100210
   integer(GLenum), parameter, public :: GLU_MAP1_TRIM_3 = 100211

   real(GLfloat), parameter, public :: GLU_OUTLINE_POLYGON = 100240
   real(GLfloat), parameter, public :: GLU_OUTLINE_PATCH = 100241

   integer(GLenum), parameter, public :: GLU_NURBS_ERROR1 = 100251
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR2 = 100252
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR3 = 100253
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR4 = 100254
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR5 = 100255
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR6 = 100256
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR7 = 100257
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR8 = 100258
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR9 = 100259
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR10 = 100260
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR11 = 100261
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR12 = 100262
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR13 = 100263
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR14 = 100264
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR15 = 100265
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR16 = 100266
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR17 = 100267
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR18 = 100268
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR19 = 100269
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR20 = 100270
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR21 = 100271
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR22 = 100272
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR23 = 100273
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR24 = 100274
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR25 = 100275
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR26 = 100276
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR27 = 100277
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR28 = 100278
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR29 = 100279
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR30 = 100280
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR31 = 100281
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR32 = 100282
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR33 = 100283
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR34 = 100284
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR35 = 100285
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR36 = 100286
   integer(GLenum), parameter, public :: GLU_NURBS_ERROR37 = 100287

   integer(GLenum), parameter, public :: GLU_CW = 100120
   integer(GLenum), parameter, public :: GLU_CCW = 100121
   integer(GLenum), parameter, public :: GLU_INTERIOR = 100122
   integer(GLenum), parameter, public :: GLU_EXTERIOR = 100123
   integer(GLenum), parameter, public :: GLU_UNKNOWN = 100124

   integer(GLenum), parameter, public :: GLU_BEGIN = GLU_TESS_BEGIN
   integer(GLenum), parameter, public :: GLU_VERTEX = GLU_TESS_VERTEX
   integer(GLenum), parameter, public :: GLU_END = GLU_TESS_END
   integer(GLenum), parameter, public :: GLU_ERROR = GLU_TESS_ERROR
   integer(GLenum), parameter, public :: GLU_EDGE_FLAG = GLU_TESS_EDGE_FLAG

   integer(GLenum), parameter, public :: GL_LIGHT_MODEL_COLOR_CONTROL = int(Z'81F8',GLenum)
   integer(GLint), parameter, public :: GL_SINGLE_COLOR = int(Z'81F9',GLint)
   integer(GLint), parameter, public :: GL_SEPARATE_SPECULAR_COLOR = int(Z'81FA',GLint)
end module opengl_types

module gl_rank1
   use ISO_C_BINDING
   use opengl_types
!   use win32_types
   implicit none
   private
   public glMultMatrix, glMultMatrixd, glMultMatrixf
   interface glMultMatrix
      subroutine glMultMatrixd(m) &
         bind(C,name='glMultMatrixd')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMultMatrixd
         real(GLdouble),intent(in) :: m(16)
      end subroutine glMultMatrixd

      subroutine glMultMatrixf(m) &
         bind(C,name='glMultMatrixf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMultMatrixf
         real(GLfloat),intent(in) :: m(16)
      end subroutine glMultMatrixf
   end interface glMultMatrix

   public glLoadMatrix, glLoadMatrixd, glLoadMatrixf
   interface glLoadMatrix
      subroutine glLoadMatrixd(m) &
         bind(C,name='glLoadMatrixd')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLoadMatrixd
         real(GLdouble),intent(in) :: m(16)
      end subroutine glLoadMatrixd

      subroutine glLoadMatrixf(m) &
         bind(C,name='glLoadMatrixf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLoadMatrixf
         real(GLfloat),intent(in) :: m(16)
      end subroutine glLoadMatrixf
   end interface glLoadMatrix
end module gl_rank1

module gl_rank2
   use ISO_C_BINDING
   use opengl_types
!   use win32_types
   implicit none
   private
   public glMultMatrix
   interface glMultMatrix
      subroutine glMultMatrixd(m) &
         bind(C,name='glMultMatrixd')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMultMatrixd
         real(GLdouble),intent(in) :: m(4,4)
      end subroutine glMultMatrixd

      subroutine glMultMatrixf(m) &
         bind(C,name='glMultMatrixf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMultMatrixf
         real(GLfloat),intent(in) :: m(4,4)
      end subroutine glMultMatrixf
   end interface glMultMatrix

   public glLoadMatrix
   interface glLoadMatrix
      subroutine glLoadMatrixd(m) &
         bind(C,name='glLoadMatrixd')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLoadMatrixd
         real(GLdouble),intent(in) :: m(4,4)
      end subroutine glLoadMatrixd

      subroutine glLoadMatrixf(m) &
         bind(C,name='glLoadMatrixf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLoadMatrixf
         real(GLfloat),intent(in) :: m(4,4)
      end subroutine glLoadMatrixf
   end interface glLoadMatrix
end module gl_rank2

module gl
   use ISO_C_BINDING
   use opengl_types
   use gl_rank1
   use gl_rank2
!   use win32_types
   implicit none
   private
   public glAccum
   interface
      subroutine glAccum(op,value) &
         bind(C,name='glAccum')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glAccum
         integer(GLenum),value :: op
         real(GLfloat),value :: value
      end subroutine glAccum
   end interface

   public glAlphaFunc
   interface
      subroutine glAlphaFunc(func,ref) &
         bind(C,name='glAlphaFunc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glAlphaFunc
         integer(GLenum),value :: func
         real(GLclampf),value :: ref
      end subroutine glAlphaFunc
   end interface

   public glAreTexturesResident
   interface
      function glAreTexturesResident(n,textures,residences) &
         bind(C,name='glAreTexturesResident')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glAreTexturesResident
         integer(GLboolean) glAreTexturesResident
         integer(GLsizei),value :: n
         integer(GLuint),intent(in) :: textures(*)
         integer(GLboolean) residences(*)
      end function glAreTexturesResident
   end interface

   public glArrayElement
   interface
      subroutine glArrayElement(i) &
         bind(C,name='glArrayElement')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glArrayElement
         integer(GLint),value :: i
      end subroutine glArrayElement
   end interface

   public glBegin
   interface
      subroutine glBegin(mode) &
         bind(C,name='glBegin')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glBegin
         integer(GLenum),value :: mode
      end subroutine glBegin
   end interface

   public glBindTexture
   interface
      subroutine glBindTexture(target,texture) &
         bind(C,name='glBindTexture')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glBindTexture
         integer(GLenum),value :: target
         integer(GLuint),value :: texture
      end subroutine glBindTexture
   end interface

   public glBitmap
   interface
      subroutine glBitmap(width,height,xorig,yorig,xmove,ymove,bitmap) &
         bind(C,name='glBitmap')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glBitmap
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
         real(GLfloat),value :: xorig
         real(GLfloat),value :: yorig
         real(GLfloat),value :: xmove
         real(GLfloat),value :: ymove
         integer(GLubyte),intent(in) :: bitmap(*)
      end subroutine glBitmap
   end interface

   public glBlendFunc
   interface
      subroutine glBlendFunc(sfactor,dfactor) &
         bind(C,name='glBlendFunc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glBlendFunc
         integer(GLenum),value :: sfactor
         integer(GLenum),value :: dfactor
      end subroutine glBlendFunc
   end interface

   public glCallList
   interface
      subroutine glCallList(list) &
         bind(C,name='glCallList')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCallList
         integer(GLuint),value :: list
      end subroutine glCallList
   end interface

   public glCallLists
   interface
      subroutine glCallLists(n,type,lists) &
         bind(C,name='glCallLists')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCallLists
         integer(GLsizei),value :: n
         integer(GLenum),value :: type
         type(C_PTR),value :: lists
      end subroutine glCallLists
   end interface

   public glClear
   interface
      subroutine glClear(mask) &
         bind(C,name='glClear')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glClear
         integer(GLbitfield),value :: mask
      end subroutine glClear
   end interface

   public glClearAccum
   interface
      subroutine glClearAccum(red,green,blue,alpha) &
         bind(C,name='glClearAccum')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glClearAccum
         real(GLfloat),value :: red
         real(GLfloat),value :: green
         real(GLfloat),value :: blue
         real(GLfloat),value :: alpha
      end subroutine glClearAccum
   end interface

   public glClearColor
   interface
      subroutine glClearColor(red,green,blue,alpha) &
         bind(C,name='glClearColor')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glClearColor
         real(GLclampf),value :: red
         real(GLclampf),value :: green
         real(GLclampf),value :: blue
         real(GLclampf),value :: alpha
      end subroutine glClearColor
   end interface

   public glClearDepth
   interface
      subroutine glClearDepth(depth) &
         bind(C,name='glClearDepth')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glClearDepth
         real(GLclampd),value :: depth
      end subroutine glClearDepth
   end interface

   public glClearIndex
   interface
      subroutine glClearIndex(c) &
         bind(C,name='glClearIndex')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glClearIndex
         real(GLfloat),value :: c
      end subroutine glClearIndex
   end interface

   public glClearStencil
   interface
      subroutine glClearStencil(s) &
         bind(C,name='glClearStencil')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glClearStencil
         integer(GLint),value :: s
      end subroutine glClearStencil
   end interface

   public glClipPlane
   interface
      subroutine glClipPlane(plane,equation) &
         bind(C,name='glClipPlane')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glClipPlane
         integer(GLenum),value :: plane
         real(GLdouble),intent(in) :: equation(4)
      end subroutine glClipPlane
   end interface

   public glColor3, glColor3b, glColor3d, glColor3f, glColor3i, glColor3s
   interface glColor3
      subroutine glColor3b(red,green,blue) &
         bind(C,name='glColor3b')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3b
         integer(GLbyte),value :: red
         integer(GLbyte),value :: green
         integer(GLbyte),value :: blue
      end subroutine glColor3b

      subroutine glColor3d(red,green,blue) &
         bind(C,name='glColor3d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3d
         real(GLdouble),value :: red
         real(GLdouble),value :: green
         real(GLdouble),value :: blue
      end subroutine glColor3d

      subroutine glColor3f(red,green,blue) &
         bind(C,name='glColor3f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3f
         real(GLfloat),value :: red
         real(GLfloat),value :: green
         real(GLfloat),value :: blue
      end subroutine glColor3f

      subroutine glColor3i(red,green,blue) &
         bind(C,name='glColor3i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3i
         integer(GLint),value :: red
         integer(GLint),value :: green
         integer(GLint),value :: blue
      end subroutine glColor3i

      subroutine glColor3s(red,green,blue) &
         bind(C,name='glColor3s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3s
         integer(GLshort),value :: red
         integer(GLshort),value :: green
         integer(GLshort),value :: blue
      end subroutine glColor3s
   end interface glColor3

   public glColor3v, glColor3bv, glColor3dv, &
      glColor3fv, glColor3iv, glColor3sv
   interface glColor3v
      subroutine glColor3bv(v) &
         bind(C,name='glColor3bv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3bv
         integer(GLbyte),intent(in) :: v(3)
      end subroutine glColor3bv

      subroutine glColor3dv(v) &
         bind(C,name='glColor3dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3dv
         real(GLdouble),intent(in) :: v(3)
      end subroutine glColor3dv

      subroutine glColor3fv(v) &
         bind(C,name='glColor3fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3fv
         real(GLfloat),intent(in) :: v(3)
      end subroutine glColor3fv

      subroutine glColor3iv(v) &
         bind(C,name='glColor3iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3iv
         integer(GLint),intent(in) :: v(3)
      end subroutine glColor3iv

      subroutine glColor3sv(v) &
         bind(C,name='glColor3sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3sv
         integer(GLshort),intent(in) :: v(3)
      end subroutine glColor3sv
   end interface glColor3v

   public glColor3u, glColor3ub, glColor3ui, glColor3us
   interface glColor3u
      subroutine glColor3ub(red,green,blue) &
         bind(C,name='glColor3ub')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3ub
         integer(GLubyte),value :: red
         integer(GLubyte),value :: green
         integer(GLubyte),value :: blue
      end subroutine glColor3ub

      subroutine glColor3ui(red,green,blue) &
         bind(C,name='glColor3ui')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3ui
         integer(GLuint),value :: red
         integer(GLuint),value :: green
         integer(GLuint),value :: blue
      end subroutine glColor3ui

      subroutine glColor3us(red,green,blue) &
         bind(C,name='glColor3us')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3us
         integer(GLushort),value :: red
         integer(GLushort),value :: green
         integer(GLushort),value :: blue
      end subroutine glColor3us
   end interface glColor3u

   public glColor3uv, glColor3ubv, glColor3uiv, glColor3usv
   interface glColor3uv
      subroutine glColor3ubv(v) &
         bind(C,name='glColor3ubv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3ubv
         integer(GLubyte),intent(in) :: v(3)
      end subroutine glColor3ubv

      subroutine glColor3uiv(v) &
         bind(C,name='glColor3uiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3uiv
         integer(GLuint),intent(in) :: v(3)
      end subroutine glColor3uiv

      subroutine glColor3usv(v) &
         bind(C,name='glColor3usv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor3usv
         integer(GLushort),intent(in) :: v(3)
      end subroutine glColor3usv
   end interface glColor3uv

   public glColor4, glColor4b, glColor4d, glColor4f, glColor4i, glColor4s
   interface glColor4
      subroutine glColor4b(red,green,blue,alpha) &
         bind(C,name='glColor4b')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4b
         integer(GLbyte),value :: red
         integer(GLbyte),value :: green
         integer(GLbyte),value :: blue
         integer(GLbyte),value :: alpha
      end subroutine glColor4b

      subroutine glColor4d(red,green,blue,alpha) &
         bind(C,name='glColor4d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4d
         real(GLdouble),value :: red
         real(GLdouble),value :: green
         real(GLdouble),value :: blue
         real(GLdouble),value :: alpha
      end subroutine glColor4d

      subroutine glColor4f(red,green,blue,alpha) &
         bind(C,name='glColor4f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4f
         real(GLfloat),value :: red
         real(GLfloat),value :: green
         real(GLfloat),value :: blue
         real(GLfloat),value :: alpha
      end subroutine glColor4f

      subroutine glColor4i(red,green,blue,alpha) &
         bind(C,name='glColor4i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4i
         integer(GLint),value :: red
         integer(GLint),value :: green
         integer(GLint),value :: blue
         integer(GLint),value :: alpha
      end subroutine glColor4i

      subroutine glColor4s(red,green,blue,alpha) &
         bind(C,name='glColor4s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4s
         integer(GLshort),value :: red
         integer(GLshort),value :: green
         integer(GLshort),value :: blue
         integer(GLshort),value :: alpha
      end subroutine glColor4s
   end interface glColor4

   public glColor4v, glColor4bv, glColor4dv, &
      glColor4fv, glColor4iv, glColor4sv
   interface glColor4v
      subroutine glColor4bv(v) &
         bind(C,name='glColor4bv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4bv
         integer(GLbyte),intent(in) :: v(4)
      end subroutine glColor4bv

      subroutine glColor4dv(v) &
         bind(C,name='glColor4dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4dv
         real(GLdouble),intent(in) :: v(4)
      end subroutine glColor4dv

      subroutine glColor4fv(v) &
         bind(C,name='glColor4fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4fv
         real(GLfloat),intent(in) :: v(4)
      end subroutine glColor4fv

      subroutine glColor4iv(v) &
         bind(C,name='glColor4iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4iv
         integer(GLint),intent(in) :: v(4)
      end subroutine glColor4iv

      subroutine glColor4sv(v) &
         bind(C,name='glColor4sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4sv
         integer(GLshort),intent(in) :: v(4)
      end subroutine glColor4sv
   end interface glColor4v

   public glColor4u, glColor4ub, glColor4ui, glColor4us
   interface glColor4u
      subroutine glColor4ub(red,green,blue,alpha) &
         bind(C,name='glColor4ub')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4ub
         integer(GLubyte),value :: red
         integer(GLubyte),value :: green
         integer(GLubyte),value :: blue
         integer(GLubyte),value :: alpha
      end subroutine glColor4ub

      subroutine glColor4ui(red,green,blue,alpha) &
         bind(C,name='glColor4ui')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4ui
         integer(GLuint),value :: red
         integer(GLuint),value :: green
         integer(GLuint),value :: blue
         integer(GLuint),value :: alpha
      end subroutine glColor4ui

      subroutine glColor4us(red,green,blue,alpha) &
         bind(C,name='glColor4us')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4us
         integer(GLushort),value :: red
         integer(GLushort),value :: green
         integer(GLushort),value :: blue
         integer(GLushort),value :: alpha
      end subroutine glColor4us
   end interface glColor4u

   public glColor4uv, glColor4ubv, glColor4uiv, glColor4usv
   interface glColor4uv
      subroutine glColor4ubv(v) &
         bind(C,name='glColor4ubv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4ubv
         integer(GLubyte),intent(in) :: v(4)
      end subroutine glColor4ubv

      subroutine glColor4uiv(v) &
         bind(C,name='glColor4uiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4uiv
         integer(GLuint),intent(in) :: v(4)
      end subroutine glColor4uiv

      subroutine glColor4usv(v) &
         bind(C,name='glColor4usv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColor4usv
         integer(GLushort),intent(in) :: v(4)
      end subroutine glColor4usv
   end interface glColor4uv

   public glColorMask
   interface
      subroutine glColorMask(red,green,blue,alpha) &
         bind(C,name='glColorMask')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColorMask
         integer(GLboolean),value :: red
         integer(GLboolean),value :: green
         integer(GLboolean),value :: blue
         integer(GLboolean),value :: alpha
      end subroutine glColorMask
   end interface

   public glColorMaterial
   interface
      subroutine glColorMaterial(face,mode) &
         bind(C,name='glColorMaterial')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColorMaterial
         integer(GLenum),value :: face
         integer(GLenum),value :: mode
      end subroutine glColorMaterial
   end interface

   public glColorPointer
   interface
      subroutine glColorPointer(size,type,stride,pointer) &
         bind(C,name='glColorPointer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glColorPointer
         integer(GLint),value :: size
         integer(GLenum),value :: type
         integer(GLsizei),value :: stride
         type(C_PTR),value :: pointer
      end subroutine glColorPointer
   end interface

   public glCopyPixels
   interface
      subroutine glCopyPixels(x,y,width,height,type) &
         bind(C,name='glCopyPixels')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCopyPixels
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
         integer(GLenum),value :: type
      end subroutine glCopyPixels
   end interface

   public glCopyTexImage1D
   interface
      subroutine glCopyTexImage1D(target,level,internalFormat,x,y,width,border) &
         bind(C,name='glCopyTexImage1D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCopyTexImage1D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLenum),value :: internalFormat
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
         integer(GLint),value :: border
      end subroutine glCopyTexImage1D
   end interface

   public glCopyTexImage2D
   interface
      subroutine glCopyTexImage2D(target,level,internalFormat,x,y,width,height,border) &
         bind(C,name='glCopyTexImage2D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCopyTexImage2D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLenum),value :: internalFormat
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
         integer(GLint),value :: border
      end subroutine glCopyTexImage2D
   end interface

   public glCopyTexSubImage1D
   interface
      subroutine glCopyTexSubImage1D(target,level,xoffset,x,y,width) &
         bind(C,name='glCopyTexSubImage1D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCopyTexSubImage1D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLint),value :: xoffset
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
      end subroutine glCopyTexSubImage1D
   end interface

   public glCopyTexSubImage2D
   interface
      subroutine glCopyTexSubImage2D(target,level,xoffset,yoffset,x,y,width,height) &
         bind(C,name='glCopyTexSubImage2D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCopyTexSubImage2D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLint),value :: xoffset
         integer(GLint),value :: yoffset
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
      end subroutine glCopyTexSubImage2D
   end interface

   public glCullFace
   interface
      subroutine glCullFace(mode) &
         bind(C,name='glCullFace')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glCullFace
         integer(GLenum),value :: mode
      end subroutine glCullFace
   end interface

   public glDeleteLists
   interface
      subroutine glDeleteLists(list,range) &
         bind(C,name='glDeleteLists')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDeleteLists
         integer(GLuint),value :: list
         integer(GLsizei),value :: range
      end subroutine glDeleteLists
   end interface

   public glDeleteTextures
   interface
      subroutine glDeleteTextures(n,textures) &
         bind(C,name='glDeleteTextures')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDeleteTextures
         integer(GLsizei),value :: n
         integer(GLuint),intent(in) :: textures(*)
      end subroutine glDeleteTextures
   end interface

   public glDepthFunc
   interface
      subroutine glDepthFunc(func) &
         bind(C,name='glDepthFunc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDepthFunc
         integer(GLenum),value :: func
      end subroutine glDepthFunc
   end interface

   public glDepthMask
   interface
      subroutine glDepthMask(flag) &
         bind(C,name='glDepthMask')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDepthMask
         integer(GLboolean),value :: flag
      end subroutine glDepthMask
   end interface

   public glDepthRange
   interface
      subroutine glDepthRange (zNear,zFar) &
         bind(C,name='glDepthRange ')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDepthRange
         real(GLclampd),value :: zNear
         real(GLclampd),value :: zFar
      end subroutine glDepthRange
   end interface

   public glDisable
   interface
      subroutine glDisable(cap) &
         bind(C,name='glDisable')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDisable
         integer(GLenum),value :: cap
      end subroutine glDisable
   end interface

   public glDisableClientState
   interface
      subroutine glDisableClientState(array) &
         bind(C,name='glDisableClientState')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDisableClientState
         integer(GLenum),value :: array
      end subroutine glDisableClientState
   end interface

   public glDrawArrays
   interface
      subroutine glDrawArrays(mode,first,count) &
         bind(C,name='glDrawArrays')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDrawArrays
         integer(GLenum),value :: mode
         integer(GLint),value :: first
         integer(GLsizei),value :: count
      end subroutine glDrawArrays
   end interface

   public glDrawBuffer
   interface
      subroutine glDrawBuffer(mode) &
         bind(C,name='glDrawBuffer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDrawBuffer
         integer(GLenum),value :: mode
      end subroutine glDrawBuffer
   end interface

   public glDrawElements
   interface
      subroutine glDrawElements(mode,count,type,indices) &
         bind(C,name='glDrawElements')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDrawElements
         integer(GLenum),value :: mode
         integer(GLsizei),value :: count
         integer(GLenum),value :: type
         type(C_PTR),value :: indices
      end subroutine glDrawElements
   end interface

   public glDrawPixels
   interface
      subroutine glDrawPixels(width,height,format,type,pixels) &
         bind(C,name='glDrawPixels')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glDrawPixels
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: pixels
      end subroutine glDrawPixels
   end interface

   public glEdgeFlag
   interface
      subroutine glEdgeFlag(flag) &
         bind(C,name='glEdgeFlag')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEdgeFlag
         integer(GLboolean),value :: flag
      end subroutine glEdgeFlag
   end interface

   public glEdgeFlagPointer
   interface
      subroutine glEdgeFlagPointer(stride,pointer) &
         bind(C,name='glEdgeFlagPointer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEdgeFlagPointer
         integer(GLsizei),value :: stride
         type(C_PTR),value :: pointer
      end subroutine glEdgeFlagPointer
   end interface

   public glEdgeFlagv
   interface
      subroutine glEdgeFlagv(flag) &
         bind(C,name='glEdgeFlagv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEdgeFlagv
         integer(GLboolean),intent(in) :: flag(1)
      end subroutine glEdgeFlagv
   end interface

   public glEnable
   interface
      subroutine glEnable(cap) &
         bind(C,name='glEnable')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEnable
         integer(GLenum),value :: cap
      end subroutine glEnable
   end interface

   public glEnableClientState
   interface
      subroutine glEnableClientState(array) &
         bind(C,name='glEnableClientState')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEnableClientState
         integer(GLenum),value :: array
      end subroutine glEnableClientState
   end interface

   public glEnd
   interface
      subroutine glEnd() bind(C,name='glEnd')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEnd
      end subroutine glEnd
   end interface

   public glEndList
   interface
      subroutine glEndList() bind(C,name='glEndList')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEndList
      end subroutine glEndList
   end interface

   public glEvalCoord1, glEvalCoord1d, glEvalCoord1f
   interface glEvalCoord1
      subroutine glEvalCoord1d(u) &
         bind(C,name='glEvalCoord1d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord1d
         real(GLdouble),value :: u
      end subroutine glEvalCoord1d

      subroutine glEvalCoord1f(u) &
         bind(C,name='glEvalCoord1f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord1f
         real(GLfloat),value :: u
      end subroutine glEvalCoord1f
   end interface glEvalCoord1

   public glEvalCoord1v, glEvalCoord1dv, glEvalCoord1fv
   interface glEvalCoord1v
      subroutine glEvalCoord1dv(u) &
         bind(C,name='glEvalCoord1dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord1dv
         real(GLdouble),intent(in) :: u(1)
      end subroutine glEvalCoord1dv

      subroutine glEvalCoord1fv(u) &
         bind(C,name='glEvalCoord1fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord1fv
         real(GLfloat),intent(in) :: u(1)
      end subroutine glEvalCoord1fv
   end interface glEvalCoord1v

   public glEvalCoord2, glEvalCoord2d, glEvalCoord2f
   interface glEvalCoord2
      subroutine glEvalCoord2d(u,v) &
         bind(C,name='glEvalCoord2d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord2d
         real(GLdouble),value :: u
         real(GLdouble),value :: v
      end subroutine glEvalCoord2d

      subroutine glEvalCoord2f(u,v) &
         bind(C,name='glEvalCoord2f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord2f
         real(GLfloat),value :: u
         real(GLfloat),value :: v
      end subroutine glEvalCoord2f
   end interface glEvalCoord2

   public glEvalCoord2v, glEvalCoord2dv, glEvalCoord2fv
   interface glEvalCoord2v
      subroutine glEvalCoord2dv(u) &
         bind(C,name='glEvalCoord2dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord2dv
         real(GLdouble),intent(in) :: u(2)
      end subroutine glEvalCoord2dv

      subroutine glEvalCoord2fv(u) &
         bind(C,name='glEvalCoord2fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalCoord2fv
         real(GLfloat),intent(in) :: u(2)
      end subroutine glEvalCoord2fv
   end interface glEvalCoord2v

   public glEvalMesh1
   interface
      subroutine glEvalMesh1(mode,i1,i2) &
         bind(C,name='glEvalMesh1')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalMesh1
         integer(GLenum),value :: mode
         integer(GLint),value :: i1
         integer(GLint),value :: i2
      end subroutine glEvalMesh1
   end interface

   public glEvalMesh2
   interface
      subroutine glEvalMesh2(mode,i1,i2,j1,j2) &
         bind(C,name='glEvalMesh2')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalMesh2
         integer(GLenum),value :: mode
         integer(GLint),value :: i1
         integer(GLint),value :: i2
         integer(GLint),value :: j1
         integer(GLint),value :: j2
      end subroutine glEvalMesh2
   end interface

   public glEvalPoint1
   interface
      subroutine glEvalPoint1(i) &
         bind(C,name='glEvalPoint1')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalPoint1
         integer(GLint),value :: i
      end subroutine glEvalPoint1
   end interface

   public glEvalPoint2
   interface
      subroutine glEvalPoint2(i,j) &
         bind(C,name='glEvalPoint2')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glEvalPoint2
         integer(GLint),value :: i
         integer(GLint),value :: j
      end subroutine glEvalPoint2
   end interface

   public glFeedbackBuffer
   interface
      subroutine glFeedbackBuffer(size,type,buffer) &
         bind(C,name='glFeedbackBuffer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFeedbackBuffer
         integer(GLsizei),value :: size
         integer(GLenum),value :: type
!         real(GLfloat),target,volatile :: buffer(*)
         type(C_PTR),value :: buffer
      end subroutine glFeedbackBuffer
   end interface

   public glFinish
   interface
      subroutine glFinish() bind(C,name='glFinish')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFinish
      end subroutine glFinish
   end interface

   public glFlush
   interface
      subroutine glFlush() bind(C,name='glFlush')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFlush
      end subroutine glFlush
   end interface

   public glFog, glFogf, glFogi
   interface glFog
      subroutine glFogf(pname,param) &
         bind(C,name='glFogf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFogf
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glFogf

      subroutine glFogi(pname,param) &
         bind(C,name='glFogi')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFogi
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glFogi
   end interface glFog

   public glFogv, glFogfv, glFogiv
   interface glFogv
      subroutine glFogfv(pname,params) &
         bind(C,name='glFogfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFogfv
         integer(GLenum),value :: pname
         real(GLfloat),intent(in) :: params(*)
      end subroutine glFogfv

      subroutine glFogiv(pname,params) &
         bind(C,name='glFogiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFogiv
         integer(GLenum),value :: pname
         integer(GLint),intent(in) :: params(*)
      end subroutine glFogiv
   end interface glFogv

   public glFrontFace
   interface
      subroutine glFrontFace(mode) &
         bind(C,name='glFrontFace')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFrontFace
         integer(GLenum),value :: mode
      end subroutine glFrontFace
   end interface

   public glFrustum
   interface
      subroutine glFrustum(left,right,bottom,top,zNear,zFar) &
         bind(C,name='glFrustum')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glFrustum
         real(GLdouble),value :: left
         real(GLdouble),value :: right
         real(GLdouble),value :: bottom
         real(GLdouble),value :: top
         real(GLdouble),value :: zNear
         real(GLdouble),value :: zFar
      end subroutine glFrustum
   end interface

   public glGenLists
   interface
      function glGenLists(range) &
         bind(C,name='glGenLists')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGenLists
         integer(GLuint) glGenLists
         integer(GLsizei),value :: range
      end function glGenLists
   end interface

   public glGenTextures
   interface
      subroutine glGenTextures(n,textures) &
         bind(C,name='glGenTextures')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGenTextures
         integer(GLsizei),value :: n
         integer(GLuint) textures(*)
      end subroutine glGenTextures
   end interface

   public glGetv, glGetBooleanv, glGetDoublev, glGetFloatv, glGetIntegerv
   interface glGetv
      subroutine glGetBooleanv(pname,params) &
         bind(C,name='glGetBooleanv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetBooleanv
         integer(GLenum),value :: pname
         integer(GLboolean) params(*)
      end subroutine glGetBooleanv

      subroutine glGetDoublev(pname,params) &
         bind(C,name='glGetDoublev')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetDoublev
         integer(GLenum),value :: pname
         real(GLdouble) params(*)
      end subroutine glGetDoublev

      subroutine glGetFloatv(pname,params) &
         bind(C,name='glGetFloatv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetFloatv
         integer(GLenum),value :: pname
         real(GLfloat) params(*)
      end subroutine glGetFloatv

      subroutine glGetIntegerv(pname,params) &
         bind(C,name='glGetIntegerv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetIntegerv
         integer(GLenum),value :: pname
         integer(GLint) params(*)
      end subroutine glGetIntegerv
   end interface glGetv

   public glGetClipPlane
   interface
      subroutine glGetClipPlane(plane,equation) &
         bind(C,name='glGetClipPlane')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetClipPlane
         integer(GLenum),value :: plane
         real(GLdouble) equation(4)
      end subroutine glGetClipPlane
   end interface

   public glGetError
   interface
      function glGetError() bind(C,name='glGetError')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetError
         integer(GLenum) glGetError
      end function glGetError
   end interface

   public glGetLightv, glGetLightfv, glGetLightiv
   interface glGetLightv
      subroutine glGetLightfv(light,pname,params) &
         bind(C,name='glGetLightfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetLightfv
         integer(GLenum),value :: light
         integer(GLenum),value :: pname
         real(GLfloat) params(*)
      end subroutine glGetLightfv

      subroutine glGetLightiv(light,pname,params) &
         bind(C,name='glGetLightiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetLightiv
         integer(GLenum),value :: light
         integer(GLenum),value :: pname
         integer(GLint) params(*)
      end subroutine glGetLightiv
   end interface glGetLightv

   public glGetMapv, glGetMapdv, glGetMapfv, glGetMapiv
   interface glGetMapv
      subroutine glGetMapdv(target,query,v) &
         bind(C,name='glGetMapdv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetMapdv
         integer(GLenum),value :: target
         integer(GLenum),value :: query
         real(GLdouble) v(*)
      end subroutine glGetMapdv

      subroutine glGetMapfv(target,query,v) &
         bind(C,name='glGetMapfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetMapfv
         integer(GLenum),value :: target
         integer(GLenum),value :: query
         real(GLfloat) v(*)
      end subroutine glGetMapfv

      subroutine glGetMapiv(target,query,v) &
         bind(C,name='glGetMapiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetMapiv
         integer(GLenum),value :: target
         integer(GLenum),value :: query
         integer(GLint) v(*)
      end subroutine glGetMapiv
   end interface glGetMapv

   public glGetMaterialv, glGetMaterialfv, glGetMaterialiv
   interface glGetMaterialv
      subroutine glGetMaterialfv(face,pname,params) &
         bind(C,name='glGetMaterialfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetMaterialfv
         integer(GLenum),value :: face
         integer(GLenum),value :: pname
         real(GLfloat) params(*)
      end subroutine glGetMaterialfv

      subroutine glGetMaterialiv(face,pname,params) &
         bind(C,name='glGetMaterialiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetMaterialiv
         integer(GLenum),value :: face
         integer(GLenum),value :: pname
         integer(GLint) params(*)
      end subroutine glGetMaterialiv
   end interface glGetMaterialv

   public glGetPixelMapv, glGetPixelMapfv, glGetPixelMapuiv, glGetPixelMapusv
   interface glGetPixelMapv
      subroutine glGetPixelMapfv(map,values) &
         bind(C,name='glGetPixelMapfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetPixelMapfv
         integer(GLenum),value :: map
         real(GLfloat) values(*)
      end subroutine glGetPixelMapfv

      subroutine glGetPixelMapuiv(map,values) &
         bind(C,name='glGetPixelMapuiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetPixelMapuiv
         integer(GLenum),value :: map
         integer(GLuint) values(*)
      end subroutine glGetPixelMapuiv

      subroutine glGetPixelMapusv(map,values) &
         bind(C,name='glGetPixelMapusv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetPixelMapusv
         integer(GLenum),value :: map
         integer(GLushort) values(*)
      end subroutine glGetPixelMapusv
   end interface glGetPixelMapv

   public glGetPointerv
   interface
      subroutine glGetPointerv(pname,params) &
         bind(C,name='glGetPointerv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetPointerv
         integer(GLenum),value :: pname
         type(C_PTR) params
      end subroutine glGetPointerv
   end interface

   public glGetPolygonStipple
   interface
      subroutine glGetPolygonStipple(mask) &
         bind(C,name='glGetPolygonStipple')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetPolygonStipple
         integer(GLubyte) mask(*)
      end subroutine glGetPolygonStipple
   end interface

   public glGetString
   interface
      function glGetString(name) &
         bind(C,name='glGetString')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetString
         type(C_PTR) glGetString
         integer(GLenum),value :: name
      end function glGetString
   end interface

   public glGetTexEnvv, glGetTexEnvfv, glGetTexEnviv
   interface glGetTexEnvv
      subroutine glGetTexEnvfv(target,pname,params) &
         bind(C,name='glGetTexEnvfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexEnvfv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         real(GLfloat) params(*)
      end subroutine glGetTexEnvfv

      subroutine glGetTexEnviv(target,pname,params) &
         bind(C,name='glGetTexEnviv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexEnviv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         integer(GLint) params(*)
      end subroutine glGetTexEnviv
   end interface glGetTexEnvv

   public glGetTexGenv, glGetTexGendv, glGetTexGenfv, glGetTexGeniv
   interface glGetTexGenv
      subroutine glGetTexGendv(coord,pname,params) &
         bind(C,name='glGetTexGendv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexGendv
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         real(GLdouble) params(*)
      end subroutine glGetTexGendv

      subroutine glGetTexGenfv(coord,pname,params) &
         bind(C,name='glGetTexGenfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexGenfv
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         real(GLfloat) params(*)
      end subroutine glGetTexGenfv

      subroutine glGetTexGeniv(coord,pname,params) &
         bind(C,name='glGetTexGeniv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexGeniv
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         integer(GLint) params(*)
      end subroutine glGetTexGeniv
   end interface glGetTexGenv

   public glGetTexImage
   interface
      subroutine glGetTexImage(target,level,format,type,pixels) &
         bind(C,name='glGetTexImage')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexImage
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: pixels
      end subroutine glGetTexImage
   end interface

   public glGetTexLevelParameterv, glGetTexLevelParameterfv, glGetTexLevelParameteriv
   interface glGetTexLevelParameterv
      subroutine glGetTexLevelParameterfv(target,level,pname,params) &
         bind(C,name='glGetTexLevelParameterfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexLevelParameterfv
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLenum),value :: pname
         real(GLfloat) params(*)
      end subroutine glGetTexLevelParameterfv

      subroutine glGetTexLevelParameteriv(target,level,pname,params) &
         bind(C,name='glGetTexLevelParameteriv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexLevelParameteriv
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLenum),value :: pname
         integer(GLint) params(*)
      end subroutine glGetTexLevelParameteriv
   end interface glGetTexLevelParameterv

   public glGetTexParameterv, glGetTexParameterfv, glGetTexParameteriv
   interface glGetTexParameterv
      subroutine glGetTexParameterfv(target,pname,params) &
         bind(C,name='glGetTexParameterfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexParameterfv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         real(GLfloat) params(*)
      end subroutine glGetTexParameterfv

      subroutine glGetTexParameteriv(target,pname,params) &
         bind(C,name='glGetTexParameteriv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glGetTexParameteriv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         integer(GLint) params(*)
      end subroutine glGetTexParameteriv
   end interface glGetTexParameterv

   public glHint
   interface
      subroutine glHint(target,mode) &
         bind(C,name='glHint')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glHint
         integer(GLenum),value :: target
         integer(GLenum),value :: mode
      end subroutine glHint
   end interface

   public glIndexMask
   interface
      subroutine glIndexMask(mask) &
         bind(C,name='glIndexMask')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexMask
         integer(GLuint),value :: mask
      end subroutine glIndexMask
   end interface

   public glIndexPointer
   interface
      subroutine glIndexPointer(type,stride,pointer) &
         bind(C,name='glIndexPointer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexPointer
         integer(GLenum),value :: type
         integer(GLsizei),value :: stride
         type(C_PTR),value :: pointer
      end subroutine glIndexPointer
   end interface

   public glIndex, glIndexd, glIndexf, glIndexi, glIndexs
   interface glIndex
      subroutine glIndexd(c) &
         bind(C,name='glIndexd')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexd
         real(GLdouble),value :: c
      end subroutine glIndexd

      subroutine glIndexf(c) &
         bind(C,name='glIndexf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexf
         real(GLfloat),value :: c
      end subroutine glIndexf

      subroutine glIndexi(c) &
         bind(C,name='glIndexi')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexi
         integer(GLint),value :: c
      end subroutine glIndexi

      subroutine glIndexs(c) &
         bind(C,name='glIndexs')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexs
         integer(GLshort),value :: c
      end subroutine glIndexs
   end interface glIndex

   public glIndexv, glIndexdv, glIndexfv, glIndexiv, glIndexsv
   interface glIndexv
      subroutine glIndexdv(c) &
         bind(C,name='glIndexdv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexdv
         real(GLdouble),intent(in) :: c(1)
      end subroutine glIndexdv

      subroutine glIndexfv(c) &
         bind(C,name='glIndexfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexfv
         real(GLfloat),intent(in) :: c(1)
      end subroutine glIndexfv

      subroutine glIndexiv(c) &
         bind(C,name='glIndexiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexiv
         integer(GLint),intent(in) :: c(1)
      end subroutine glIndexiv

      subroutine glIndexsv(c) &
         bind(C,name='glIndexsv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexsv
         integer(GLshort),intent(in) :: c(1)
      end subroutine glIndexsv
   end interface glIndexv

   public glIndexu, glIndexub
   interface glIndexu
      subroutine glIndexub(c) &
         bind(C,name='glIndexub')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexub
         integer(GLubyte),value :: c
      end subroutine glIndexub
   end interface glIndexu

   public glIndexuv, glIndexubv
   interface glIndexuv
      subroutine glIndexubv(c) &
         bind(C,name='glIndexubv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIndexubv
         integer(GLubyte),intent(in) :: c(1)
      end subroutine glIndexubv
   end interface glIndexuv

   public glInitNames
   interface
      subroutine glInitNames() bind(C,name='glInitNames')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glInitNames
      end subroutine glInitNames
   end interface

   public glInterleavedArrays
   interface
      subroutine glInterleavedArrays(format,stride,pointer) &
         bind(C,name='glInterleavedArrays')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glInterleavedArrays
         integer(GLenum),value :: format
         integer(GLsizei),value :: stride
         type(C_PTR),value :: pointer
      end subroutine glInterleavedArrays
   end interface

   public glIsEnabled
   interface
      function glIsEnabled(cap) &
         bind(C,name='glIsEnabled')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIsEnabled
         integer(GLboolean) glIsEnabled
         integer(GLenum),value :: cap
      end function glIsEnabled
   end interface

   public glIsList
   interface
      function glIsList(list) &
         bind(C,name='glIsList')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIsList
         integer(GLboolean) glIsList
         integer(GLuint),value :: list
      end function glIsList
   end interface

   public glIsTexture
   interface
      function glIsTexture(texture) &
         bind(C,name='glIsTexture')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glIsTexture
         integer(GLboolean) glIsTexture
         integer(GLuint),value :: texture
      end function glIsTexture
   end interface

   public glLightModel, glLightModelf, glLightModeli
   interface glLightModel
      subroutine glLightModelf(pname,param) &
         bind(C,name='glLightModelf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLightModelf
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glLightModelf

      subroutine glLightModeli(pname,param) &
         bind(C,name='glLightModeli')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLightModeli
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glLightModeli
   end interface glLightModel

   public glLightModelv, glLightModelfv, glLightModeliv
   interface glLightModelv
      subroutine glLightModelfv(pname,params) &
         bind(C,name='glLightModelfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLightModelfv
         integer(GLenum),value :: pname
         real(GLfloat),intent(in) :: params(*)
      end subroutine glLightModelfv

      subroutine glLightModeliv(pname,params) &
         bind(C,name='glLightModeliv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLightModeliv
         integer(GLenum),value :: pname
         integer(GLint),intent(in) :: params(*)
      end subroutine glLightModeliv
   end interface glLightModelv

   public glLight, glLightf, glLighti
   interface glLight
      subroutine glLightf(light,pname,param) &
         bind(C,name='glLightf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLightf
         integer(GLenum),value :: light
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glLightf

      subroutine glLighti(light,pname,param) &
         bind(C,name='glLighti')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLighti
         integer(GLenum),value :: light
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glLighti
   end interface glLight

   public glLightv, glLightfv, glLightiv
   interface glLightv
      subroutine glLightfv(light,pname,params) &
         bind(C,name='glLightfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLightfv
         integer(GLenum),value :: light
         integer(GLenum),value :: pname
         real(GLfloat),intent(in) :: params(*)
      end subroutine glLightfv

      subroutine glLightiv(light,pname,params) &
         bind(C,name='glLightiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLightiv
         integer(GLenum),value :: light
         integer(GLenum),value :: pname
         integer(GLint),intent(in) :: params(*)
      end subroutine glLightiv
   end interface glLightv

   public glLineStipple
   interface
      subroutine glLineStipple(factor,pattern) &
         bind(C,name='glLineStipple')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLineStipple
         integer(GLint),value :: factor
         integer(GLushort),value :: pattern
      end subroutine glLineStipple
   end interface

   public glLineWidth
   interface
      subroutine glLineWidth(width) &
         bind(C,name='glLineWidth')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLineWidth
         real(GLfloat),value :: width
      end subroutine glLineWidth
   end interface

   public glListBase
   interface
      subroutine glListBase(base) &
         bind(C,name='glListBase')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glListBase
         integer(GLuint),value :: base
      end subroutine glListBase
   end interface

   public glLoadIdentity
   interface
      subroutine glLoadIdentity() bind(C,name='glLoadIdentity')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLoadIdentity
      end subroutine glLoadIdentity
   end interface

   public glLoadMatrix, glLoadMatrixd, glLoadMatrixf

   public glLoadName
   interface
      subroutine glLoadName(name) &
         bind(C,name='glLoadName')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLoadName
         integer(GLuint),value :: name
      end subroutine glLoadName
   end interface

   public glLogicOp
   interface
      subroutine glLogicOp(opcode) &
         bind(C,name='glLogicOp')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glLogicOp
         integer(GLenum),value :: opcode
      end subroutine glLogicOp
   end interface

   public glMap1, glMap1d, glMap1f
   interface glMap1
      subroutine glMap1d(target,u1,u2,stride,order,points) &
         bind(C,name='glMap1d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMap1d
         integer(GLenum),value :: target
         real(GLdouble),value :: u1
         real(GLdouble),value :: u2
         integer(GLint),value :: stride
         integer(GLint),value :: order
         real(GLdouble),intent(in) :: points(*)
      end subroutine glMap1d

      subroutine glMap1f(target,u1,u2,stride,order,points) &
         bind(C,name='glMap1f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMap1f
         integer(GLenum),value :: target
         real(GLfloat),value :: u1
         real(GLfloat),value :: u2
         integer(GLint),value :: stride
         integer(GLint),value :: order
         real(GLfloat),intent(in) :: points(*)
      end subroutine glMap1f
   end interface glMap1

   public glMap2, glMap2d, glMap2f
   interface glMap2
      subroutine glMap2d(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points) &
         bind(C,name='glMap2d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMap2d
         integer(GLenum),value :: target
         real(GLdouble),value :: u1
         real(GLdouble),value :: u2
         integer(GLint),value :: ustride
         integer(GLint),value :: uorder
         real(GLdouble),value :: v1
         real(GLdouble),value :: v2
         integer(GLint),value :: vstride
         integer(GLint),value :: vorder
         real(GLdouble),intent(in) :: points(*)
      end subroutine glMap2d

      subroutine glMap2f(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points) &
         bind(C,name='glMap2f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMap2f
         integer(GLenum),value :: target
         real(GLfloat),value :: u1
         real(GLfloat),value :: u2
         integer(GLint),value :: ustride
         integer(GLint),value :: uorder
         real(GLfloat),value :: v1
         real(GLfloat),value :: v2
         integer(GLint),value :: vstride
         integer(GLint),value :: vorder
         real(GLfloat),intent(in) :: points(*)
      end subroutine glMap2f
   end interface glMap2

   public glMapGrid1, glMapGrid1d, glMapGrid1f
   interface glMapGrid1
      subroutine glMapGrid1d(un,u1,u2) &
         bind(C,name='glMapGrid1d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMapGrid1d
         integer(GLint),value :: un
         real(GLdouble),value :: u1
         real(GLdouble),value :: u2
      end subroutine glMapGrid1d

      subroutine glMapGrid1f(un,u1,u2) &
         bind(C,name='glMapGrid1f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMapGrid1f
         integer(GLint),value :: un
         real(GLfloat),value :: u1
         real(GLfloat),value :: u2
      end subroutine glMapGrid1f
   end interface glMapGrid1

   public glMapGrid2, glMapGrid2d, glMapGrid2f
   interface glMapGrid2
      subroutine glMapGrid2d(un,u1,u2,vn,v1,v2) &
         bind(C,name='glMapGrid2d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMapGrid2d
         integer(GLint),value :: un
         real(GLdouble),value :: u1
         real(GLdouble),value :: u2
         integer(GLint),value :: vn
         real(GLdouble),value :: v1
         real(GLdouble),value :: v2
      end subroutine glMapGrid2d

      subroutine glMapGrid2f(un,u1,u2,vn,v1,v2) &
         bind(C,name='glMapGrid2f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMapGrid2f
         integer(GLint),value :: un
         real(GLfloat),value :: u1
         real(GLfloat),value :: u2
         integer(GLint),value :: vn
         real(GLfloat),value :: v1
         real(GLfloat),value :: v2
      end subroutine glMapGrid2f
   end interface glMapGrid2

   public glMaterial, glMaterialf, glMateriali
   interface glMaterial
      subroutine glMaterialf(face,pname,param) &
         bind(C,name='glMaterialf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMaterialf
         integer(GLenum),value :: face
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glMaterialf

      subroutine glMateriali(face,pname,param) &
         bind(C,name='glMateriali')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMateriali
         integer(GLenum),value :: face
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glMateriali
   end interface glMaterial

   public glMaterialv, glMaterialfv, glMaterialiv
   interface glMaterialv
      subroutine glMaterialfv(face,pname,params) &
         bind(C,name='glMaterialfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMaterialfv
         integer(GLenum),value :: face
         integer(GLenum),value :: pname
         real(GLfloat),intent(in) :: params(*)
      end subroutine glMaterialfv

      subroutine glMaterialiv(face,pname,params) &
         bind(C,name='glMaterialiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMaterialiv
         integer(GLenum),value :: face
         integer(GLenum),value :: pname
         integer(GLint),intent(in) :: params(*)
      end subroutine glMaterialiv
   end interface glMaterialv

   public glMatrixMode
   interface
      subroutine glMatrixMode(mode) &
         bind(C,name='glMatrixMode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glMatrixMode
         integer(GLenum),value :: mode
      end subroutine glMatrixMode
   end interface

   public glMultMatrix, glMultMatrixd, glMultMatrixf

   public glNewList
   interface
      subroutine glNewList(list,mode) &
         bind(C,name='glNewList')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNewList
         integer(GLuint),value :: list
         integer(GLenum),value :: mode
      end subroutine glNewList
   end interface

   public glNormal3, glNormal3b, glNormal3d, glNormal3f, glNormal3i, glNormal3s
   interface glNormal3
      subroutine glNormal3b (nx,ny,nz) &
         bind(C,name='glNormal3b ')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3b
         integer(GLbyte),value :: nx
         integer(GLbyte),value :: ny
         integer(GLbyte),value :: nz
      end subroutine glNormal3b

      subroutine glNormal3d(nx,ny,nz) &
         bind(C,name='glNormal3d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3d
         real(GLdouble),value :: nx
         real(GLdouble),value :: ny
         real(GLdouble),value :: nz
      end subroutine glNormal3d

      subroutine glNormal3f(nx,ny,nz) &
         bind(C,name='glNormal3f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3f
         real(GLfloat),value :: nx
         real(GLfloat),value :: ny
         real(GLfloat),value :: nz
      end subroutine glNormal3f

      subroutine glNormal3i(nx,ny,nz) &
         bind(C,name='glNormal3i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3i
         integer(GLint),value :: nx
         integer(GLint),value :: ny
         integer(GLint),value :: nz
      end subroutine glNormal3i

      subroutine glNormal3s(nx,ny,nz) &
         bind(C,name='glNormal3s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3s
         integer(GLshort),value :: nx
         integer(GLshort),value :: ny
         integer(GLshort),value :: nz
      end subroutine glNormal3s
   end interface glNormal3

   public glNormal3v, glNormal3bv, glNormal3dv, &
      glNormal3fv, glNormal3iv, glNormal3sv
   interface glNormal3v
      subroutine glNormal3bv(v) &
         bind(C,name='glNormal3bv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3bv
         integer(GLbyte),intent(in) :: v(3)
      end subroutine glNormal3bv

      subroutine glNormal3dv(v) &
         bind(C,name='glNormal3dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3dv
         real(GLdouble),intent(in) :: v(3)
      end subroutine glNormal3dv

      subroutine glNormal3fv(v) &
         bind(C,name='glNormal3fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3fv
         real(GLfloat),intent(in) :: v(3)
      end subroutine glNormal3fv

      subroutine glNormal3iv(v) &
         bind(C,name='glNormal3iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3iv
         integer(GLint),intent(in) :: v(3)
      end subroutine glNormal3iv

      subroutine glNormal3sv(v) &
         bind(C,name='glNormal3sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormal3sv
         integer(GLshort),intent(in) :: v(3)
      end subroutine glNormal3sv
   end interface glNormal3v

   public glNormalPointer
   interface
      subroutine glNormalPointer(type,stride,pointer) &
         bind(C,name='glNormalPointer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glNormalPointer
         integer(GLenum),value :: type
         integer(GLsizei),value :: stride
         type(C_PTR),value :: pointer
      end subroutine glNormalPointer
   end interface

   public glOrtho
   interface
      subroutine glOrtho(left,right,bottom,top,zNear,zFar) &
         bind(C,name='glOrtho')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glOrtho
         real(GLdouble),value :: left
         real(GLdouble),value :: right
         real(GLdouble),value :: bottom
         real(GLdouble),value :: top
         real(GLdouble),value :: zNear
         real(GLdouble),value :: zFar
      end subroutine glOrtho
   end interface

   public glPassThrough
   interface
      subroutine glPassThrough(token) &
         bind(C,name='glPassThrough')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPassThrough
         real(GLfloat),value :: token
      end subroutine glPassThrough
   end interface

   public glPixelMapv, glPixelMapfv, glPixelMapuiv, glPixelMapusv
   interface glPixelMapv
      subroutine glPixelMapfv(map,mapsize,values) &
         bind(C,name='glPixelMapfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelMapfv
         integer(GLenum),value :: map
         integer(GLsizei),value :: mapsize
         real(GLfloat),intent(in) :: values(*)
      end subroutine glPixelMapfv

      subroutine glPixelMapuiv(map,mapsize,values) &
         bind(C,name='glPixelMapuiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelMapuiv
         integer(GLenum),value :: map
         integer(GLsizei),value :: mapsize
         integer(GLuint),intent(in) :: values(*)
      end subroutine glPixelMapuiv

      subroutine glPixelMapusv(map,mapsize,values) &
         bind(C,name='glPixelMapusv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelMapusv
         integer(GLenum),value :: map
         integer(GLsizei),value :: mapsize
         integer(GLushort),intent(in) :: values(*)
      end subroutine glPixelMapusv
   end interface glPixelMapv

   public glPixelStore, glPixelStoref, glPixelStorei
   interface glPixelStore
      subroutine glPixelStoref(pname,param) &
         bind(C,name='glPixelStoref')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelStoref
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glPixelStoref

      subroutine glPixelStorei(pname,param) &
         bind(C,name='glPixelStorei')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelStorei
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glPixelStorei
   end interface glPixelStore

   public glPixelTransfer, glPixelTransferf, glPixelTransferi
   interface glPixelTransfer
      subroutine glPixelTransferf(pname,param) &
         bind(C,name='glPixelTransferf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelTransferf
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glPixelTransferf

      subroutine glPixelTransferi(pname,param) &
         bind(C,name='glPixelTransferi')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelTransferi
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glPixelTransferi
   end interface glPixelTransfer

   public glPixelZoom
   interface
      subroutine glPixelZoom(xfactor,yfactor) &
         bind(C,name='glPixelZoom')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPixelZoom
         real(GLfloat),value :: xfactor
         real(GLfloat),value :: yfactor
      end subroutine glPixelZoom
   end interface

   public glPointSize
   interface
      subroutine glPointSize(size) &
         bind(C,name='glPointSize')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPointSize
         real(GLfloat),value :: size
      end subroutine glPointSize
   end interface

   public glPolygonMode
   interface
      subroutine glPolygonMode(face,mode) &
         bind(C,name='glPolygonMode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPolygonMode
         integer(GLenum),value :: face
         integer(GLenum),value :: mode
      end subroutine glPolygonMode
   end interface

   public glPolygonOffset
   interface
      subroutine glPolygonOffset(factor,units) &
         bind(C,name='glPolygonOffset')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPolygonOffset
         real(GLfloat),value :: factor
         real(GLfloat),value :: units
      end subroutine glPolygonOffset
   end interface

   public glPolygonStipple
   interface
      subroutine glPolygonStipple(mask) &
         bind(C,name='glPolygonStipple')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPolygonStipple
         integer(GLubyte),intent(in) :: mask(*)
      end subroutine glPolygonStipple
   end interface

   public glPopAttrib
   interface
      subroutine glPopAttrib() bind(C,name='glPopAttrib')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPopAttrib
      end subroutine glPopAttrib
   end interface

   public glPopClientAttrib
   interface
      subroutine glPopClientAttrib() bind(C,name='glPopClientAttrib')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPopClientAttrib
      end subroutine glPopClientAttrib
   end interface

   public glPopMatrix
   interface
      subroutine glPopMatrix() bind(C,name='glPopMatrix')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPopMatrix
      end subroutine glPopMatrix
   end interface

   public glPopName
   interface
      subroutine glPopName() bind(C,name='glPopName')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPopName
      end subroutine glPopName
   end interface

   public glPrioritizeTextures
   interface
      subroutine glPrioritizeTextures(n,textures,priorities) &
         bind(C,name='glPrioritizeTextures')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPrioritizeTextures
         integer(GLsizei),value :: n
         integer(GLuint),intent(in) :: textures(*)
         real(GLclampf),intent(in) :: priorities(*)
      end subroutine glPrioritizeTextures
   end interface

   public glPushAttrib
   interface
      subroutine glPushAttrib(mask) &
         bind(C,name='glPushAttrib')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPushAttrib
         integer(GLbitfield),value :: mask
      end subroutine glPushAttrib
   end interface

   public glPushClientAttrib
   interface
      subroutine glPushClientAttrib(mask) &
         bind(C,name='glPushClientAttrib')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPushClientAttrib
         integer(GLbitfield),value :: mask
      end subroutine glPushClientAttrib
   end interface

   public glPushMatrix
   interface
      subroutine glPushMatrix() bind(C,name='glPushMatrix')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPushMatrix
      end subroutine glPushMatrix
   end interface

   public glPushName
   interface
      subroutine glPushName(name) &
         bind(C,name='glPushName')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glPushName
         integer(GLuint),value :: name
      end subroutine glPushName
   end interface

   public glRasterPos2, glRasterPos2d, &
      glRasterPos2f, glRasterPos2i, glRasterPos2s
   interface glRasterPos2
      subroutine glRasterPos2d(x,y) &
         bind(C,name='glRasterPos2d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2d
         real(GLdouble),value :: x
         real(GLdouble),value :: y
      end subroutine glRasterPos2d

      subroutine glRasterPos2f(x,y) &
         bind(C,name='glRasterPos2f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2f
         real(GLfloat),value :: x
         real(GLfloat),value :: y
      end subroutine glRasterPos2f

      subroutine glRasterPos2i(x,y) &
         bind(C,name='glRasterPos2i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2i
         integer(GLint),value :: x
         integer(GLint),value :: y
      end subroutine glRasterPos2i

      subroutine glRasterPos2s(x,y) &
         bind(C,name='glRasterPos2s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2s
         integer(GLshort),value :: x
         integer(GLshort),value :: y
      end subroutine glRasterPos2s
   end interface glRasterPos2

   public glRasterPos2v, glRasterPos2dv, &
      glRasterPos2fv, glRasterPos2iv, glRasterPos2sv
   interface glRasterPos2v
      subroutine glRasterPos2dv(v) &
         bind(C,name='glRasterPos2dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2dv
         real(GLdouble),intent(in) :: v(2)
      end subroutine glRasterPos2dv

      subroutine glRasterPos2fv(v) &
         bind(C,name='glRasterPos2fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2fv
         real(GLfloat),intent(in) :: v(2)
      end subroutine glRasterPos2fv

      subroutine glRasterPos2iv(v) &
         bind(C,name='glRasterPos2iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2iv
         integer(GLint),intent(in) :: v(2)
      end subroutine glRasterPos2iv

      subroutine glRasterPos2sv(v) &
         bind(C,name='glRasterPos2sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos2sv
         integer(GLshort),intent(in) :: v(2)
      end subroutine glRasterPos2sv
   end interface glRasterPos2v

   public glRasterPos3, glRasterPos3d, &
      glRasterPos3f, glRasterPos3i, glRasterPos3s
   interface glRasterPos3
      subroutine glRasterPos3d(x,y,z) &
         bind(C,name='glRasterPos3d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3d
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
      end subroutine glRasterPos3d

      subroutine glRasterPos3f(x,y,z) &
         bind(C,name='glRasterPos3f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3f
         real(GLfloat),value :: x
         real(GLfloat),value :: y
         real(GLfloat),value :: z
      end subroutine glRasterPos3f

      subroutine glRasterPos3i(x,y,z) &
         bind(C,name='glRasterPos3i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3i
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLint),value :: z
      end subroutine glRasterPos3i

      subroutine glRasterPos3s(x,y,z) &
         bind(C,name='glRasterPos3s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3s
         integer(GLshort),value :: x
         integer(GLshort),value :: y
         integer(GLshort),value :: z
      end subroutine glRasterPos3s
   end interface glRasterPos3

   public glRasterPos3v, glRasterPos3dv, &
      glRasterPos3fv, glRasterPos3iv, glRasterPos3sv
   interface glRasterPos3v
      subroutine glRasterPos3dv(v) &
         bind(C,name='glRasterPos3dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3dv
         real(GLdouble),intent(in) :: v(3)
      end subroutine glRasterPos3dv

      subroutine glRasterPos3fv(v) &
         bind(C,name='glRasterPos3fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3fv
         real(GLfloat),intent(in) :: v(3)
      end subroutine glRasterPos3fv

      subroutine glRasterPos3iv(v) &
         bind(C,name='glRasterPos3iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3iv
         integer(GLint),intent(in) :: v(3)
      end subroutine glRasterPos3iv

      subroutine glRasterPos3sv(v) &
         bind(C,name='glRasterPos3sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos3sv
         integer(GLshort),intent(in) :: v(3)
      end subroutine glRasterPos3sv
   end interface glRasterPos3v

   public glRasterPos4, glRasterPos4d, &
      glRasterPos4f, glRasterPos4i, glRasterPos4s
   interface glRasterPos4
      subroutine glRasterPos4d(x,y,z,w) &
         bind(C,name='glRasterPos4d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4d
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
         real(GLdouble),value :: w
      end subroutine glRasterPos4d

      subroutine glRasterPos4f(x,y,z,w) &
         bind(C,name='glRasterPos4f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4f
         real(GLfloat),value :: x
         real(GLfloat),value :: y
         real(GLfloat),value :: z
         real(GLfloat),value :: w
      end subroutine glRasterPos4f

      subroutine glRasterPos4i(x,y,z,w) &
         bind(C,name='glRasterPos4i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4i
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLint),value :: z
         integer(GLint),value :: w
      end subroutine glRasterPos4i

      subroutine glRasterPos4s(x,y,z,w) &
         bind(C,name='glRasterPos4s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4s
         integer(GLshort),value :: x
         integer(GLshort),value :: y
         integer(GLshort),value :: z
         integer(GLshort),value :: w
      end subroutine glRasterPos4s
   end interface glRasterPos4

   public glRasterPos4v, glRasterPos4dv, &
      glRasterPos4fv, glRasterPos4iv, glRasterPos4sv
   interface glRasterPos4v
      subroutine glRasterPos4dv(v) &
         bind(C,name='glRasterPos4dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4dv
         real(GLdouble),intent(in) :: v(4)
      end subroutine glRasterPos4dv

      subroutine glRasterPos4fv(v) &
         bind(C,name='glRasterPos4fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4fv
         real(GLfloat),intent(in) :: v(4)
      end subroutine glRasterPos4fv

      subroutine glRasterPos4iv(v) &
         bind(C,name='glRasterPos4iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4iv
         integer(GLint),intent(in) :: v(4)
      end subroutine glRasterPos4iv

      subroutine glRasterPos4sv(v) &
         bind(C,name='glRasterPos4sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRasterPos4sv
         integer(GLshort),intent(in) :: v(4)
      end subroutine glRasterPos4sv
   end interface glRasterPos4v

   public glReadBuffer
   interface
      subroutine glReadBuffer(mode) &
         bind(C,name='glReadBuffer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glReadBuffer
         integer(GLenum),value :: mode
      end subroutine glReadBuffer
   end interface

   public glReadPixels
   interface
      subroutine glReadPixels(x,y,width,height,format,type,pixels) &
         bind(C,name='glReadPixels')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glReadPixels
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: pixels
      end subroutine glReadPixels
   end interface

   public glRect, glRectd, glRectf, glRecti, glRects
   interface glRect
      subroutine glRectd(x1,y1,x2,y2) &
         bind(C,name='glRectd')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRectd
         real(GLdouble),value :: x1
         real(GLdouble),value :: y1
         real(GLdouble),value :: x2
         real(GLdouble),value :: y2
      end subroutine glRectd

      subroutine glRectf(x1,y1,x2,y2) &
         bind(C,name='glRectf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRectf
         real(GLfloat),value :: x1
         real(GLfloat),value :: y1
         real(GLfloat),value :: x2
         real(GLfloat),value :: y2
      end subroutine glRectf

      subroutine glRecti(x1,y1,x2,y2) &
         bind(C,name='glRecti')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRecti
         integer(GLint),value :: x1
         integer(GLint),value :: y1
         integer(GLint),value :: x2
         integer(GLint),value :: y2
      end subroutine glRecti

      subroutine glRects(x1,y1,x2,y2) &
         bind(C,name='glRects')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRects
         integer(GLshort),value :: x1
         integer(GLshort),value :: y1
         integer(GLshort),value :: x2
         integer(GLshort),value :: y2
      end subroutine glRects
   end interface glRect

   public glRectv, glRectdv, glRectfv, glRectiv, glRectsv
   interface glRectv
      subroutine glRectdv(v1,v2) &
         bind(C,name='glRectdv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRectdv
         real(GLdouble),intent(in) :: v1(2)
         real(GLdouble),intent(in) :: v2(2)
      end subroutine glRectdv

      subroutine glRectfv(v1,v2) &
         bind(C,name='glRectfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRectfv
         real(GLfloat),intent(in) :: v1(2)
         real(GLfloat),intent(in) :: v2(2)
      end subroutine glRectfv

      subroutine glRectiv(v1,v2) &
         bind(C,name='glRectiv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRectiv
         integer(GLint),intent(in) :: v1(2)
         integer(GLint),intent(in) :: v2(2)
      end subroutine glRectiv

      subroutine glRectsv(v1,v2) &
         bind(C,name='glRectsv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRectsv
         integer(GLshort),intent(in) :: v1(2)
         integer(GLshort),intent(in) :: v2(2)
      end subroutine glRectsv
   end interface glRectv

   public glRenderMode
   interface
      function glRenderMode(mode) &
         bind(C,name='glRenderMode')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRenderMode
         integer(GLint) glRenderMode
         integer(GLenum),value :: mode
      end function glRenderMode
   end interface

   public glRotate, glRotated, glRotatef
   interface glRotate
      subroutine glRotated(angle,x,y,z) &
         bind(C,name='glRotated')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRotated
         real(GLdouble),value :: angle
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
      end subroutine glRotated

      subroutine glRotatef(angle,x,y,z) &
         bind(C,name='glRotatef')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glRotatef
         real(GLfloat),value :: angle
         real(GLfloat),value :: x
         real(GLfloat),value :: y
         real(GLfloat),value :: z
      end subroutine glRotatef
   end interface glRotate

   public glScale, glScaled, glScalef
   interface glScale
      subroutine glScaled(x,y,z) &
         bind(C,name='glScaled')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glScaled
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
      end subroutine glScaled

      subroutine glScalef(x,y,z) &
         bind(C,name='glScalef')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glScalef
         real(GLfloat),value :: x
         real(GLfloat),value :: y
         real(GLfloat),value :: z
      end subroutine glScalef
   end interface glScale

   public glScissor
   interface
      subroutine glScissor(x,y,width,height) &
         bind(C,name='glScissor')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glScissor
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
      end subroutine glScissor
   end interface

   public glSelectBuffer
   interface
      subroutine glSelectBuffer(size,buffer) &
         bind(C,name='glSelectBuffer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glSelectBuffer
         integer(GLsizei),value :: size
!         integer(GLuint),target,volatile :: buffer(*)
         type(C_PTR),value :: buffer
      end subroutine glSelectBuffer
   end interface

   public glShadeModel
   interface
      subroutine glShadeModel(mode) &
         bind(C,name='glShadeModel')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glShadeModel
         integer(GLenum),value :: mode
      end subroutine glShadeModel
   end interface

   public glStencilFunc
   interface
      subroutine glStencilFunc(func,ref,mask) &
         bind(C,name='glStencilFunc')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glStencilFunc
         integer(GLenum),value :: func
         integer(GLint),value :: ref
         integer(GLuint),value :: mask
      end subroutine glStencilFunc
   end interface

   public glStencilMask
   interface
      subroutine glStencilMask(mask) &
         bind(C,name='glStencilMask')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glStencilMask
         integer(GLuint),value :: mask
      end subroutine glStencilMask
   end interface

   public glStencilOp
   interface
      subroutine glStencilOp(fail,zfail,zpass) &
         bind(C,name='glStencilOp')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glStencilOp
         integer(GLenum),value :: fail
         integer(GLenum),value :: zfail
         integer(GLenum),value :: zpass
      end subroutine glStencilOp
   end interface

   public glTexCoord1, glTexCoord1d, glTexCoord1f, glTexCoord1i, glTexCoord1s
   interface glTexCoord1
      subroutine glTexCoord1d(s) &
         bind(C,name='glTexCoord1d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1d
         real(GLdouble),value :: s
      end subroutine glTexCoord1d

      subroutine glTexCoord1f(s) &
         bind(C,name='glTexCoord1f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1f
         real(GLfloat),value :: s
      end subroutine glTexCoord1f

      subroutine glTexCoord1i(s) &
         bind(C,name='glTexCoord1i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1i
         integer(GLint),value :: s
      end subroutine glTexCoord1i

      subroutine glTexCoord1s(s) &
         bind(C,name='glTexCoord1s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1s
         integer(GLshort),value :: s
      end subroutine glTexCoord1s
   end interface glTexCoord1

   public glTexCoord1v, glTexCoord1dv, glTexCoord1fv, glTexCoord1iv, glTexCoord1sv
   interface glTexCoord1v
      subroutine glTexCoord1dv(v) &
         bind(C,name='glTexCoord1dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1dv
         real(GLdouble),intent(in) :: v(1)
      end subroutine glTexCoord1dv

      subroutine glTexCoord1fv(v) &
         bind(C,name='glTexCoord1fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1fv
         real(GLfloat),intent(in) :: v(1)
      end subroutine glTexCoord1fv

      subroutine glTexCoord1iv(v) &
         bind(C,name='glTexCoord1iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1iv
         integer(GLint),intent(in) :: v(1)
      end subroutine glTexCoord1iv

      subroutine glTexCoord1sv(v) &
         bind(C,name='glTexCoord1sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord1sv
         integer(GLshort),intent(in) :: v(1)
      end subroutine glTexCoord1sv
   end interface glTexCoord1v

   public glTexCoord2, glTexCoord2d, glTexCoord2f, glTexCoord2i, glTexCoord2s
   interface glTexCoord2
      subroutine glTexCoord2d(s,t) &
         bind(C,name='glTexCoord2d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2d
         real(GLdouble),value :: s
         real(GLdouble),value :: t
      end subroutine glTexCoord2d

      subroutine glTexCoord2f(s,t) &
         bind(C,name='glTexCoord2f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2f
         real(GLfloat),value :: s
         real(GLfloat),value :: t
      end subroutine glTexCoord2f

      subroutine glTexCoord2i(s,t) &
         bind(C,name='glTexCoord2i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2i
         integer(GLint),value :: s
         integer(GLint),value :: t
      end subroutine glTexCoord2i

      subroutine glTexCoord2s(s,t) &
         bind(C,name='glTexCoord2s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2s
         integer(GLshort),value :: s
         integer(GLshort),value :: t
      end subroutine glTexCoord2s
   end interface glTexCoord2

   public glTexCoord2v, glTexCoord2dv, &
      glTexCoord2fv, glTexCoord2iv, glTexCoord2sv
   interface glTexCoord2v
      subroutine glTexCoord2dv(v) &
         bind(C,name='glTexCoord2dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2dv
         real(GLdouble),intent(in) :: v(2)
      end subroutine glTexCoord2dv

      subroutine glTexCoord2fv(v) &
         bind(C,name='glTexCoord2fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2fv
         real(GLfloat),intent(in) :: v(2)
      end subroutine glTexCoord2fv

      subroutine glTexCoord2iv(v) &
         bind(C,name='glTexCoord2iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2iv
         integer(GLint),intent(in) :: v(2)
      end subroutine glTexCoord2iv

      subroutine glTexCoord2sv(v) &
         bind(C,name='glTexCoord2sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord2sv
         integer(GLshort),intent(in) :: v(2)
      end subroutine glTexCoord2sv
   end interface glTexCoord2v

   public glTexCoord3, glTexCoord3d, glTexCoord3f, glTexCoord3i, glTexCoord3s
   interface glTexCoord3
      subroutine glTexCoord3d(s,t,r) &
         bind(C,name='glTexCoord3d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3d
         real(GLdouble),value :: s
         real(GLdouble),value :: t
         real(GLdouble),value :: r
      end subroutine glTexCoord3d

      subroutine glTexCoord3f(s,t,r) &
         bind(C,name='glTexCoord3f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3f
         real(GLfloat),value :: s
         real(GLfloat),value :: t
         real(GLfloat),value :: r
      end subroutine glTexCoord3f

      subroutine glTexCoord3i(s,t,r) &
         bind(C,name='glTexCoord3i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3i
         integer(GLint),value :: s
         integer(GLint),value :: t
         integer(GLint),value :: r
      end subroutine glTexCoord3i

      subroutine glTexCoord3s(s,t,r) &
         bind(C,name='glTexCoord3s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3s
         integer(GLshort),value :: s
         integer(GLshort),value :: t
         integer(GLshort),value :: r
      end subroutine glTexCoord3s
   end interface glTexCoord3

   public glTexCoord3v, glTexCoord3dv, &
      glTexCoord3fv, glTexCoord3iv, glTexCoord3sv
   interface glTexCoord3v
      subroutine glTexCoord3dv(v) &
         bind(C,name='glTexCoord3dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3dv
         real(GLdouble),intent(in) :: v(3)
      end subroutine glTexCoord3dv

      subroutine glTexCoord3fv(v) &
         bind(C,name='glTexCoord3fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3fv
         real(GLfloat),intent(in) :: v(3)
      end subroutine glTexCoord3fv

      subroutine glTexCoord3iv(v) &
         bind(C,name='glTexCoord3iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3iv
         integer(GLint),intent(in) :: v(3)
      end subroutine glTexCoord3iv

      subroutine glTexCoord3sv(v) &
         bind(C,name='glTexCoord3sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord3sv
         integer(GLshort),intent(in) :: v(3)
      end subroutine glTexCoord3sv
   end interface glTexCoord3v

   public glTexCoord4, glTexCoord4d, glTexCoord4f, glTexCoord4i, glTexCoord4s
   interface glTexCoord4
      subroutine glTexCoord4d(s,t,r,q) &
         bind(C,name='glTexCoord4d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4d
         real(GLdouble),value :: s
         real(GLdouble),value :: t
         real(GLdouble),value :: r
         real(GLdouble),value :: q
      end subroutine glTexCoord4d

      subroutine glTexCoord4f(s,t,r,q) &
         bind(C,name='glTexCoord4f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4f
         real(GLfloat),value :: s
         real(GLfloat),value :: t
         real(GLfloat),value :: r
         real(GLfloat),value :: q
      end subroutine glTexCoord4f

      subroutine glTexCoord4i(s,t,r,q) &
         bind(C,name='glTexCoord4i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4i
         integer(GLint),value :: s
         integer(GLint),value :: t
         integer(GLint),value :: r
         integer(GLint),value :: q
      end subroutine glTexCoord4i

      subroutine glTexCoord4s(s,t,r,q) &
         bind(C,name='glTexCoord4s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4s
         integer(GLshort),value :: s
         integer(GLshort),value :: t
         integer(GLshort),value :: r
         integer(GLshort),value :: q
      end subroutine glTexCoord4s
   end interface glTexCoord4

   public glTexCoord4v, glTexCoord4dv, &
      glTexCoord4fv, glTexCoord4iv, glTexCoord4sv
   interface glTexCoord4v
      subroutine glTexCoord4dv(v) &
         bind(C,name='glTexCoord4dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4dv
         real(GLdouble),intent(in) :: v(4)
      end subroutine glTexCoord4dv

      subroutine glTexCoord4fv(v) &
         bind(C,name='glTexCoord4fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4fv
         real(GLfloat),intent(in) :: v(4)
      end subroutine glTexCoord4fv

      subroutine glTexCoord4iv(v) &
         bind(C,name='glTexCoord4iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4iv
         integer(GLint),intent(in) :: v(4)
      end subroutine glTexCoord4iv

      subroutine glTexCoord4sv(v) &
         bind(C,name='glTexCoord4sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoord4sv
         integer(GLshort),intent(in) :: v(4)
      end subroutine glTexCoord4sv
   end interface glTexCoord4v

   public glTexCoordPointer
   interface
      subroutine glTexCoordPointer(size,type,stride,pointer) &
         bind(C,name='glTexCoordPointer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexCoordPointer
         integer(GLint),value :: size
         integer(GLenum),value :: type
         integer(GLsizei),value :: stride
         type(C_PTR),value :: pointer
      end subroutine glTexCoordPointer
   end interface

   public glTexEnv, glTexEnvf, glTexEnvi
   interface glTexEnv
      subroutine glTexEnvf(target,pname,param) &
         bind(C,name='glTexEnvf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexEnvf
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glTexEnvf

      subroutine glTexEnvi(target,pname,param) &
         bind(C,name='glTexEnvi')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexEnvi
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glTexEnvi
   end interface glTexEnv

   public glTexEnvv, glTexEnvfv, glTexEnviv
   interface glTexEnvv
      subroutine glTexEnvfv(target,pname,params) &
         bind(C,name='glTexEnvfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexEnvfv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         real(GLfloat),intent(in) :: params(*)
      end subroutine glTexEnvfv

      subroutine glTexEnviv(target,pname,params) &
         bind(C,name='glTexEnviv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexEnviv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         integer(GLint),intent(in) :: params(*)
      end subroutine glTexEnviv
   end interface glTexEnvv

   public glTexGen, glTexGend, glTexGenf, glTexGeni
   interface glTexGen
      subroutine glTexGend(coord,pname,param) &
         bind(C,name='glTexGend')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexGend
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         real(GLdouble),value :: param
      end subroutine glTexGend

      subroutine glTexGenf(coord,pname,param) &
         bind(C,name='glTexGenf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexGenf
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glTexGenf

      subroutine glTexGeni(coord,pname,param) &
         bind(C,name='glTexGeni')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexGeni
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glTexGeni
   end interface glTexGen

   public glTexGenv, glTexGendv, glTexGenfv, glTexGeniv
   interface glTexGenv
      subroutine glTexGendv(coord,pname,params) &
         bind(C,name='glTexGendv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexGendv
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         real(GLdouble),intent(in) :: params(*)
      end subroutine glTexGendv

      subroutine glTexGenfv(coord,pname,params) &
         bind(C,name='glTexGenfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexGenfv
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         real(GLfloat),intent(in) :: params(*)
      end subroutine glTexGenfv

      subroutine glTexGeniv(coord,pname,params) &
         bind(C,name='glTexGeniv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexGeniv
         integer(GLenum),value :: coord
         integer(GLenum),value :: pname
         integer(GLint),intent(in) :: params(*)
      end subroutine glTexGeniv
   end interface glTexGenv

   public glTexImage1D
   interface
      subroutine glTexImage1D(target,level,internalformat,width,border,format,type,pixels) &
         bind(C,name='glTexImage1D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexImage1D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLint),value :: internalformat
         integer(GLsizei),value :: width
         integer(GLint),value :: border
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: pixels
      end subroutine glTexImage1D
   end interface

   public glTexImage2D
   interface
      subroutine glTexImage2D(target,level,internalformat,width, &
         height,border,format,type,pixels) &
         bind(C,name='glTexImage2D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexImage2D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLint),value :: internalformat
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
         integer(GLint),value :: border
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: pixels
      end subroutine glTexImage2D
   end interface

   public glTexParameter, glTexParameterf, glTexParameteri
   interface glTexParameter
      subroutine glTexParameterf(target,pname,param) &
         bind(C,name='glTexParameterf')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexParameterf
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         real(GLfloat),value :: param
      end subroutine glTexParameterf

      subroutine glTexParameteri(target,pname,param) &
         bind(C,name='glTexParameteri')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexParameteri
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         integer(GLint),value :: param
      end subroutine glTexParameteri
   end interface glTexParameter

   public glTexParameterv, glTexParameterfv, glTexParameteriv
   interface glTexParameterv
      subroutine glTexParameterfv(target,pname,params) &
         bind(C,name='glTexParameterfv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexParameterfv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         real(GLfloat),intent(in) :: params(*)
      end subroutine glTexParameterfv

      subroutine glTexParameteriv(target,pname,params) &
         bind(C,name='glTexParameteriv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexParameteriv
         integer(GLenum),value :: target
         integer(GLenum),value :: pname
         integer(GLint),intent(in) :: params(*)
      end subroutine glTexParameteriv
   end interface glTexParameterv

   public glTexSubImage1D
   interface
      subroutine glTexSubImage1D(target,level,xoffset,width,format,type,pixels) &
         bind(C,name='glTexSubImage1D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexSubImage1D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLint),value :: xoffset
         integer(GLsizei),value :: width
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: pixels
      end subroutine glTexSubImage1D
   end interface

   public glTexSubImage2D
   interface
      subroutine glTexSubImage2D(target,level,xoffset,yoffset,width,height,format,type,pixels) &
         bind(C,name='glTexSubImage2D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTexSubImage2D
         integer(GLenum),value :: target
         integer(GLint),value :: level
         integer(GLint),value :: xoffset
         integer(GLint),value :: yoffset
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: pixels
      end subroutine glTexSubImage2D
   end interface

   public glTranslate, glTranslated, glTranslatef
   interface glTranslate
      subroutine glTranslated(x,y,z) &
         bind(C,name='glTranslated')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTranslated
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
      end subroutine glTranslated

      subroutine glTranslatef(x,y,z) &
         bind(C,name='glTranslatef')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glTranslatef
         real(GLfloat),value :: x
         real(GLfloat),value :: y
         real(GLfloat),value :: z
      end subroutine glTranslatef
   end interface glTranslate

   public glVertex2, glVertex2d, glVertex2f, glVertex2i, glVertex2s
   interface glVertex2
      subroutine glVertex2d(x,y) &
         bind(C,name='glVertex2d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2d
         real(GLdouble),value :: x
         real(GLdouble),value :: y
      end subroutine glVertex2d

      subroutine glVertex2f(x,y) &
         bind(C,name='glVertex2f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2f
         real(GLfloat),value :: x
         real(GLfloat),value :: y
      end subroutine glVertex2f

      subroutine glVertex2i(x,y) &
         bind(C,name='glVertex2i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2i
         integer(GLint),value :: x
         integer(GLint),value :: y
      end subroutine glVertex2i

      subroutine glVertex2s(x,y) &
         bind(C,name='glVertex2s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2s
         integer(GLshort),value :: x
         integer(GLshort),value :: y
      end subroutine glVertex2s
   end interface glVertex2

   public glVertex2v, glVertex2dv, glVertex2fv, glVertex2iv, glVertex2sv
   interface glVertex2v
      subroutine glVertex2dv(v) &
         bind(C,name='glVertex2dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2dv
         real(GLdouble),intent(in) :: v(2)
      end subroutine glVertex2dv

      subroutine glVertex2fv(v) &
         bind(C,name='glVertex2fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2fv
         real(GLfloat),intent(in) :: v(2)
      end subroutine glVertex2fv

      subroutine glVertex2iv(v) &
         bind(C,name='glVertex2iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2iv
         integer(GLint),intent(in) :: v(2)
      end subroutine glVertex2iv

      subroutine glVertex2sv(v) &
         bind(C,name='glVertex2sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex2sv
         integer(GLshort),intent(in) :: v(2)
      end subroutine glVertex2sv
   end interface glVertex2v

   public glVertex3, glVertex3d, glVertex3f, glVertex3i, glVertex3s
   interface glVertex3
      subroutine glVertex3d(x,y,z) &
         bind(C,name='glVertex3d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3d
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
      end subroutine glVertex3d

      subroutine glVertex3f(x,y,z) &
         bind(C,name='glVertex3f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3f
         real(GLfloat),value :: x
         real(GLfloat),value :: y
         real(GLfloat),value :: z
      end subroutine glVertex3f

      subroutine glVertex3i(x,y,z) &
         bind(C,name='glVertex3i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3i
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLint),value :: z
      end subroutine glVertex3i

      subroutine glVertex3s(x,y,z) &
         bind(C,name='glVertex3s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3s
         integer(GLshort),value :: x
         integer(GLshort),value :: y
         integer(GLshort),value :: z
      end subroutine glVertex3s
   end interface glVertex3

   public glVertex3v, glVertex3dv, glVertex3fv, glVertex3iv, glVertex3sv
   interface glVertex3v
      subroutine glVertex3dv(v) &
         bind(C,name='glVertex3dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3dv
         real(GLdouble),intent(in) :: v(3)
      end subroutine glVertex3dv

      subroutine glVertex3fv(v) &
         bind(C,name='glVertex3fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3fv
         real(GLfloat),intent(in) :: v(3)
      end subroutine glVertex3fv

      subroutine glVertex3iv(v) &
         bind(C,name='glVertex3iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3iv
         integer(GLint),intent(in) :: v(3)
      end subroutine glVertex3iv

      subroutine glVertex3sv(v) &
         bind(C,name='glVertex3sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex3sv
         integer(GLshort),intent(in) :: v(3)
      end subroutine glVertex3sv
   end interface glVertex3v

   public glVertex4, glVertex4d, glVertex4f, glVertex4i, glVertex4s
   interface glVertex4
      subroutine glVertex4d(x,y,z,w) &
         bind(C,name='glVertex4d')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4d
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
         real(GLdouble),value :: w
      end subroutine glVertex4d

      subroutine glVertex4f(x,y,z,w) &
         bind(C,name='glVertex4f')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4f
         real(GLfloat),value :: x
         real(GLfloat),value :: y
         real(GLfloat),value :: z
         real(GLfloat),value :: w
      end subroutine glVertex4f

      subroutine glVertex4i(x,y,z,w) &
         bind(C,name='glVertex4i')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4i
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLint),value :: z
         integer(GLint),value :: w
      end subroutine glVertex4i

      subroutine glVertex4s(x,y,z,w) &
         bind(C,name='glVertex4s')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4s
         integer(GLshort),value :: x
         integer(GLshort),value :: y
         integer(GLshort),value :: z
         integer(GLshort),value :: w
      end subroutine glVertex4s
   end interface glVertex4

   public glVertex4v, glVertex4dv, glVertex4fv, glVertex4iv, glVertex4sv
   interface glVertex4v
      subroutine glVertex4dv(v) &
         bind(C,name='glVertex4dv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4dv
         real(GLdouble),intent(in) :: v(4)
      end subroutine glVertex4dv

      subroutine glVertex4fv(v) &
         bind(C,name='glVertex4fv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4fv
         real(GLfloat),intent(in) :: v(4)
      end subroutine glVertex4fv

      subroutine glVertex4iv(v) &
         bind(C,name='glVertex4iv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4iv
         integer(GLint),intent(in) :: v(4)
      end subroutine glVertex4iv

      subroutine glVertex4sv(v) &
         bind(C,name='glVertex4sv')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertex4sv
         integer(GLshort),intent(in) :: v(4)
      end subroutine glVertex4sv
   end interface glVertex4v

   public glVertexPointer
   interface
      subroutine glVertexPointer(size,type,stride,pointer) &
         bind(C,name='glVertexPointer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glVertexPointer
         integer(GLint),value :: size
         integer(GLenum),value :: type
         integer(GLsizei),value :: stride
         type(C_PTR),value :: pointer
      end subroutine glVertexPointer
   end interface

   public glViewport
   interface
      subroutine glViewport(x,y,width,height) &
         bind(C,name='glViewport')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: glViewport
         integer(GLint),value :: x
         integer(GLint),value :: y
         integer(GLsizei),value :: width
         integer(GLsizei),value :: height
      end subroutine glViewport
   end interface
end module gl

module glu_begin_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessBeginProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_begin_mod

module glu_error_mod
   use opengl_types
   implicit none
   private

   public gluQuadricCallback, gluQuadricCallback_GENERIC
   interface gluQuadricCallback_GENERIC
      subroutine gluQuadricCallback(qobj,which,fn) &
         bind(C,name='gluQuadricCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluQuadricCallback
         type(GLUquadric),value :: qobj
         integer(GLenum),value :: which
         procedure(GLUquadricErrorProc) :: fn
      end subroutine gluQuadricCallback
   end interface gluQuadricCallback_GENERIC

   public gluTessCallback, gluTessCallback_GENERIC
   interface gluTessCallback_GENERIC
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessErrorProc) fn
      end subroutine gluTessCallback
   end interface gluTessCallback_GENERIC

   public gluNurbsCallback, gluNurbsCallback_GENERIC
   interface gluNurbsCallback_GENERIC
      subroutine gluNurbsCallback(nobj,which,fn) &
         bind(C,name='gluNurbsCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNurbsCallback
         type(GLUnurbs),value :: nobj
         integer(GLenum),value :: which
         procedure(GLUnurbsErrorProc) fn
      end subroutine gluNurbsCallback
   end interface gluNurbsCallback_GENERIC
end module glu_error_mod

module glu_funptr_mod
   use opengl_types
   implicit none
   private

   public gluQuadricCallback, gluQuadricCallback_GENERIC
   interface gluQuadricCallback_GENERIC
      subroutine gluQuadricCallback(qobj,which,fn) &
         bind(C,name='gluQuadricCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluQuadricCallback
         type(GLUquadric),value :: qobj
         integer(GLenum),value :: which
         type(GLUfuncptr),value :: fn
      end subroutine gluQuadricCallback
   end interface gluQuadricCallback_GENERIC

   public gluTessCallback, gluTessCallback_GENERIC
   interface gluTessCallback_GENERIC
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         type(GLUfuncptr),value :: fn
      end subroutine gluTessCallback
   end interface gluTessCallback_GENERIC

   public gluNurbsCallback, gluNurbsCallback_GENERIC
   interface gluNurbsCallback_GENERIC
      subroutine gluNurbsCallback(nobj,which,fn) &
         bind(C,name='gluNurbsCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNurbsCallback
         type(GLUnurbs),value :: nobj
         integer(GLenum),value :: which
         type(GLUfuncptr),value :: fn
      end subroutine gluNurbsCallback
   end interface gluNurbsCallback_GENERIC
end module glu_funptr_mod

module glu_edgeFlag_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessEdgeFlagProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_edgeFlag_mod

module glu_vertex_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessVertexProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_vertex_mod

module glu_end_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessEndProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_end_mod

module glu_combine_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessCombineProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_combine_mod

module glu_beginData_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessBeginDataProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_beginData_mod

module glu_edgeFlagData_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessEdgeFlagDataProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_edgeFlagData_mod

module glu_vertexData_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessVertexDataProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_VertexData_mod

module glu_endData_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessEndDataProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_endData_mod

module glu_errorData_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessErrorDataProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_errorData_mod

module glu_combineData_mod
   use opengl_types
   implicit none
   private

   public gluTessCallback
   interface
      subroutine gluTessCallback(tess,which,fn) &
         bind(C,name='gluTessCallback')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessCallback
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         procedure(GLUtessCombineDataProc) fn
      end subroutine gluTessCallback
   end interface
end module glu_combineData_mod

module glu
   use ISO_C_BINDING
   use opengl_types
   use glu_error_mod, only: &
      gluQuadricCallback=>gluQuadricCallback_GENERIC, &
      gluTessCallback=>gluTessCallback_GENERIC, &
      gluNurbsCallback=>gluNurbsCallback_GENERIC
   use glu_error_mod, only: &
      gluQuadricErrorCallback=>gluQuadricCallback, &
      gluTessErrorCallback=>gluTessCallback, &
      gluNurbsErrorCallback=>gluNurbsCallback
   use glu_funptr_mod, only: &
      gluQuadricCallback=>gluQuadricCallback_GENERIC, &
      gluTessCallback=>gluTessCallback_GENERIC, &
      gluNurbsCallback=>gluNurbsCallback_GENERIC
   use glu_funptr_mod, only: &
      gluQuadricCallback_FUNPTR=>gluQuadricCallback, &
      gluTessCallback_FUNPTR=>gluTessCallback, &
      gluNurbsCallback_FUNPTR=>gluNurbsCallback
!! Terribly annoying that Fortran can't distinguish
!! between subroutine dummy arguments.
   use glu_begin_mod,only: gluTessBeginCallback=>gluTessCallback
   use glu_edgeFlag_mod,only: gluTessEdgeFlagCallback=>gluTessCallback
   use glu_vertex_mod,only: gluTessVertexCallback=>gluTessCallback
   use glu_end_mod,only: gluTessEndCallback=>gluTessCallback
   use glu_combine_mod,only: gluTessCombineCallback=>gluTessCallback
   use glu_beginData_mod,only: gluTessBeginDataCallback=>gluTessCallback
   use glu_edgeFlagData_mod,only: gluTessEdgeFlagDataCallback=>gluTessCallback
   use glu_vertexData_mod,only: gluTessVertexDataCallback=>gluTessCallback
   use glu_endData_mod,only: gluTessEndDataCallback=>gluTessCallback
   use glu_errorData_mod,only: gluTessErrorDataCallback=>gluTessCallback
   use glu_combineData_mod,only: gluTessCombineDataCallback=>gluTessCallback
   implicit none
   private
   public gluQuadricCallback,gluTessCallback,gluNurbsCallback
   public gluQuadricErrorCallback,gluTessBeginCallback, &
      gluTessEdgeFlagCallback,gluTessVertexCallback, &
      gluTessEndCallback,gluTessErrorCallback, &
      gluTessCombineCallback, gluTessBeginDataCallback, &
      gluTessEdgeFlagDataCallback, gluTessVertexDataCallback, &
      gluTessEndDataCallback, gluTessErrorDataCallback, &
      gluTessCombineDataCallback, gluNurbsErrorCallback, &
      gluQuadricCallback_FUNPTR, gluTessCallback_FUNPTR, &
      gluNurbsCallback_FUNPTR

   public gluErrorString
   interface
      function gluErrorString(errCode) &
         bind(C,name='gluErrorString')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluErrorString
         type(C_PTR) gluErrorString
         integer(GLenum),value :: errcode
      end function gluErrorString
   end interface

   public gluErrorUnicodeStringEXT
   interface
      function gluErrorUnicodeStringEXT(errCode) &
         bind(C,name='gluErrorUnicodeStringEXT')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluErrorUnicodeStringEXT
         type(C_PTR) gluErrorUnicodeStringEXT
         integer(GLenum),value :: errcode
      end function gluErrorUnicodeStringEXT
   end interface

   public gluGetString
   interface
      function gluGetString(name) &
         bind(C,name='gluGetString')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluGetString
         type(C_PTR) gluGetString
         integer(GLenum),value :: name
      end function gluGetString
   end interface

   public gluOrtho2D
   interface
      subroutine gluOrtho2D(left,right,bottom,top) &
         bind(C,name='gluOrtho2D')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluOrtho2D
         real(GLdouble),value :: left
         real(GLdouble),value :: right
         real(GLdouble),value :: bottom
         real(GLdouble),value :: top
      end subroutine gluOrtho2D
   end interface

   public gluPerspective
   interface
      subroutine gluPerspective(fovy,aspect,zNear,zFar) &
         bind(C,name='gluPerspective')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluPerspective
         real(GLdouble),value :: fovy
         real(GLdouble),value :: aspect
         real(GLdouble),value :: zNear
         real(GLdouble),value :: zFar
      end subroutine gluPerspective
   end interface

   public gluPickMatrix
   interface
      subroutine gluPickMatrix(x,y,width,height,viewport) &
         bind(C,name='gluPickMatrix')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluPickMatrix
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: width
         real(GLdouble),value :: height
         integer(GLint) viewport(4)
      end subroutine gluPickMatrix
   end interface

   public gluLookAt
   interface
      subroutine gluLookAt(eyex,eyey,eyez,centerx,centery,centerz,upx,upy,upz) &
         bind(C,name='gluLookAt')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluLookAt
         real(GLdouble),value :: eyex
         real(GLdouble),value :: eyey
         real(GLdouble),value :: eyez
         real(GLdouble),value :: centerx
         real(GLdouble),value :: centery
         real(GLdouble),value :: centerz
         real(GLdouble),value :: upx
         real(GLdouble),value :: upy
         real(GLdouble),value :: upz
      end subroutine gluLookAt
   end interface

   public gluProject
   interface
      function gluProject(objx,objy,objz,modelMatrix,projMatrix, &
         viewport,winx,winy,winz) &
         bind(C,name='gluProject')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluProject
         integer(C_INT) gluProject
         real(GLdouble),value :: objx
         real(GLdouble),value :: objy
         real(GLdouble),value :: objz
         real(GLdouble),intent(in) :: modelMatrix(16)
         real(GLdouble),intent(in) :: projMatrix(16)
         integer(GLint),intent(in) :: viewport(4)
         real(GLdouble) winx
         real(GLdouble) winy
         real(GLdouble) winz
      end function gluProject
   end interface

   public gluUnProject
   interface
      function gluUnProject(winx,winy,winz,modelMatrix,projMatrix,viewport,objx,objy,objz) &
         bind(C,name='gluUnProject')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluUnProject
         integer(C_INT) gluUnProject
         real(GLdouble),value :: winx
         real(GLdouble),value :: winy
         real(GLdouble),value :: winz
         real(GLdouble),intent(in) :: modelMatrix(16)
         real(GLdouble),intent(in) :: projMatrix(16)
         integer(GLint),intent(in) :: viewport(4)
         real(GLdouble) objx
         real(GLdouble) objy
         real(GLdouble) objz
      end function gluUnProject
   end interface

   public gluScaleImage
   interface
      function gluScaleImage(format,widthin,heightin,typein,datain,widthout,heightout,typeout,dataout) &
         bind(C,name='gluScaleImage')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluScaleImage
         integer(C_INT) gluScaleImage
         integer(GLenum),value :: format
         integer(GLint),value :: widthin
         integer(GLint),value :: heightin
         integer(GLenum),value :: typein
         type(C_PTR),value :: datain
         integer(GLint),value :: widthout
         integer(GLint),value :: heightout
         integer(GLenum),value :: typeout
         type(C_PTR),value :: dataout
      end function gluScaleImage
   end interface

   public gluBuild1DMipmaps
   interface
      function gluBuild1DMipmaps(target,components,width,format,type,data) &
         bind(C,name='gluBuild1DMipmaps')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluBuild1DMipmaps
         integer(C_INT) gluBuild1DMipmaps
         integer(GLenum),value :: target
         integer(GLint),value :: components
         integer(GLint),value :: width
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: data
      end function gluBuild1DMipmaps
   end interface

   public gluBuild2DMipmaps
   interface
      function gluBuild2DMipmaps(target,components,width,height,format,type,data) &
         bind(C,name='gluBuild2DMipmaps')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluBuild2DMipmaps
         integer(C_INT) gluBuild2DMipmaps
         integer(GLenum),value :: target
         integer(GLint),value :: components
         integer(GLint),value :: width
         integer(GLint),value :: height
         integer(GLenum),value :: format
         integer(GLenum),value :: type
         type(C_PTR),value :: data
      end function gluBuild2DMipmaps
   end interface

   public gluNewQuadric
   interface
      function gluNewQuadric() &
         bind(C,name='gluNewQuadric')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNewQuadric
         type(GLUquadric) gluNewQuadric
      end function gluNewQuadric
   end interface

   public gluDeleteQuadric
   interface
      subroutine gluDeleteQuadric(state) &
         bind(C,name='gluDeleteQuadric')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluDeleteQuadric
         type(GLUquadric),value :: state
      end subroutine gluDeleteQuadric
   end interface

   public gluQuadricNormals
   interface
      subroutine gluQuadricNormals(quadObject,normals) &
         bind(C,name='gluQuadricNormals')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluQuadricNormals
         type(GLUquadric),value :: quadObject
         integer(GLenum),value :: normals
      end subroutine gluQuadricNormals
   end interface

   public gluQuadricTexture
   interface
      subroutine gluQuadricTexture(quadObject,textureCoords) &
         bind(C,name='gluQuadricTexture')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluQuadricTexture
         type(GLUquadric),value :: quadObject
         integer(GLboolean),value :: textureCoords
      end subroutine gluQuadricTexture
   end interface

   public gluQuadricOrientation
   interface
      subroutine gluQuadricOrientation(quadObject,orientation) &
         bind(C,name='gluQuadricOrientation')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluQuadricOrientation
         type(GLUquadric),value :: quadObject
         integer(GLenum),value :: orientation
      end subroutine gluQuadricOrientation
   end interface

   public gluQuadricDrawStyle
   interface
      subroutine gluQuadricDrawStyle(quadObject,drawStyle) &
         bind(C,name='gluQuadricDrawStyle')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluQuadricDrawStyle
         type(GLUquadric),value :: quadObject
         integer(GLenum),value :: drawStyle
      end subroutine gluQuadricDrawStyle
   end interface

   public gluCylinder
   interface
      subroutine gluCylinder(qobj,baseRadius,topRadius,height,slices,stacks) &
         bind(C,name='gluCylinder')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluCylinder
         type(GLUquadric),value :: qobj
         real(GLdouble),value :: baseRadius
         real(GLdouble),value :: topRadius
         real(GLdouble),value :: height
         integer(GLint),value :: slices
         integer(GLint),value :: stacks
      end subroutine gluCylinder
   end interface

   public gluDisk
   interface
      subroutine gluDisk(qobj,innerRadius,outerRadius,slices,loops) &
         bind(C,name='gluDisk')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluDisk
         type(GLUquadric),value :: qobj
         real(GLdouble),value :: innerRadius
         real(GLdouble),value :: outerRadius
         integer(GLint),value :: slices
         integer(GLint),value :: loops
      end subroutine gluDisk
   end interface

   public gluPartialDisk
   interface
      subroutine gluPartialDisk(qobj,innerRadius,outerRadius, &
         slices,loops,startAngle,sweepAngle) &
         bind(C,name='gluPartialDisk')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluPartialDisk
         type(GLUquadric),value :: qobj
         real(GLdouble),value :: innerRadius
         real(GLdouble),value :: outerRadius
         integer(GLint),value :: slices
         integer(GLint),value :: loops
         real(GLdouble),value :: startAngle
         real(GLdouble),value :: sweepAngle
      end subroutine gluPartialDisk
   end interface

   public gluSphere
   interface
      subroutine gluSphere(qobj,radius,slices,stacks) &
         bind(C,name='gluSphere')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluSphere
         type(GLUquadric),value :: qobj
         real(GLdouble),value :: radius
         integer(GLint),value :: slices
         integer(GLint),value :: stacks
      end subroutine gluSphere
   end interface

   public gluNewTess
   interface
      function gluNewTess() &
         bind(C,name='gluNewTess')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNewTess
         type(GLUtesselator) gluNewTess
      end function gluNewTess
   end interface

   public gluDeleteTess
   interface
      subroutine gluDeleteTess(tess) &
         bind(C,name='gluDeleteTess')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluDeleteTess
         type(GLUtesselator),value :: tess
      end subroutine gluDeleteTess
   end interface

   public gluTessBeginPolygon
   interface
      subroutine gluTessBeginPolygon(tess,polygon_data) &
         bind(C,name='gluTessBeginPolygon')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessBeginPolygon
         type(GLUtesselator),value :: tess
         type(C_PTR),value :: polygon_data
      end subroutine gluTessBeginPolygon
   end interface

   public gluTessBeginContour
   interface
      subroutine gluTessBeginContour(tess) &
         bind(C,name='gluTessBeginContour')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessBeginContour
         type(GLUtesselator),value :: tess
      end subroutine gluTessBeginContour
   end interface

   public gluTessVertex
   interface
      subroutine gluTessVertex(tess,coords,data) &
         bind(C,name='gluTessVertex')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessVertex
         type(GLUtesselator),value :: tess
         real(GLdouble) coords(3)
         type(C_PTR),value :: data
      end subroutine gluTessVertex
   end interface

   public gluTessEndContour
   interface
      subroutine gluTessEndContour(tess) &
         bind(C,name='gluTessEndContour')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessEndContour
         type(GLUtesselator),value :: tess
      end subroutine gluTessEndContour
   end interface

   public gluTessEndPolygon
   interface
      subroutine gluTessEndPolygon(tess) &
         bind(C,name='gluTessEndPolygon')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessEndPolygon
         type(GLUtesselator),value :: tess
      end subroutine gluTessEndPolygon
   end interface

   public gluTessProperty
   interface
      subroutine gluTessProperty(tess,which,value) &
         bind(C,name='gluTessProperty')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessProperty
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         real(GLdouble),value :: value
      end subroutine gluTessProperty
   end interface

   public gluTessNormal
   interface
      subroutine gluTessNormal(tess,x,y,z) &
         bind(C,name='gluTessNormal')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluTessNormal
         type(GLUtesselator),value :: tess
         real(GLdouble),value :: x
         real(GLdouble),value :: y
         real(GLdouble),value :: z
      end subroutine gluTessNormal
   end interface

   public gluGetTessProperty
   interface
      subroutine gluGetTessProperty(tess,which,value) &
         bind(C,name='gluGetTessProperty')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluGetTessProperty
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: which
         real(GLdouble) value
      end subroutine gluGetTessProperty
   end interface

   public gluNewNurbsRenderer
   interface
      function gluNewNurbsRenderer() &
         bind(C,name='gluNewNurbsRenderer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNewNurbsRenderer
         type(GLUnurbs) gluNewNurbsRenderer
      end function gluNewNurbsRenderer
   end interface

   public gluDeleteNurbsRenderer
   interface
      subroutine gluDeleteNurbsRenderer(nobj) &
         bind(C,name='gluDeleteNurbsRenderer')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluDeleteNurbsRenderer
         type(GLUnurbs),value :: nobj
      end subroutine gluDeleteNurbsRenderer
   end interface

   public gluBeginSurface
   interface
      subroutine gluBeginSurface(nobj) &
         bind(C,name='gluBeginSurface')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluBeginSurface
         type(GLUnurbs),value :: nobj
      end subroutine gluBeginSurface
   end interface

   public gluBeginCurve
   interface
      subroutine gluBeginCurve(nobj) &
         bind(C,name='gluBeginCurve')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluBeginCurve
         type(GLUnurbs),value :: nobj
      end subroutine gluBeginCurve
   end interface

   public gluEndCurve
   interface
      subroutine gluEndCurve(nobj) &
         bind(C,name='gluEndCurve')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluEndCurve
         type(GLUnurbs),value :: nobj
      end subroutine gluEndCurve
   end interface

   public gluEndSurface
   interface
      subroutine gluEndSurface(nobj) &
         bind(C,name='gluEndSurface')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluEndSurface
         type(GLUnurbs),value :: nobj
      end subroutine gluEndSurface
   end interface

   public gluBeginTrim
   interface
      subroutine gluBeginTrim(nobj) &
         bind(C,name='gluBeginTrim')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluBeginTrim
         type(GLUnurbs),value :: nobj
      end subroutine gluBeginTrim
   end interface

   public gluEndTrim
   interface
      subroutine gluEndTrim(nobj) &
         bind(C,name='gluEndTrim')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluEndTrim
         type(GLUnurbs),value :: nobj
      end subroutine gluEndTrim
   end interface

   public gluPwlCurve
   interface
      subroutine gluPwlCurve(nobj,count,array,stride,type) &
         bind(C,name='gluPwlCurve')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluPwlCurve
         type(GLUnurbs),value :: nobj
         integer(GLint),value :: count
         real(GLfloat),intent(in) :: array(*)
         integer(GLint),value :: stride
         integer(GLenum),value :: type
      end subroutine gluPwlCurve
   end interface

   public gluNurbsCurve
   interface
      subroutine gluNurbsCurve(nobj,nknots,knot,stride,ctlarray,order,type) &
         bind(C,name='gluNurbsCurve')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNurbsCurve
         type(GLUnurbs),value :: nobj
         integer(GLint),value :: nknots
         real(GLfloat),intent(in) :: knot(*)
         integer(GLint),value :: stride
         real(GLfloat),intent(in) :: ctlarray(*)
         integer(GLint),value :: order
         integer(GLenum),value :: type
      end subroutine gluNurbsCurve
   end interface

   public gluNurbsSurface
   interface
      subroutine gluNurbsSurface(nobj,sknot_count,sknot,tknot_count, &
         tknot,s_stride,t_stride,ctlarray,sorder,torder,type) &
         bind(C,name='gluNurbsSurface')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNurbsSurface
         type(GLUnurbs),value :: nobj
         integer(GLint),value :: sknot_count
         real(GLfloat),intent(in) :: sknot(*)
         integer(GLint),value :: tknot_count
         real(GLfloat),intent(in) :: tknot(*)
         integer(GLint),value :: s_stride
         integer(GLint),value :: t_stride
         real(GLfloat),intent(in) :: ctlarray(*)
         integer(GLint),value :: sorder
         integer(GLint),value :: torder
         integer(GLenum),value :: type
      end subroutine gluNurbsSurface
   end interface

   public gluLoadSamplingMatrices
   interface
      subroutine gluLoadSamplingMatrices(nobj,modelMatrix,projMatrix,viewport) &
         bind(C,name='gluLoadSamplingMatrices')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluLoadSamplingMatrices
         type(GLUnurbs),value :: nobj
         real(GLfloat),intent(in) :: modelMatrix(16)
         real(GLfloat),intent(in) :: projMatrix(16)
         integer(GLint),intent(in) :: viewport(4)
      end subroutine gluLoadSamplingMatrices
   end interface

   public gluNurbsProperty
   interface
      subroutine gluNurbsProperty(nobj,property,value) &
         bind(C,name='gluNurbsProperty')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNurbsProperty
         type(GLUnurbs),value :: nobj
         integer(GLenum),value :: property
         real(Glfloat),value :: value
      end subroutine gluNurbsProperty
   end interface

   public gluGetNurbsProperty
   interface
      subroutine gluGetNurbsProperty(nobj,property,value) &
         bind(C,name='gluGetNurbsProperty')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluGetNurbsProperty
         type(GLUnurbs),value :: nobj
         integer(GLenum),value :: property
         real(Glfloat) value
      end subroutine gluGetNurbsProperty
   end interface

   public gluBeginPolygon
   interface
      subroutine gluBeginPolygon(tess) &
         bind(C,name='gluBeginPolygon')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluBeginPolygon
         type(GLUtesselator),value :: tess
      end subroutine gluBeginPolygon
   end interface

   public gluNextContour
   interface
      subroutine gluNextContour(tess,type) &
         bind(C,name='gluNextContour')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluNextContour
         type(GLUtesselator),value :: tess
         integer(GLenum),value :: type
      end subroutine gluNextContour
   end interface

   public gluEndPolygon
   interface
      subroutine gluEndPolygon(tess) &
         bind(C,name='gluEndPolygon')
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: gluEndPolygon
         type(GLUtesselator),value :: tess
      end subroutine gluEndPolygon
   end interface
end module glu
