! win32_types.f90
! Public domain 2010-2011 James Van Buskirk
! Compiled with:
! gfortran -Wall -fno-range-check -c win32_types.f90

module win32_types
   use ISO_C_BINDING
   use ISO_C_BINDING, only: SC_LOCK => C_PTR
   implicit none
   private

   integer, parameter, public :: BOOL = C_INT
   integer, parameter, public :: BYTE = C_SIGNED_CHAR
   integer, parameter, public :: DWORD = C_LONG
   integer, parameter, public :: DWORD32 = C_INT
   integer, parameter, public :: DWORD64 = C_INT64_T
   integer, parameter, public :: HANDLE = C_INTPTR_T
   integer, parameter, public :: INT_PTR = C_INTPTR_T
   integer, parameter, public :: INT32 = C_INT32_T
   integer, parameter, public :: INT64 = C_INT64_T
   integer, parameter, public :: LARGE_INTEGER = C_INT64_T
   integer, parameter, public :: LONG = C_LONG
   integer, parameter, public :: LONGLONG = C_INT64_T
   integer, parameter, public :: LONG_PTR = C_INTPTR_T
   integer, parameter, public :: LONG32 = C_INT
   integer, parameter, public :: LONG64 = C_INT64_T
   integer, parameter, public :: QWORD = C_INT64_T
   integer, parameter, public :: SHORT = C_SHORT
   integer, parameter, public :: UCHAR = C_CHAR
   integer, parameter, public :: UINT = C_INT
   integer, parameter, public :: UINT_PTR = C_INTPTR_T
   integer, parameter, public :: UINT8 = C_SIGNED_CHAR
   integer, parameter, public :: UINT16 = C_SHORT
   integer, parameter, public :: UINT32 = C_INT
   integer, parameter, public :: UINT64 = C_INT64_T
   integer, parameter, public :: ULONG = C_LONG
   integer, parameter, public :: ULONGLONG = C_INT64_T
   integer, parameter, public :: ULONG_PTR = C_INTPTR_T
   integer, parameter, public :: ULONG32 = C_INT
   integer, parameter, public :: ULONG64 = C_INT64_T
   integer, parameter, public :: UNSIGNED16 = C_SHORT
   integer, parameter, public :: UNSIGNED32 = C_LONG
   integer, parameter, public :: USHORT = C_SHORT
   integer, parameter, public :: WORD = C_SHORT
   integer, parameter, public :: ATOM = C_INT16_T
   integer, parameter, public :: BOOLEAN = BYTE
   integer, parameter, public :: COLORREF = DWORD
   integer, parameter, public :: DWORDLONG = ULONGLONG
   integer, parameter, public :: DWORD_PTR = ULONG_PTR
   integer, parameter, public :: HACCEL = HANDLE
   integer, parameter, public :: HALF_PTR = &
      merge(C_INT,C_SHORT,C_INTPTR_T==C_INT64_T)
   integer, parameter, public :: HBITMAP = HANDLE
   integer, parameter, public :: HBRUSH = HANDLE
   integer, parameter, public :: HCOLORSPACE = HANDLE
   integer, parameter, public :: HCONV = HANDLE
   integer, parameter, public :: HCONVLIST = HANDLE
   integer, parameter, public :: HCURSOR = HANDLE
   integer, parameter, public :: HDC = HANDLE
   integer, parameter, public :: HDDEDATA = HANDLE
   integer, parameter, public :: HDESK = HANDLE
   integer, parameter, public :: HDROP = HANDLE
   integer, parameter, public :: HDWP = HANDLE
   integer, parameter, public :: HENHMETAFILE = HANDLE
   integer, parameter, public :: HFILE = C_INT
   integer, parameter, public :: HFONT = HANDLE
   integer, parameter, public :: HGDIOBJ = HANDLE
   integer, parameter, public :: HGLOBAL = HANDLE
   integer, parameter, public :: HHOOK = HANDLE
   integer, parameter, public :: HICON = HANDLE
   integer, parameter, public :: HINSTANCE = HANDLE
   integer, parameter, public :: HKEY = HANDLE
   integer, parameter, public :: HKL = HANDLE
   integer, parameter, public :: HLOCAL = HANDLE
   integer, parameter, public :: HMENU = HANDLE
   integer, parameter, public :: HMETAFILE = HANDLE
   integer, parameter, public :: HMODULE = HANDLE
   integer, parameter, public :: HMONITOR = HANDLE
   integer, parameter, public :: HPALETTE = HANDLE
   integer, parameter, public :: HPEN = HANDLE
   integer, parameter, public :: HRESULT = LONG
   integer, parameter, public :: HRGN = HANDLE
   integer, parameter, public :: HRSRC = HANDLE
   integer, parameter, public :: HSZ = HANDLE
   integer, parameter, public :: HWINSTA = HANDLE
   integer, parameter, public :: HWND = HANDLE
   integer, parameter, public :: LANGID = WORD
   integer, parameter, public :: LCID = DWORD
   integer, parameter, public :: LCTYPE = DWORD
   integer, parameter, public :: LGRPID = DWORD
   integer, parameter, public :: LPARAM = LONG_PTR
   integer, parameter, public :: LRESULT = LONG_PTR
   integer, parameter, public :: SC_HANDLE = HANDLE
   integer, parameter, public :: SERVICE_STATUS_HANDLE = HANDLE
   integer, parameter, public :: SSIZE_T = LONG_PTR
   integer, parameter, public :: SIZE_T = ULONG_PTR
   integer, parameter, public :: UHALF_PTR = &
      merge(C_INT,C_SHORT,C_INTPTR_T==C_INT64_T)
   integer, parameter, public :: USN = LONGLONG
   integer, parameter, public :: WPARAM = UINT_PTR

   integer,parameter,public :: WCHAR = SHORT

! Boolean constants
   integer(BOOL), parameter, public :: BOOL_TRUE = 1
   integer(BOOL), parameter, public :: BOOL_FALSE = 0

! Invalid Handle
   integer(HANDLE), parameter, public :: INVALID_HANDLE_VALUE = int(Z'FFFFFFFFFFFFFFFF',HANDLE)

! Constants for LoadIcon function
   integer(C_INTPTR_T), parameter, public :: IDI_APPLICATION = 32512
   integer(C_INTPTR_T), parameter, public :: IDI_ASTERISK = 32516
   integer(C_INTPTR_T), parameter, public :: IDI_HAND = 32513
   integer(C_INTPTR_T), parameter, public :: IDI_ERROR = IDI_HAND
   integer(C_INTPTR_T), parameter, public :: IDI_EXCLAMATION = 32515
   integer(C_INTPTR_T), parameter, public :: IDI_INFORMATION = IDI_ASTERISK
   integer(C_INTPTR_T), parameter, public :: IDI_QUESTION = 32514
   integer(C_INTPTR_T), parameter, public :: IDI_SHIELD = 32518
   integer(C_INTPTR_T), parameter, public :: IDI_WARNING = IDI_EXCLAMATION
   integer(C_INTPTR_T), parameter, public :: IDI_WINLOGO = 32517

! Constants for LoadCursor function
   integer(C_INTPTR_T), parameter, public :: IDC_APPSTARTING = 32650
   integer(C_INTPTR_T), parameter, public :: IDC_ARROW = 32512
   integer(C_INTPTR_T), parameter, public :: IDC_CROSS = 32515
   integer(C_INTPTR_T), parameter, public :: IDC_HAND = 32649
   integer(C_INTPTR_T), parameter, public :: IDC_HELP = 32651
   integer(C_INTPTR_T), parameter, public :: IDC_IBEAM = 32513
   integer(C_INTPTR_T), parameter, public :: IDC_ICON = 32641
   integer(C_INTPTR_T), parameter, public :: IDC_NO = 32648
   integer(C_INTPTR_T), parameter, public :: IDC_SIZE = 32640
   integer(C_INTPTR_T), parameter, public :: IDC_SIZEALL = 32646
   integer(C_INTPTR_T), parameter, public :: IDC_SIZENESW = 32643
   integer(C_INTPTR_T), parameter, public :: IDC_SIZENS = 32645
   integer(C_INTPTR_T), parameter, public :: IDC_SIZENWSE = 32642
   integer(C_INTPTR_T), parameter, public :: IDC_SIZEWE = 32644
   integer(C_INTPTR_T), parameter, public :: IDC_UPARROW = 32516
   integer(C_INTPTR_T), parameter, public :: IDC_WAIT = 32514

! Constants for GetStockObject
   integer, parameter, public :: BLACK_BRUSH = 4
   integer, parameter, public :: DKGRAY_BRUSH = 3
   integer, parameter, public :: DC_BRUSH = 18
   integer, parameter, public :: GRAY_BRUSH = 2
   integer, parameter, public :: HOLLOW_BRUSH = 5
   integer, parameter, public :: LTGRAY_BRUSH = 1
   integer, parameter, public :: NULL_BRUSH = 5
   integer, parameter, public :: WHITE_BRUSH = 0
   integer, parameter, public :: BLACK_PEN = 7
   integer, parameter, public :: DC_PEN = 19
   integer, parameter, public :: NULL_PEN = 8
   integer, parameter, public :: WHITE_PEN = 6
   integer, parameter, public :: ANSI_FIXED_FONT = 11
   integer, parameter, public :: ANSI_VAR_FONT = 12
   integer, parameter, public :: DEVICE_DEFAULT_FONT = 14
   integer, parameter, public :: DEFAULT_GUI_FONT = 17
   integer, parameter, public :: OEM_FIXED_FONT = 10
   integer, parameter, public :: SYSTEM_FONT = 13
   integer, parameter, public :: SYSTEM_FIXED_FONT = 16
   integer, parameter, public :: DEFAULT_PALETTE = 15

! Extended window styles
   integer(DWORD), parameter, public :: WS_EX_ACCEPTFILES = int(Z'00000010',DWORD)
   integer(DWORD), parameter, public :: WS_EX_APPWINDOW = int(Z'00040000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_CLIENTEDGE = int(Z'00000200',DWORD)
   integer(DWORD), parameter, public :: WS_EX_COMPOSITED = int(Z'02000000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_CONTEXTHELP = int(Z'00000400',DWORD)
   integer(DWORD), parameter, public :: WS_EX_CONTROLPARENT = int(Z'00010000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_DLGMODALFRAME = int(Z'00000001',DWORD)
   integer(DWORD), parameter, public :: WS_EX_LAYERED = int(Z'00080000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_LAYOUTRTL = int(Z'00400000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_LEFT = int(Z'00000000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_LEFTSCROLLBAR = int(Z'00004000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_LTRREADING = int(Z'00000000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_MDICHILD = int(Z'00000040',DWORD)
   integer(DWORD), parameter, public :: WS_EX_NOACTIVATE = int(Z'08000000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_NOINHERITLAYOUT = int(Z'00100000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_NOPARENTNOTIFY = int(Z'00000004',DWORD)
   integer(DWORD), parameter, public :: WS_EX_RIGHT = int(Z'00001000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_RIGHTSCROLLBAR = int(Z'00000000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_RTLREADING = int(Z'00002000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_STATICEDGE = int(Z'00020000',DWORD)
   integer(DWORD), parameter, public :: WS_EX_TOOLWINDOW = int(Z'00000080',DWORD)
   integer(DWORD), parameter, public :: WS_EX_TOPMOST = int(Z'00000008',DWORD)
   integer(DWORD), parameter, public :: WS_EX_TRANSPARENT = int(Z'00000020',DWORD)
   integer(DWORD), parameter, public :: WS_EX_WINDOWEDGE = int(Z'00000100',DWORD)
   integer(DWORD), parameter, public :: WS_EX_OVERLAPPEDWINDOW = &
      ior(WS_EX_WINDOWEDGE,WS_EX_CLIENTEDGE)
   integer(DWORD), parameter, public :: WS_EX_PALETTEWINDOW = &
      iany([WS_EX_WINDOWEDGE,WS_EX_TOOLWINDOW,WS_EX_TOPMOST])

! Button styles
   integer(DWORD), parameter, public :: BS_3STATE = 5
   integer(DWORD), parameter, public :: BS_AUTO3STATE = 6
   integer(DWORD), parameter, public :: BS_AUTOCHECKBOX = 3
   integer(DWORD), parameter, public :: BS_AUTORADIOBUTTON = 9
   integer(DWORD), parameter, public :: BS_CHECKBOX = 2
   integer(DWORD), parameter, public :: BS_DEFPUSHBUTTON = 1
   integer(DWORD), parameter, public :: BS_GROUPBOX = 7
   integer(DWORD), parameter, public :: BS_LEFTTEXT = 32
   integer(DWORD), parameter, public :: BS_OWNERDRAW = 11
   integer(DWORD), parameter, public :: BS_PUSHBUTTON = 0
   integer(DWORD), parameter, public :: BS_RADIOBUTTON = 4
   integer(DWORD), parameter, public :: BS_USERBUTTON = 8
   integer(DWORD), parameter, public :: BS_BITMAP = 128
   integer(DWORD), parameter, public :: BS_BOTTOM = 2048
   integer(DWORD), parameter, public :: BS_CENTER = 768
   integer(DWORD), parameter, public :: BS_ICON = 64
   integer(DWORD), parameter, public :: BS_FLAT = 32768
   integer(DWORD), parameter, public :: BS_LEFT = 256
   integer(DWORD), parameter, public :: BS_MULTILINE = 8192
   integer(DWORD), parameter, public :: BS_NOTIFY = 16384
   integer(DWORD), parameter, public :: BS_PUSHLIKE = 4096
   integer(DWORD), parameter, public :: BS_RIGHT = 512
   integer(DWORD), parameter, public :: BS_RIGHTBUTTON = 32
   integer(DWORD), parameter, public :: BS_TEXT = 0
   integer(DWORD), parameter, public :: BS_TOP = 1024
   integer(DWORD), parameter, public :: BS_TYPEMASK = 15
   integer(DWORD), parameter, public :: BS_VCENTER = 3072

! Combo box styles
   integer(DWORD), parameter, public :: CBS_AUTOHSCROLL = 64
   integer(DWORD), parameter, public :: CBS_DISABLENOSCROLL = 2048
   integer(DWORD), parameter, public :: CBS_DROPDOWN = 2
   integer(DWORD), parameter, public :: CBS_DROPDOWNLIST = 3
   integer(DWORD), parameter, public :: CBS_HASSTRINGS = 512
   integer(DWORD), parameter, public :: CBS_LOWERCASE = 16384
   integer(DWORD), parameter, public :: CBS_NOINTEGRALHEIGHT = 1024
   integer(DWORD), parameter, public :: CBS_OEMCONVERT = 128
   integer(DWORD), parameter, public :: CBS_OWNERDRAWFIXED = 16
   integer(DWORD), parameter, public :: CBS_OWNERDRAWVARIABLE = 32
   integer(DWORD), parameter, public :: CBS_SIMPLE = 1
   integer(DWORD), parameter, public :: CBS_SORT = 256
   integer(DWORD), parameter, public :: CBS_UPPERCASE = 8192

! Edit control styles
   integer(DWORD), parameter, public :: ES_AUTOHSCROLL = 128
   integer(DWORD), parameter, public :: ES_AUTOVSCROLL = 64
   integer(DWORD), parameter, public :: ES_CENTER = 1
   integer(DWORD), parameter, public :: ES_LEFT = 0
   integer(DWORD), parameter, public :: ES_LOWERCASE = 16
   integer(DWORD), parameter, public :: ES_MULTILINE = 4
   integer(DWORD), parameter, public :: ES_NOHIDESEL = 256
   integer(DWORD), parameter, public :: ES_NUMBER = 8192
   integer(DWORD), parameter, public :: ES_OEMCONVERT = 1024
   integer(DWORD), parameter, public :: ES_PASSWORD = 32
   integer(DWORD), parameter, public :: ES_READONLY = 2048
   integer(DWORD), parameter, public :: ES_RIGHT = 2
   integer(DWORD), parameter, public :: ES_UPPERCASE = 8
   integer(DWORD), parameter, public :: ES_WANTRETURN = 4096

! List box styles
   integer(DWORD), parameter, public :: LBS_COMBOBOX = 32768
   integer(DWORD), parameter, public :: LBS_DISABLENOSCROLL = 4096
   integer(DWORD), parameter, public :: LBS_EXTENDEDSEL = 2048
   integer(DWORD), parameter, public :: LBS_HASSTRINGS = 64
   integer(DWORD), parameter, public :: LBS_MULTICOLUMN = 512
   integer(DWORD), parameter, public :: LBS_MULTIPLESEL = 8
   integer(DWORD), parameter, public :: LBS_NODATA = 8192
   integer(DWORD), parameter, public :: LBS_NOINTEGRALHEIGHT = 256
   integer(DWORD), parameter, public :: LBS_NOREDRAW = 4
   integer(DWORD), parameter, public :: LBS_NOSEL = 16384
   integer(DWORD), parameter, public :: LBS_NOTIFY = 1
   integer(DWORD), parameter, public :: LBS_OWNERDRAWFIXED = 16
   integer(DWORD), parameter, public :: LBS_OWNERDRAWVARIABLE = 32
   integer(DWORD), parameter, public :: LBS_SORT = 2
   integer(DWORD), parameter, public :: LBS_STANDARD = 10485763
   integer(DWORD), parameter, public :: LBS_USETABSTOPS = 128
   integer(DWORD), parameter, public :: LBS_WANTKEYBOARDINPUT = 1024

! Scroll bar control styles
   integer(DWORD), parameter, public :: SBS_BOTTOMALIGN = 4
   integer(DWORD), parameter, public :: SBS_HORZ = 0
   integer(DWORD), parameter, public :: SBS_LEFTALIGN = 2
   integer(DWORD), parameter, public :: SBS_RIGHTALIGN = 4
   integer(DWORD), parameter, public :: SBS_SIZEBOX = 8
   integer(DWORD), parameter, public :: SBS_SIZEBOXBOTTOMRIGHTALIGN = 4
   integer(DWORD), parameter, public :: SBS_SIZEBOXTOPLEFTALIGN = 2
   integer(DWORD), parameter, public :: SBS_SIZEGRIP = 16
   integer(DWORD), parameter, public :: SBS_TOPALIGN = 2
   integer(DWORD), parameter, public :: SBS_VERT = 1

! static control styles
   integer(DWORD), parameter, public :: SS_BITMAP = 14
   integer(DWORD), parameter, public :: SS_BLACKFRAME = 7
   integer(DWORD), parameter, public :: SS_BLACKRECT = 4
   integer(DWORD), parameter, public :: SS_CENTER = 1
   integer(DWORD), parameter, public :: SS_CENTERIMAGE = 512
   integer(DWORD), parameter, public :: SS_EDITCONTROL = 8192
   integer(DWORD), parameter, public :: SS_ENDELLIPSIS = 16384
   integer(DWORD), parameter, public :: SS_ENHMETAFILE = 15
   integer(DWORD), parameter, public :: SS_ETCHEDFRAME = 18
   integer(DWORD), parameter, public :: SS_ETCHEDHORZ = 16
   integer(DWORD), parameter, public :: SS_ETCHEDVERT = 17
   integer(DWORD), parameter, public :: SS_GRAYFRAME = 8
   integer(DWORD), parameter, public :: SS_ICON = 3
   integer(DWORD), parameter, public :: SS_LEFT = 0
   integer(DWORD), parameter, public :: SS_LEFTNOWORDWRAP = 12
   integer(DWORD), parameter, public :: SS_NOPREFIX = 128
   integer(DWORD), parameter, public :: SS_NOTIFY = 256
   integer(DWORD), parameter, public :: SS_OWNERDRAW = 13
   integer(DWORD), parameter, public :: SS_PATHELLIPSIS = 32768
   integer(DWORD), parameter, public :: SS_REALSIZECONTROL = 64
   integer(DWORD), parameter, public :: SS_REALSIZEIMAGE = 2048
   integer(DWORD), parameter, public :: SS_RIGHT = 2
   integer(DWORD), parameter, public :: SS_RIGHTJUST = 1024
   integer(DWORD), parameter, public :: SS_SIMPLE = 11
   integer(DWORD), parameter, public :: SS_SUNKEN = 4096
   integer(DWORD), parameter, public :: SS_TYPEMASK = 31
   integer(DWORD), parameter, public :: SS_WHITEFRAME = 9
   integer(DWORD), parameter, public :: SS_WHITERECT = 6
   integer(DWORD), parameter, public :: SS_WORDELLIPSIS = 49152

! Window style values
   integer(DWORD), parameter, public :: WS_BORDER = int(Z'00800000',DWORD)
   integer(DWORD), parameter, public :: WS_CAPTION = int(Z'00C00000',DWORD)
   integer(DWORD), parameter, public :: WS_CHILD = int(Z'40000000',DWORD)
   integer(DWORD), parameter, public :: WS_CHILDWINDOW = int(Z'40000000',DWORD)
   integer(DWORD), parameter, public :: WS_CLIPCHILDREN = int(Z'02000000',DWORD)
   integer(DWORD), parameter, public :: WS_CLIPSIBLINGS = int(Z'04000000',DWORD)
   integer(DWORD), parameter, public :: WS_DISABLED = int(Z'08000000',DWORD)
   integer(DWORD), parameter, public :: WS_DLGFRAME = int(Z'00400000',DWORD)
   integer(DWORD), parameter, public :: WS_GROUP = int(Z'00020000',DWORD)
   integer(DWORD), parameter, public :: WS_HSCROLL = int(Z'00100000',DWORD)
   integer(DWORD), parameter, public :: WS_ICONOC = int(Z'20000000',DWORD)
   integer(DWORD), parameter, public :: WS_MAXIMIZE = int(Z'01000000',DWORD)
   integer(DWORD), parameter, public :: WS_MAXIMIZEBOX = int(Z'00010000',DWORD)
   integer(DWORD), parameter, public :: WS_MINIMIZE = int(Z'20000000',DWORD)
   integer(DWORD), parameter, public :: WS_MINIMIZEBOX = int(Z'00020000',DWORD)
   integer(DWORD), parameter, public :: WS_OVERLAPPED = int(Z'00000000',DWORD)
   integer(DWORD), parameter, public :: WS_POPUP = int(Z'80000000',DWORD)
   integer(DWORD), parameter, public :: WS_SIZEBOX = int(Z'00040000',DWORD)
   integer(DWORD), parameter, public :: WS_SYSMENU = int(Z'00080000',DWORD)
   integer(DWORD), parameter, public :: WS_TABSTOP = int(Z'00010000',DWORD)
   integer(DWORD), parameter, public :: WS_THICKFRAME = int(Z'00040000',DWORD)
   integer(DWORD), parameter, public :: WS_TILED = int(Z'00000000',DWORD)
   integer(DWORD), parameter, public :: WS_VISIBLE = int(Z'10000000',DWORD)
   integer(DWORD), parameter, public :: WS_VSCROLL = int(Z'00200000',DWORD)
   integer(DWORD), parameter, public :: WS_OVERLAPPEDWINDOW = &
      iany([WS_OVERLAPPED,WS_CAPTION,WS_SYSMENU,WS_THICKFRAME,WS_MINIMIZEBOX,WS_MAXIMIZEBOX])
   integer(DWORD), parameter, public :: WS_POPUPWINDOW = &
      iany([WS_POPUP,WS_BORDER,WS_SYSMENU])
   integer(DWORD), parameter, public :: WS_TILEDWINDOW = &
      iany([WS_OVERLAPPED,WS_CAPTION,WS_SYSMENU,WS_THICKFRAME,WS_MINIMIZEBOX,WS_MAXIMIZEBOX])

! Window class styles
   integer, parameter, public :: CS_VREDRAW = int(Z'0001')
   integer, parameter, public :: CS_HREDRAW = int(Z'0002')
   integer, parameter, public :: CS_DBLCLKS = int(Z'0008')
   integer, parameter, public :: CS_OWNDC = int(Z'0020')
   integer, parameter, public :: CS_CLASSDC = int(Z'0040')
   integer, parameter, public :: CS_PARENTDC = int(Z'0080')
   integer, parameter, public :: CS_NOCLOSE = int(Z'0200')
   integer, parameter, public :: CS_SAVEBITS = int(Z'0800')
   integer, parameter, public :: CS_BYTEALIGNCLIENT = int(Z'1000')
   integer, parameter, public :: CS_BYTEALIGNWINDOW = int(Z'2000')
   integer, parameter, public :: CS_GLOBALCLASS = int(Z'4000')
   integer, parameter, public :: CS_IME = int(Z'00010000')
   integer, parameter, public :: CS_DROPSHADOW = int(Z'00020000')

   integer, parameter, public :: CW_USEDEFAULT = int(Z'80000000')
   integer(HWND), parameter, public :: HWND_BROADCAST = int(Z'ffff',HWND)
   integer(HWND), parameter, public :: HWND_MESSAGE = -3_HWND
   integer(HWND), parameter, public :: HWND_DESKTOP = 0_HWND
   integer(HWND), parameter, public :: HWND_TOP = 0_HWND
   integer(HWND), parameter, public :: HWND_BOTTOM = 1_HWND
   integer(HWND), parameter, public :: HWND_TOPMOST = -1_HWND
   integer(HWND), parameter, public :: HWND_NOTOPMOST = -2_HWND

   integer, parameter, public :: SW_FORCEMINIMIZE = 11
   integer, parameter, public :: SW_HIDE = 0
   integer, parameter, public :: SW_MAXIMIZE = 3
   integer, parameter, public :: SW_MINIMIZE = 6
   integer, parameter, public :: SW_RESTORE = 9
   integer, parameter, public :: SW_SHOW = 5
   integer, parameter, public :: SW_SHOWDEFAULT = 10
   integer, parameter, public :: SW_SHOWMAXIMIZED = 3
   integer, parameter, public :: SW_SHOWMINIMIZED = 2
   integer, parameter, public :: SW_SHOWMINNOACTIVE = 7
   integer, parameter, public :: SW_SHOWNA = 8
   integer, parameter, public :: SW_SHOWNOACTIVATE = 4
   integer, parameter, public :: SW_SHOWNORMAL = 1

! Constants for DrawText
   integer(UINT), parameter, public :: DT_TOP = int(Z'00000000',UINT)
   integer(UINT), parameter, public :: DT_LEFT = int(Z'00000000',UINT)
   integer(UINT), parameter, public :: DT_CENTER = int(Z'00000001',UINT)
   integer(UINT), parameter, public :: DT_RIGHT = int(Z'00000002',UINT)
   integer(UINT), parameter, public :: DT_VCENTER = int(Z'00000004',UINT)
   integer(UINT), parameter, public :: DT_BOTTOM = int(Z'00000008',UINT)
   integer(UINT), parameter, public :: DT_WORDBREAK = int(Z'00000010',UINT)
   integer(UINT), parameter, public :: DT_SINGLELINE = int(Z'00000020',UINT)
   integer(UINT), parameter, public :: DT_EXPANDTABS = int(Z'00000040',UINT)
   integer(UINT), parameter, public :: DT_TABSTOP = int(Z'00000080',UINT)
   integer(UINT), parameter, public :: DT_NOCLIP = int(Z'00000100',UINT)
   integer(UINT), parameter, public :: DT_EXTERNALLEADING = int(Z'00000200',UINT)
   integer(UINT), parameter, public :: DT_CALCRECT = int(Z'00000400',UINT)
   integer(UINT), parameter, public :: DT_NOPREFIX = int(Z'00000800',UINT)
   integer(UINT), parameter, public :: DT_INTERNAL = int(Z'00001000',UINT)

   integer(UINT), parameter, public :: DT_EDITCONTROL = int(Z'00002000',UINT)
   integer(UINT), parameter, public :: DT_PATH_ELLIPSIS = int(Z'00004000',UINT)
   integer(UINT), parameter, public :: DT_END_ELLIPSIS = int(Z'00008000',UINT)
   integer(UINT), parameter, public :: DT_MODIFYSTRING = int(Z'00010000',UINT)
   integer(UINT), parameter, public :: DT_RTLREADING = int(Z'00020000',UINT)
   integer(UINT), parameter, public :: DT_WORD_ELLIPSIS = int(Z'00040000',UINT)
   integer(UINT), parameter, public :: DT_NOFULLWIDTHCHARBREAK = int(Z'00080000',UINT)
   integer(UINT), parameter, public :: DT_HIDEPREFIX = int(Z'00100000',UINT)
   integer(UINT), parameter, public :: DT_PREFIXONLY = int(Z'00200000',UINT)

! Constants for MessageBox function
   integer(UINT), parameter, public :: MB_ABORTRETRYIGNORE = int(Z'00000002')
   integer(UINT), parameter, public :: MB_CANCELTRYCONTINUE = int(Z'00000006')
   integer(UINT), parameter, public :: MB_HELP = int(Z'00004000')
   integer(UINT), parameter, public :: MB_OK = int(Z'00000000')
   integer(UINT), parameter, public :: MB_OKCANCEL = int(Z'00000001')
   integer(UINT), parameter, public :: MB_RETRYCANCEL = int(Z'00000005')
   integer(UINT), parameter, public :: MB_YESNO = int(Z'00000004')
   integer(UINT), parameter, public :: MB_YESNOCANCEL = int(Z'00000003')
   integer(UINT), parameter, public :: MB_ICONEXCLAMATION = int(Z'00000030')
   integer(UINT), parameter, public :: MB_ICONWARNING = int(Z'00000030')
   integer(UINT), parameter, public :: MB_ICONINFORMATION = int(Z'00000040')
   integer(UINT), parameter, public :: MB_ICONASTERISK = int(Z'00000040')
   integer(UINT), parameter, public :: MB_ICONQUESTION = int(Z'00000020')
   integer(UINT), parameter, public :: MB_ICONSTOP = int(Z'00000010')
   integer(UINT), parameter, public :: MB_ICONERROR = int(Z'00000010')
   integer(UINT), parameter, public :: MB_ICONHAND = int(Z'00000010')
   integer(UINT), parameter, public :: MB_DEFBUTTON1 = int(Z'00000000')
   integer(UINT), parameter, public :: MB_DEFBUTTON2 = int(Z'00000100')
   integer(UINT), parameter, public :: MB_DEFBUTTON3 = int(Z'00000200')
   integer(UINT), parameter, public :: MB_DEFBUTTON4 = int(Z'00000300')
   integer(UINT), parameter, public :: MB_APPLMODAL = int(Z'00000000')
   integer(UINT), parameter, public :: MB_SYSTEMMODAL = int(Z'00001000')
   integer(UINT), parameter, public :: MB_TASKMODAL = int(Z'00002000')
   integer(UINT), parameter, public :: MB_DEFAULT_DESKTOP_ONLY = int(Z'00020000')
   integer(UINT), parameter, public :: MB_RIGHT = int(Z'00080000')
   integer(UINT), parameter, public :: MB_RTLREADING = int(Z'00100000')
   integer(UINT), parameter, public :: MB_SETFOREGROUND = int(Z'00010000')
   integer(UINT), parameter, public :: MB_TOPMOST = int(Z'00040000')
   integer(UINT), parameter, public :: MB_SERVICE_NOTIFICATION = int(Z'00200000')

! Return values for MessgeBox function
   integer, parameter, public :: IDABORT = 3
   integer, parameter, public :: IDCANCEL = 2
   integer, parameter, public :: IDCONTINUE = 11
   integer, parameter, public :: IDIGNORE = 5
   integer, parameter, public :: IDNO = 7
   integer, parameter, public :: IDOK = 1
   integer, parameter, public :: IDRETRY = 4
   integer, parameter, public :: IDTRYAGAIN = 10
   integer, parameter, public :: IDYES = 6

! Constants for MonitorFromPoint
   integer(DWORD), parameter, public :: MONITOR_DEFAULTTONEAREST = 2
   integer(DWORD), parameter, public :: MONITOR_DEFAULTTONULL = 0
   integer(DWORD), parameter, public :: MONITOR_DEFAULTTOPRIMARY = 1

   integer(DWORD), parameter, public :: PFD_DRAW_TO_WINDOW = int(Z'00000004',DWORD)
   integer(DWORD), parameter, public :: PFD_DRAW_TO_BITMAP = int(Z'00000008',DWORD)
   integer(DWORD), parameter, public :: PFD_SUPPORT_GDI = int(Z'00000010',DWORD)
   integer(DWORD), parameter, public :: PFD_SUPPORT_OPENGL = int(Z'00000020',DWORD)
   integer(DWORD), parameter, public :: PFD_GENERIC_ACCELERATED = int(Z'00001000',DWORD)
   integer(DWORD), parameter, public :: PFD_GENERIC_FORMAT = int(Z'00000040',DWORD)
   integer(DWORD), parameter, public :: PFD_NEED_PALETTE = int(Z'00000080',DWORD)
   integer(DWORD), parameter, public :: PFD_NEED_SYSTEM_PALETTE = int(Z'00000100',DWORD)
   integer(DWORD), parameter, public :: PFD_DOUBLEBUFFER = int(Z'00000001',DWORD)
   integer(DWORD), parameter, public :: PFD_STEREO = int(Z'00000002',DWORD)
   integer(DWORD), parameter, public :: PFD_SWAP_LAYER_BUFFERS = int(Z'00000800',DWORD)
   integer(DWORD), parameter, public :: PFD_DEPTH_DONTCARE = int(Z'20000000',DWORD)
   integer(DWORD), parameter, public :: PFD_DOUBLEBUFFER_DONTCARE = int(Z'40000000',DWORD)
   integer(DWORD), parameter, public :: PFD_STEREO_DONTCARE = int(Z'80000000',DWORD)
   integer(DWORD), parameter, public :: PFD_SWAP_COPY = int(Z'00000400',DWORD)
   integer(DWORD), parameter, public :: PFD_SWAP_EXCHANGE = int(Z'00000200',DWORD)

   integer(BYTE), parameter, public :: PFD_TYPE_RGBA = 0_BYTE
   integer(BYTE), parameter, public :: PFD_TYPE_COLORINDEX = 1_BYTE

   integer(BYTE), parameter, public :: PFD_MAIN_PLANE = 0_BYTE
   integer(BYTE), parameter, public :: PFD_OVERLAY_PLANE = 1_BYTE
   integer(BYTE), parameter, public :: PFD_UNDERLAY_PLANE = -1_BYTE

   integer, parameter, public :: LPD_SUPPORT_OPENGL = int(Z'00000020')
   integer, parameter, public :: LPD_SUPPORT_GDI = int(Z'00000010')
   integer, parameter, public :: LPD_DOUBLEBUFFER = int(Z'00000001')
   integer, parameter, public :: LPD_STEREO = int(Z'00000002')
   integer, parameter, public :: LPD_SWAP_EXCHANGE = int(Z'00000200')
   integer, parameter, public :: LPD_SWAP_COPY = int(Z'00000400')
   integer, parameter, public :: LPD_TRANSPARENT = int(Z'00001000')
   integer, parameter, public :: LPD_SHARE_DEPTH = int(Z'00000040')
   integer, parameter, public :: LPD_SHARE_STENCIL = int(Z'00000080')
   integer, parameter, public :: LPD_SHARE_ACCUM = int(Z'00000100')
   integer, parameter, public :: LPD_TYPE_RGBA = int(Z'00000000')
   integer, parameter, public :: LPD_TYPE_COLORINDEX = int(Z'00000001')

! Windows messages
   integer(UINT), parameter, public :: WM_NULL = int(Z'0000',UINT)
   integer(UINT), parameter, public :: WM_CREATE = int(Z'0001',UINT)
   integer(UINT), parameter, public :: WM_DESTROY = int(Z'0002',UINT)
   integer(UINT), parameter, public :: WM_MOVE = int(Z'0003',UINT)
   integer(UINT), parameter, public :: WM_SIZE = int(Z'0005',UINT)

   integer(UINT), parameter, public :: WM_ACTIVATE = int(Z'0006',UINT)

   integer(UINT), parameter, public :: WM_SETFOCUS = int(Z'0007',UINT)
   integer(UINT), parameter, public :: WM_KILLFOCUS = int(Z'0008',UINT)
   integer(UINT), parameter, public :: WM_ENABLE = int(Z'000A',UINT)
   integer(UINT), parameter, public :: WM_SETREDRAW = int(Z'000B',UINT)
   integer(UINT), parameter, public :: WM_SETTEXT = int(Z'000C',UINT)
   integer(UINT), parameter, public :: WM_GETTEXT = int(Z'000D',UINT)
   integer(UINT), parameter, public :: WM_GETTEXTLENGTH = int(Z'000E',UINT)
   integer(UINT), parameter, public :: WM_PAINT = int(Z'000F',UINT)
   integer(UINT), parameter, public :: WM_CLOSE = int(Z'0010',UINT)

   integer(UINT), parameter, public :: WM_QUERYENDSESSION = int(Z'0011',UINT)
   integer(UINT), parameter, public :: WM_QUERYOPEN = int(Z'0013',UINT)
   integer(UINT), parameter, public :: WM_ENDSESSION = int(Z'0016',UINT)

   integer(UINT), parameter, public :: WM_QUIT = int(Z'0012',UINT)
   integer(UINT), parameter, public :: WM_ERASEBKGND = int(Z'0014',UINT)
   integer(UINT), parameter, public :: WM_SYSCOLORCHANGE = int(Z'0015',UINT)
   integer(UINT), parameter, public :: WM_SHOWWINDOW = int(Z'0018',UINT)
   integer(UINT), parameter, public :: WM_WININICHANGE = int(Z'001A',UINT)
   integer(UINT), parameter, public :: WM_DEVMODECHANGE = int(Z'001B',UINT)
   integer(UINT), parameter, public :: WM_ACTIVATEAPP = int(Z'001C',UINT)
   integer(UINT), parameter, public :: WM_FONTCHANGE = int(Z'001D',UINT)
   integer(UINT), parameter, public :: WM_TIMECHANGE = int(Z'001E',UINT)
   integer(UINT), parameter, public :: WM_CANCELMODE = int(Z'001F',UINT)
   integer(UINT), parameter, public :: WM_SETCURSOR = int(Z'0020',UINT)
   integer(UINT), parameter, public :: WM_MOUSEACTIVATE = int(Z'0021',UINT)
   integer(UINT), parameter, public :: WM_CHILDACTIVATE = int(Z'0022',UINT)
   integer(UINT), parameter, public :: WM_QUEUESYNC = int(Z'0023',UINT)

   integer(UINT), parameter, public :: WM_GETMINMAXINFO = int(Z'0024',UINT)

   integer(UINT), parameter, public :: WM_PAINTICON = int(Z'0026',UINT)
   integer(UINT), parameter, public :: WM_ICONERASEBKGND = int(Z'0027',UINT)
   integer(UINT), parameter, public :: WM_NEXTDLGCTL = int(Z'0028',UINT)
   integer(UINT), parameter, public :: WM_SPOOLERSTATUS = int(Z'002A',UINT)
   integer(UINT), parameter, public :: WM_DRAWITEM = int(Z'002B',UINT)
   integer(UINT), parameter, public :: WM_MEASUREITEM = int(Z'002C',UINT)
   integer(UINT), parameter, public :: WM_DELETEITEM = int(Z'002D',UINT)
   integer(UINT), parameter, public :: WM_VKEYTOITEM = int(Z'002E',UINT)
   integer(UINT), parameter, public :: WM_CHARTOITEM = int(Z'002F',UINT)
   integer(UINT), parameter, public :: WM_SETFONT = int(Z'0030',UINT)
   integer(UINT), parameter, public :: WM_GETFONT = int(Z'0031',UINT)
   integer(UINT), parameter, public :: WM_SETHOTKEY = int(Z'0032',UINT)
   integer(UINT), parameter, public :: WM_GETHOTKEY = int(Z'0033',UINT)
   integer(UINT), parameter, public :: WM_QUERYDRAGICON = int(Z'0037',UINT)
   integer(UINT), parameter, public :: WM_COMPAREITEM = int(Z'0039',UINT)

   integer(UINT), parameter, public :: WM_GETOBJECT = int(Z'003D',UINT)

   integer(UINT), parameter, public :: WM_COMPACTING = int(Z'0041',UINT)
   integer(UINT), parameter, public :: WM_COMMNOTIFY = int(Z'0044',UINT)
   integer(UINT), parameter, public :: WM_WINDOWPOSCHANGING = int(Z'0046',UINT)
   integer(UINT), parameter, public :: WM_WINDOWPOSCHANGED = int(Z'0047',UINT)

   integer(UINT), parameter, public :: WM_POWER = int(Z'0048',UINT)

   integer(UINT), parameter, public :: WM_COPYDATA = int(Z'004A',UINT)
   integer(UINT), parameter, public :: WM_CANCELJOURNAL = int(Z'004B',UINT)

   integer(UINT), parameter, public :: WM_NOTIFY = int(Z'004E',UINT)
   integer(UINT), parameter, public :: WM_INPUTLANGCHANGEREQUEST = int(Z'0050',UINT)
   integer(UINT), parameter, public :: WM_INPUTLANGCHANGE = int(Z'0051',UINT)
   integer(UINT), parameter, public :: WM_TCARD = int(Z'0052',UINT)
   integer(UINT), parameter, public :: WM_HELP = int(Z'0053',UINT)
   integer(UINT), parameter, public :: WM_USERCHANGED = int(Z'0054',UINT)
   integer(UINT), parameter, public :: WM_NOTIFYFORMAT = int(Z'0055',UINT)

   integer(UINT), parameter, public :: WM_CONTEXTMENU = int(Z'007B',UINT)
   integer(UINT), parameter, public :: WM_STYLECHANGING = int(Z'007C',UINT)
   integer(UINT), parameter, public :: WM_STYLECHANGED = int(Z'007D',UINT)
   integer(UINT), parameter, public :: WM_DISPLAYCHANGE = int(Z'007E',UINT)
   integer(UINT), parameter, public :: WM_GETICON = int(Z'007F',UINT)
   integer(UINT), parameter, public :: WM_SETICON = int(Z'0080',UINT)

   integer(UINT), parameter, public :: WM_NCCREATE = int(Z'0081',UINT)
   integer(UINT), parameter, public :: WM_NCDESTROY = int(Z'0082',UINT)
   integer(UINT), parameter, public :: WM_NCCALCSIZE = int(Z'0083',UINT)
   integer(UINT), parameter, public :: WM_NCHITTEST = int(Z'0084',UINT)
   integer(UINT), parameter, public :: WM_NCPAINT = int(Z'0085',UINT)
   integer(UINT), parameter, public :: WM_NCACTIVATE = int(Z'0086',UINT)
   integer(UINT), parameter, public :: WM_GETDLGCODE = int(Z'0087',UINT)

   integer(UINT), parameter, public :: WM_SYNCPAINT = int(Z'0088',UINT)

   integer(UINT), parameter, public :: WM_NCMOUSEMOVE = int(Z'00A0',UINT)
   integer(UINT), parameter, public :: WM_NCLBUTTONDOWN = int(Z'00A1',UINT)
   integer(UINT), parameter, public :: WM_NCLBUTTONUP = int(Z'00A2',UINT)
   integer(UINT), parameter, public :: WM_NCLBUTTONDBLCLK = int(Z'00A3',UINT)
   integer(UINT), parameter, public :: WM_NCRBUTTONDOWN = int(Z'00A4',UINT)
   integer(UINT), parameter, public :: WM_NCRBUTTONUP = int(Z'00A5',UINT)
   integer(UINT), parameter, public :: WM_NCRBUTTONDBLCLK = int(Z'00A6',UINT)
   integer(UINT), parameter, public :: WM_NCMBUTTONDOWN = int(Z'00A7',UINT)
   integer(UINT), parameter, public :: WM_NCMBUTTONUP = int(Z'00A8',UINT)
   integer(UINT), parameter, public :: WM_NCMBUTTONDBLCLK = int(Z'00A9',UINT)

   integer(UINT), parameter, public :: WM_NCXBUTTONDOWN = int(Z'00AB',UINT)
   integer(UINT), parameter, public :: WM_NCXBUTTONUP = int(Z'00AC',UINT)
   integer(UINT), parameter, public :: WM_NCXBUTTONDBLCLK = int(Z'00AD',UINT)
   integer(UINT), parameter, public :: WM_INPUT = int(Z'00FF',UINT)
   integer(UINT), parameter, public :: WM_KEYFIRST = int(Z'0100',UINT)
   integer(UINT), parameter, public :: WM_KEYDOWN = int(Z'0100',UINT)
   integer(UINT), parameter, public :: WM_KEYUP = int(Z'0101',UINT)
   integer(UINT), parameter, public :: WM_CHAR = int(Z'0102',UINT)
   integer(UINT), parameter, public :: WM_DEADCHAR = int(Z'0103',UINT)
   integer(UINT), parameter, public :: WM_SYSKEYDOWN = int(Z'0104',UINT)
   integer(UINT), parameter, public :: WM_SYSKEYUP = int(Z'0105',UINT)
   integer(UINT), parameter, public :: WM_SYSCHAR = int(Z'0106',UINT)
   integer(UINT), parameter, public :: WM_SYSDEADCHAR = int(Z'0107',UINT)
   integer(UINT), parameter, public :: WM_UNICHAR = int(Z'0109',UINT)
   integer(UINT), parameter, public :: WM_KEYLAST = int(Z'0109',UINT)
   integer, parameter, public :: UNICODE_NOCHAR = int(Z'FFFF')
   integer(UINT), parameter, public :: WM_IME_STARTCOMPOSITION = int(Z'010D',UINT)
   integer(UINT), parameter, public :: WM_IME_ENDCOMPOSITION = int(Z'010E',UINT)
   integer(UINT), parameter, public :: WM_IME_COMPOSITION = int(Z'010F',UINT)
   integer(UINT), parameter, public :: WM_IME_KEYLAST = int(Z'010F',UINT)
   integer(UINT), parameter, public :: WM_INITDIALOG = int(Z'0110',UINT)
   integer(UINT), parameter, public :: WM_COMMAND = int(Z'0111',UINT)
   integer(UINT), parameter, public :: WM_SYSCOMMAND = int(Z'0112',UINT)
   integer(UINT), parameter, public :: WM_TIMER = int(Z'0113',UINT)
   integer(UINT), parameter, public :: WM_HSCROLL = int(Z'0114',UINT)
   integer(UINT), parameter, public :: WM_VSCROLL = int(Z'0115',UINT)
   integer(UINT), parameter, public :: WM_INITMENU = int(Z'0116',UINT)
   integer(UINT), parameter, public :: WM_INITMENUPOPUP = int(Z'0117',UINT)
   integer(UINT), parameter, public :: WM_MENUSELECT = int(Z'011F',UINT)

   integer(UINT), parameter, public :: WM_GESTURE = int(Z'0119',UINT)
   integer(UINT), parameter, public :: WM_GESTURENOTIFY = int(Z'011A',UINT)

   integer(UINT), parameter, public :: WM_MENUCHAR = int(Z'0120',UINT)
   integer(UINT), parameter, public :: WM_ENTERIDLE = int(Z'0121',UINT)

   integer(UINT), parameter, public :: WM_MENURBUTTONUP = int(Z'0122',UINT)
   integer(UINT), parameter, public :: WM_MENUDRAG = int(Z'0123',UINT)
   integer(UINT), parameter, public :: WM_MENUGETOBJECT = int(Z'0124',UINT)
   integer(UINT), parameter, public :: WM_UNINITMENUPOPUP = int(Z'0125',UINT)
   integer(UINT), parameter, public :: WM_MENUCOMMAND = int(Z'0126',UINT)

   integer(UINT), parameter, public :: WM_CHANGEUISTATE = int(Z'0127',UINT)
   integer(UINT), parameter, public :: WM_UPDATEUISTATE = int(Z'0128',UINT)
   integer(UINT), parameter, public :: WM_QUERYUISTATE = int(Z'0129',UINT)

   integer(UINT), parameter, public :: WM_CTLCOLORMSGBOX = int(Z'0132',UINT)
   integer(UINT), parameter, public :: WM_CTLCOLOREDIT = int(Z'0133',UINT)
   integer(UINT), parameter, public :: WM_CTLCOLORLISTBOX = int(Z'0134',UINT)
   integer(UINT), parameter, public :: WM_CTLCOLORBTN = int(Z'0135',UINT)
   integer(UINT), parameter, public :: WM_CTLCOLORDLG = int(Z'0136',UINT)
   integer(UINT), parameter, public :: WM_CTLCOLORSCROLLBAR = int(Z'0137',UINT)
   integer(UINT), parameter, public :: WM_CTLCOLORSTATIC = int(Z'0138',UINT)
   integer(UINT), parameter, public :: MN_GETHMENU = int(Z'01E1',UINT)

   integer(UINT), parameter, public :: WM_MOUSEFIRST = int(Z'0200',UINT)
   integer(UINT), parameter, public :: WM_MOUSEMOVE = int(Z'0200',UINT)
   integer(UINT), parameter, public :: WM_LBUTTONDOWN = int(Z'0201',UINT)
   integer(UINT), parameter, public :: WM_LBUTTONUP = int(Z'0202',UINT)
   integer(UINT), parameter, public :: WM_LBUTTONDBLCLK = int(Z'0203',UINT)
   integer(UINT), parameter, public :: WM_RBUTTONDOWN = int(Z'0204',UINT)
   integer(UINT), parameter, public :: WM_RBUTTONUP = int(Z'0205',UINT)
   integer(UINT), parameter, public :: WM_RBUTTONDBLCLK = int(Z'0206',UINT)
   integer(UINT), parameter, public :: WM_MBUTTONDOWN = int(Z'0207',UINT)
   integer(UINT), parameter, public :: WM_MBUTTONUP = int(Z'0208',UINT)
   integer(UINT), parameter, public :: WM_MBUTTONDBLCLK = int(Z'0209',UINT)
   integer(UINT), parameter, public :: WM_MOUSEWHEEL = int(Z'020A',UINT)
   integer(UINT), parameter, public :: WM_XBUTTONDOWN = int(Z'020B',UINT)
   integer(UINT), parameter, public :: WM_XBUTTONUP = int(Z'020C',UINT)
   integer(UINT), parameter, public :: WM_XBUTTONDBLCLK = int(Z'020D',UINT)
   integer(UINT), parameter, public :: WM_MOUSELAST = int(Z'020D',UINT)

   integer(UINT), parameter, public :: WM_PARENTNOTIFY = int(Z'0210',UINT)
   integer(UINT), parameter, public :: WM_ENTERMENULOOP = int(Z'0211',UINT)
   integer(UINT), parameter, public :: WM_EXITMENULOOP = int(Z'0212',UINT)

   integer(UINT), parameter, public :: WM_NEXTMENU = int(Z'0213',UINT)
   integer(UINT), parameter, public :: WM_SIZING = int(Z'0214',UINT)
   integer(UINT), parameter, public :: WM_CAPTURECHANGED = int(Z'0215',UINT)
   integer(UINT), parameter, public :: WM_MOVING = int(Z'0216',UINT)

   integer(UINT), parameter, public :: WM_POWERBROADCAST = int(Z'0218',UINT)

   integer, parameter, public :: PBT_APMQUERYSUSPEND = int(Z'0000')
   integer, parameter, public :: PBT_APMQUERYSTANDBY = int(Z'0001')

   integer, parameter, public :: PBT_APMQUERYSUSPENDFAILED = int(Z'0002')
   integer, parameter, public :: PBT_APMQUERYSTANDBYFAILED = int(Z'0003')

   integer, parameter, public :: PBT_APMSUSPEND = int(Z'0004')
   integer, parameter, public :: PBT_APMSTANDBY = int(Z'0005')

   integer, parameter, public :: PBT_APMRESUMECRITICAL = int(Z'0006')
   integer, parameter, public :: PBT_APMRESUMESUSPEND = int(Z'0007')
   integer, parameter, public :: PBT_APMRESUMESTANDBY = int(Z'0008')

   integer, parameter, public :: PBTF_APMRESUMEFROMFAILURE = int(Z'00000001')

   integer, parameter, public :: PBT_APMBATTERYLOW = int(Z'0009')
   integer, parameter, public :: PBT_APMPOWERSTATUSCHANGE = int(Z'000A')

   integer, parameter, public :: PBT_APMOEMEVENT = int(Z'000B')
   integer, parameter, public :: PBT_APMRESUMEAUTOMATIC = int(Z'0012')

   integer(UINT), parameter, public :: WM_DEVICECHANGE = int(Z'0219',UINT)

   integer(UINT), parameter, public :: WM_MDICREATE = int(Z'0220',UINT)
   integer(UINT), parameter, public :: WM_MDIDESTROY = int(Z'0221',UINT)
   integer(UINT), parameter, public :: WM_MDIACTIVATE = int(Z'0222',UINT)
   integer(UINT), parameter, public :: WM_MDIRESTORE = int(Z'0223',UINT)
   integer(UINT), parameter, public :: WM_MDINEXT = int(Z'0224',UINT)
   integer(UINT), parameter, public :: WM_MDIMAXIMIZE = int(Z'0225',UINT)
   integer(UINT), parameter, public :: WM_MDITILE = int(Z'0226',UINT)
   integer(UINT), parameter, public :: WM_MDICASCADE = int(Z'0227',UINT)
   integer(UINT), parameter, public :: WM_MDIICONARRANGE = int(Z'0228',UINT)
   integer(UINT), parameter, public :: WM_MDIGETACTIVE = int(Z'0229',UINT)

   integer(UINT), parameter, public :: WM_MDISETMENU = int(Z'0230',UINT)
   integer(UINT), parameter, public :: WM_ENTERSIZEMOVE = int(Z'0231',UINT)
   integer(UINT), parameter, public :: WM_EXITSIZEMOVE = int(Z'0232',UINT)
   integer(UINT), parameter, public :: WM_DROPFILES = int(Z'0233',UINT)
   integer(UINT), parameter, public :: WM_MDIREFRESHMENU = int(Z'0234',UINT)

   integer(UINT), parameter, public :: WM_IME_SETCONTEXT = int(Z'0281',UINT)
   integer(UINT), parameter, public :: WM_IME_NOTIFY = int(Z'0282',UINT)
   integer(UINT), parameter, public :: WM_IME_CONTROL = int(Z'0283',UINT)
   integer(UINT), parameter, public :: WM_IME_COMPOSITIONFULL = int(Z'0284',UINT)
   integer(UINT), parameter, public :: WM_IME_SELECT = int(Z'0285',UINT)
   integer(UINT), parameter, public :: WM_IME_CHAR = int(Z'0286',UINT)
   integer(UINT), parameter, public :: WM_IME_REQUEST = int(Z'0288',UINT)
   integer(UINT), parameter, public :: WM_IME_KEYDOWN = int(Z'0290',UINT)
   integer(UINT), parameter, public :: WM_IME_KEYUP = int(Z'0291',UINT)

   integer(UINT), parameter, public :: WM_MOUSEHOVER = int(Z'02A1',UINT)
   integer(UINT), parameter, public :: WM_MOUSELEAVE = int(Z'02A3',UINT)
   integer(UINT), parameter, public :: WM_NCMOUSEHOVER = int(Z'02A0',UINT)
   integer(UINT), parameter, public :: WM_NCMOUSELEAVE = int(Z'02A2',UINT)
   integer(UINT), parameter, public :: WM_WTSSESSION_CHANGE = int(Z'02B1',UINT)
   integer(UINT), parameter, public :: WM_TABLET_FIRST = int(Z'02c0',UINT)
   integer(UINT), parameter, public :: WM_TABLET_LAST = int(Z'02df',UINT)
   integer(UINT), parameter, public :: WM_CUT = int(Z'0300',UINT)
   integer(UINT), parameter, public :: WM_COPY = int(Z'0301',UINT)
   integer(UINT), parameter, public :: WM_PASTE = int(Z'0302',UINT)
   integer(UINT), parameter, public :: WM_CLEAR = int(Z'0303',UINT)
   integer(UINT), parameter, public :: WM_UNDO = int(Z'0304',UINT)
   integer(UINT), parameter, public :: WM_RENDERFORMAT = int(Z'0305',UINT)
   integer(UINT), parameter, public :: WM_RENDERALLFORMATS = int(Z'0306',UINT)
   integer(UINT), parameter, public :: WM_DESTROYCLIPBOARD = int(Z'0307',UINT)
   integer(UINT), parameter, public :: WM_DRAWCLIPBOARD = int(Z'0308',UINT)
   integer(UINT), parameter, public :: WM_PAINTCLIPBOARD = int(Z'0309',UINT)
   integer(UINT), parameter, public :: WM_VSCROLLCLIPBOARD = int(Z'030A',UINT)
   integer(UINT), parameter, public :: WM_SIZECLIPBOARD = int(Z'030B',UINT)
   integer(UINT), parameter, public :: WM_ASKCBFORMATNAME = int(Z'030C',UINT)
   integer(UINT), parameter, public :: WM_CHANGECBCHAIN = int(Z'030D',UINT)
   integer(UINT), parameter, public :: WM_HSCROLLCLIPBOARD = int(Z'030E',UINT)
   integer(UINT), parameter, public :: WM_QUERYNEWPALETTE = int(Z'030F',UINT)
   integer(UINT), parameter, public :: WM_PALETTEISCHANGING = int(Z'0310',UINT)
   integer(UINT), parameter, public :: WM_PALETTECHANGED = int(Z'0311',UINT)
   integer(UINT), parameter, public :: WM_HOTKEY = int(Z'0312',UINT)
   integer(UINT), parameter, public :: WM_PRINT = int(Z'0317',UINT)
   integer(UINT), parameter, public :: WM_PRINTCLIENT = int(Z'0318',UINT)
   integer(UINT), parameter, public :: WM_APPCOMMAND = int(Z'0319',UINT)
   integer(UINT), parameter, public :: WM_THEMECHANGED = int(Z'031A',UINT)
   integer(UINT), parameter, public :: WM_HANDHELDFIRST = int(Z'0358',UINT)
   integer(UINT), parameter, public :: WM_HANDHELDLAST = int(Z'035F',UINT)
   integer(UINT), parameter, public :: WM_AFXFIRST = int(Z'0360',UINT)
   integer(UINT), parameter, public :: WM_AFXLAST = int(Z'037F',UINT)
   integer(UINT), parameter, public :: WM_PENWINFIRST = int(Z'0380',UINT)
   integer(UINT), parameter, public :: WM_PENWINLAST = int(Z'038F',UINT)
   integer(UINT), parameter, public :: WM_APP = int(Z'8000',UINT)
   integer(UINT), parameter, public :: WM_USER = int(Z'0400',UINT)

   integer(UINT), parameter, public :: WM_SETTINGCHANGE = WM_WININICHANGE

   integer, parameter, public :: PWR_OK = 1
   integer, parameter, public :: PWR_FAIL = -1
   integer, parameter, public :: PWR_SUSPENDREQUEST = 1
   integer, parameter, public :: PWR_SUSPENDRESUME = 2
   integer, parameter, public :: PWR_CRITICALRESUME = 3

   integer, parameter, public :: NFR_ANSI = 1
   integer, parameter, public :: NFR_UNICODE = 2
   integer, parameter, public :: NF_QUERY = 3
   integer, parameter, public :: NF_REQUERY = 4

   integer, parameter, public :: UIS_SET = 1
   integer, parameter, public :: UIS_CLEAR = 2
   integer, parameter, public :: UIS_INITIALIZE = 3

   integer, parameter, public :: UISF_HIDEFOCUS = int(Z'1')
   integer, parameter, public :: UISF_HIDEACCEL = int(Z'2')
   integer, parameter, public :: UISF_ACTIVE = int(Z'4')

   integer, parameter, public :: WHEEL_DELTA = 120
! Untranslated
!#define GET_WHEEL_DELTA_WPARAM(wParam) ((short)HIWORD(wParam))
!#define WHEEL_PAGESCROLL (UINT_MAX)
!#define GET_KEYSTATE_WPARAM(wParam) (LOWORD(wParam))
!#define GET_NCHITTEST_WPARAM(wParam) ((short)LOWORD(wParam))
!#define GET_XBUTTON_WPARAM(wParam) (HIWORD(wParam))

   integer, parameter, public :: XBUTTON1 = int(Z'0001')
   integer, parameter, public :: XBUTTON2 = int(Z'0002')

   integer, parameter, public :: PBT_POWERSETTINGCHANGE = 32787

   integer, parameter, public :: WMSZ_LEFT = 1
   integer, parameter, public :: WMSZ_RIGHT = 2
   integer, parameter, public :: WMSZ_TOP = 3
   integer, parameter, public :: WMSZ_TOPLEFT = 4
   integer, parameter, public :: WMSZ_TOPRIGHT = 5
   integer, parameter, public :: WMSZ_BOTTOM = 6
   integer, parameter, public :: WMSZ_BOTTOMLEFT = 7
   integer, parameter, public :: WMSZ_BOTTOMRIGHT = 8

! Virtual key codes
   integer, parameter, public :: VK_LBUTTON = int(Z'01')
   integer, parameter, public :: VK_RBUTTON = int(Z'02')
   integer, parameter, public :: VK_CANCEL = int(Z'03')
   integer, parameter, public :: VK_MBUTTON = int(Z'04')
   integer, parameter, public :: VK_XBUTTON1 = int(Z'05')
   integer, parameter, public :: VK_XBUTTON2 = int(Z'06')
   integer, parameter, public :: VK_BACK = int(Z'08')
   integer, parameter, public :: VK_TAB = int(Z'09')
   integer, parameter, public :: VK_CLEAR = int(Z'0C')
   integer, parameter, public :: VK_RETURN = int(Z'0D')
   integer, parameter, public :: VK_SHIFT = int(Z'10')
   integer, parameter, public :: VK_CONTROL = int(Z'11')
   integer, parameter, public :: VK_MENU = int(Z'12')
   integer, parameter, public :: VK_PAUSE = int(Z'13')
   integer, parameter, public :: VK_CAPITAL = int(Z'14')
   integer, parameter, public :: VK_KANA = int(Z'15')
   integer, parameter, public :: VK_HANGEUL = int(Z'15')
   integer, parameter, public :: VK_HANGUL = int(Z'15')
   integer, parameter, public :: VK_JUNJA = int(Z'17')
   integer, parameter, public :: VK_FINAL = int(Z'18')
   integer, parameter, public :: VK_HANJA = int(Z'19')
   integer, parameter, public :: VK_KANJI = int(Z'19')
   integer, parameter, public :: VK_ESCAPE = int(Z'1B')
   integer, parameter, public :: VK_CONVERT = int(Z'1C')
   integer, parameter, public :: VK_NONCONVERT = int(Z'1D')
   integer, parameter, public :: VK_ACCEPT = int(Z'1E')
   integer, parameter, public :: VK_MODECHANGE = int(Z'1F')
   integer, parameter, public :: VK_SPACE = int(Z'20')
   integer, parameter, public :: VK_PRIOR = int(Z'21')
   integer, parameter, public :: VK_NEXT = int(Z'22')
   integer, parameter, public :: VK_END = int(Z'23')
   integer, parameter, public :: VK_HOME = int(Z'24')
   integer, parameter, public :: VK_LEFT = int(Z'25')
   integer, parameter, public :: VK_UP = int(Z'26')
   integer, parameter, public :: VK_RIGHT = int(Z'27')
   integer, parameter, public :: VK_DOWN = int(Z'28')
   integer, parameter, public :: VK_SELECT = int(Z'29')
   integer, parameter, public :: VK_PRINT = int(Z'2A')
   integer, parameter, public :: VK_EXECUTE = int(Z'2B')
   integer, parameter, public :: VK_SNAPSHOT = int(Z'2C')
   integer, parameter, public :: VK_INSERT = int(Z'2D')
   integer, parameter, public :: VK_DELETE = int(Z'2E')
   integer, parameter, public :: VK_HELP = int(Z'2F')

   integer, parameter, public :: VK_LWIN = int(Z'5B')
   integer, parameter, public :: VK_RWIN = int(Z'5C')
   integer, parameter, public :: VK_APPS = int(Z'5D')
   integer, parameter, public :: VK_SLEEP = int(Z'5F')
   integer, parameter, public :: VK_NUMPAD0 = int(Z'60')
   integer, parameter, public :: VK_NUMPAD1 = int(Z'61')
   integer, parameter, public :: VK_NUMPAD2 = int(Z'62')
   integer, parameter, public :: VK_NUMPAD3 = int(Z'63')
   integer, parameter, public :: VK_NUMPAD4 = int(Z'64')
   integer, parameter, public :: VK_NUMPAD5 = int(Z'65')
   integer, parameter, public :: VK_NUMPAD6 = int(Z'66')
   integer, parameter, public :: VK_NUMPAD7 = int(Z'67')
   integer, parameter, public :: VK_NUMPAD8 = int(Z'68')
   integer, parameter, public :: VK_NUMPAD9 = int(Z'69')
   integer, parameter, public :: VK_MULTIPLY = int(Z'6A')
   integer, parameter, public :: VK_ADD = int(Z'6B')
   integer, parameter, public :: VK_SEPARATOR = int(Z'6C')
   integer, parameter, public :: VK_SUBTRACT = int(Z'6D')
   integer, parameter, public :: VK_DECIMAL = int(Z'6E')
   integer, parameter, public :: VK_DIVIDE = int(Z'6F')
   integer, parameter, public :: VK_F1 = int(Z'70')
   integer, parameter, public :: VK_F2 = int(Z'71')
   integer, parameter, public :: VK_F3 = int(Z'72')
   integer, parameter, public :: VK_F4 = int(Z'73')
   integer, parameter, public :: VK_F5 = int(Z'74')
   integer, parameter, public :: VK_F6 = int(Z'75')
   integer, parameter, public :: VK_F7 = int(Z'76')
   integer, parameter, public :: VK_F8 = int(Z'77')
   integer, parameter, public :: VK_F9 = int(Z'78')
   integer, parameter, public :: VK_F10 = int(Z'79')
   integer, parameter, public :: VK_F11 = int(Z'7A')
   integer, parameter, public :: VK_F12 = int(Z'7B')
   integer, parameter, public :: VK_F13 = int(Z'7C')
   integer, parameter, public :: VK_F14 = int(Z'7D')
   integer, parameter, public :: VK_F15 = int(Z'7E')
   integer, parameter, public :: VK_F16 = int(Z'7F')
   integer, parameter, public :: VK_F17 = int(Z'80')
   integer, parameter, public :: VK_F18 = int(Z'81')
   integer, parameter, public :: VK_F19 = int(Z'82')
   integer, parameter, public :: VK_F20 = int(Z'83')
   integer, parameter, public :: VK_F21 = int(Z'84')
   integer, parameter, public :: VK_F22 = int(Z'85')
   integer, parameter, public :: VK_F23 = int(Z'86')
   integer, parameter, public :: VK_F24 = int(Z'87')
   integer, parameter, public :: VK_NUMLOCK = int(Z'90')
   integer, parameter, public :: VK_SCROLL = int(Z'91')
   integer, parameter, public :: VK_OEM_NEC_EQUAL = int(Z'92')
   integer, parameter, public :: VK_OEM_FJ_JISHO = int(Z'92')
   integer, parameter, public :: VK_OEM_FJ_MASSHOU = int(Z'93')
   integer, parameter, public :: VK_OEM_FJ_TOUROKU = int(Z'94')
   integer, parameter, public :: VK_OEM_FJ_LOYA = int(Z'95')
   integer, parameter, public :: VK_OEM_FJ_ROYA = int(Z'96')
   integer, parameter, public :: VK_LSHIFT = int(Z'A0')
   integer, parameter, public :: VK_RSHIFT = int(Z'A1')
   integer, parameter, public :: VK_LCONTROL = int(Z'A2')
   integer, parameter, public :: VK_RCONTROL = int(Z'A3')
   integer, parameter, public :: VK_LMENU = int(Z'A4')
   integer, parameter, public :: VK_RMENU = int(Z'A5')
   integer, parameter, public :: VK_BROWSER_BACK = int(Z'A6')
   integer, parameter, public :: VK_BROWSER_FORWARD = int(Z'A7')
   integer, parameter, public :: VK_BROWSER_REFRESH = int(Z'A8')
   integer, parameter, public :: VK_BROWSER_STOP = int(Z'A9')
   integer, parameter, public :: VK_BROWSER_SEARCH = int(Z'AA')
   integer, parameter, public :: VK_BROWSER_FAVORITES = int(Z'AB')
   integer, parameter, public :: VK_BROWSER_HOME = int(Z'AC')
   integer, parameter, public :: VK_VOLUME_MUTE = int(Z'AD')
   integer, parameter, public :: VK_VOLUME_DOWN = int(Z'AE')
   integer, parameter, public :: VK_VOLUME_UP = int(Z'AF')
   integer, parameter, public :: VK_MEDIA_NEXT_TRACK = int(Z'B0')
   integer, parameter, public :: VK_MEDIA_PREV_TRACK = int(Z'B1')
   integer, parameter, public :: VK_MEDIA_STOP = int(Z'B2')
   integer, parameter, public :: VK_MEDIA_PLAY_PAUSE = int(Z'B3')
   integer, parameter, public :: VK_LAUNCH_MAIL = int(Z'B4')
   integer, parameter, public :: VK_LAUNCH_MEDIA_SELECT = int(Z'B5')
   integer, parameter, public :: VK_LAUNCH_APP1 = int(Z'B6')
   integer, parameter, public :: VK_LAUNCH_APP2 = int(Z'B7')
   integer, parameter, public :: VK_OEM_1 = int(Z'BA')
   integer, parameter, public :: VK_OEM_PLUS = int(Z'BB')
   integer, parameter, public :: VK_OEM_COMMA = int(Z'BC')
   integer, parameter, public :: VK_OEM_MINUS = int(Z'BD')
   integer, parameter, public :: VK_OEM_PERIOD = int(Z'BE')
   integer, parameter, public :: VK_OEM_2 = int(Z'BF')
   integer, parameter, public :: VK_OEM_3 = int(Z'C0')
   integer, parameter, public :: VK_OEM_4 = int(Z'DB')
   integer, parameter, public :: VK_OEM_5 = int(Z'DC')
   integer, parameter, public :: VK_OEM_6 = int(Z'DD')
   integer, parameter, public :: VK_OEM_7 = int(Z'DE')
   integer, parameter, public :: VK_OEM_8 = int(Z'DF')
   integer, parameter, public :: VK_OEM_AX = int(Z'E1')
   integer, parameter, public :: VK_OEM_102 = int(Z'E2')
   integer, parameter, public :: VK_ICO_HELP = int(Z'E3')
   integer, parameter, public :: VK_ICO_00 = int(Z'E4')
   integer, parameter, public :: VK_PROCESSKEY = int(Z'E5')
   integer, parameter, public :: VK_ICO_CLEAR = int(Z'E6')
   integer, parameter, public :: VK_PACKET = int(Z'E7')
   integer, parameter, public :: VK_OEM_RESET = int(Z'E9')
   integer, parameter, public :: VK_OEM_JUMP = int(Z'EA')
   integer, parameter, public :: VK_OEM_PA1 = int(Z'EB')
   integer, parameter, public :: VK_OEM_PA2 = int(Z'EC')
   integer, parameter, public :: VK_OEM_PA3 = int(Z'ED')
   integer, parameter, public :: VK_OEM_WSCTRL = int(Z'EE')
   integer, parameter, public :: VK_OEM_CUSEL = int(Z'EF')
   integer, parameter, public :: VK_OEM_ATTN = int(Z'F0')
   integer, parameter, public :: VK_OEM_FINISH = int(Z'F1')
   integer, parameter, public :: VK_OEM_COPY = int(Z'F2')
   integer, parameter, public :: VK_OEM_AUTO = int(Z'F3')
   integer, parameter, public :: VK_OEM_ENLW = int(Z'F4')
   integer, parameter, public :: VK_OEM_BACKTAB = int(Z'F5')
   integer, parameter, public :: VK_ATTN = int(Z'F6')
   integer, parameter, public :: VK_CRSEL = int(Z'F7')
   integer, parameter, public :: VK_EXSEL = int(Z'F8')
   integer, parameter, public :: VK_EREOF = int(Z'F9')
   integer, parameter, public :: VK_PLAY = int(Z'FA')
   integer, parameter, public :: VK_ZOOM = int(Z'FB')
   integer, parameter, public :: VK_NONAME = int(Z'FC')
   integer, parameter, public :: VK_PA1 = int(Z'FD')
   integer, parameter, public :: VK_OEM_CLEAR = int(Z'FE')

! Constants for GetQueueStatus function

   integer(UINT), parameter, public :: QS_KEY = int(Z'0001',UINT)
   integer(UINT), parameter, public :: QS_MOUSEMOVE = int(Z'0002',UINT)
   integer(UINT), parameter, public :: QS_MOUSEBUTTON = int(Z'0004',UINT)
   integer(UINT), parameter, public :: QS_POSTMESSAGE = int(Z'0008',UINT)
   integer(UINT), parameter, public :: QS_TIMER = int(Z'0010',UINT)
   integer(UINT), parameter, public :: QS_PAINT = int(Z'0020',UINT)
   integer(UINT), parameter, public :: QS_SENDMESSAGE = int(Z'0040',UINT)
   integer(UINT), parameter, public :: QS_HOTKEY = int(Z'0080',UINT)
   integer(UINT), parameter, public :: QS_ALLPOSTMESSAGE = int(Z'0100',UINT)
   integer(UINT), parameter, public :: QS_RAWINPUT = int(Z'0400',UINT)
   integer(UINT), parameter, public :: QS_MOUSE = ior(QS_MOUSEMOVE,QS_MOUSEBUTTON)
   integer(UINT), parameter, public :: QS_INPUT = iANY([QS_MOUSE, &
      QS_KEY,QS_RAWINPUT])
   integer(UINT), parameter, public :: QS_ALLEVENTS = iany([QS_INPUT, &
      QS_POSTMESSAGE,QS_TIMER,QS_PAINT,QS_HOTKEY])
   integer(UINT), parameter, public :: QS_ALLINPUT = iany([QS_INPUT, &
      QS_POSTMESSAGE,QS_TIMER,QS_PAINT,QS_HOTKEY,QS_SENDMESSAGE])

! Constants for PeekMeesage funnction

   integer(UINT), parameter, public :: PM_NOREMOVE = int(Z'0000',UINT)
   integer(UINT), parameter, public :: PM_REMOVE = int(Z'0001',UINT)
   integer(UINT), parameter, public :: PM_NOYIELD = int(Z'0002',UINT)
   integer(UINT), parameter, public :: PM_QS_INPUT = ishft(QS_INPUT,16)
   integer(UINT), parameter, public :: PM_QS_POSTMESSAGE = ishft(iany([QS_POSTMESSAGE, &
      QS_HOTKEY,QS_TIMER]),16)
   integer(UINT), parameter, public :: PM_QS_PAINT = ishft(QS_PAINT,16)
   integer(UINT), parameter, public :: PM_QS_SENDMESSAGE = ishft(QS_SENDMESSAGE,16)

! Constants for SetTimer function
   integer(UINT), parameter, public :: USER_TIMER_MAXIMUM = int(Z'7FFFFFFF',UINT)
   integer(UINT), parameter, public :: USER_TIMER_MINIMUM = int(Z'0000000A',UINT)

! Generic Access Rights
   integer(DWORD), parameter, public :: GENERIC_ALL = int(Z'10000000',DWORD)
   integer(DWORD), parameter, public :: GENERIC_EXECUTE = int(Z'20000000',DWORD)
   integer(DWORD), parameter, public :: GENERIC_READ = int(Z'80000000',DWORD)
   integer(DWORD), parameter, public :: GENERIC_WRITE = int(Z'40000000',DWORD)

! Standard Access Rights
   integer(DWORD), parameter, public :: DELETE = int(Z'10000',DWORD)
   integer(DWORD), parameter, public :: READ_CONTROL = int(Z'20000',DWORD)
   integer(DWORD), parameter, public :: SYNCHRONIZE = int(Z'100000',DWORD)
   integer(DWORD), parameter, public :: WRITE_DAC = int(Z'40000',DWORD)
   integer(DWORD), parameter, public :: WRITE_OWNER = int(Z'80000',DWORD)
   integer(DWORD), parameter, public :: STANDARD_RIGHTS_ALL = &
      iany([DELETE,READ_CONTROL,WRITE_DAC,WRITE_OWNER,SYNCHRONIZE])
   integer(DWORD), parameter, public :: STANDARD_RIGHTS_EXECUTE = READ_CONTROL
   integer(DWORD), parameter, public :: STANDARD_RIGHTS_READ = READ_CONTROL
   integer(DWORD), parameter, public :: STANDARD_RIGHTS_REQUIRED = &
      iany([DELETE,READ_CONTROL,WRITE_DAC,WRITE_OWNER])
   integer(DWORD), parameter, public :: STANDARD_RIGHTS_WRITE = READ_CONTROL

! File access rights
   integer(DWORD), parameter, public :: FILE_ADD_FILE = int(Z'2',DWORD)
   integer(DWORD), parameter, public :: FILE_ADD_SUBDIRECTORY = int(Z'4',DWORD)
   integer(DWORD), parameter, public :: FILE_ALL_ACCESS = int(Z'1f01ff',DWORD)
   integer(DWORD), parameter, public :: FILE_APPEND_DATA = int(Z'4',DWORD)
   integer(DWORD), parameter, public :: FILE_CREATE_PIPE_INSTANCE = int(Z'4',DWORD)
   integer(DWORD), parameter, public :: FILE_DELETE_CHILD = int(Z'40',DWORD)
   integer(DWORD), parameter, public :: FILE_EXECUTE = int(Z'20',DWORD)
   integer(DWORD), parameter, public :: FILE_LIST_DIRECTORY = int(Z'1',DWORD)
   integer(DWORD), parameter, public :: FILE_READ_ATTRIBUTES = int(Z'80',DWORD)
   integer(DWORD), parameter, public :: FILE_READ_DATA = int(Z'1',DWORD)
   integer(DWORD), parameter, public :: FILE_READ_EA = int(Z'8',DWORD)
   integer(DWORD), parameter, public :: FILE_TRAVERSE = int(Z'20',DWORD)
   integer(DWORD), parameter, public :: FILE_WRITE_ATTRIBUTES = int(Z'100',DWORD)
   integer(DWORD), parameter, public :: FILE_WRITE_DATA = int(Z'2',DWORD)
   integer(DWORD), parameter, public :: FILE_WRITE_EA = int(Z'10',DWORD)
   integer(DWORD), parameter, public :: FILE_GENERIC_EXECUTE = &
      iany([FILE_EXECUTE,FILE_READ_ATTRIBUTES,STANDARD_RIGHTS_EXECUTE,SYNCHRONIZE])
   integer(DWORD), parameter, public :: FILE_GENERIC_READ = &
      iany([FILE_READ_ATTRIBUTES,FILE_READ_DATA,FILE_READ_EA, &
      STANDARD_RIGHTS_READ,SYNCHRONIZE])
   integer(DWORD), parameter, public :: FILE_GENERIC_WRITE = &
      iany([FILE_APPEND_DATA,FILE_WRITE_ATTRIBUTES,FILE_WRITE_DATA, &
      FILE_WRITE_EA,STANDARD_RIGHTS_WRITE,SYNCHRONIZE])

! Shared Modes
   integer(DWORD), parameter, public :: FILE_SHARE_DELETE = int(Z'00000004',DWORD)
   integer(DWORD), parameter, public :: FILE_SHARE_READ = int(Z'00000001',DWORD)
   integer(DWORD), parameter, public :: FILE_SHARE_WRITE = int(Z'00000002',DWORD)

! Creation Dispositions
   integer(DWORD), parameter, public :: CREATE_ALWAYS = 2
   integer(DWORD), parameter, public :: CREATE_NEW = 1
   integer(DWORD), parameter, public :: OPEN_ALWAYS = 4
   integer(DWORD), parameter, public :: OPEN_EXISTING = 3
   integer(DWORD), parameter, public :: TRUNCATE_EXISTING = 5

! File Attributes
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_ARCHIVE = int(Z'20',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_COMPRESSED = int(Z'800',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_DEVICE = int(Z'40',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_DIRECTORY = int(Z'10',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_ENCRYPTED = int(Z'4000',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_HIDDEN = int(Z'2',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_NORMAL = int(Z'80',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = int(Z'2000',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_OFFLINE = int(Z'1000',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_READONLY = int(Z'1',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_REPARSE_POINT = int(Z'400',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_SPARSE_FILE = int(Z'200',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_SYSTEM = int(Z'4',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_TEMPORARY = int(Z'100',DWORD)
   integer(DWORD), parameter, public :: FILE_ATTRIBUTE_VIRTUAL = int(Z'10000',DWORD)

! File Flags
   integer(DWORD), parameter, public :: FILE_FLAG_BACKUP_SEMANTICS = int(Z'2000000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_DELETE_ON_CLOSE = int(Z'4000000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_NO_BUFFERING = int(Z'20000000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_OPEN_NO_RECALL = int(Z'100000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_OPEN_REPARSE_POINT = int(Z'200000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_OVERLAPPED = int(Z'40000000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_POSIX_SEMANTICS = int(Z'1000000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_RANDOM_ACCESS = int(Z'10000000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_SEQUENTIAL_SCAN = int(Z'8000000',DWORD)
   integer(DWORD), parameter, public :: FILE_FLAG_WRITE_THROUGH = int(Z'80000000',DWORD)

! Security Flags
   integer(DWORD), parameter, public :: SECURITY_ANONYMOUS = int(Z'0',DWORD)
   integer(DWORD), parameter, public :: SECURITY_CONTEXT_TRACKING = int(Z'40000',DWORD)
   integer(DWORD), parameter, public :: SECURITY_DELEGATION = int(Z'30000',DWORD)
   integer(DWORD), parameter, public :: SECURITY_EFFECTIVE_ONLY = int(Z'80000',DWORD)
   integer(DWORD), parameter, public :: SECURITY_IDENTIFICATION = int(Z'10000',DWORD)
   integer(DWORD), parameter, public :: SECURITY_IMPERSONATION = int(Z'20000',DWORD)

! Standard Handles
   integer(DWORD), parameter, public :: STD_INPUT_HANDLE = -10_DWORD
   integer(DWORD), parameter, public :: STD_OUTPUT_HANDLE = -11_DWORD
   integer(DWORD), parameter, public :: STD_ERROR_HANDLE = -12_DWORD

! Constants for wglUseFontOutlines
   integer(C_INT), parameter, public :: WGL_FONT_LINES = 0
   integer(C_INT), parameter, public :: WGL_FONT_POLYGONS = 1

! Other wgl* constants
integer, parameter, public :: WGL_SWAPMULTIPLE_MAX = 16

! Constants for GetDeviceCaps function
   integer(C_INT), parameter, public :: DRIVERVERSION = 0
   integer(C_INT), parameter, public :: TECHNOLOGY = 2
   integer(C_INT), parameter, public :: HORZSIZE = 4
   integer(C_INT), parameter, public :: VERTSIZE = 6
   integer(C_INT), parameter, public :: HORZRES = 8
   integer(C_INT), parameter, public :: VERTRES = 10
   integer(C_INT), parameter, public :: BITSPIXEL = 12
   integer(C_INT), parameter, public :: PLANES = 14
   integer(C_INT), parameter, public :: NUMBRUSHES = 16
   integer(C_INT), parameter, public :: NUMPENS = 18
   integer(C_INT), parameter, public :: NUMMARKERS = 20
   integer(C_INT), parameter, public :: NUMFONTS = 22
   integer(C_INT), parameter, public :: NUMCOLORS = 24
   integer(C_INT), parameter, public :: PDEVICESIZE = 26
   integer(C_INT), parameter, public :: CURVECAPS = 28
   integer(C_INT), parameter, public :: LINECAPS = 30
   integer(C_INT), parameter, public :: POLYGONALCAPS = 32
   integer(C_INT), parameter, public :: TEXTCAPS = 34
   integer(C_INT), parameter, public :: CLIPCAPS = 36
   integer(C_INT), parameter, public :: RASTERCAPS = 38
   integer(C_INT), parameter, public :: ASPECTX = 40
   integer(C_INT), parameter, public :: ASPECTY = 42
   integer(C_INT), parameter, public :: ASPECTXY = 44

   integer(C_INT), parameter, public :: LOGPIXELSX = 88
   integer(C_INT), parameter, public :: LOGPIXELSY = 90

   integer(C_INT), parameter, public :: SIZEPALETTE = 104
   integer(C_INT), parameter, public :: NUMRESERVED = 106
   integer(C_INT), parameter, public :: COLORRES = 108

   integer(C_INT), parameter, public :: PHYSICALWIDTH = 110
   integer(C_INT), parameter, public :: PHYSICALHEIGHT = 111
   integer(C_INT), parameter, public :: PHYSICALOFFSETX = 112
   integer(C_INT), parameter, public :: PHYSICALOFFSETY = 113
   integer(C_INT), parameter, public :: SCALINGFACTORX = 114
   integer(C_INT), parameter, public :: SCALINGFACTORY = 115

   integer(C_INT), parameter, public :: VREFRESH = 116

   integer(C_INT), parameter, public :: DESKTOPVERTRES = 117

   integer(C_INT), parameter, public :: DESKTOPHORZRES = 118

   integer(C_INT), parameter, public :: BLTALIGNMENT = 119

   integer(C_INT), parameter, public :: SHADEBLENDCAPS = 120
   integer(C_INT), parameter, public :: COLORMGMTCAPS = 121

! Device Technologies
   integer(C_INT), parameter, public :: DT_PLOTTER = 0
   integer(C_INT), parameter, public :: DT_RASDISPLAY = 1
   integer(C_INT), parameter, public :: DT_RASPRINTER = 2
   integer(C_INT), parameter, public :: DT_RASCAMERA = 3
   integer(C_INT), parameter, public :: DT_CHARSTREAM = 4
   integer(C_INT), parameter, public :: DT_METAFILE = 5
   integer(C_INT), parameter, public :: DT_DISPFILE = 6

! Curve Capabilities
   integer(C_INT), parameter, public :: CC_NONE = 0
   integer(C_INT), parameter, public :: CC_CIRCLES = 1
   integer(C_INT), parameter, public :: CC_PIE = 2
   integer(C_INT), parameter, public :: CC_CHORD = 4
   integer(C_INT), parameter, public :: CC_ELLIPSES = 8
   integer(C_INT), parameter, public :: CC_WIDE = 16
   integer(C_INT), parameter, public :: CC_STYLED = 32
   integer(C_INT), parameter, public :: CC_WIDESTYLED = 64
   integer(C_INT), parameter, public :: CC_INTERIORS = 128
   integer(C_INT), parameter, public :: CC_ROUNDRECT = 256

! Line Capabilities
   integer(C_INT), parameter, public :: LC_NONE = 0
   integer(C_INT), parameter, public :: LC_POLYLINE = 2
   integer(C_INT), parameter, public :: LC_MARKER = 4
   integer(C_INT), parameter, public :: LC_POLYMARKER = 8
   integer(C_INT), parameter, public :: LC_WIDE = 16
   integer(C_INT), parameter, public :: LC_STYLED = 32
   integer(C_INT), parameter, public :: LC_WIDESTYLED = 64
   integer(C_INT), parameter, public :: LC_INTERIORS = 128

! Polygon Capabilities
   integer(C_INT), parameter, public :: PC_NONE = 0
   integer(C_INT), parameter, public :: PC_POLYGON = 1
   integer(C_INT), parameter, public :: PC_RECTANGLE = 2
   integer(C_INT), parameter, public :: PC_WINDPOLYGON = 4
   integer(C_INT), parameter, public :: PC_TRAPEZOID = 4
   integer(C_INT), parameter, public :: PC_SCANLINE = 8
   integer(C_INT), parameter, public :: PC_WIDE = 16
   integer(C_INT), parameter, public :: PC_STYLED = 32
   integer(C_INT), parameter, public :: PC_WIDESTYLED = 64
   integer(C_INT), parameter, public :: PC_INTERIORS = 128
   integer(C_INT), parameter, public :: PC_POLYPOLYGON = 256
   integer(C_INT), parameter, public :: PC_PATHS = 512

   integer(C_INT), parameter, public :: CP_NONE = 0
   integer(C_INT), parameter, public :: CP_RECTANGLE = 1
   integer(C_INT), parameter, public :: CP_REGION = 2

! Text Capabilities
   integer(C_INT), parameter, public :: TC_OP_CHARACTER = int(Z'00000001',C_INT)
   integer(C_INT), parameter, public :: TC_OP_STROKE = int(Z'00000002',C_INT)
   integer(C_INT), parameter, public :: TC_CP_STROKE = int(Z'00000004',C_INT)
   integer(C_INT), parameter, public :: TC_CR_90 = int(Z'00000008',C_INT)
   integer(C_INT), parameter, public :: TC_CR_ANY = int(Z'00000010',C_INT)
   integer(C_INT), parameter, public :: TC_SF_X_YINDEP = int(Z'00000020',C_INT)
   integer(C_INT), parameter, public :: TC_SA_DOUBLE = int(Z'00000040',C_INT)
   integer(C_INT), parameter, public :: TC_SA_INTEGER = int(Z'00000080',C_INT)
   integer(C_INT), parameter, public :: TC_SA_CONTIN = int(Z'00000100',C_INT)
   integer(C_INT), parameter, public :: TC_EA_DOUBLE = int(Z'00000200',C_INT)
   integer(C_INT), parameter, public :: TC_IA_ABLE = int(Z'00000400',C_INT)
   integer(C_INT), parameter, public :: TC_UA_ABLE = int(Z'00000800',C_INT)
   integer(C_INT), parameter, public :: TC_SO_ABLE = int(Z'00001000',C_INT)
   integer(C_INT), parameter, public :: TC_RA_ABLE = int(Z'00002000',C_INT)
   integer(C_INT), parameter, public :: TC_VA_ABLE = int(Z'00004000',C_INT)
   integer(C_INT), parameter, public :: TC_RESERVED = int(Z'00008000',C_INT)
   integer(C_INT), parameter, public :: TC_SCROLLBLT = int(Z'00010000',C_INT)

! Raste Capabiliteis
   integer(C_INT), parameter, public :: RC_NONE = 0
   integer(C_INT), parameter, public :: RC_BITBLT = 1
   integer(C_INT), parameter, public :: RC_BANDING = 2
   integer(C_INT), parameter, public :: RC_SCALING = 4
   integer(C_INT), parameter, public :: RC_BITMAP64 = 8
   integer(C_INT), parameter, public :: RC_GDI20_OUTPUT = int(Z'0010',C_INT)
   integer(C_INT), parameter, public :: RC_GDI20_STATE = int(Z'0020',C_INT)
   integer(C_INT), parameter, public :: RC_SAVEBITMAP = int(Z'0040',C_INT)
   integer(C_INT), parameter, public :: RC_DI_BITMAP = int(Z'0080',C_INT)
   integer(C_INT), parameter, public :: RC_PALETTE = int(Z'0100',C_INT)
   integer(C_INT), parameter, public :: RC_DIBTODEV = int(Z'0200',C_INT)
   integer(C_INT), parameter, public :: RC_BIGFONT = int(Z'0400',C_INT)
   integer(C_INT), parameter, public :: RC_STRETCHBLT = int(Z'0800',C_INT)
   integer(C_INT), parameter, public :: RC_FLOODFILL = int(Z'1000',C_INT)
   integer(C_INT), parameter, public :: RC_STRETCHDIB = int(Z'2000',C_INT)
   integer(C_INT), parameter, public :: RC_OP_DX_OUTPUT = int(Z'4000',C_INT)
   integer(C_INT), parameter, public :: RC_DEVBITS = int(Z'8000',C_INT)

! Shading and Blending Capabilities
   integer(C_INT), parameter, public :: SB_NONE = int(Z'00000000',C_INT)
   integer(C_INT), parameter, public :: SB_CONST_ALPHA = int(Z'00000001',C_INT)
   integer(C_INT), parameter, public :: SB_PIXEL_ALPHA = int(Z'00000002',C_INT)
   integer(C_INT), parameter, public :: SB_PREMULT_ALPHA = int(Z'00000004',C_INT)

   integer(C_INT), parameter, public :: SB_GRAD_RECT = int(Z'00000010',C_INT)
   integer(C_INT), parameter, public :: SB_GRAD_TRI = int(Z'00000020',C_INT)

! Color Management Capabilities
   integer(C_INT), parameter, public :: CM_NONE = int(Z'00000000',C_INT)
   integer(C_INT), parameter, public :: CM_DEVICE_ICM = int(Z'00000001',C_INT)
   integer(C_INT), parameter, public :: CM_GAMMA_RAMP = int(Z'00000002',C_INT)
   integer(C_INT), parameter, public :: CM_CMYK_COLOR = int(Z'00000004',C_INT)

! Constants for CreateFont function
   integer(C_INT), parameter, public :: GM_COMPATIBLE = 1
   integer(C_INT), parameter, public :: GM_ADVANCED = 2
   integer(C_INT), parameter, public :: GM_LAST = 2

   integer(C_INT), parameter, public :: FW_DONTCARE = 0
   integer(C_INT), parameter, public :: FW_THIN = 100
   integer(C_INT), parameter, public :: FW_EXTRALIGHT = 200
   integer(C_INT), parameter, public :: FW_LIGHT = 300
   integer(C_INT), parameter, public :: FW_NORMAL = 400
   integer(C_INT), parameter, public :: FW_MEDIUM = 500
   integer(C_INT), parameter, public :: FW_SEMIBOLD = 600
   integer(C_INT), parameter, public :: FW_BOLD = 700
   integer(C_INT), parameter, public :: FW_EXTRABOLD = 800
   integer(C_INT), parameter, public :: FW_HEAVY = 900

   integer(C_INT), parameter, public :: FW_ULTRALIGHT = FW_EXTRALIGHT
   integer(C_INT), parameter, public :: FW_REGULAR = FW_NORMAL
   integer(C_INT), parameter, public :: FW_DEMIBOLD = FW_SEMIBOLD
   integer(C_INT), parameter, public :: FW_ULTRABOLD = FW_EXTRABOLD
   integer(C_INT), parameter, public :: FW_BLACK = FW_HEAVY

   integer(DWORD), parameter, public :: ANSI_CHARSET = 0
   integer(DWORD), parameter, public :: DEFAULT_CHARSET = 1
   integer(DWORD), parameter, public :: SYMBOL_CHARSET = 2
   integer(DWORD), parameter, public :: SHIFTJIS_CHARSET = 128
   integer(DWORD), parameter, public :: HANGEUL_CHARSET = 129
   integer(DWORD), parameter, public :: HANGUL_CHARSET = 129
   integer(DWORD), parameter, public :: GB2312_CHARSET = 134
   integer(DWORD), parameter, public :: CHINESEBIG5_CHARSET = 136
   integer(DWORD), parameter, public :: OEM_CHARSET = 255
   integer(DWORD), parameter, public :: JOHAB_CHARSET = 130
   integer(DWORD), parameter, public :: HEBREW_CHARSET = 177
   integer(DWORD), parameter, public :: ARABIC_CHARSET = 178
   integer(DWORD), parameter, public :: GREEK_CHARSET = 161
   integer(DWORD), parameter, public :: TURKISH_CHARSET = 162
   integer(DWORD), parameter, public :: VIETNAMESE_CHARSET = 163
   integer(DWORD), parameter, public :: THAI_CHARSET = 222
   integer(DWORD), parameter, public :: EASTEUROPE_CHARSET = 238
   integer(DWORD), parameter, public :: RUSSIAN_CHARSET = 204

   integer(DWORD), parameter, public :: MAC_CHARSET = 77
   integer(DWORD), parameter, public :: BALTIC_CHARSET = 186

   integer(DWORD), parameter, public :: OUT_DEFAULT_PRECIS = 0
   integer(DWORD), parameter, public :: OUT_STRING_PRECIS = 1
   integer(DWORD), parameter, public :: OUT_CHARACTER_PRECIS = 2
   integer(DWORD), parameter, public :: OUT_STROKE_PRECIS = 3
   integer(DWORD), parameter, public :: OUT_TT_PRECIS = 4
   integer(DWORD), parameter, public :: OUT_DEVICE_PRECIS = 5
   integer(DWORD), parameter, public :: OUT_RASTER_PRECIS = 6
   integer(DWORD), parameter, public :: OUT_TT_ONLY_PRECIS = 7
   integer(DWORD), parameter, public :: OUT_OUTLINE_PRECIS = 8
   integer(DWORD), parameter, public :: OUT_SCREEN_OUTLINE_PRECIS = 9
   integer(DWORD), parameter, public :: OUT_PS_ONLY_PRECIS = 10

   integer(DWORD), parameter, public :: CLIP_DEFAULT_PRECIS = 0
   integer(DWORD), parameter, public :: CLIP_CHARACTER_PRECIS = 1
   integer(DWORD), parameter, public :: CLIP_STROKE_PRECIS = 2
   integer(DWORD), parameter, public :: CLIP_MASK = int(Z'f',DWORD)
   integer(DWORD), parameter, public :: CLIP_LH_ANGLES = ishft(1,4)
   integer(DWORD), parameter, public :: CLIP_TT_ALWAYS = ishft(2,4)
   integer(DWORD), parameter, public :: CLIP_DFA_DISABLE = ishft(4,4)
   integer(DWORD), parameter, public :: CLIP_EMBEDDED = ishft(8,4)
   integer(DWORD), parameter, public :: CLIP_DFA_OVERRIDE = CLIP_DFA_DISABLE

   integer(DWORD), parameter, public :: DEFAULT_QUALITY = 0
   integer(DWORD), parameter, public :: DRAFT_QUALITY = 1
   integer(DWORD), parameter, public :: PROOF_QUALITY = 2
   integer(DWORD), parameter, public :: NONANTIALIASED_QUALITY = 3
   integer(DWORD), parameter, public :: ANTIALIASED_QUALITY = 4

   integer(DWORD), parameter, public :: CLEARTYPE_QUALITY = 5
   integer(DWORD), parameter, public :: CLEARTYPE_NATURAL_QUALITY = 6

   integer(DWORD), parameter, public :: DEFAULT_PITCH = 0
   integer(DWORD), parameter, public :: FIXED_PITCH = 1
   integer(DWORD), parameter, public :: VARIABLE_PITCH = 2
   integer(DWORD), parameter, public :: MONO_FONT = 8

   integer(DWORD), parameter, public :: FF_DONTCARE = ishft(0,4)
   integer(DWORD), parameter, public :: FF_ROMAN = ishft(1,4)

   integer(DWORD), parameter, public :: FF_SWISS = ishft(2,4)

   integer(DWORD), parameter, public :: FF_MODERN = ishft(3,4)

   integer(DWORD), parameter, public :: FF_SCRIPT = ishft(4,4)
   integer(DWORD), parameter, public :: FF_DECORATIVE = ishft(5,4)

! Return values for SelectObject function
   integer(DWORD), parameter, public :: GDI_ERROR = int(Z'FFFFFFFF',DWORD)
   integer(HGDIOBJ), parameter, public :: HGDI_ERROR = int(Z'FFFFFFFFFFFFFFFF',HGDIOBJ)

   integer(HGDIOBJ), parameter, public :: ERROR = 0
   integer(HGDIOBJ), parameter, public :: NULLREGION = 1
   integer(HGDIOBJ), parameter, public :: SIMPLEREGION = 2
   integer(HGDIOBJ), parameter, public :: COMPLEXREGION = 3
   integer(HGDIOBJ), parameter, public :: RGN_ERROR = ERROR

! Open File constants
   integer, parameter, public :: OF_READ = int(Z'0000')
   integer, parameter, public :: OF_WRITE = int(Z'0001')
   integer, parameter, public :: OF_READWRITE = int(Z'0002')
   integer, parameter, public :: OF_SHARE_COMPAT = int(Z'0000')
   integer, parameter, public :: OF_SHARE_EXCLUSIVE = int(Z'0010')
   integer, parameter, public :: OF_SHARE_DENY_WRITE = int(Z'0020')
   integer, parameter, public :: OF_SHARE_DENY_READ = int(Z'0030')
   integer, parameter, public :: OF_SHARE_DENY_NONE = int(Z'0040')
   integer, parameter, public :: OF_PARSE = int(Z'0100')
   integer, parameter, public :: OF_DELETE = int(Z'0200')
   integer, parameter, public :: OF_VERIFY = int(Z'0400')
   integer, parameter, public :: OF_CANCEL = int(Z'0800')
   integer, parameter, public :: OF_CREATE = int(Z'1000')
   integer, parameter, public :: OF_PROMPT = int(Z'2000')
   integer, parameter, public :: OF_EXIST = int(Z'4000')
   integer, parameter, public :: OF_REOPEN = int(Z'8000')

! Console constants
   integer(WORD), parameter, public :: FOCUS_EVENT = int(Z'0010',WORD)
   integer(WORD), parameter, public :: KEY_EVENT = int(Z'0001',WORD)
   integer(WORD), parameter, public :: MENU_EVENT = int(Z'0008',WORD)
   integer(WORD), parameter, public :: MOUSE_EVENT = int(Z'0002',WORD)
   integer(WORD), parameter, public :: WINDOW_BUFFER_SIZE_EVENT = int(Z'0004',WORD)

   integer(DWORD), parameter, public :: FROM_LEFT_1ST_BUTTON_PRESSED = int(Z'1',DWORD)
   integer(DWORD), parameter, public :: FROM_LEFT_2ND_BUTTON_PRESSED = int(Z'4',DWORD)
   integer(DWORD), parameter, public :: FROM_LEFT_3RD_BUTTON_PRESSED = int(Z'8',DWORD)
   integer(DWORD), parameter, public :: FROM_LEFT_4TH_BUTTON_PRESSED = int(Z'10',DWORD)
   integer(DWORD), parameter, public :: RIGHTMOST_BUTTON_PRESSED = int(Z'2',DWORD)

   integer(DWORD), parameter, public :: CAPSLOCK_ON = int(Z'80',DWORD)
   integer(DWORD), parameter, public :: ENHANCED_KEY = int(Z'100',DWORD)
   integer(DWORD), parameter, public :: LEFT_ALT_PRESSED = int(Z'2',DWORD)
   integer(DWORD), parameter, public :: LEFT_CTRL_PRESSED = int(Z'8',DWORD)
   integer(DWORD), parameter, public :: NUMLOCK_ON = int(Z'20',DWORD)
   integer(DWORD), parameter, public :: RIGHT_ALT_PRESSED = int(Z'1',DWORD)
   integer(DWORD), parameter, public :: RIGHT_CTRL_PRESSED = int(Z'4',DWORD)
   integer(DWORD), parameter, public :: SCROLLLOCK_ON = int(Z'40',DWORD)
   integer(DWORD), parameter, public :: SHIFT_PRESSED = int(Z'10',DWORD)
   integer(DWORD), parameter, public :: DOUBLE_CLICK = int(Z'2',DWORD)
   integer(DWORD), parameter, public :: MOUSE_HWHEELED = int(Z'8',DWORD)
   integer(DWORD), parameter, public :: MOUSE_MOVED = int(Z'1',DWORD)
   integer(DWORD), parameter, public :: MOUSE_WHEELD = int(Z'4',DWORD)

   integer(DWORD),parameter,public :: PC_RESERVED = int(Z'01')
   integer(DWORD),parameter,public :: PC_EXPLICIT = int(Z'02')
   integer(DWORD),parameter,public :: PC_NOCOLLAPSE = int(Z'04')

   integer,parameter,public :: ACCESS_MASK = DWORD
   integer,parameter,public :: PRINTER_ACCESS_ADMINISTER = int(Z'00000004')
   integer,parameter,public :: PRINTER_ACCESS_USE = int(Z'00000008')
   integer,parameter,public :: PRINTER_ALL_ACCESS = int(Z'f000c')
   integer,parameter,public :: PRINTER_ATTRIBUTE_QUEUED = int(Z'00000001')
   integer,parameter,public :: PRINTER_ATTRIBUTE_DIRECT = int(Z'00000002')
   integer,parameter,public :: PRINTER_ATTRIBUTE_DEFAULT = int(Z'00000004')
   integer,parameter,public :: PRINTER_ATTRIBUTE_SHARED = int(Z'00000008')
   integer,parameter,public :: PRINTER_ATTRIBUTE_NETWORK = int(Z'00000010')
   integer,parameter,public :: PRINTER_ATTRIBUTE_HIDDEN = int(Z'00000020')
   integer,parameter,public :: PRINTER_ATTRIBUTE_LOCAL = int(Z'00000040')

   integer,parameter,public :: PRINTER_ATTRIBUTE_ENABLE_DEVQ = int(Z'00000080')
   integer,parameter,public :: PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS = int(Z'00000100')
   integer,parameter,public :: PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST = int(Z'00000200')

   integer,parameter,public :: PRINTER_ATTRIBUTE_WORK_OFFLINE = int(Z'00000400')
   integer,parameter,public :: PRINTER_ATTRIBUTE_ENABLE_BIDI = int(Z'00000800')
   integer,parameter,public :: PRINTER_ATTRIBUTE_RAW_ONLY = int(Z'00001000')
   integer,parameter,public :: PRINTER_ATTRIBUTE_PUBLISHED = int(Z'00002000')
   integer,parameter,public :: PRINTER_ATTRIBUTE_FAX = int(Z'00004000')
   integer,parameter,public :: PRINTER_ATTRIBUTE_TS = int(Z'00008000')

   integer,parameter,public :: PRINTER_STATUS_PAUSED = int(Z'00000001')
   integer,parameter,public :: PRINTER_STATUS_ERROR = int(Z'00000002')
   integer,parameter,public :: PRINTER_STATUS_PENDING_DELETION = int(Z'00000004')
   integer,parameter,public :: PRINTER_STATUS_PAPER_JAM = int(Z'00000008')
   integer,parameter,public :: PRINTER_STATUS_PAPER_OUT = int(Z'00000010')
   integer,parameter,public :: PRINTER_STATUS_MANUAL_FEED = int(Z'00000020')
   integer,parameter,public :: PRINTER_STATUS_PAPER_PROBLEM = int(Z'00000040')
   integer,parameter,public :: PRINTER_STATUS_OFFLINE = int(Z'00000080')
   integer,parameter,public :: PRINTER_STATUS_IO_ACTIVE = int(Z'00000100')
   integer,parameter,public :: PRINTER_STATUS_BUSY = int(Z'00000200')
   integer,parameter,public :: PRINTER_STATUS_PRINTING = int(Z'00000400')
   integer,parameter,public :: PRINTER_STATUS_OUTPUT_BIN_FULL = int(Z'00000800')
   integer,parameter,public :: PRINTER_STATUS_NOT_AVAILABLE = int(Z'00001000')
   integer,parameter,public :: PRINTER_STATUS_WAITING = int(Z'00002000')
   integer,parameter,public :: PRINTER_STATUS_PROCESSING = int(Z'00004000')
   integer,parameter,public :: PRINTER_STATUS_INITIALIZING = int(Z'00008000')
   integer,parameter,public :: PRINTER_STATUS_WARMING_UP = int(Z'00010000')
   integer,parameter,public :: PRINTER_STATUS_TONER_LOW = int(Z'00020000')
   integer,parameter,public :: PRINTER_STATUS_NO_TONER = int(Z'00040000')
   integer,parameter,public :: PRINTER_STATUS_PAGE_PUNT = int(Z'00080000')
   integer,parameter,public :: PRINTER_STATUS_USER_INTERVENTION = int(Z'00100000')
   integer,parameter,public :: PRINTER_STATUS_OUT_OF_MEMORY = int(Z'00200000')
   integer,parameter,public :: PRINTER_STATUS_DOOR_OPEN = int(Z'00400000')
   integer,parameter,public :: PRINTER_STATUS_SERVER_UNKNOWN = int(Z'00800000')
   integer,parameter,public :: PRINTER_STATUS_POWER_SAVE = int(Z'01000000')

   integer,parameter,public :: SP_NOTREPORTED = int(Z'4000')
   integer,parameter,public :: SP_ERROR = (-1)
   integer,parameter,public :: SP_APPABORT = (-2)
   integer,parameter,public :: SP_USERABORT = (-3)
   integer,parameter,public :: SP_OUTOFDISK = (-4)
   integer,parameter,public :: SP_OUTOFMEMORY = (-5)

   integer,parameter,public :: NEWFRAME = 1
   integer,parameter,public :: ABORTDOC = 2
   integer,parameter,public :: NEXTBAND = 3
   integer,parameter,public :: SETCOLORTABLE = 4
   integer,parameter,public :: GETCOLORTABLE = 5
   integer,parameter,public :: FLUSHOUTPUT = 6
   integer,parameter,public :: DRAFTMODE = 7
   integer,parameter,public :: QUERYESCSUPPORT = 8
   integer,parameter,public :: SETABORTPROC = 9
   integer,parameter,public :: STARTDOC_ = 10
   integer,parameter,public :: ENDDOC_ = 11
   integer,parameter,public :: GETPHYSPAGESIZE = 12
   integer,parameter,public :: GETPRINTINGOFFSET = 13
   integer,parameter,public :: GETSCALINGFACTOR = 14
   integer,parameter,public :: MFCOMMENT = 15
   integer,parameter,public :: GETPENWIDTH = 16
   integer,parameter,public :: SETCOPYCOUNT = 17
   integer,parameter,public :: SELECTPAPERSOURCE = 18
   integer,parameter,public :: DEVICEDATA = 19
   integer,parameter,public :: PASSTHROUGH = 19
   integer,parameter,public :: GETTECHNOLGY = 20
   integer,parameter,public :: GETTECHNOLOGY = 20
   integer,parameter,public :: SETLINECAP = 21
   integer,parameter,public :: SETLINEJOIN = 22
   integer,parameter,public :: SETMITERLIMIT = 23
   integer,parameter,public :: BANDINFO = 24
   integer,parameter,public :: DRAWPATTERNRECT = 25
   integer,parameter,public :: GETVECTORPENSIZE = 26
   integer,parameter,public :: GETVECTORBRUSHSIZE = 27
   integer,parameter,public :: ENABLEDUPLEX = 28
   integer,parameter,public :: GETSETPAPERBINS = 29
   integer,parameter,public :: GETSETPRINTORIENT = 30
   integer,parameter,public :: ENUMPAPERBINS = 31
   integer,parameter,public :: SETDIBSCALING = 32
   integer,parameter,public :: EPSPRINTING = 33
   integer,parameter,public :: ENUMPAPERMETRICS = 34
   integer,parameter,public :: GETSETPAPERMETRICS = 35
   integer,parameter,public :: POSTSCRIPT_DATA = 37
   integer,parameter,public :: POSTSCRIPT_IGNORE = 38
   integer,parameter,public :: MOUSETRAILS = 39
   integer,parameter,public :: GETDEVICEUNITS = 42

   integer,parameter,public :: GETEXTENDEDTEXTMETRICS = 256
   integer,parameter,public :: GETEXTENTTABLE = 257
   integer,parameter,public :: GETPAIRKERNTABLE = 258
   integer,parameter,public :: GETTRACKKERNTABLE = 259
   integer,parameter,public :: EXTTEXTOUT = 512
   integer,parameter,public :: GETFACENAME = 513
   integer,parameter,public :: DOWNLOADFACE = 514
   integer,parameter,public :: ENABLERELATIVEWIDTHS = 768
   integer,parameter,public :: ENABLEPAIRKERNING = 769
   integer,parameter,public :: SETKERNTRACK = 770
   integer,parameter,public :: SETALLJUSTVALUES = 771
   integer,parameter,public :: SETCHARSET = 772

   integer,parameter,public :: STRETCHBLT = 2048
   integer,parameter,public :: METAFILE_DRIVER = 2049
   integer,parameter,public :: GETSETSCREENPARAMS = 3072
   integer,parameter,public :: QUERYDIBSUPPORT = 3073
   integer,parameter,public :: BEGIN_PATH = 4096
   integer,parameter,public :: CLIP_TO_PATH = 4097
   integer,parameter,public :: END_PATH = 4098
   integer,parameter,public :: EXT_DEVICE_CAPS = 4099
   integer,parameter,public :: RESTORE_CTM = 4100
   integer,parameter,public :: SAVE_CTM = 4101
   integer,parameter,public :: SET_ARC_DIRECTION = 4102
   integer,parameter,public :: SET_BACKGROUND_COLOR = 4103
   integer,parameter,public :: SET_POLY_MODE = 4104
   integer,parameter,public :: SET_SCREEN_ANGLE = 4105
   integer,parameter,public :: SET_SPREAD = 4106
   integer,parameter,public :: TRANSFORM_CTM = 4107
   integer,parameter,public :: SET_CLIP_BOX = 4108
   integer,parameter,public :: SET_BOUNDS = 4109
   integer,parameter,public :: SET_MIRROR_MODE = 4110
   integer,parameter,public :: OPENCHANNEL = 4110
   integer,parameter,public :: DOWNLOADHEADER = 4111
   integer,parameter,public :: CLOSECHANNEL = 4112
   integer,parameter,public :: POSTSCRIPT_PASSTHROUGH = 4115
   integer,parameter,public :: ENCAPSULATED_POSTSCRIPT = 4116

   integer,parameter,public :: POSTSCRIPT_IDENTIFY = 4117
   integer,parameter,public :: POSTSCRIPT_INJECTION = 4118

   integer,parameter,public :: CHECKJPEGFORMAT = 4119
   integer,parameter,public :: CHECKPNGFORMAT = 4120

   integer,parameter,public :: GET_PS_FEATURESETTING = 4121

   integer,parameter,public :: SPCLPASSTHROUGH2 = 4568

   integer,parameter,public :: DI_APPBANDING = int(Z'00000001')
   integer,parameter,public :: DI_ROPS_READ_DESTINATION = int(Z'00000002')

   integer,parameter,public :: SRCCOPY = int(Z'00CC0020')
   integer,parameter,public :: SRCPAINT = int(Z'00EE0086')
   integer,parameter,public :: SRCAND = int(Z'008800C6')
   integer,parameter,public :: SRCINVERT = int(Z'00660046')
   integer,parameter,public :: SRCERASE = int(Z'00440328')
   integer,parameter,public :: NOTSRCCOPY = int(Z'00330008')
   integer,parameter,public :: NOTSRCERASE = int(Z'001100A6')
   integer,parameter,public :: MERGECOPY = int(Z'00C000CA')
   integer,parameter,public :: MERGEPAINT = int(Z'00BB0226')
   integer,parameter,public :: PATCOPY = int(Z'00F00021')
   integer,parameter,public :: PATPAINT = int(Z'00FB0A09')
   integer,parameter,public :: PATINVERT = int(Z'005A0049')
   integer,parameter,public :: DSTINVERT = int(Z'00550009')
   integer,parameter,public :: BLACKNESS = int(Z'00000042')
   integer,parameter,public :: WHITENESS = int(Z'00FF0062')
   integer,parameter,public :: NOMIRRORBITMAP = int(Z'80000000')
   integer,parameter,public :: CAPTUREBLT = int(Z'40000000')
!#define MAKEROP4(fore,back) (DWORD)((((back) << 8) & 0xFF000000) | (fore))

   integer(UINT),parameter,public :: MF_INSERT = int(Z'00000000',UINT)
   integer(UINT),parameter,public :: MF_CHANGE = int(Z'00000080',UINT)
   integer(UINT),parameter,public :: MF_APPEND = int(Z'00000100',UINT)
   integer(UINT),parameter,public :: MF_DELETE = int(Z'00000200',UINT)
   integer(UINT),parameter,public :: MF_REMOVE = int(Z'00001000',UINT)
   integer(UINT),parameter,public :: MF_BYCOMMAND = int(Z'00000000',UINT)
   integer(UINT),parameter,public :: MF_BYPOSITION = int(Z'00000400',UINT)
   integer(UINT),parameter,public :: MF_SEPARATOR = int(Z'00000800',UINT)
   integer(UINT),parameter,public :: MF_ENABLED = int(Z'00000000',UINT)
   integer(UINT),parameter,public :: MF_GRAYED = int(Z'00000001',UINT)
   integer(UINT),parameter,public :: MF_DISABLED = int(Z'00000002',UINT)
   integer(UINT),parameter,public :: MF_UNCHECKED = int(Z'00000000',UINT)
   integer(UINT),parameter,public :: MF_CHECKED = int(Z'00000008',UINT)
   integer(UINT),parameter,public :: MF_USECHECKBITMAPS = int(Z'00000200',UINT)
   integer(UINT),parameter,public :: MF_STRING = int(Z'00000000',UINT)
   integer(UINT),parameter,public :: MF_BITMAP = int(Z'00000004',UINT)
   integer(UINT),parameter,public :: MF_OWNERDRAW = int(Z'00000100',UINT)
   integer(UINT),parameter,public :: MF_POPUP = int(Z'00000010',UINT)
   integer(UINT),parameter,public :: MF_MENUBARBREAK = int(Z'00000020',UINT)
   integer(UINT),parameter,public :: MF_MENUBREAK = int(Z'00000040',UINT)
   integer(UINT),parameter,public :: MF_UNHILITE = int(Z'00000000',UINT)
   integer(UINT),parameter,public :: MF_HILITE = int(Z'00000080',UINT)
   integer(UINT),parameter,public :: MF_DEFAULT = int(Z'00001000',UINT)
   integer(UINT),parameter,public :: MF_SYSMENU = int(Z'00002000',UINT)
   integer(UINT),parameter,public :: MF_HELP = int(Z'00004000',UINT)
   integer(UINT),parameter,public :: MF_RIGHTJUSTIFY = int(Z'00004000',UINT)
   integer(UINT),parameter,public :: MF_MOUSESELECT = int(Z'00008000',UINT)
   integer(UINT),parameter,public :: MF_END = int(Z'00000080',UINT)

   integer(UINT),parameter,public :: MFT_STRING = MF_STRING
   integer(UINT),parameter,public :: MFT_BITMAP = MF_BITMAP
   integer(UINT),parameter,public :: MFT_MENUBARBREAK = MF_MENUBARBREAK
   integer(UINT),parameter,public :: MFT_MENUBREAK = MF_MENUBREAK
   integer(UINT),parameter,public :: MFT_OWNERDRAW = MF_OWNERDRAW
   integer(UINT),parameter,public :: MFT_RADIOCHECK = int(Z'00000200',UINT)
   integer(UINT),parameter,public :: MFT_SEPARATOR = MF_SEPARATOR
   integer(UINT),parameter,public :: MFT_RIGHTORDER = int(Z'00002000',UINT)
   integer(UINT),parameter,public :: MFT_RIGHTJUSTIFY = MF_RIGHTJUSTIFY

   integer(UINT),parameter,public :: MFS_GRAYED = int(Z'00000003',UINT)
   integer(UINT),parameter,public :: MFS_DISABLED = MFS_GRAYED
   integer(UINT),parameter,public :: MFS_CHECKED = MF_CHECKED
   integer(UINT),parameter,public :: MFS_HILITE = MF_HILITE
   integer(UINT),parameter,public :: MFS_ENABLED = MF_ENABLED
   integer(UINT),parameter,public :: MFS_UNCHECKED = MF_UNCHECKED
   integer(UINT),parameter,public :: MFS_UNHILITE = MF_UNHILITE
   integer(UINT),parameter,public :: MFS_DEFAULT = MF_DEFAULT

   integer,parameter,public :: SWP_NOSIZE = int(Z'0001')
   integer,parameter,public :: SWP_NOMOVE = int(Z'0002')
   integer,parameter,public :: SWP_NOZORDER = int(Z'0004')
   integer,parameter,public :: SWP_NOREDRAW = int(Z'0008')
   integer,parameter,public :: SWP_NOACTIVATE = int(Z'0010')
   integer,parameter,public :: SWP_FRAMECHANGED = int(Z'0020')
   integer,parameter,public :: SWP_SHOWWINDOW = int(Z'0040')
   integer,parameter,public :: SWP_HIDEWINDOW = int(Z'0080')
   integer,parameter,public :: SWP_NOCOPYBITS = int(Z'0100')
   integer,parameter,public :: SWP_NOOWNERZORDER = int(Z'0200')
   integer,parameter,public :: SWP_NOSENDCHANGING = int(Z'0400')

   integer,parameter,public :: SWP_DRAWFRAME = SWP_FRAMECHANGED
   integer,parameter,public :: SWP_NOREPOSITION = SWP_NOOWNERZORDER
   integer,parameter,public :: SWP_DEFERERASE = int(Z'2000')
   integer,parameter,public :: SWP_ASYNCWINDOWPOS = int(Z'4000')

   integer,parameter,public :: GW_HWNDFIRST = 0
   integer,parameter,public :: GW_HWNDLAST = 1
   integer,parameter,public :: GW_HWNDNEXT = 2
   integer,parameter,public :: GW_HWNDPREV = 3
   integer,parameter,public :: GW_OWNER = 4
   integer,parameter,public :: GW_CHILD = 5
   integer,parameter,public :: GW_ENABLEDPOPUP = 6
   integer,parameter,public :: GW_MAX = 6

   integer,parameter,public :: GMEM_FIXED = int(Z'0')
   integer,parameter,public :: GMEM_MOVEABLE = int(Z'2')
   integer,parameter,public :: GMEM_NOCOMPACT = int(Z'10')
   integer,parameter,public :: GMEM_NODISCARD = int(Z'20')
   integer,parameter,public :: GMEM_ZEROINIT = int(Z'40')
   integer,parameter,public :: GMEM_MODIFY = int(Z'80')
   integer,parameter,public :: GMEM_DISCARDABLE = int(Z'100')
   integer,parameter,public :: GMEM_NOT_BANKED = int(Z'1000')
   integer,parameter,public :: GMEM_SHARE = int(Z'2000')
   integer,parameter,public :: GMEM_DDESHARE = int(Z'2000')
   integer,parameter,public :: GMEM_NOTIFY = int(Z'4000')
   integer,parameter,public :: GMEM_LOWER = GMEM_NOT_BANKED
   integer,parameter,public :: GMEM_VALID_FLAGS = int(Z'7F72')
   integer,parameter,public :: GMEM_INVALID_HANDLE = int(Z'8000')

   integer,parameter,public :: GHND = ior(GMEM_MOVEABLE,GMEM_ZEROINIT)
   integer,parameter,public :: GPTR = ior(GMEM_FIXED,GMEM_ZEROINIT)

   integer(DWORD),parameter,public :: VS_FF_DEBUG = &
      int(Z'00000001',DWORD)
   integer(DWORD),parameter,public :: VS_FF_INFOINFERRED = &
      int(Z'00000010',DWORD)
   integer(DWORD),parameter,public :: VS_FF_PATCHED = &
      int(Z'00000004',DWORD)
   integer(DWORD),parameter,public :: VS_FF_PRERELEASE = &
      int(Z'00000002',DWORD)
   integer(DWORD),parameter,public :: VS_FF_PRIVATEBUILD = &
      int(Z'00000008',DWORD)
   integer(DWORD),parameter,public :: VS_FF_SPECIALBUILD = &
      int(Z'00000020',DWORD)

   integer(DWORD),parameter,public :: VOS_DOS = int(Z'00010000',DWORD)
   integer(DWORD),parameter,public :: VOS_NT = int(Z'00040000',DWORD)
   integer(DWORD),parameter,public :: VOS__WINDOWS16 = &
      int(Z'00000001',DWORD)
   integer(DWORD),parameter,public :: VOS__WINDOWS32 = &
      int(Z'00000004',DWORD)
   integer(DWORD),parameter,public :: VOS_OS216 = int(Z'00020000',DWORD)
   integer(DWORD),parameter,public :: VOS_OS232 = int(Z'00030000',DWORD)
   integer(DWORD),parameter,public :: VOS__PM16 = int(Z'00000002',DWORD)
   integer(DWORD),parameter,public :: VOS__PM32 = int(Z'00000003',DWORD)
   integer(DWORD),parameter,public :: VOS_UNKNOWN = int(Z'00000000',DWORD)
   integer(DWORD),parameter,public :: VOS_DOS_WINDOWS16 = &
      int(Z'00010001',DWORD)
   integer(DWORD),parameter,public :: VOS_DOS_WINDOWS32 = &
      int(Z'00010004',DWORD)
   integer(DWORD),parameter,public :: VOS_NT_WINDOWS32 = &
      int(Z'00040004',DWORD)
   integer(DWORD),parameter,public :: VOS_OS216_PM16 = &
      int(Z'00020002',DWORD)
   integer(DWORD),parameter,public :: VOS_OS232_PM32 = &
      int(Z'00030003',DWORD)

   integer(DWORD),parameter,public :: VFT_APP = int(Z'00000001',DWORD)
   integer(DWORD),parameter,public :: VFT_DLL = int(Z'00000002',DWORD)
   integer(DWORD),parameter,public :: VFT_DRV = int(Z'00000003',DWORD)
   integer(DWORD),parameter,public :: VFT_FONT = int(Z'00000004',DWORD)
   integer(DWORD),parameter,public :: VFT_STATIC_LIB = &
      int(Z'00000007',DWORD)
   integer(DWORD),parameter,public :: VFT_UNKNOWN = int(Z'00000000',DWORD)
   integer(DWORD),parameter,public :: VFT_VXD = int(Z'00000005',DWORD)

   integer(DWORD),parameter,public :: VFT2_DRV_COMM = int(Z'0000000a',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_DISPLAY = &
      int(Z'00000004',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_INSTALLABLE = &
      int(Z'00000008',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_KEYBOARD = &
      int(Z'00000002',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_LANGUAGE = &
      int(Z'00000003',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_MOUSE = &
      int(Z'00000005',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_NETWORK = &
      int(Z'00000006',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_PRINTER = &
      int(Z'00000001',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_SOUND = &
      int(Z'00000009',DWORD)
   integer(DWORD),parameter,public :: VFT2_DRV_SYSTEM = &
      int(Z'00000007',DWORD)
   integer(DWORD),parameter,public :: &
      VFT2_DRV_VERSIONED_PRINTER = int(Z'0000000c',DWORD)

   integer(DWORD),parameter,public :: VFT2_FONT_RASTER = &
      int(Z'00000001',DWORD)
   integer(DWORD),parameter,public :: VFT2_FONT_TRUETYPE = &
      int(Z'00000003',DWORD)
   integer(DWORD),parameter,public :: VFT2_FONT_VECTOR = &
      int(Z'00000002',DWORD)
   integer(DWORD),parameter,public :: VFT2_UNKNOWN = &
      int(Z'00000000',DWORD)

   integer(C_INT),parameter,public :: HEAPEMPTY = (-1)
   integer(C_INT),parameter,public :: HEAPOK = (-2)
   integer(C_INT),parameter,public :: HEAPBADBEGIN = (-3)
   integer(C_INT),parameter,public :: HEAPBADNODE = (-4)
   integer(C_INT),parameter,public :: HEAPEND = (-5)
   integer(C_INT),parameter,public :: HEAPBADPTR = (-6)

   integer,parameter,public :: CCHDEVICENAME = 32
   integer,parameter,public :: CCHFORMNAME = 32

   integer(WORD),parameter,public :: DM_SPECVERSION = int(Z'0401',WORD)

   integer(DWORD),parameter,public :: DM_ORIENTATION = int(Z'00000001',DWORD)
   integer(DWORD),parameter,public :: DM_PAPERSIZE = int(Z'00000002',DWORD)
   integer(DWORD),parameter,public :: DM_PAPERLENGTH = int(Z'00000004',DWORD)
   integer(DWORD),parameter,public :: DM_PAPERWIDTH = int(Z'00000008',DWORD)
   integer(DWORD),parameter,public :: DM_SCALE = int(Z'00000010',DWORD)
   integer(DWORD),parameter,public :: DM_POSITION = int(Z'00000020',DWORD)
   integer(DWORD),parameter,public :: DM_NUP = int(Z'00000040',DWORD)
   integer(DWORD),parameter,public :: DM_DISPLAYORIENTATION = int(Z'00000080',DWORD)
   integer(DWORD),parameter,public :: DM_COPIES = int(Z'00000100',DWORD)
   integer(DWORD),parameter,public :: DM_DEFAULTSOURCE = int(Z'00000200',DWORD)
   integer(DWORD),parameter,public :: DM_PRINTQUALITY = int(Z'00000400',DWORD)
   integer(DWORD),parameter,public :: DM_COLOR = int(Z'00000800',DWORD)
   integer(DWORD),parameter,public :: DM_DUPLEX = int(Z'00001000',DWORD)
   integer(DWORD),parameter,public :: DM_YRESOLUTION = int(Z'00002000',DWORD)
   integer(DWORD),parameter,public :: DM_TTOPTION = int(Z'00004000',DWORD)
   integer(DWORD),parameter,public :: DM_COLLATE = int(Z'00008000',DWORD)
   integer(DWORD),parameter,public :: DM_FORMNAME = int(Z'00010000',DWORD)
   integer(DWORD),parameter,public :: DM_LOGPIXELS = int(Z'00020000',DWORD)
   integer(DWORD),parameter,public :: DM_BITSPERPEL = int(Z'00040000',DWORD)
   integer(DWORD),parameter,public :: DM_PELSWIDTH = int(Z'00080000',DWORD)
   integer(DWORD),parameter,public :: DM_PELSHEIGHT = int(Z'00100000',DWORD)
   integer(DWORD),parameter,public :: DM_DISPLAYFLAGS = int(Z'00200000',DWORD)
   integer(DWORD),parameter,public :: DM_DISPLAYFREQUENCY = int(Z'00400000',DWORD)
   integer(DWORD),parameter,public :: DM_ICMMETHOD = int(Z'00800000',DWORD)
   integer(DWORD),parameter,public :: DM_ICMINTENT = int(Z'01000000',DWORD)
   integer(DWORD),parameter,public :: DM_MEDIATYPE = int(Z'02000000',DWORD)
   integer(DWORD),parameter,public :: DM_DITHERTYPE = int(Z'04000000',DWORD)
   integer(DWORD),parameter,public :: DM_PANNINGWIDTH = int(Z'08000000',DWORD)
   integer(DWORD),parameter,public :: DM_PANNINGHEIGHT = int(Z'10000000',DWORD)
   integer(DWORD),parameter,public :: DM_DISPLAYFIXEDOUTPUT = int(Z'20000000',DWORD)

   integer(C_SHORT),parameter,public :: DMORIENT_PORTRAIT = 1_C_SHORT
   integer(C_SHORT),parameter,public :: DMORIENT_LANDSCAPE = 2_C_SHORT

   integer(C_SHORT),parameter,public :: DMPAPER_LETTER = 1_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_FIRST = DMPAPER_LETTER
   integer(C_SHORT),parameter,public :: DMPAPER_LETTERSMALL = 2_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_TABLOID = 3_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LEDGER = 4_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LEGAL = 5_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_STATEMENT = 6_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_EXECUTIVE = 7_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A3 = 8_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A4 = 9_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A4SMALL = 10_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A5 = 11_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B4 = 12_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B5 = 13_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_FOLIO = 14_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_QUARTO = 15_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_10X14 = 16_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_11X17 = 17_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_NOTE = 18_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_9 = 19_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_10 = 20_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_11 = 21_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_12 = 22_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_14 = 23_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_CSHEET = 24_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_DSHEET = 25_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ESHEET = 26_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_DL = 27_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_C5 = 28_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_C3 = 29_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_C4 = 30_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_C6 = 31_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_C65 = 32_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_B4 = 33_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_B5 = 34_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_B6 = 35_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_ITALY = 36_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_MONARCH = 37_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_PERSONAL = 38_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_FANFOLD_US = 39_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_FANFOLD_STD_GERMAN = 40_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_FANFOLD_LGL_GERMAN = 41_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ISO_B4 = 42_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JAPANESE_POSTCARD = 43_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_9X11 = 44_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_10X11 = 45_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_15X11 = 46_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_ENV_INVITE = 47_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_RESERVED_48 = 48_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_RESERVED_49 = 49_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LETTER_EXTRA = 50_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LEGAL_EXTRA = 51_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_TABLOID_EXTRA = 52_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A4_EXTRA = 53_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LETTER_TRANSVERSE = 54_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A4_TRANSVERSE = 55_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LETTER_EXTRA_TRANSVERSE = 56_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A_PLUS = 57_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B_PLUS = 58_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LETTER_PLUS = 59_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A4_PLUS = 60_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A5_TRANSVERSE = 61_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B5_TRANSVERSE = 62_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A3_EXTRA = 63_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A5_EXTRA = 64_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B5_EXTRA = 65_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A2 = 66_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A3_TRANSVERSE = 67_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A3_EXTRA_TRANSVERSE = 68_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_DBL_JAPANESE_POSTCARD = 69_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A6 = 70_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_KAKU2 = 71_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_KAKU3 = 72_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_CHOU3 = 73_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_CHOU4 = 74_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_LETTER_ROTATED = 75_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A3_ROTATED = 76_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A4_ROTATED = 77_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A5_ROTATED = 78_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B4_JIS_ROTATED = 79_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B5_JIS_ROTATED = 80_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JAPANESE_POSTCARD_ROTATED = 81_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED = 82_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_A6_ROTATED = 83_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_KAKU2_ROTATED = 84_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_KAKU3_ROTATED = 85_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_CHOU3_ROTATED = 86_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_CHOU4_ROTATED = 87_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B6_JIS = 88_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_B6_JIS_ROTATED = 89_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_12X11 = 90_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_YOU4 = 91_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_JENV_YOU4_ROTATED = 92_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_P16K = 93_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_P32K = 94_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_P32KBIG = 95_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_1 = 96_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_2 = 97_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_3 = 98_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_4 = 99_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_5 = 100_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_6 = 101_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_7 = 102_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_8 = 103_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_9 = 104_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_10 = 105_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_P16K_ROTATED = 106_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_P32K_ROTATED = 107_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_P32KBIG_ROTATED = 108_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_1_ROTATED = 109_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_2_ROTATED = 110_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_3_ROTATED = 111_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_4_ROTATED = 112_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_5_ROTATED = 113_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_6_ROTATED = 114_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_7_ROTATED = 115_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_8_ROTATED = 116_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_9_ROTATED = 117_C_SHORT
   integer(C_SHORT),parameter,public :: DMPAPER_PENV_10_ROTATED = 118_C_SHORT

   integer(C_SHORT),parameter,public :: DMPAPER_LAST = DMPAPER_PENV_10_ROTATED

   integer(C_SHORT),parameter,public :: DMPAPER_USER = 256_C_SHORT

   integer(C_SHORT),parameter,public :: DMBIN_UPPER = 1_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_FIRST = DMBIN_UPPER
   integer(C_SHORT),parameter,public :: DMBIN_ONLYONE = 1_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_LOWER = 2_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_MIDDLE = 3_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_MANUAL = 4_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_ENVELOPE = 5_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_ENVMANUAL = 6_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_AUTO = 7_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_TRACTOR = 8_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_SMALLFMT = 9_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_LARGEFMT = 10_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_LARGECAPACITY = 11_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_CASSETTE = 14_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_FORMSOURCE = 15_C_SHORT
   integer(C_SHORT),parameter,public :: DMBIN_LAST = DMBIN_FORMSOURCE

   integer(C_SHORT),parameter,public :: DMBIN_USER = 256_C_SHORT

   integer(C_SHORT),parameter,public :: DMRES_DRAFT = (-1_C_SHORT)
   integer(C_SHORT),parameter,public :: DMRES_LOW = (-2_C_SHORT)
   integer(C_SHORT),parameter,public :: DMRES_MEDIUM = (-3_C_SHORT)
   integer(C_SHORT),parameter,public :: DMRES_HIGH = (-4_C_SHORT)

   integer(SHORT),parameter,public :: DMCOLOR_MONOCHROME = 1_C_SHORT
   integer(SHORT),parameter,public :: DMCOLOR_COLOR = 2_C_SHORT

   integer(SHORT),parameter,public :: DMDUP_SIMPLEX = 1_C_SHORT
   integer(SHORT),parameter,public :: DMDUP_VERTICAL = 2_C_SHORT
   integer(SHORT),parameter,public :: DMDUP_HORIZONTAL = 3_C_SHORT

   integer(SHORT),parameter,public :: DMTT_BITMAP = 1_C_SHORT
   integer(SHORT),parameter,public :: DMTT_DOWNLOAD = 2_C_SHORT
   integer(SHORT),parameter,public :: DMTT_SUBDEV = 3_C_SHORT
   integer(SHORT),parameter,public :: DMTT_DOWNLOAD_OUTLINE = 4_C_SHORT

   integer(SHORT),parameter,public :: DMCOLLATE_FALSE = 0_C_SHORT
   integer(SHORT),parameter,public :: DMCOLLATE_TRUE = 1_C_SHORT

   integer(DWORD),parameter,public :: DMDO_DEFAULT = 0
   integer(DWORD),parameter,public :: DMDO_90 = 1
   integer(DWORD),parameter,public :: DMDO_180 = 2
   integer(DWORD),parameter,public :: DMDO_270 = 3

   integer(DWORD),parameter,public :: DMDFO_DEFAULT = 0
   integer(DWORD),parameter,public :: DMDFO_STRETCH = 1
   integer(DWORD),parameter,public :: DMDFO_CENTER = 2

   integer,parameter,public :: DMDISPLAYFLAGS_TEXTMODE = int(Z'00000004')

   integer(DWORD),parameter,public :: DMNUP_SYSTEM = 1
   integer(DWORD),parameter,public :: DMNUP_ONEUP = 2

   integer(DWORD),parameter,public :: DMICMMETHOD_NONE = 1
   integer(DWORD),parameter,public :: DMICMMETHOD_SYSTEM = 2
   integer(DWORD),parameter,public :: DMICMMETHOD_DRIVER = 3
   integer(DWORD),parameter,public :: DMICMMETHOD_DEVICE = 4

   integer(DWORD),parameter,public :: DMICMMETHOD_USER = 256

   integer(DWORD),parameter,public :: DMICM_SATURATE = 1
   integer(DWORD),parameter,public :: DMICM_CONTRAST = 2
   integer(DWORD),parameter,public :: DMICM_COLORIMETRIC = 3
   integer(DWORD),parameter,public :: DMICM_ABS_COLORIMETRIC = 4

   integer(DWORD),parameter,public :: DMICM_USER = 256

   integer(DWORD),parameter,public :: DMMEDIA_STANDARD = 1
   integer(DWORD),parameter,public :: DMMEDIA_TRANSPARENCY = 2
   integer(DWORD),parameter,public :: DMMEDIA_GLOSSY = 3

   integer(DWORD),parameter,public :: DMMEDIA_USER = 256

   integer(DWORD),parameter,public :: DMDITHER_NONE = 1
   integer(DWORD),parameter,public :: DMDITHER_COARSE = 2
   integer(DWORD),parameter,public :: DMDITHER_FINE = 3
   integer(DWORD),parameter,public :: DMDITHER_LINEART = 4
   integer(DWORD),parameter,public :: DMDITHER_ERRORDIFFUSION = 5
   integer(DWORD),parameter,public :: DMDITHER_RESERVED6 = 6
   integer(DWORD),parameter,public :: DMDITHER_RESERVED7 = 7
   integer(DWORD),parameter,public :: DMDITHER_RESERVED8 = 8
   integer(DWORD),parameter,public :: DMDITHER_RESERVED9 = 9
   integer(DWORD),parameter,public :: DMDITHER_GRAYSCALE = 10

   integer(DWORD),parameter,public :: DMDITHER_USER = 256

   integer(DWORD),parameter,public :: DM_UPDATE = 1
   integer(DWORD),parameter,public :: DM_COPY = 2
   integer(DWORD),parameter,public :: DM_PROMPT = 4
   integer(DWORD),parameter,public :: DM_MODIFY = 8

   integer(DWORD),parameter,public :: DM_IN_BUFFER = DM_MODIFY
   integer(DWORD),parameter,public :: DM_IN_PROMPT = DM_PROMPT
   integer(DWORD),parameter,public :: DM_OUT_BUFFER = DM_COPY
   integer(DWORD),parameter,public :: DM_OUT_DEFAULT = DM_UPDATE

   integer(WORD),parameter,public :: DC_FIELDS = 1_WORD
   integer(WORD),parameter,public :: DC_PAPERS = 2_WORD
   integer(WORD),parameter,public :: DC_PAPERSIZE = 3_WORD
   integer(WORD),parameter,public :: DC_MINEXTENT = 4_WORD
   integer(WORD),parameter,public :: DC_MAXEXTENT = 5_WORD
   integer(WORD),parameter,public :: DC_BINS = 6_WORD
   integer(WORD),parameter,public :: DC_DUPLEX = 7_WORD
   integer(WORD),parameter,public :: DC_SIZE = 8_WORD
   integer(WORD),parameter,public :: DC_EXTRA = 9_WORD
   integer(WORD),parameter,public :: DC_VERSION = 10_WORD
   integer(WORD),parameter,public :: DC_DRIVER = 11_WORD
   integer(WORD),parameter,public :: DC_BINNAMES = 12_WORD
   integer(WORD),parameter,public :: DC_ENUMRESOLUTIONS = 13_WORD
   integer(WORD),parameter,public :: DC_FILEDEPENDENCIES = 14_WORD
   integer(WORD),parameter,public :: DC_TRUETYPE = 15_WORD
   integer(WORD),parameter,public :: DC_PAPERNAMES = 16_WORD
   integer(WORD),parameter,public :: DC_ORIENTATION = 17_WORD
   integer(WORD),parameter,public :: DC_COPIES = 18_WORD
   integer(WORD),parameter,public :: DC_BINADJUST = 19_WORD
   integer(WORD),parameter,public :: DC_EMF_COMPLIANT = 20_WORD
   integer(WORD),parameter,public :: DC_DATATYPE_PRODUCED = 21_WORD
   integer(WORD),parameter,public :: DC_COLLATE = 22_WORD
   integer(WORD),parameter,public :: DC_MANUFACTURER = 23_WORD
   integer(WORD),parameter,public :: DC_MODEL = 24_WORD
   integer(WORD),parameter,public :: DC_PERSONALITY = 25_WORD
   integer(WORD),parameter,public :: DC_PRINTRATE = 26_WORD
   integer(WORD),parameter,public :: DC_PRINTRATEUNIT = 27_WORD
   integer(WORD),parameter,public :: PRINTRATEUNIT_PPM = 1_WORD
   integer(WORD),parameter,public :: PRINTRATEUNIT_CPS = 2_WORD
   integer(WORD),parameter,public :: PRINTRATEUNIT_LPM = 3_WORD
   integer(WORD),parameter,public :: PRINTRATEUNIT_IPM = 4_WORD
   integer(WORD),parameter,public :: DC_PRINTERMEM = 28_WORD
   integer(WORD),parameter,public :: DC_MEDIAREADY = 29_WORD
   integer(WORD),parameter,public :: DC_STAPLE = 30_WORD
   integer(WORD),parameter,public :: DC_PRINTRATEPPM = 31_WORD
   integer(WORD),parameter,public :: DC_COLORDEVICE = 32_WORD
   integer(WORD),parameter,public :: DC_NUP = 33_WORD
   integer(WORD),parameter,public :: DC_MEDIATYPENAMES = 34_WORD
   integer(WORD),parameter,public :: DC_MEDIATYPES = 35_WORD

   integer(DWORD),parameter,public :: DC_GRAYSCALE = 1
   integer(DWORD),parameter,public :: DC_INTERLACED = 2

   integer(DWORD),parameter,public :: PD_ALLPAGES = int(Z'0',DWORD)
   integer(DWORD),parameter,public :: PD_SELECTION = int(Z'1',DWORD)
   integer(DWORD),parameter,public :: PD_PAGENUMS = int(Z'2',DWORD)
   integer(DWORD),parameter,public :: PD_NOSELECTION = int(Z'4',DWORD)
   integer(DWORD),parameter,public :: PD_NOPAGENUMS = int(Z'8',DWORD)
   integer(DWORD),parameter,public :: PD_COLLATE = int(Z'10',DWORD)
   integer(DWORD),parameter,public :: PD_PRINTTOFILE = int(Z'20',DWORD)
   integer(DWORD),parameter,public :: PD_PRINTSETUP = int(Z'40',DWORD)
   integer(DWORD),parameter,public :: PD_NOWARNING = int(Z'80',DWORD)
   integer(DWORD),parameter,public :: PD_RETURNDC = int(Z'100',DWORD)
   integer(DWORD),parameter,public :: PD_RETURNIC = int(Z'200',DWORD)
   integer(DWORD),parameter,public :: PD_RETURNDEFAULT = int(Z'400',DWORD)
   integer(DWORD),parameter,public :: PD_SHOWHELP = int(Z'800',DWORD)
   integer(DWORD),parameter,public :: PD_ENABLEPRINTHOOK = int(Z'1000',DWORD)
   integer(DWORD),parameter,public :: PD_ENABLESETUPHOOK = int(Z'2000',DWORD)
   integer(DWORD),parameter,public :: PD_ENABLEPRINTTEMPLATE = int(Z'4000',DWORD)
   integer(DWORD),parameter,public :: PD_ENABLESETUPTEMPLATE = int(Z'8000',DWORD)
   integer(DWORD),parameter,public :: PD_ENABLEPRINTTEMPLATEHANDLE = int(Z'10000',DWORD)
   integer(DWORD),parameter,public :: PD_ENABLESETUPTEMPLATEHANDLE = int(Z'20000',DWORD)
   integer(DWORD),parameter,public :: PD_USEDEVMODECOPIES = int(Z'40000',DWORD)
   integer(DWORD),parameter,public :: PD_USEDEVMODECOPIESANDCOLLATE = int(Z'40000',DWORD)
   integer(DWORD),parameter,public :: PD_DISABLEPRINTTOFILE = int(Z'80000',DWORD)
   integer(DWORD),parameter,public :: PD_HIDEPRINTTOFILE = int(Z'100000',DWORD)
   integer(DWORD),parameter,public :: PD_NONETWORKBUTTON = int(Z'200000',DWORD)
   integer(DWORD),parameter,public :: PD_CURRENTPAGE = int(Z'400000',DWORD)
   integer(DWORD),parameter,public :: PD_NOCURRENTPAGE = int(Z'800000',DWORD)
   integer(DWORD),parameter,public :: PD_EXCLUSIONFLAGS = int(Z'1000000',DWORD)
   integer(DWORD),parameter,public :: PD_USELARGETEMPLATE = int(Z'10000000',DWORD)

   integer(DWORD),parameter,public :: PD_EXCL_COPIESANDCOLLATE = ior(DM_COPIES,DM_COLLATE)
   integer(DWORD),parameter,public :: START_PAGE_GENERAL = int(Z'ffffffff',DWORD)

   integer(DWORD),parameter,public :: PD_RESULT_CANCEL = 0
   integer(DWORD),parameter,public :: PD_RESULT_PRINT = 1
   integer(DWORD),parameter,public :: PD_RESULT_APPLY = 2

   integer(DWORD),parameter,public :: CDERR_DIALOGFAILURE = int(Z'FFFF',DWORD)

   integer(DWORD),parameter,public :: CDERR_GENERALCODES = int(Z'0000',DWORD)
   integer(DWORD),parameter,public :: CDERR_STRUCTSIZE = int(Z'0001',DWORD)
   integer(DWORD),parameter,public :: CDERR_INITIALIZATION = int(Z'0002',DWORD)
   integer(DWORD),parameter,public :: CDERR_NOTEMPLATE = int(Z'0003',DWORD)
   integer(DWORD),parameter,public :: CDERR_NOHINSTANCE = int(Z'0004',DWORD)
   integer(DWORD),parameter,public :: CDERR_LOADSTRFAILURE = int(Z'0005',DWORD)
   integer(DWORD),parameter,public :: CDERR_FINDRESFAILURE = int(Z'0006',DWORD)
   integer(DWORD),parameter,public :: CDERR_LOADRESFAILURE = int(Z'0007',DWORD)
   integer(DWORD),parameter,public :: CDERR_LOCKRESFAILURE = int(Z'0008',DWORD)
   integer(DWORD),parameter,public :: CDERR_MEMALLOCFAILURE = int(Z'0009',DWORD)
   integer(DWORD),parameter,public :: CDERR_MEMLOCKFAILURE = int(Z'000A',DWORD)
   integer(DWORD),parameter,public :: CDERR_NOHOOK = int(Z'000B',DWORD)
   integer(DWORD),parameter,public :: CDERR_REGISTERMSGFAIL = int(Z'000C',DWORD)

   integer(DWORD),parameter,public :: PDERR_PRINTERCODES = int(Z'1000',DWORD)
   integer(DWORD),parameter,public :: PDERR_SETUPFAILURE = int(Z'1001',DWORD)
   integer(DWORD),parameter,public :: PDERR_PARSEFAILURE = int(Z'1002',DWORD)
   integer(DWORD),parameter,public :: PDERR_RETDEFFAILURE = int(Z'1003',DWORD)
   integer(DWORD),parameter,public :: PDERR_LOADDRVFAILURE = int(Z'1004',DWORD)
   integer(DWORD),parameter,public :: PDERR_GETDEVMODEFAIL = int(Z'1005',DWORD)
   integer(DWORD),parameter,public :: PDERR_INITFAILURE = int(Z'1006',DWORD)
   integer(DWORD),parameter,public :: PDERR_NODEVICES = int(Z'1007',DWORD)
   integer(DWORD),parameter,public :: PDERR_NODEFAULTPRN = int(Z'1008',DWORD)
   integer(DWORD),parameter,public :: PDERR_DNDMMISMATCH = int(Z'1009',DWORD)
   integer(DWORD),parameter,public :: PDERR_CREATEICFAILURE = int(Z'100A',DWORD)
   integer(DWORD),parameter,public :: PDERR_PRINTERNOTFOUND = int(Z'100B',DWORD)
   integer(DWORD),parameter,public :: PDERR_DEFAULTDIFFERENT = int(Z'100C',DWORD)

   integer(DWORD),parameter,public :: CFERR_CHOOSEFONTCODES = int(Z'2000',DWORD)
   integer(DWORD),parameter,public :: CFERR_NOFONTS = int(Z'2001',DWORD)
   integer(DWORD),parameter,public :: CFERR_MAXLESSTHANMIN = int(Z'2002',DWORD)

   integer(DWORD),parameter,public :: FNERR_FILENAMECODES = int(Z'3000',DWORD)
   integer(DWORD),parameter,public :: FNERR_SUBCLASSFAILURE = int(Z'3001',DWORD)
   integer(DWORD),parameter,public :: FNERR_INVALIDFILENAME = int(Z'3002',DWORD)
   integer(DWORD),parameter,public :: FNERR_BUFFERTOOSMALL = int(Z'3003',DWORD)

   integer(DWORD),parameter,public :: FRERR_FINDREPLACECODES = int(Z'4000',DWORD)
   integer(DWORD),parameter,public :: FRERR_BUFFERLENGTHZERO = int(Z'4001',DWORD)

   integer(DWORD),parameter,public :: CCERR_CHOOSECOLORCODES = int(Z'5000',DWORD)

   integer(HRESULT),parameter,public :: S_OK = int(Z'00000000',HRESULT)
   integer(HRESULT),parameter,public :: S_FALSE = int(Z'00000001',HRESULT)
   integer(HRESULT),parameter,public :: E_PENDING = int(Z'8000000A',HRESULT)
   integer(HRESULT),parameter,public :: E_NOTIMPL = int(Z'80004001',HRESULT)
   integer(HRESULT),parameter,public :: E_NOINTERFACE = int(Z'80004002',HRESULT)
   integer(HRESULT),parameter,public :: E_POINTER = int(Z'80004003',HRESULT)
   integer(HRESULT),parameter,public :: E_ABORT = int(Z'80004004',HRESULT)
   integer(HRESULT),parameter,public :: E_FAIL = int(Z'80004005',HRESULT)
   integer(HRESULT),parameter,public :: E_UNEXPECTED = int(Z'8000FFFF',HRESULT)
   integer(HRESULT),parameter,public :: E_ACCESSDENIED = int(Z'80070005',HRESULT)
   integer(HRESULT),parameter,public :: E_HANDLE = int(Z'80070006',HRESULT)
   integer(HRESULT),parameter,public :: E_OUTOFMEMORY = int(Z'8007000e',HRESULT)
   integer(HRESULT),parameter,public :: E_INVALIDARG = int(Z'80070057',HRESULT)

   integer(DWORD),parameter,public :: PSD_DEFAULTMINMARGINS = int(Z'0',DWORD)
   integer(DWORD),parameter,public :: PSD_INWININIINTLMEASURE = int(Z'0',DWORD)
   integer(DWORD),parameter,public :: PSD_MINMARGINS = int(Z'1',DWORD)
   integer(DWORD),parameter,public :: PSD_MARGINS = int(Z'2',DWORD)
   integer(DWORD),parameter,public :: PSD_INTHOUSANDTHSOFINCHES = int(Z'4',DWORD)
   integer(DWORD),parameter,public :: PSD_INHUNDREDTHSOFMILLIMETERS = int(Z'8',DWORD)
   integer(DWORD),parameter,public :: PSD_DISABLEMARGINS = int(Z'10',DWORD)
   integer(DWORD),parameter,public :: PSD_DISABLEPRINTER = int(Z'20',DWORD)
   integer(DWORD),parameter,public :: PSD_NOWARNING = int(Z'80',DWORD)
   integer(DWORD),parameter,public :: PSD_DISABLEORIENTATION = int(Z'100',DWORD)
   integer(DWORD),parameter,public :: PSD_RETURNDEFAULT = int(Z'400',DWORD)
   integer(DWORD),parameter,public :: PSD_DISABLEPAPER = int(Z'200',DWORD)
   integer(DWORD),parameter,public :: PSD_SHOWHELP = int(Z'800',DWORD)
   integer(DWORD),parameter,public :: PSD_ENABLEPAGESETUPHOOK = int(Z'2000',DWORD)
   integer(DWORD),parameter,public :: PSD_ENABLEPAGESETUPTEMPLATE = int(Z'8000',DWORD)
   integer(DWORD),parameter,public :: PSD_ENABLEPAGESETUPTEMPLATEHANDLE = int(Z'20000',DWORD)
   integer(DWORD),parameter,public :: PSD_ENABLEPAGEPAINTHOOK = int(Z'40000',DWORD)
   integer(DWORD),parameter,public :: PSD_DISABLEPAGEPAINTING = int(Z'80000',DWORD)
   integer(DWORD),parameter,public :: PSD_NONETWORKBUTTON = int(Z'200000',DWORD)

   integer(LPARAM),parameter,public :: PRF_CHECKVISIBLE = int(Z'00000001',LPARAM)
   integer(LPARAM),parameter,public :: PRF_NONCLIENT = int(Z'00000002',LPARAM)
   integer(LPARAM),parameter,public :: PRF_CLIENT = int(Z'00000004',LPARAM)
   integer(LPARAM),parameter,public :: PRF_ERASEBKGND = int(Z'00000008',LPARAM)
   integer(LPARAM),parameter,public :: PRF_CHILDREN = int(Z'00000010',LPARAM)
   integer(LPARAM),parameter,public :: PRF_OWNED = int(Z'00000020',LPARAM)

   integer(WPARAM),parameter,public :: SIZE_RESTORED = 0
   integer(WPARAM),parameter,public :: SIZE_MINIMIZED = 1
   integer(WPARAM),parameter,public :: SIZE_MAXIMIZED = 2
   integer(WPARAM),parameter,public :: SIZE_MAXSHOW = 3
   integer(WPARAM),parameter,public :: SIZE_MAXHIDE = 4

   integer(WPARAM),parameter,public :: SIZENORMAL = SIZE_RESTORED
   integer(WPARAM),parameter,public :: SIZEICONIC = SIZE_MINIMIZED
   integer(WPARAM),parameter,public :: SIZEFULLSCREEN = SIZE_MAXIMIZED
   integer(WPARAM),parameter,public :: SIZEZOOMSHOW = SIZE_MAXSHOW
   integer(WPARAM),parameter,public :: SIZEZOOMHIDE = SIZE_MAXHIDE

   integer(DWORD),parameter,public :: FORMAT_MESSAGE_ALLOCATE_BUFFER = int(Z'100',DWORD)
   integer(DWORD),parameter,public :: FORMAT_MESSAGE_IGNORE_INSERTS = int(Z'200',DWORD)
   integer(DWORD),parameter,public :: FORMAT_MESSAGE_FROM_STRING = int(Z'400',DWORD)
   integer(DWORD),parameter,public :: FORMAT_MESSAGE_FROM_HMODULE = int(Z'800',DWORD)
   integer(DWORD),parameter,public :: FORMAT_MESSAGE_FROM_SYSTEM = int(Z'1000',DWORD)
   integer(DWORD),parameter,public :: FORMAT_MESSAGE_ARGUMENT_ARRAY = int(Z'2000',DWORD)
   integer(DWORD),parameter,public :: FORMAT_MESSAGE_MAX_WIDTH_MASK = int(Z'ff',DWORD)

   integer(USHORT),parameter,public :: LANG_NEUTRAL = int(Z'00',USHORT)
   integer(USHORT),parameter,public :: LANG_INVARIANT = int(Z'7f',USHORT)

   integer(USHORT),parameter,public :: LANG_AFRIKAANS = int(Z'36',USHORT)
   integer(USHORT),parameter,public :: LANG_ALBANIAN = int(Z'1c',USHORT)
   integer(USHORT),parameter,public :: LANG_ALSATIAN = int(Z'84',USHORT)
   integer(USHORT),parameter,public :: LANG_AMHARIC = int(Z'5e',USHORT)
   integer(USHORT),parameter,public :: LANG_ARABIC = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: LANG_ARMENIAN = int(Z'2b',USHORT)
   integer(USHORT),parameter,public :: LANG_ASSAMESE = int(Z'4d',USHORT)
   integer(USHORT),parameter,public :: LANG_AZERI = int(Z'2c',USHORT)
   integer(USHORT),parameter,public :: LANG_BASHKIR = int(Z'6d',USHORT)
   integer(USHORT),parameter,public :: LANG_BASQUE = int(Z'2d',USHORT)
   integer(USHORT),parameter,public :: LANG_BELARUSIAN = int(Z'23',USHORT)
   integer(USHORT),parameter,public :: LANG_BENGALI = int(Z'45',USHORT)
   integer(USHORT),parameter,public :: LANG_BRETON = int(Z'7e',USHORT)
   integer(USHORT),parameter,public :: LANG_BOSNIAN = int(Z'1a',USHORT)
   integer(USHORT),parameter,public :: LANG_BOSNIAN_NEUTRAL = int(Z'781a',USHORT)
   integer(USHORT),parameter,public :: LANG_BULGARIAN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: LANG_CATALAN = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: LANG_CHINESE = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: LANG_CHINESE_SIMPLIFIED = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: LANG_CHINESE_TRADITIONAL = int(Z'7c04',USHORT)
   integer(USHORT),parameter,public :: LANG_CORSICAN = int(Z'83',USHORT)
   integer(USHORT),parameter,public :: LANG_CROATIAN = int(Z'1a',USHORT)
   integer(USHORT),parameter,public :: LANG_CZECH = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: LANG_DANISH = int(Z'06',USHORT)
   integer(USHORT),parameter,public :: LANG_DARI = int(Z'8c',USHORT)
   integer(USHORT),parameter,public :: LANG_DIVEHI = int(Z'65',USHORT)
   integer(USHORT),parameter,public :: LANG_DUTCH = int(Z'13',USHORT)
   integer(USHORT),parameter,public :: LANG_ENGLISH = int(Z'09',USHORT)
   integer(USHORT),parameter,public :: LANG_ESTONIAN = int(Z'25',USHORT)
   integer(USHORT),parameter,public :: LANG_FAEROESE = int(Z'38',USHORT)
   integer(USHORT),parameter,public :: LANG_FARSI = int(Z'29',USHORT)
   integer(USHORT),parameter,public :: LANG_FILIPINO = int(Z'64',USHORT)
   integer(USHORT),parameter,public :: LANG_FINNISH = int(Z'0b',USHORT)
   integer(USHORT),parameter,public :: LANG_FRENCH = int(Z'0c',USHORT)
   integer(USHORT),parameter,public :: LANG_FRISIAN = int(Z'62',USHORT)
   integer(USHORT),parameter,public :: LANG_GALICIAN = int(Z'56',USHORT)
   integer(USHORT),parameter,public :: LANG_GEORGIAN = int(Z'37',USHORT)
   integer(USHORT),parameter,public :: LANG_GERMAN = int(Z'07',USHORT)
   integer(USHORT),parameter,public :: LANG_GREEK = int(Z'08',USHORT)
   integer(USHORT),parameter,public :: LANG_GREENLANDIC = int(Z'6f',USHORT)
   integer(USHORT),parameter,public :: LANG_GUJARATI = int(Z'47',USHORT)
   integer(USHORT),parameter,public :: LANG_HAUSA = int(Z'68',USHORT)
   integer(USHORT),parameter,public :: LANG_HEBREW = int(Z'0d',USHORT)
   integer(USHORT),parameter,public :: LANG_HINDI = int(Z'39',USHORT)
   integer(USHORT),parameter,public :: LANG_HUNGARIAN = int(Z'0e',USHORT)
   integer(USHORT),parameter,public :: LANG_ICELANDIC = int(Z'0f',USHORT)
   integer(USHORT),parameter,public :: LANG_IGBO = int(Z'70',USHORT)
   integer(USHORT),parameter,public :: LANG_INDONESIAN = int(Z'21',USHORT)
   integer(USHORT),parameter,public :: LANG_INUKTITUT = int(Z'5d',USHORT)
   integer(USHORT),parameter,public :: LANG_IRISH = int(Z'3c',USHORT)
   integer(USHORT),parameter,public :: LANG_ITALIAN = int(Z'10',USHORT)
   integer(USHORT),parameter,public :: LANG_JAPANESE = int(Z'11',USHORT)
   integer(USHORT),parameter,public :: LANG_KANNADA = int(Z'4b',USHORT)
   integer(USHORT),parameter,public :: LANG_KASHMIRI = int(Z'60',USHORT)
   integer(USHORT),parameter,public :: LANG_KAZAK = int(Z'3f',USHORT)
   integer(USHORT),parameter,public :: LANG_KHMER = int(Z'53',USHORT)
   integer(USHORT),parameter,public :: LANG_KICHE = int(Z'86',USHORT)
   integer(USHORT),parameter,public :: LANG_KINYARWANDA = int(Z'87',USHORT)
   integer(USHORT),parameter,public :: LANG_KONKANI = int(Z'57',USHORT)
   integer(USHORT),parameter,public :: LANG_KOREAN = int(Z'12',USHORT)
   integer(USHORT),parameter,public :: LANG_KYRGYZ = int(Z'40',USHORT)
   integer(USHORT),parameter,public :: LANG_LAO = int(Z'54',USHORT)
   integer(USHORT),parameter,public :: LANG_LATVIAN = int(Z'26',USHORT)
   integer(USHORT),parameter,public :: LANG_LITHUANIAN = int(Z'27',USHORT)
   integer(USHORT),parameter,public :: LANG_LOWER_SORBIAN = int(Z'2e',USHORT)
   integer(USHORT),parameter,public :: LANG_LUXEMBOURGISH = int(Z'6e',USHORT)
   integer(USHORT),parameter,public :: LANG_MACEDONIAN = int(Z'2f',USHORT)
   integer(USHORT),parameter,public :: LANG_MALAY = int(Z'3e',USHORT)
   integer(USHORT),parameter,public :: LANG_MALAYALAM = int(Z'4c',USHORT)
   integer(USHORT),parameter,public :: LANG_MALTESE = int(Z'3a',USHORT)
   integer(USHORT),parameter,public :: LANG_MANIPURI = int(Z'58',USHORT)
   integer(USHORT),parameter,public :: LANG_MAORI = int(Z'81',USHORT)
   integer(USHORT),parameter,public :: LANG_MAPUDUNGUN = int(Z'7a',USHORT)
   integer(USHORT),parameter,public :: LANG_MARATHI = int(Z'4e',USHORT)
   integer(USHORT),parameter,public :: LANG_MOHAWK = int(Z'7c',USHORT)
   integer(USHORT),parameter,public :: LANG_MONGOLIAN = int(Z'50',USHORT)
   integer(USHORT),parameter,public :: LANG_NEPALI = int(Z'61',USHORT)
   integer(USHORT),parameter,public :: LANG_NORWEGIAN = int(Z'14',USHORT)
   integer(USHORT),parameter,public :: LANG_OCCITAN = int(Z'82',USHORT)
   integer(USHORT),parameter,public :: LANG_ORIYA = int(Z'48',USHORT)
   integer(USHORT),parameter,public :: LANG_PASHTO = int(Z'63',USHORT)
   integer(USHORT),parameter,public :: LANG_PERSIAN = int(Z'29',USHORT)
   integer(USHORT),parameter,public :: LANG_POLISH = int(Z'15',USHORT)
   integer(USHORT),parameter,public :: LANG_PORTUGUESE = int(Z'16',USHORT)
   integer(USHORT),parameter,public :: LANG_PUNJABI = int(Z'46',USHORT)
   integer(USHORT),parameter,public :: LANG_QUECHUA = int(Z'6b',USHORT)
   integer(USHORT),parameter,public :: LANG_ROMANIAN = int(Z'18',USHORT)
   integer(USHORT),parameter,public :: LANG_ROMANSH = int(Z'17',USHORT)
   integer(USHORT),parameter,public :: LANG_RUSSIAN = int(Z'19',USHORT)
   integer(USHORT),parameter,public :: LANG_SAMI = int(Z'3b',USHORT)
   integer(USHORT),parameter,public :: LANG_SANSKRIT = int(Z'4f',USHORT)
   integer(USHORT),parameter,public :: LANG_SERBIAN = int(Z'1a',USHORT)
   integer(USHORT),parameter,public :: LANG_SERBIAN_NEUTRAL = int(Z'7c1a',USHORT)
   integer(USHORT),parameter,public :: LANG_SINDHI = int(Z'59',USHORT)
   integer(USHORT),parameter,public :: LANG_SINHALESE = int(Z'5b',USHORT)
   integer(USHORT),parameter,public :: LANG_SLOVAK = int(Z'1b',USHORT)
   integer(USHORT),parameter,public :: LANG_SLOVENIAN = int(Z'24',USHORT)
   integer(USHORT),parameter,public :: LANG_SOTHO = int(Z'6c',USHORT)
   integer(USHORT),parameter,public :: LANG_SPANISH = int(Z'0a',USHORT)
   integer(USHORT),parameter,public :: LANG_SWAHILI = int(Z'41',USHORT)
   integer(USHORT),parameter,public :: LANG_SWEDISH = int(Z'1d',USHORT)
   integer(USHORT),parameter,public :: LANG_SYRIAC = int(Z'5a',USHORT)
   integer(USHORT),parameter,public :: LANG_TAJIK = int(Z'28',USHORT)
   integer(USHORT),parameter,public :: LANG_TAMAZIGHT = int(Z'5f',USHORT)
   integer(USHORT),parameter,public :: LANG_TAMIL = int(Z'49',USHORT)
   integer(USHORT),parameter,public :: LANG_TATAR = int(Z'44',USHORT)
   integer(USHORT),parameter,public :: LANG_TELUGU = int(Z'4a',USHORT)
   integer(USHORT),parameter,public :: LANG_THAI = int(Z'1e',USHORT)
   integer(USHORT),parameter,public :: LANG_TIBETAN = int(Z'51',USHORT)
   integer(USHORT),parameter,public :: LANG_TIGRIGNA = int(Z'73',USHORT)
   integer(USHORT),parameter,public :: LANG_TSWANA = int(Z'32',USHORT)
   integer(USHORT),parameter,public :: LANG_TURKISH = int(Z'1f',USHORT)
   integer(USHORT),parameter,public :: LANG_TURKMEN = int(Z'42',USHORT)
   integer(USHORT),parameter,public :: LANG_UIGHUR = int(Z'80',USHORT)
   integer(USHORT),parameter,public :: LANG_UKRAINIAN = int(Z'22',USHORT)
   integer(USHORT),parameter,public :: LANG_UPPER_SORBIAN = int(Z'2e',USHORT)
   integer(USHORT),parameter,public :: LANG_URDU = int(Z'20',USHORT)
   integer(USHORT),parameter,public :: LANG_UZBEK = int(Z'43',USHORT)
   integer(USHORT),parameter,public :: LANG_VIETNAMESE = int(Z'2a',USHORT)
   integer(USHORT),parameter,public :: LANG_WELSH = int(Z'52',USHORT)
   integer(USHORT),parameter,public :: LANG_WOLOF = int(Z'88',USHORT)
   integer(USHORT),parameter,public :: LANG_XHOSA = int(Z'34',USHORT)
   integer(USHORT),parameter,public :: LANG_YAKUT = int(Z'85',USHORT)
   integer(USHORT),parameter,public :: LANG_YI = int(Z'78',USHORT)
   integer(USHORT),parameter,public :: LANG_YORUBA = int(Z'6a',USHORT)
   integer(USHORT),parameter,public :: LANG_ZULU = int(Z'35',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_NEUTRAL = int(Z'00',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_DEFAULT = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SYS_DEFAULT = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CUSTOM_DEFAULT = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CUSTOM_UNSPECIFIED = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_UI_CUSTOM_DEFAULT = int(Z'05',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_AFRIKAANS_SOUTH_AFRICA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ALBANIAN_ALBANIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ALSATIAN_FRANCE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_AMHARIC_ETHIOPIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_SAUDI_ARABIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_IRAQ = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_EGYPT = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_LIBYA = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_ALGERIA = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_MOROCCO = int(Z'06',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_TUNISIA = int(Z'07',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_OMAN = int(Z'08',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_YEMEN = int(Z'09',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_SYRIA = int(Z'0a',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_JORDAN = int(Z'0b',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_LEBANON = int(Z'0c',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_KUWAIT = int(Z'0d',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_UAE = int(Z'0e',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_BAHRAIN = int(Z'0f',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARABIC_QATAR = int(Z'10',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ARMENIAN_ARMENIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ASSAMESE_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_AZERI_LATIN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_AZERI_CYRILLIC = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BASHKIR_RUSSIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BASQUE_BASQUE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BELARUSIAN_BELARUS = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BENGALI_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BENGALI_BANGLADESH = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC = int(Z'08',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BRETON_FRANCE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_BULGARIAN_BULGARIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CATALAN_CATALAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CHINESE_TRADITIONAL = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CHINESE_SIMPLIFIED = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CHINESE_HONGKONG = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CHINESE_SINGAPORE = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CHINESE_MACAU = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CORSICAN_FRANCE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CZECH_CZECH_REPUBLIC = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CROATIAN_CROATIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_DANISH_DENMARK = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_DIVEHI_MALDIVES = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_DUTCH = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_DUTCH_BELGIAN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_US = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_UK = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_AUS = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_CAN = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_NZ = int(Z'05',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_IRELAND = int(Z'06',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_EIRE = int(Z'06',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_SOUTH_AFRICA = int(Z'07',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_JAMAICA = int(Z'08',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_CARIBBEAN = int(Z'09',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_BELIZE = int(Z'0a',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_TRINIDAD = int(Z'0b',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_ZIMBABWE = int(Z'0c',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_PHILIPPINES = int(Z'0d',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_INDIA = int(Z'10',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_MALAYSIA = int(Z'11',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ENGLISH_SINGAPORE = int(Z'12',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ESTONIAN_ESTONIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FAEROESE_FAROE_ISLANDS = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FILIPINO_PHILIPPINES = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FINNISH_FINLAND = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FRENCH = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FRENCH_BELGIAN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FRENCH_CANADIAN = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FRENCH_SWISS = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FRENCH_LUXEMBOURG = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FRENCH_MONACO = int(Z'06',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_FRISIAN_NETHERLANDS = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GALICIAN_GALICIAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GEORGIAN_GEORGIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GERMAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GERMAN_SWISS = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GERMAN_AUSTRIAN = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GERMAN_LUXEMBOURG = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GERMAN_LIECHTENSTEIN = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GREEK_GREECE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GREENLANDIC_GREENLAND = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_GUJARATI_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_HAUSA_NIGERIA_LATIN = int(Z'01',USHORT)
!/* SUBLANG_HAUSA_NIGERIA_LATIN is what MS defines */
   integer(USHORT),parameter,public :: SUBLANG_HAUSA_NIGERIA = SUBLANG_HAUSA_NIGERIA_LATIN
   integer(USHORT),parameter,public :: SUBLANG_HEBREW_ISRAEL = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_HINDI_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_HUNGARIAN_HUNGARY = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ICELANDIC_ICELAND = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_IGBO_NIGERIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_INDONESIAN_INDONESIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_INUKTITUT_CANADA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_INUKTITUT_CANADA_LATIN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_IRISH_IRELAND = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ITALIAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ITALIAN_SWISS = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_JAPANESE_JAPAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KASHMIRI_INDIA = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KASHMIRI_SASIA = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KAZAK_KAZAKHSTAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KHMER_CAMBODIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KICHE_GUATEMALA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KINYARWANDA_RWANDA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KONKANI_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KOREAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_KYRGYZ_KYRGYZSTAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_LAO_LAO = int(Z'01',USHORT)
!/* SUBLANG_LAO_LAO is what MS defines */
   integer(USHORT),parameter,public :: SUBLANG_LAO_LAO_PDR = SUBLANG_LAO_LAO
   integer(USHORT),parameter,public :: SUBLANG_LATVIAN_LATVIA = int(Z'01',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_LITHUANIAN_LITHUANIA = int(Z'01',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_LITHUANIAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_LOWER_SORBIAN_GERMANY = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_LUXEMBOURGISH_LUXEMBOURG = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MACEDONIAN_MACEDONIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MALAY_MALAYSIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MALAY_BRUNEI_DARUSSALAM = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MALAYALAM_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MALTESE_MALTA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MAORI_NEW_ZEALAND = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MAPUDUNGUN_CHILE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MARATHI_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MOHAWK_MOHAWK = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_MONGOLIAN_PRC = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_NEPALI_NEPAL = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_NEPALI_INDIA = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_NORWEGIAN_BOKMAL = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_NORWEGIAN_NYNORSK = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_OCCITAN_FRANCE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ORIYA_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_PASHTO_AFGHANISTAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_PERSIAN_IRAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_POLISH_POLAND = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_PORTUGUESE_BRAZILIAN = int(Z'01',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_PORTUGUESE_PORTUGAL = int(Z'02',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_PORTUGUESE = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_PUNJABI_INDIA = int(Z'01',USHORT)
!/* ??? #define SUBLANG_PUNJABI_PAKISTAN 0x01 ??? */
   integer(USHORT),parameter,public :: SUBLANG_QUECHUA_BOLIVIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_QUECHUA_ECUADOR = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_QUECHUA_PERU = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ROMANIAN_ROMANIA = int(Z'01',USHORT)
!/* ??? #define SUBLANG_ROMANIAN_MOLDOVA 0x01 ??? */
   integer(USHORT),parameter,public :: SUBLANG_ROMANSH_SWITZERLAND = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_RUSSIAN_RUSSIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_NORTHERN_NORWAY = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_NORTHERN_SWEDEN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_NORTHERN_FINLAND = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_LULE_NORWAY = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_LULE_SWEDEN = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_SOUTHERN_NORWAY = int(Z'06',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_SOUTHERN_SWEDEN = int(Z'07',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_SKOLT_FINLAND = int(Z'08',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SAMI_INARI_FINLAND = int(Z'09',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SANSKRIT_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SERBIAN_LATIN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SERBIAN_CYRILLIC = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN = int(Z'06',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC = int(Z'07',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SINDHI_AFGHANISTAN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SINHALESE_SRI_LANKA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SLOVAK_SLOVAKIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SLOVENIAN_SLOVENIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_MEXICAN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_MODERN = int(Z'03',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_GUATEMALA = int(Z'04',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_COSTA_RICA = int(Z'05',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_PANAMA = int(Z'06',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_DOMINICAN_REPUBLIC = int(Z'07',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_VENEZUELA = int(Z'08',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_COLOMBIA = int(Z'09',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_PERU = int(Z'0a',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_ARGENTINA = int(Z'0b',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_ECUADOR = int(Z'0c',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_CHILE = int(Z'0d',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_URUGUAY = int(Z'0e',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_PARAGUAY = int(Z'0f',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_BOLIVIA = int(Z'10',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_EL_SALVADOR = int(Z'11',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_HONDURAS = int(Z'12',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_NICARAGUA = int(Z'13',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_PUERTO_RICO = int(Z'14',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SPANISH_US = int(Z'15',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_SWEDISH_SWEDEN = int(Z'01',USHORT)

   integer(USHORT),parameter,public :: SUBLANG_SWEDISH = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SWEDISH_FINLAND = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_SYRIAC = int(Z'01',USHORT)
!/* SUBLANG_SYRIAC_SYRIA is what MSDN mentions */
   integer(USHORT),parameter,public :: SUBLANG_SYRIAC_SYRIA = SUBLANG_SYRIAC
   integer(USHORT),parameter,public :: SUBLANG_TAJIK_TAJIKISTAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TAMAZIGHT_ALGERIA_LATIN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TAMIL_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TATAR_RUSSIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TELUGU_INDIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_THAI_THAILAND = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TIBETAN_PRC = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TIBETAN_BHUTAN = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TIGRIGNA_ERITREA = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TSWANA_SOUTH_AFRICA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TURKISH_TURKEY = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_TURKMEN_TURKMENISTAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_UIGHUR_PRC = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_UKRAINIAN_UKRAINE = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_UPPER_SORBIAN_GERMANY = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_URDU_PAKISTAN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_URDU_INDIA = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_UZBEK_LATIN = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_UZBEK_CYRILLIC = int(Z'02',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_VIETNAMESE_VIETNAM = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_WELSH_UNITED_KINGDOM = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_WOLOF_SENEGAL = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_YORUBA_NIGERIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_XHOSA_SOUTH_AFRICA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_YAKUT_RUSSIA = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_YI_PRC = int(Z'01',USHORT)
   integer(USHORT),parameter,public :: SUBLANG_ZULU_SOUTH_AFRICA = int(Z'01',USHORT)

   integer(HFILE), parameter, public :: HFILE_ERROR = -1
   integer(UINT),parameter,public :: ERROR_BAD_FORMAT = int(Z'0000000b',UINT)
   integer(UINT),parameter,public :: ERROR_FILE_NOT_FOUND = int(Z'00000002',UINT)
   integer(UINT),parameter,public :: ERROR_PATH_NOT_FOUND = int(Z'00000003',UINT)
   integer(DWORD),parameter,public :: ERROR_BEGINNING_OF_MEDIA = int(Z'0000044e',DWORD)
   integer(DWORD),parameter,public :: ERROR_BUS_RESET = int(Z'00000457',DWORD)
   integer(DWORD),parameter,public :: ERROR_DEVICE_NOT_PARTITIONED = int(Z'00000453',DWORD)
   integer(DWORD),parameter,public :: ERROR_END_OF_MEDIA = int(Z'0000044c',DWORD)
   integer(DWORD),parameter,public :: ERROR_FILEMARK_DETECTED = int(Z'0000044d',DWORD)
   integer(DWORD),parameter,public :: ERROR_INVALID_BLOCK_LENGTH = int(Z'00000452',DWORD)
   integer(DWORD),parameter,public :: ERROR_MEDIA_CHANGED = int(Z'00000456',DWORD)
   integer(DWORD),parameter,public :: ERROR_NO_DATA_DETECTED = int(Z'00000450',DWORD)
   integer(DWORD),parameter,public :: ERROR_NO_MEDIA_IN_DRIVE = int(Z'00000458',DWORD)
   integer(DWORD),parameter,public :: ERROR_NOT_SUPPORTED = int(Z'00000032',DWORD)
   integer(DWORD),parameter,public :: ERROR_PARTITION_FAILURE = int(Z'00000451',DWORD)
   integer(DWORD),parameter,public :: ERROR_SETMARK_DETECTED = int(Z'0000044f',DWORD)
   integer(DWORD),parameter,public :: ERROR_UNABLE_TO_LOCK_MEDIA = int(Z'00000454',DWORD)
   integer(DWORD),parameter,public :: ERROR_UNABLE_TO_UNLOAD_MEDIA = int(Z'00000455',DWORD)
   integer(DWORD),parameter,public :: ERROR_WRITE_PROTECT = int(Z'00000013',DWORD)
   integer(DWORD), parameter, public :: TAPE_FILEMARKS = int(Z'1',DWORD)
   integer(DWORD), parameter, public :: TAPE_LONG_FILEMARKS = int(Z'3',DWORD)
   integer(DWORD), parameter, public :: TAPE_SETMARKS = int(Z'0',DWORD)
   integer(DWORD), parameter, public :: TAPE_SHORT_FILEMARKS = int(Z'2',DWORD)

   integer(UINT), parameter, public :: CP_ACP = 0
   integer(UINT), parameter, public :: CP_MACCP = 2
   integer(UINT), parameter, public :: CP_OEMCP = 1
   integer(UINT), parameter, public :: CP_SYMBOL = 42
   integer(UINT), parameter, public :: CP_THREAD_ACP = 3
   integer(UINT), parameter, public :: CP_UTF7 = 65000
   integer(UINT), parameter, public :: CP_UTF8 = 65001

   integer(DWORD), parameter, public :: WC_COMPOSITECHECK = int(Z'200',DWORD)
   integer(DWORD), parameter, public :: WC_DISCARDNS = int(Z'10',DWORD)
   integer(DWORD), parameter, public :: WC_SEPCHARS = int(Z'20',DWORD)
   integer(DWORD), parameter, public :: WC_DEFAULTCHAR = int(Z'40',DWORD)
   integer(DWORD), parameter, public :: WC_NO_BEST_FIT_CHARS = int(Z'400',DWORD)

   integer,parameter,public :: OFS_MAXPATHNAME  = 128

   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_ASCII16 = int(Z'00000001',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_REVERSE_ASCII16 = int(Z'00000010',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_STATISTICS = int(Z'00000002',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_REVERSE_STATISTICS = int(Z'00000020',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_CONTROLS = int(Z'00000004',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_REVERSE_CONTROLS = int(Z'00000040',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_SIGNATURE = int(Z'00000008',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_REVERSE_SIGNATURE = int(Z'00000080',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_ILLEGAL_CHARS = int(Z'00000100',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_ODD_LENGTH = int(Z'00000200',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_NULL_BYTES = int(Z'00001000',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_UNICODE_MASK = int(Z'0000000f',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_REVERSE_MASK = int(Z'000000f0',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_NOT_UNICODE_MASK = int(Z'00000f00',C_INT)
   integer(C_INT),parameter,public :: IS_TEXT_UNICODE_NOT_ASCII_MASK = int(Z'0000f000',C_INT)

   integer(UINT),parameter,public :: SEM_FAILCRITICALERRORS = int(Z'1',UINT)
   integer(UINT),parameter,public :: SEM_NOGPFAULTERRORBOX = int(Z'2',UINT)
   integer(UINT),parameter,public :: SEM_NOALIGNMENTFAULTEXCEPT = int(Z'4',UINT)
   integer(UINT),parameter,public :: SEM_NOOPENFILEERRORBOX = int(Z'8000',UINT)

   integer(BYTE),parameter,public :: FVIRTKEY = int(BOOL_TRUE,BYTE)
   integer(BYTE),parameter,public :: FNOINVERT = int(Z'02',BYTE)
   integer(BYTE),parameter,public :: FSHIFT = int(Z'04',BYTE)
   integer(BYTE),parameter,public :: FCONTROL = int(Z'08',BYTE)
   integer(BYTE),parameter,public :: FALT = int(Z'10',BYTE)

   integer(C_INTPTR_T),parameter,public :: OBM_CLOSE = 32754
   integer(C_INTPTR_T),parameter,public :: OBM_UPARROW = 32753
   integer(C_INTPTR_T),parameter,public :: OBM_DNARROW = 32752
   integer(C_INTPTR_T),parameter,public :: OBM_RGARROW = 32751
   integer(C_INTPTR_T),parameter,public :: OBM_LFARROW = 32750
   integer(C_INTPTR_T),parameter,public :: OBM_REDUCE = 32749
   integer(C_INTPTR_T),parameter,public :: OBM_ZOOM = 32748
   integer(C_INTPTR_T),parameter,public :: OBM_RESTORE = 32747
   integer(C_INTPTR_T),parameter,public :: OBM_REDUCED = 32746
   integer(C_INTPTR_T),parameter,public :: OBM_ZOOMD = 32745
   integer(C_INTPTR_T),parameter,public :: OBM_RESTORED = 32744
   integer(C_INTPTR_T),parameter,public :: OBM_UPARROWD = 32743
   integer(C_INTPTR_T),parameter,public :: OBM_DNARROWD = 32742
   integer(C_INTPTR_T),parameter,public :: OBM_RGARROWD = 32741
   integer(C_INTPTR_T),parameter,public :: OBM_LFARROWD = 32740
   integer(C_INTPTR_T),parameter,public :: OBM_MNARROW = 32739
   integer(C_INTPTR_T),parameter,public :: OBM_COMBO = 32738
   integer(C_INTPTR_T),parameter,public :: OBM_UPARROWI = 32737
   integer(C_INTPTR_T),parameter,public :: OBM_DNARROWI = 32736
   integer(C_INTPTR_T),parameter,public :: OBM_RGARROWI = 32735
   integer(C_INTPTR_T),parameter,public :: OBM_LFARROWI = 32734

   integer(C_INTPTR_T),parameter,public :: OBM_OLD_CLOSE = 32767
   integer(C_INTPTR_T),parameter,public :: OBM_SIZE = 32766
   integer(C_INTPTR_T),parameter,public :: OBM_OLD_UPARROW = 32765
   integer(C_INTPTR_T),parameter,public :: OBM_OLD_DNARROW = 32764
   integer(C_INTPTR_T),parameter,public :: OBM_OLD_RGARROW = 32763
   integer(C_INTPTR_T),parameter,public :: OBM_OLD_LFARROW = 32762
   integer(C_INTPTR_T),parameter,public :: OBM_BTSIZE = 32761
   integer(C_INTPTR_T),parameter,public :: OBM_CHECK = 32760
   integer(C_INTPTR_T),parameter,public :: OBM_CHECKBOXES = 32759
   integer(C_INTPTR_T),parameter,public :: OBM_BTNCORNERS = 32758
   integer(C_INTPTR_T),parameter,public :: OBM_OLD_REDUCE = 32757
   integer(C_INTPTR_T),parameter,public :: OBM_OLD_ZOOM = 32756
   integer(C_INTPTR_T),parameter,public :: OBM_OLD_RESTORE = 32755

   integer(C_INTPTR_T),parameter,public :: OCR_NORMAL = 32512
   integer(C_INTPTR_T),parameter,public :: OCR_IBEAM = 32513
   integer(C_INTPTR_T),parameter,public :: OCR_WAIT = 32514
   integer(C_INTPTR_T),parameter,public :: OCR_CROSS = 32515
   integer(C_INTPTR_T),parameter,public :: OCR_UP = 32516
   integer(C_INTPTR_T),parameter,public :: OCR_SIZE = 32640
   integer(C_INTPTR_T),parameter,public :: OCR_ICON = 32641
   integer(C_INTPTR_T),parameter,public :: OCR_SIZENWSE = 32642
   integer(C_INTPTR_T),parameter,public :: OCR_SIZENESW = 32643
   integer(C_INTPTR_T),parameter,public :: OCR_SIZEWE = 32644
   integer(C_INTPTR_T),parameter,public :: OCR_SIZENS = 32645
   integer(C_INTPTR_T),parameter,public :: OCR_SIZEALL = 32646
   integer(C_INTPTR_T),parameter,public :: OCR_ICOCUR = 32647
   integer(C_INTPTR_T),parameter,public :: OCR_NO = 32648
   integer(C_INTPTR_T),parameter,public :: OCR_HAND = 32649
   integer(C_INTPTR_T),parameter,public :: OCR_APPSTARTING = 32650

   integer(C_INTPTR_T),parameter,public :: OIC_SAMPLE = 32512
   integer(C_INTPTR_T),parameter,public :: OIC_HAND = 32513
   integer(C_INTPTR_T),parameter,public :: OIC_QUES = 32514
   integer(C_INTPTR_T),parameter,public :: OIC_BANG = 32515
   integer(C_INTPTR_T),parameter,public :: OIC_NOTE = 32516
   integer(C_INTPTR_T),parameter,public :: OIC_WINLOGO = 32517
   integer(C_INTPTR_T),parameter,public :: OIC_WARNING = OIC_BANG
   integer(C_INTPTR_T),parameter,public :: OIC_ERROR = OIC_HAND
   integer(C_INTPTR_T),parameter,public :: OIC_INFORMATION = OIC_NOTE

   integer(UINT),parameter,public :: IMAGE_BITMAP = 0
   integer(UINT),parameter,public :: IMAGE_ICON = 1
   integer(UINT),parameter,public :: IMAGE_CURSOR = 2
   integer(UINT),parameter,public :: IMAGE_ENHMETAFILE = 3

   integer(UINT),parameter,public :: LR_DEFAULTCOLOR = int(Z'0000',UINT)
   integer(UINT),parameter,public :: LR_MONOCHROME = int(Z'0001',UINT)
   integer(UINT),parameter,public :: LR_COLOR = int(Z'0002',UINT)
   integer(UINT),parameter,public :: LR_COPYRETURNORG = int(Z'0004',UINT)
   integer(UINT),parameter,public :: LR_COPYDELETEORG = int(Z'0008',UINT)
   integer(UINT),parameter,public :: LR_LOADFROMFILE = int(Z'0010',UINT)
   integer(UINT),parameter,public :: LR_LOADTRANSPARENT = int(Z'0020',UINT)
   integer(UINT),parameter,public :: LR_DEFAULTSIZE = int(Z'0040',UINT)
   integer(UINT),parameter,public :: LR_VGACOLOR = int(Z'0080',UINT)
   integer(UINT),parameter,public :: LR_LOADMAP3DCOLORS = int(Z'1000',UINT)
   integer(UINT),parameter,public :: LR_CREATEDIBSECTION = int(Z'2000',UINT)
   integer(UINT),parameter,public :: LR_COPYFROMRESOURCE = int(Z'4000',UINT)
   integer(UINT),parameter,public :: LR_SHARED = int(Z'8000',UINT)

   integer(C_INT),parameter,public :: SM_CXSCREEN = 0
   integer(C_INT),parameter,public :: SM_CYSCREEN = 1
   integer(C_INT),parameter,public :: SM_CXVSCROLL = 2
   integer(C_INT),parameter,public :: SM_CYHSCROLL = 3
   integer(C_INT),parameter,public :: SM_CYCAPTION = 4
   integer(C_INT),parameter,public :: SM_CXBORDER = 5
   integer(C_INT),parameter,public :: SM_CYBORDER = 6
   integer(C_INT),parameter,public :: SM_CXDLGFRAME = 7
   integer(C_INT),parameter,public :: SM_CYDLGFRAME = 8
   integer(C_INT),parameter,public :: SM_CYVTHUMB = 9
   integer(C_INT),parameter,public :: SM_CXHTHUMB = 10
   integer(C_INT),parameter,public :: SM_CXICON = 11
   integer(C_INT),parameter,public :: SM_CYICON = 12
   integer(C_INT),parameter,public :: SM_CXCURSOR = 13
   integer(C_INT),parameter,public :: SM_CYCURSOR = 14
   integer(C_INT),parameter,public :: SM_CYMENU = 15
   integer(C_INT),parameter,public :: SM_CXFULLSCREEN = 16
   integer(C_INT),parameter,public :: SM_CYFULLSCREEN = 17
   integer(C_INT),parameter,public :: SM_CYKANJIWINDOW = 18
   integer(C_INT),parameter,public :: SM_MOUSEPRESENT = 19
   integer(C_INT),parameter,public :: SM_CYVSCROLL = 20
   integer(C_INT),parameter,public :: SM_CXHSCROLL = 21
   integer(C_INT),parameter,public :: SM_DEBUG = 22
   integer(C_INT),parameter,public :: SM_SWAPBUTTON = 23
   integer(C_INT),parameter,public :: SM_RESERVED1 = 24
   integer(C_INT),parameter,public :: SM_RESERVED2 = 25
   integer(C_INT),parameter,public :: SM_RESERVED3 = 26
   integer(C_INT),parameter,public :: SM_RESERVED4 = 27
   integer(C_INT),parameter,public :: SM_CXMIN = 28
   integer(C_INT),parameter,public :: SM_CYMIN = 29
   integer(C_INT),parameter,public :: SM_CXSIZE = 30
   integer(C_INT),parameter,public :: SM_CYSIZE = 31
   integer(C_INT),parameter,public :: SM_CXFRAME = 32
   integer(C_INT),parameter,public :: SM_CYFRAME = 33
   integer(C_INT),parameter,public :: SM_CXMINTRACK = 34
   integer(C_INT),parameter,public :: SM_CYMINTRACK = 35
   integer(C_INT),parameter,public :: SM_CXDOUBLECLK = 36
   integer(C_INT),parameter,public :: SM_CYDOUBLECLK = 37
   integer(C_INT),parameter,public :: SM_CXICONSPACING = 38
   integer(C_INT),parameter,public :: SM_CYICONSPACING = 39
   integer(C_INT),parameter,public :: SM_MENUDROPALIGNMENT = 40
   integer(C_INT),parameter,public :: SM_PENWINDOWS = 41
   integer(C_INT),parameter,public :: SM_DBCSENABLED = 42
   integer(C_INT),parameter,public :: SM_CMOUSEBUTTONS = 43

   integer(C_INT),parameter,public :: SM_CXFIXEDFRAME = SM_CXDLGFRAME
   integer(C_INT),parameter,public :: SM_CYFIXEDFRAME = SM_CYDLGFRAME
   integer(C_INT),parameter,public :: SM_CXSIZEFRAME = SM_CXFRAME
   integer(C_INT),parameter,public :: SM_CYSIZEFRAME = SM_CYFRAME

   integer(C_INT),parameter,public :: SM_SECURE = 44
   integer(C_INT),parameter,public :: SM_CXEDGE = 45
   integer(C_INT),parameter,public :: SM_CYEDGE = 46
   integer(C_INT),parameter,public :: SM_CXMINSPACING = 47
   integer(C_INT),parameter,public :: SM_CYMINSPACING = 48
   integer(C_INT),parameter,public :: SM_CXSMICON = 49
   integer(C_INT),parameter,public :: SM_CYSMICON = 50
   integer(C_INT),parameter,public :: SM_CYSMCAPTION = 51
   integer(C_INT),parameter,public :: SM_CXSMSIZE = 52
   integer(C_INT),parameter,public :: SM_CYSMSIZE = 53
   integer(C_INT),parameter,public :: SM_CXMENUSIZE = 54
   integer(C_INT),parameter,public :: SM_CYMENUSIZE = 55
   integer(C_INT),parameter,public :: SM_ARRANGE = 56
   integer(C_INT),parameter,public :: SM_CXMINIMIZED = 57
   integer(C_INT),parameter,public :: SM_CYMINIMIZED = 58
   integer(C_INT),parameter,public :: SM_CXMAXTRACK = 59
   integer(C_INT),parameter,public :: SM_CYMAXTRACK = 60
   integer(C_INT),parameter,public :: SM_CXMAXIMIZED = 61
   integer(C_INT),parameter,public :: SM_CYMAXIMIZED = 62
   integer(C_INT),parameter,public :: SM_NETWORK = 63
   integer(C_INT),parameter,public :: SM_CLEANBOOT = 67
   integer(C_INT),parameter,public :: SM_CXDRAG = 68
   integer(C_INT),parameter,public :: SM_CYDRAG = 69
   integer(C_INT),parameter,public :: SM_SHOWSOUNDS = 70
   integer(C_INT),parameter,public :: SM_CXMENUCHECK = 71
   integer(C_INT),parameter,public :: SM_CYMENUCHECK = 72
   integer(C_INT),parameter,public :: SM_SLOWMACHINE = 73
   integer(C_INT),parameter,public :: SM_MIDEASTENABLED = 74
   integer(C_INT),parameter,public :: SM_MOUSEWHEELPRESENT = 75
   integer(C_INT),parameter,public :: SM_XVIRTUALSCREEN = 76
   integer(C_INT),parameter,public :: SM_YVIRTUALSCREEN = 77
   integer(C_INT),parameter,public :: SM_CXVIRTUALSCREEN = 78
   integer(C_INT),parameter,public :: SM_CYVIRTUALSCREEN = 79
   integer(C_INT),parameter,public :: SM_CMONITORS = 80
   integer(C_INT),parameter,public :: SM_SAMEDISPLAYFORMAT = 81
   integer(C_INT),parameter,public :: SM_IMMENABLED = 82
   integer(C_INT),parameter,public :: SM_CXFOCUSBORDER = 83
   integer(C_INT),parameter,public :: SM_CYFOCUSBORDER = 84
   integer(C_INT),parameter,public :: SM_TABLETPC = 86
   integer(C_INT),parameter,public :: SM_MEDIACENTER = 87
   integer(C_INT),parameter,public :: SM_STARTER = 88
   integer(C_INT),parameter,public :: SM_SERVERR2 = 89
   integer(C_INT),parameter,public :: SM_CMETRICS = 90
   integer(C_INT),parameter,public :: SM_REMOTESESSION = int(Z'1000',C_INT)
   integer(C_INT),parameter,public :: SM_SHUTTINGDOWN = int(Z'2000',C_INT)
   integer(C_INT),parameter,public :: SM_REMOTECONTROL = int(Z'2001',C_INT)
   integer(C_INT),parameter,public :: SM_CARETBLINKINGENABLED = int(Z'2002',C_INT)

   integer(UINT),parameter,public :: MIIM_STATE = int(Z'00000001',UINT)
   integer(UINT),parameter,public :: MIIM_ID = int(Z'00000002',UINT)
   integer(UINT),parameter,public :: MIIM_SUBMENU = int(Z'00000004',UINT)
   integer(UINT),parameter,public :: MIIM_CHECKMARKS = int(Z'00000008',UINT)
   integer(UINT),parameter,public :: MIIM_TYPE = int(Z'00000010',UINT)
   integer(UINT),parameter,public :: MIIM_DATA = int(Z'00000020',UINT)

   integer(DWORD),parameter,public :: DEBUG_PROCESS = int(Z'1',DWORD)
   integer(DWORD),parameter,public :: DEBUG_ONLY_THIS_PROCESS = int(Z'2',DWORD)
   integer(DWORD),parameter,public :: CREATE_SUSPENDED = int(Z'4',DWORD)
   integer(DWORD),parameter,public :: DETACHED_PROCESS = int(Z'8',DWORD)
   integer(DWORD),parameter,public :: CREATE_NEW_CONSOLE = int(Z'10',DWORD)
   integer(DWORD),parameter,public :: NORMAL_PRIORITY_CLASS = int(Z'20',DWORD)
   integer(DWORD),parameter,public :: IDLE_PRIORITY_CLASS = int(Z'40',DWORD)
   integer(DWORD),parameter,public :: HIGH_PRIORITY_CLASS = int(Z'80',DWORD)
   integer(DWORD),parameter,public :: REALTIME_PRIORITY_CLASS = int(Z'100',DWORD)
   integer(DWORD),parameter,public :: CREATE_NEW_PROCESS_GROUP = int(Z'200',DWORD)
   integer(DWORD),parameter,public :: CREATE_UNICODE_ENVIRONMENT = int(Z'400',DWORD)
   integer(DWORD),parameter,public :: CREATE_SEPARATE_WOW_VDM = int(Z'800',DWORD)
   integer(DWORD),parameter,public :: CREATE_SHARED_WOW_VDM = int(Z'1000',DWORD)
   integer(DWORD),parameter,public :: CREATE_FORCEDOS = int(Z'2000',DWORD)
   integer(DWORD),parameter,public :: BELOW_NORMAL_PRIORITY_CLASS = int(Z'4000',DWORD)
   integer(DWORD),parameter,public :: ABOVE_NORMAL_PRIORITY_CLASS = int(Z'8000',DWORD)
   integer(DWORD),parameter,public :: STACK_SIZE_PARAM_IS_A_RESERVATION = int(Z'10000',DWORD)

   integer(DWORD),parameter,public :: CREATE_BREAKAWAY_FROM_JOB = int(Z'1000000',DWORD)
   integer(DWORD),parameter,public :: CREATE_PRESERVE_CODE_AUTHZ_LEVEL = int(Z'2000000',DWORD)

   integer(DWORD),parameter,public :: CREATE_DEFAULT_ERROR_MODE = int(Z'4000000',DWORD)
   integer(DWORD),parameter,public :: CREATE_NO_WINDOW = int(Z'8000000',DWORD)

   integer,parameter,public :: PROFILE_USER = int(Z'10000000')
   integer,parameter,public :: PROFILE_KERNEL = int(Z'20000000')
   integer,parameter,public :: PROFILE_SERVER = int(Z'40000000')

   integer,parameter,public :: CREATE_IGNORE_SYSTEM_DEFAULT = int(Z'80000000')

   integer(DWORD),parameter,public :: FOREGROUND_BLUR = int(Z'00000001',DWORD)
   integer(DWORD),parameter,public :: FOREGROUND_GREEN = int(Z'00000002',DWORD)
   integer(DWORD),parameter,public :: FOREGROUND_RED = int(Z'00000004',DWORD)
   integer(DWORD),parameter,public :: FOREGROUND_INTENSITY = int(Z'00000008',DWORD)
   integer(DWORD),parameter,public :: BACKGROUND_BLUE = int(Z'00000010',DWORD)
   integer(DWORD),parameter,public :: BACKGROUND_GREEN = int(Z'00000020',DWORD)
   integer(DWORD),parameter,public :: BACKGROUND_RED = int(Z'00000040',DWORD)
   integer(DWORD),parameter,public :: BACKGROUND_INTENSITY = int(Z'00000080',DWORD)

   integer(DWORD),parameter,public :: STARTF_USESHOWWINDOW = int(Z'1',DWORD)
   integer(DWORD),parameter,public :: STARTF_USESIZE = int(Z'2',DWORD)
   integer(DWORD),parameter,public :: STARTF_USEPOSITION = int(Z'4',DWORD)
   integer(DWORD),parameter,public :: STARTF_USECOUNTCHARS = int(Z'8',DWORD)
   integer(DWORD),parameter,public :: STARTF_USEFILLATTRIBUTE = int(Z'10',DWORD)
   integer(DWORD),parameter,public :: STARTF_RUNFULLSCREEN = int(Z'20',DWORD)
   integer(DWORD),parameter,public :: STARTF_FORCEONFEEDBACK = int(Z'40',DWORD)
   integer(DWORD),parameter,public :: STARTF_FORCEOFFFEEDBACK = int(Z'80',DWORD)
   integer(DWORD),parameter,public :: STARTF_USESTDHANDLES = int(Z'100',DWORD)

   integer(DWORD),parameter,public :: STARTF_USEHOTKEY = int(Z'200',DWORD)

   integer,parameter,public :: MAX_PATH = 260

   integer(UINT),parameter,public :: DIB_RGB_COLORS = 0
   integer(UINT),parameter,public :: DIB_PAL_COLORS = 1

   integer(DWORD),parameter,public :: BI_RGB = 0
   integer(DWORD),parameter,public :: BI_RLE8 = 1
   integer(DWORD),parameter,public :: BI_RLE4 = 2
   integer(DWORD),parameter,public :: BI_BITFIELDS = 3
   integer(DWORD),parameter,public :: BI_JPEG = 4
   integer(DWORD),parameter,public :: BI_PNG = 5

   integer(C_INT),parameter,public :: TRANSPARENT = 1
   integer(C_INT),parameter,public :: OPAQUE = 2
   integer(C_INT),parameter,public :: BKMODE_LAST = 2

   integer,parameter,public :: MM_TEXT = 1
   integer,parameter,public :: MM_LOMETRIC = 2
   integer,parameter,public :: MM_HIMETRIC = 3
   integer,parameter,public :: MM_LOENGLISH = 4
   integer,parameter,public :: MM_HIENGLISH = 5
   integer,parameter,public :: MM_TWIPS = 6
   integer,parameter,public :: MM_ISOTROPIC = 7
   integer,parameter,public :: MM_ANISOTROPIC = 8

   integer,parameter,public :: LF_FACESIZE = 32
   integer,parameter,public :: LF_FULLFACESIZE = 64

   integer,parameter,public :: STAMP_DESIGNVECTOR = &
      int(Z'8000000') + iachar('d') + ishft(iachar('v'),8)
   integer,parameter,public :: STAMP_AXESLIST = &
      int(Z'8000000') + iachar('a') + ishft(iachar('l'),8)
   integer,parameter,public :: MM_MAX_NUMAXES = 16
   integer,parameter,public :: MM_MAX_AXES_NAMELEN = 16

   integer(BYTE),parameter,public :: TMPF_FIXED_PITCH = int(Z'01',BYTE)
   integer(BYTE),parameter,public :: TMPF_VECTOR = int(Z'02',BYTE)
   integer(BYTE),parameter,public :: TMPF_DEVICE = int(Z'08',BYTE)
   integer(BYTE),parameter,public :: TMPF_TRUETYPE = int(Z'04',BYTE)

   integer(DWORD),parameter,public :: NTM_REGULAR = int(Z'00000040',DWORD)
   integer(DWORD),parameter,public :: NTM_BOLD = int(Z'00000020',DWORD)
   integer(DWORD),parameter,public :: NTM_ITALIC = int(Z'00000001',DWORD)

   integer(DWORD),parameter,public :: NTM_NONNEGATIVE_AC = int(Z'00010000',DWORD)
   integer(DWORD),parameter,public :: NTM_PS_OPENTYPE = int(Z'00020000',DWORD)
   integer(DWORD),parameter,public :: NTM_TT_OPENTYPE = int(Z'00040000',DWORD)
   integer(DWORD),parameter,public :: NTM_MULTIPLEMASTER = int(Z'00080000',DWORD)
   integer(DWORD),parameter,public :: NTM_TYPE1 = int(Z'00100000',DWORD)
   integer(DWORD),parameter,public :: NTM_DSIG = int(Z'00200000',DWORD)

   integer(DWORD),parameter,public :: RASTER_FONTTYPE = int(Z'0001',DWORD)
   integer(DWORD),parameter,public :: DEVICE_FONTTYPE = int(Z'002',DWORD)
   integer(DWORD),parameter,public :: TRUETYPE_FONTTYPE = int(Z'004',DWORD)

   integer(DWORD),parameter,public :: OFN_READONLY = int(Z'1',DWORD)
   integer(DWORD),parameter,public :: OFN_OVERWRITEPROMPT = int(Z'2',DWORD)
   integer(DWORD),parameter,public :: OFN_HIDEREADONLY = int(Z'4',DWORD)
   integer(DWORD),parameter,public :: OFN_NOCHANGEDIR = int(Z'8',DWORD)
   integer(DWORD),parameter,public :: OFN_SHOWHELP = int(Z'10',DWORD)
   integer(DWORD),parameter,public :: OFN_ENABLEHOOK = int(Z'20',DWORD)
   integer(DWORD),parameter,public :: OFN_ENABLETEMPLATE = int(Z'40',DWORD)
   integer(DWORD),parameter,public :: OFN_ENABLETEMPLATEHANDLE = int(Z'80',DWORD)
   integer(DWORD),parameter,public :: OFN_NOVALIDATE = int(Z'100',DWORD)
   integer(DWORD),parameter,public :: OFN_ALLOWMULTISELECT = int(Z'200',DWORD)
   integer(DWORD),parameter,public :: OFN_EXTENSIONDIFFERENT = int(Z'400',DWORD)
   integer(DWORD),parameter,public :: OFN_PATHMUSTEXIST = int(Z'800',DWORD)
   integer(DWORD),parameter,public :: OFN_FILEMUSTEXIST = int(Z'1000',DWORD)
   integer(DWORD),parameter,public :: OFN_CREATEPROMPT = int(Z'2000',DWORD)
   integer(DWORD),parameter,public :: OFN_SHAREAWARE = int(Z'4000',DWORD)
   integer(DWORD),parameter,public :: OFN_NOREADONLYRETURN = int(Z'8000',DWORD)
   integer(DWORD),parameter,public :: OFN_NOTESTFILECREATE = int(Z'10000',DWORD)
   integer(DWORD),parameter,public :: OFN_NONETWORKBUTTON = int(Z'20000',DWORD)
   integer(DWORD),parameter,public :: OFN_NOLONGNAMES = int(Z'40000',DWORD)
   integer(DWORD),parameter,public :: OFN_EXPLORER = int(Z'80000',DWORD)
   integer(DWORD),parameter,public :: OFN_NODEREFERENCELINKS = int(Z'100000',DWORD)
   integer(DWORD),parameter,public :: OFN_LONGNAMES = int(Z'200000',DWORD)
   integer(DWORD),parameter,public :: OFN_ENABLEINCLUDENOTIFY = int(Z'400000',DWORD)
   integer(DWORD),parameter,public :: OFN_ENABLESIZING = int(Z'800000',DWORD)
   integer(DWORD),parameter,public :: OFN_DONTADDTORECENT = int(Z'2000000',DWORD)
   integer(DWORD),parameter,public :: OFN_FORCESHOWHIDDEN = int(Z'10000000',DWORD)
   integer(DWORD),parameter,public :: OFN_EX_NOPLACESBAR = int(Z'1',DWORD)
   integer(DWORD),parameter,public :: OFN_SHAREFALLTHROUGH = 2
   integer(DWORD),parameter,public :: OFN_SHARENOWARN = 1
   integer(DWORD),parameter,public :: OFN_SHAREWARN = 0

   type,bind(C),public :: WNDCLASSEX_T
      integer(UINT) cbSize
      integer(UINT) style
      type(C_FUNPTR) lpfnWndProc
      integer(C_INT) cbClsExtra
      integer(C_INT) cbWndExtra
      integer(HINSTANCE) hInstance
      integer(HICON) hIcon
      integer(HCURSOR) hCursor
      integer(HBRUSH) hbrBackground
      type(C_PTR) lpszMenuName
      type(C_PTR) lpszClassName
      integer(HICON) hIconSm
   end type WNDCLASSEX_T

   type, bind(C), public :: POINT_T
      integer(LONG) x
      integer(LONG) y
   end type POINT_T

   type, bind(C), public :: MSG_T
      integer(HWND) hwnd
      integer(UINT) message
      integer(WPARAM) wParam
      integer(LPARAM) lParam
      integer(DWORD) time
      type(POINT_T) pt
   end type MSG_T

   type, bind(C), public :: RECT_T
      integer(LONG) left
      integer(LONG) top
      integer(LONG) right
      integer(LONG) bottom
   end type RECT_T

   type, bind(C), public :: PAINTSTRUCT_T
      integer(HDC) hdc
      integer(BOOL) fErase
      type(RECT_T) rcPaint
      integer(BOOL) fRestore
      integer(BOOL) fIncUpdate
      integer(BYTE) rgbReserved(32)
   end type PAINTSTRUCT_T

   type, bind(C), public :: MONITORINFO_T
      integer(C_LONG) cbSize
      type(RECT_T) rcMonitor
      type(RECT_T) rcWork
      integer(C_LONG) dwFlags
   end type MONITORINFO_T

   type, bind(C), public :: PIXELFORMATDESCRIPTOR_T
      integer(WORD) nSize
      integer(WORD) nVersion
      integer(DWORD) dwFlags
      integer(BYTE) iPixelType
      integer(BYTE) cColorBits
      integer(BYTE) cRedBits
      integer(BYTE) cRedShift
      integer(BYTE) cGreenBits
      integer(BYTE) cGreenShift
      integer(BYTE) cBlueBits
      integer(BYTE) cBlueShift
      integer(BYTE) cAlphaBits
      integer(BYTE) cAlphaShift
      integer(BYTE) cAccumBits
      integer(BYTE) cAccumRedBits
      integer(BYTE) cAccumGreenBits
      integer(BYTE) cAccumBlueBits
      integer(BYTE) cAccumAlphaBits
      integer(BYTE) cDepthBits
      integer(BYTE) cStencilBits
      integer(BYTE) cAuxBuffers
      integer(BYTE) iLayerType
      integer(BYTE) bReserved
      integer(DWORD) dwLayerMask
      integer(DWORD) dwVisibleMask
      integer(DWORD) dwDamageMask
   end type PIXELFORMATDESCRIPTOR_T

   type, bind(C), public :: LAYERPLANEDESCRIPTOR_T
      integer(WORD) nSize
      integer(WORD) nVersion
      integer(DWORD) dwFlags
      integer(BYTE) iPixelType
      integer(BYTE) cColorBits
      integer(BYTE) cRedBits
      integer(BYTE) cRedShift
      integer(BYTE) cGreenBits
      integer(BYTE) cGreenShift
      integer(BYTE) cBlueBits
      integer(BYTE) cBlueShift
      integer(BYTE) cAlphaBits
      integer(BYTE) cAlphaShift
      integer(BYTE) cAccumBits
      integer(BYTE) cAccumRedBits
      integer(BYTE) cAccumGreenBits
      integer(BYTE) cAccumBlueBits
      integer(BYTE) cAccumAlphaBits
      integer(BYTE) cDepthBits
      integer(BYTE) cStencilBits
      integer(BYTE) cAuxBuffers
      integer(BYTE) iLayerType
      integer(BYTE) bReserved
      integer(COLORREF) crTransparent
   end type LAYERPLANEDESCRIPTOR_T

   type, bind(C), public :: POINTFLOAT_T
      real(C_FLOAT) x
      real(C_FLOAT) y
   end type POINTFLOAT_T

   type, bind(C), public :: GLYPHMETRICS_T
      integer(UINT) gmBlackBoxX
      integer(UINT) gmBlackBoxY
      type(POINT_T) gmptGlyphOrigin
      integer(C_SHORT) gmCellIncX
      integer(C_SHORT) gmCellIncY
   end type GLYPHMETRICS_T

   type, bind(C), public :: GLYPHMETRICSFLOAT_T
      real(C_FLOAT) gmfBlackBoxX
      real(C_FLOAT) gmfBlackBoxY
      type(POINTFLOAT_T) gmfptGlyphOrigin
      real(C_FLOAT) gmfCellIncX
      real(C_FLOAT) gmfCellIncY
   end type GLYPHMETRICSFLOAT_T

   type, bind(C), public :: MINMAXINFO_T
      type(POINT_T) ptReserved
      type(POINT_T) ptMxSize
      type(POINT_T) ptMaxPosition
      type(POINT_T) ptMinTrackSize
      type(POINT_T) ptMaxTrackSize
   end type MINMAXINFO_T

   type, bind(C), public :: COPYDATASTRUCT_T
      integer(ULONG_PTR) dwData
      integer(DWORD) cbData
      type(C_PTR) lpData
   end type COPYDATASTRUCT_T

   type, bind(C), public :: MDINEXTMENU_T
      integer(HMENU) hmenuIn
      integer(HMENU) hmenuNext
      integer(HWND) hwndNext
   end type MDINEXTMENU_T

   type, bind(C), public :: CREATESTRUCT_T
      type(C_PTR) lpCreateParams
      integer(HINSTANCE) hInstance
      integer(HMENU) hMenu
      integer(HWND) hwndParent
      integer(C_INT) cy
      integer(C_INT) cx
      integer(C_INT) y
      integer(C_INT) x
      integer(LONG) style
      type(C_PTR) lpszName
      type(C_PTR) lpszClass
      integer(DWORD) dwExStyle
   end type CREATESTRUCT_T

   type, bind(C), public :: CLIENTCREATESTRUCT_T
      integer(HANDLE) hWindowMenu
      integer(UINT) idFirstChild
   end type CLIENTCREATESTRUCT_T

   type, bind(C), public :: MDICREATESTRUCT_T
      type(C_PTR) szClass
      type(C_PTR) szTitle
      integer(HANDLE) hOwner
      integer(C_INT) x
      integer(C_INT) y
      integer(C_INT) cx
      integer(C_INT) cy
      integer(DWORD) style
      integer(LPARAM) lParam
   end type MDICREATESTRUCT_T

   type, bind(C), public :: SECURITY_ATTRIBUTES_T
      integer(DWORD) nLength
      type(C_PTR) lpSecurityDescriptor
      integer(BOOL) bInheritHandle
   end type SECURITY_ATTRIBUTES_T

   type, bind(C), public :: WGLSWAP_T
      integer(HDC) hdc
      integer(UINT) uiFlags
   end type WGLSWAP_T

   type, bind(C), public :: COORD_T
      integer(SHORT) X
      integer(SHORT) Y
   end type COORD_T

   type, bind(C), public :: CHAR_INFO_T
      character(kind=C_CHAR) AsciiChar
      character(kind=C_CHAR) OnlyForUnicode
      integer(WORD) Attributes
   end type CHAR_INFO_T

   type, bind(C), public :: SMALL_RECT_T
      integer(SHORT) Left
      integer(SHORT) Top
      integer(SHORT) Right
      integer(SHORT) Bottome
   end type SMALL_RECT_T

   type, bind(C), public :: FOCUS_EVENT_RECORD_T
      integer(BOOL) bSetFocus
   end type FOCUS_EVENT_RECORD_T

   type, bind(C), public :: KEY_EVENT_RECORD_T
      integer(BOOL) bKeyDown
      integer(WORD) wRepeatCount
      integer(WORD) wVirtualKeyCode
      integer(WORD) wVirtualScanCode
      character(kind=C_CHAR) AsciiChar
      character(kind=C_CHAR) OnlyForUnicode
      integer(DWORD) dwControlKeyState
   end type KEY_EVENT_RECORD_T

   type, bind(C), public :: MENU_EVENT_RECORD_T
      integer(UINT) dwCommandID
   end type MENU_EVENT_RECORD_T

   type, bind(C), public :: MOUSE_EVENT_RECORD_T
      type(COORD_T) dwMousePosition
      integer(DWORD) dwButtonState
      integer(DWORD) dwControlKeyState
      integer(DWORD) dwEventFlags
   end type MOUSE_EVENT_RECORD_T

   type, bind(C), public :: WINDOW_BUFFER_SIZE_RECORD_T
      type(COORD_T) dwSize
   end type WINDOW_BUFFER_SIZE_RECORD_T

   type, bind(C), public :: INPUT_RECORD_T
      integer(WORD) EventType
      integer(DWORD) Event(4)
   end type INPUT_RECORD_T

   type, bind(C), public :: OVERLAPPED_T
      integer(ULONG_PTR) Internal
      integer(ULONG_PTR) InternalHigh
! Union of next two with type(C_PTR) Pointer
      type(C_PTR) Pointer
! else
!      integer(DWORD) Offset
!      integer(DWORD) OffsetHigh
! End union
      integer(HANDLE) hEvent
   end type OVERLAPPED_T

   type,bind(C),public :: PALETTEENTRY_T
      integer(BYTE) peRed
      integer(BYTE) peGreen
      integer(BYTE) peBlue
      integer(BYTE) peFlags
   end type PALETTEENTRY_T

   type,bind(C),public :: LOGPALETTE_T
      integer(WORD) palVersion
      integer(WORD) palNumEntries
      type(PALETTEENTRY_T) palpalEntry(1)
   end type LOGPALETTE_T

   type,bind(C),public :: PRINTER_DEFAULTS_T
      type(C_PTR) pDataType
      type(C_PTR) pDevMode
      integer(ACCESS_MASK) DesiredAccess
   end type PRINTER_DEFAULTS_T

   type,bind(C),public :: PRINTER_INFO_2_T
      type(C_PTR) pServerName
      type(C_PTR) pPrinterName
      type(C_PTR) pShareName
      type(C_PTR) pPortName
      type(C_PTR) pDriverName
      type(C_PTR) pComment
      type(C_PTR) pLocation
      type(C_PTR) pDevMode
      type(C_PTR) pSepFile
      type(C_PTR) pPrintProcessor
      type(C_PTR) pDataType
      type(C_PTR) pParameters
      type(C_PTR) pSecurityDescriptor
      integer(DWORD) Attributes
      integer(DWORD) Priority
      integer(DWORD) DefaultPriority
      integer(DWORD) StartTime
      integer(DWORD) UntilTime
      integer(DWORD) Status
      integer(DWORD) cJobs
      integer(DWORD) AveragePPM
   end type PRINTER_INFO_2_T

!   type,bind(C),public :: FORM_INFO_1_T
!      DWORD Flags
!      type(C_PTR) pName
!      type(SIZEL) Size
!      type(RECTL) ImageableArea
!   end type FORM_INFO_1_T

   type,bind(C),public :: DOCINFO_T
      integer(C_INT) cbSize
      type(C_PTR) lpszDocName
      type(C_PTR) lpszOutput
      type(C_PTR) lpszDataType
      integer(DWORD) fwType
   end type DOCINFO_T

   type,bind(C),public :: VS_FIXEDFILEINFO_T
      integer(DWORD) dwSignature
      integer(DWORD) dwStrucVersion
      integer(DWORD) dwFileVersionMS
      integer(DWORD) dwFileVersionLS
      integer(DWORD) dwProductVersionMS
      integer(DWORD) dwProductVersionLS
      integer(DWORD) dwFileFlagsMask
      integer(DWORD) dwFileFlags
      integer(DWORD) dwFileOS
      integer(DWORD) dwFileType
      integer(DWORD) dwFileSubType
      integer(DWORD) dwFieDateMS
      integer(DWORD) dwFileDateLS
   end type VS_FIXEDFILEINFO_T

   type,bind(C),public :: VS_VERSIONINFO_T
      integer(WORD) wLength
      integer(WORD) wValueLength
      integer(WORD) wType
      integer(SHORT) szKey
      integer(WORD) Padding1
      type(VS_FIXEDFILEINFO_T) Value
      integer(WORD) Padding2
      integer(WORD) Children
   end type VS_VERSIONINFO_T

   type,bind(C),public :: String_T
      integer(WORD) wLength
      integer(WORD) wValueLength
      integer(WORD) wType
      integer(WCHAR) szKey
      integer(WORD) Padding
      integer(WORD) Value
   end type String_T

   type,bind(C),public :: StringTable_T
      integer(WORD) wLength
      integer(WORD) wValueLength
      integer(WORD) wType
      integer(WCHAR) szKey
      integer(WORD) Padding
      type(String_T) Children
   end type StringTable_T

   type,bind(C),public :: StringFileInfo_T
      integer(WORD) wLength
      integer(WORD) wValueLength
      integer(WORD) wType
      integer(WCHAR) szKey
      integer(WORD) Padding
      type(StringTable_T) Children
   end type StringFileInfo_T

   type,bind(C),public :: Var_T
      integer(WORD) wLength
      integer(WORD) wValueLength
      integer(WORD) wType
      integer(WCHAR) szKey(12)
      integer(WORD) Padding(1)
      integer(DWORD) Value(1)
   end type Var_T

   type,bind(C),public :: VarFileInfo_T
      integer(WORD) wLength
      integer(WORD) wValueLength
      integer(WORD) wType
      integer(WCHAR) szKey
      integer(WORD) Padding
      type(Var_T) Children
   end type VarFileInfo_T

   type,bind(C),public :: POINTL_T
      integer(LONG) x
      integer(LONG) y
   end type POINTL_T

   type,bind(C),public :: DEVMODE_T
      character(kind=C_CHAR) dmDeviceName(CCHDEVICENAME)
      integer(WORD) dmSepcVersion
      integer(WORD) dmDriverVersion
      integer(WORD) dmSize
      integer(WORD) dmDriverExtra
      integer(DWORD) dmFields
! union
      integer(C_SHORT) dmOrientation
      integer(C_SHORT) dmPaperSize
      integer(C_SHORT) dmPaperLength
      integer(C_SHORT) dmPaperWidth
      integer(C_SHORT) dmScale
      integer(C_SHORT) dmCopies
      integer(C_SHORT) dmDefaultSource
      integer(C_SHORT) dmPrintQuality
! else
!      type(POINTL_T) dmPosition
!      integer(DWORD) dmDisplayOrientation
!      integer(DWORD) dmDisplayFixedOutput
! end union
      integer(C_SHORT) dmColor
      integer(C_SHORT) dmDuplex
      integer(C_SHORT) dmYResolution
      integer(C_SHORT) dmTTOption
      integer(C_SHORT) dmCollate
      character(kind=C_CHAR) dmFormName(CCHFORMNAME)
      integer(WORD) dmLogPixels
      integer(DWORD) dmBitsPerPel
      integer(DWORD) dmPelsWidth
      integer(DWORD) dmPelsHeight
! union
      integer(DWORD) dmDisplayFlags
! else
!      integer(DWORD) dmNup
! end union
      integer(DWORD) dmDisplayFrequency
      integer(DWORD) dmICMMethod
      integer(DWORD) dmICMIntent
      integer(DWORD) dmMediaType
      integer(DWORD) dmDitherType
      integer(DWORD) dmReserved1
      integer(DWORD) dmReserved2
      integer(DWORD) dmPanningWidth
      integer(DWORD) dmPanningHeight
   end type DEVMODE_T

   type,bind(C),public :: PRINTDLG_T
      integer(DWORD) lStructSize
      integer(HWND) hwndOwner
      integer(HGLOBAL) hDevMode
      integer(HGLOBAL) hDevNames
      integer(HDC) hDC
      integer(DWORD) Flags
      integer(WORD) nFromPage
      integer(WORD) nToPage
      integer(WORD) nMinPage
      integer(WORD) nMaxPage
      integer(WORD) nCopies
      integer(HINSTANCE) hInstance
      integer(LPARAM) lCustData
      type(C_FUNPTR) lpfnPrintHook
      type(C_FUNPTR) lpfnSetupHook
      type(C_PTR) lpPrintTemplateName
      type(C_PTR) lpSetupTemplateName
      integer(HGLOBAL) hPrintTemplate
      integer(HGLOBAL) hSetupTemplate
   end type PRINTDLG_T

   type,bind(C),public :: PRINTPAGERANGE_T
      integer(DWORD) nFromPage
      integer(DWORD) nToPage
   end type PRINTPAGERANGE_T

   type,bind(C),public :: PRINTDLGEX_T
      integer(DWORD) lStructSize
      integer(HWND) hwndOwner
      integer(HGLOBAL) hDevMode
      integer(HGLOBAL) hDevNames
      integer(HDC) hDC
      integer(DWORD) Flags
      integer(DWORD) Flags2
      integer(DWORD) ExclusionFlags
      integer(DWORD) nPageRanges
      integer(DWORD) nMaxPageRanges
      type(C_PTR) lpPageRanges
      integer(DWORD) nMinPage
      integer(DWORD) nMaxPage
      integer(DWORD) nCopies
      integer(HINSTANCE) hInstance
      type(C_PTR) lpPrintTemplateName
      type(C_PTR) lpCallback
      integer(DWORD) nPropertyPages
      type(C_PTR) lphPropertyPages
      integer(DWORD) nStartPage
      integer(DWORD) dwResultAction
   end type PRINTDLGEX_T

   type,bind(C),public :: DEVNAMES_T
      integer(WORD) wDriverOffset
      integer(WORD) wDeviceOffset
      integer(WORD) wOutputOffset
      integer(WORD) wDefault
   end type DEVNAMES_T

   type,bind(C),public :: PAGESETUPDLG_T
      integer(DWORD) lStructSize
      integer(HWND) hwndOwner
      integer(HGLOBAL) hDevMode
      integer(HGLOBAL) hDevNames
      integer(DWORD) Flags
      type(POINT_T) ptPaperSize
      type(RECT_T) rtMinMargin
      type(RECT_T) rtMargin
      integer(HINSTANCE) hInstance
      integer(LPARAM) lCustData
      type(C_FUNPTR) lpfnPageSetupHook
      type(C_FUNPTR) lpfnPagePaintHook
      type(C_PTR) lpPageSetupTemplateName
      integer(HGLOBAL) lpPageSetupTemplate
   end type PAGESETUPDLG_T

   type, bind(C), public :: WOW64_CONTEXT_T
      integer(DWORD) unknown(308) ! Undocumented
   end type WOW64_CONTEXT_T

   type, bind(C), public :: WOW64_LDT_ENTRY_T
      integer(WORD) LimitLow
      integer(WORD) BaseLow
      integer(BYTE) BaseMid
      integer(BYTE) Flags1
      integer(BYTE) Flags2
      integer(BYTE) BaseHi
   end type WOW64_LDT_ENTRY_T

   type,bind(C),public :: OFSTRUCT_T
      integer(BYTE) cBytes
      integer(BYTE) fFixedDisk
      integer(WORD) nErrCode
      integer(WORD) Reserved1
      integer(WORD) Reserved2
      character(kind=C_CHAR) szPathName(OFS_MAXPATHNAME)
   end type OFSTRUCT_T

   type,bind(C),public :: ACCEL_T
      integer(BYTE) fVirt
      integer(WORD) key
      integer(WORD) cmd
   end type ACCEL_T

   type,bind(C),public :: ICONINFO_T
      integer(BOOL) fIcon
      integer(DWORD) xHotSpot
      integer(DWORD) yHotSpot
      integer(HBITMAP) hbmMask
      integer(HBITMAP) hbmColor
   end type ICONINFO_T

   type,bind(C),public :: MENUITEMINFO_T
      integer(UINT) cbSize
      integer(UINT) fMask
      integer(UINT) fType
      integer(UINT) fState
      integer(UINT) wID
      integer(HMENU) hSubMenu
      integer(HBITMAP) hbmpChecked
      integer(HBITMAP) hbmpUnchecked
      integer(ULONG_PTR) dwItemData
      type(C_PTR) dwTypeData
      integer(UINT) cch
      integer(HBITMAP) hbmpItem
   end type MENUITEMINFO_T

   type,bind(C),public :: STARTUPINFO_T
      integer(DWORD) cb
      type(C_PTR) lpReserved
      type(C_PTR) lpDesktop
      type(C_PTR) lpTitle
      integer(DWORD) dwX
      integer(DWORD) dwY
      integer(DWORD) dwXSize
      integer(DWORD) dwYSize
      integer(DWORD) dwXCountChars
      integer(DWORD) dwYCountChars
      integer(DWORD) dwFillAttribute
      integer(DWORD) dwFlags
      integer(WORD) wShowWindow
      integer(WORD) cbReserved2
      type(C_PTR) lpReserved2
      integer(HANDLE) hStdInput
      integer(HANDLE) hStdOutput
      integer(HANDLE) hStdError
   end type STARTUPINFO_T

   type,bind(C),public :: PROCESS_INFORMATION_T
      integer(HANDLE) hProcess
      integer(HANDLE) hThread
      integer(DWORD) dwProcessId
      integer(DWORD) dwThreadId
   end type PROCESS_INFORMATION_T

   type,bind(C),public :: FILETIME_T
      integer(DWORD) dwLowDateTime
      integer(DWORD) dwHighDateTime
   end type FILETIME_T

   type,bind(C),public :: WIN32_FIND_DATA_T
      integer(DWORD) dwFileAttributes
      type(FILETIME_T) ftCreationTime
      type(FILETIME_T) ftLastAccessTime
      type(FILETIME_T) ftLastWriteTime
      integer(DWORD) nFileSizeHigh
      integer(DWORD) nFileSizeLow
      integer(DWORD) dwReserved0
      integer(DWORD) dwReserved1
      character(kind=C_CHAR) cFileName(MAX_PATH)
      character(kind=C_CHAR) cAlternate(14)
   end type WIN32_FIND_DATA_T

   type,bind(C),public :: BITMAPINFOHEADER_T
      integer(DWORD) biSize
      integer(LONG) biWidth
      integer(LONG) biHeight
      integer(WORD) biPlanes
      integer(WORD) biBitCount
      integer(DWORD) biCompression
      integer(DWORD) biSizeImage
      integer(LONG) biXPelsPerMeter
      integer(LONG) biYPelsPerMeter
      integer(DWORD) biClrUsed
      integer(DWORD) biClrImportant
   end type BITMAPINFOHEADER_T

   type,bind(C),public :: RGBQUAD_T
      integer(BYTE) rgbBlue
      integer(BYTE) rgbGreen
      integer(BYTE) rgbRed
      integer(BYTE) rgbReserved
   end type RGBQUAD_T

   type,bind(C),public :: BITMAPINFO_T
      type(BITMAPINFOHEADER_T) bmiHeader
      type(RGBQUAD_T) bmiColors(1)
   end type BITMAPINFO_T

   type,bind(C),public :: LOGFONT_T
      integer(LONG) lfHeight
      integer(LONG) lfWidth
      integer(LONG) lfEscapement
      integer(LONG) lfOrientation
      integer(LONG) lfWeight
      integer(BYTE) lfItalic
      integer(BYTE) lfUnderline
      integer(BYTE) lfStrikeOut
      integer(BYTE) lfCharSet
      integer(BYTE) lfOutPrecision
      integer(BYTE) lfClipPrecision
      integer(BYTE) lfQuality
      integer(BYTE) lfPitchAndFamily
      character(kind=C_CHAR) lfFaceName(LF_FACESIZE)
   end type LOGFONT_T

   type,bind(C),public :: ENUMLOGFONTEX_T
      type(LOGFONT_T) elfLogFont
      character(kind=C_CHAR) elfFullName(LF_FULLFACESIZE)
      character(kind=C_CHAR) elfStyle(LF_FACESIZE)
      character(kind=C_CHAR) elfScript(LF_FACESIZE)
   end type ENUMLOGFONTEX_T

   type,bind(C),public :: DESIGNVECTOR_T
      integer(DWORD) dvReserved
      integer(DWORD) dvNumAxes
      integer(LONG) dvValues(MM_MAX_NUMAXES)
   end type DESIGNVECTOR_T

   type,bind(C),public :: AXISINFO_T
      integer(LONG) axMinValue
      integer(LONG) axMaxValue
      character(kind=C_CHAR) asAxisName(MM_MAX_AXES_NAMELEN)
   end type AXISINFO_T

   type,bind(C),public :: AXESLIST_T
      integer(DWORD) axlReserved
      integer(DWORD) axlNumAxes
      type(AXISINFO_T) axlAxisInfo(MM_MAX_NUMAXES)
   end type AXESLIST_T

   type,bind(C),public :: ENUMLOGFONTEXDV_T
      type(ENUMLOGFONTEX_T) elfEnumLogfontEx
      type(DESIGNVECTOR_T) elfDesignVector
   end type ENUMLOGFONTEXDV_T

   type,bind(C),public :: TEXTMETRIC_T
      integer(LONG) tmHeight
      integer(LONG) tmAscent
      integer(LONG) tmDescent
      integer(LONG) tmInternalLeading
      integer(LONG) tmExternalLeading
      integer(LONG) tmAveCharWidth
      integer(LONG) tmMaxCharWidth
      integer(LONG) tmWeight
      integer(LONG) tmOverhang
      integer(LONG) tmDigitizedAspectX
      integer(LONG) tmDigitizedAspectY
      character(kind=C_CHAR) tmFirstChar
      character(kind=C_CHAR) tmLsstChar
      character(kind=C_CHAR) tmDefaultChar
      character(kind=C_CHAR) tmBreakChar
      integer(BYTE) tmItalic
      integer(BYTE) tmUnderlined
      integer(BYTE) tmStruckOut
      integer(BYTE) tmPitchAndFamily
      integer(BYTE) tmCharSet
   end type TEXTMETRIC_T

   type,bind(C),public :: NEWTEXTMETRIC_T
      integer(LONG) tmHeight
      integer(LONG) tmAscent
      integer(LONG) tmDescent
      integer(LONG) tmInternalLeading
      integer(LONG) tmExternalLeading
      integer(LONG) tmAveCharWidth
      integer(LONG) tmMaxCharWidth
      integer(LONG) tmWeight
      integer(LONG) tmOverhang
      integer(LONG) tmDigitizedAspectX
      integer(LONG) tmDigitizedAspectY
      character(kind=C_CHAR) tmFirstChar
      character(kind=C_CHAR) tmLsstChar
      character(kind=C_CHAR) tmDefaultChar
      character(kind=C_CHAR) tmBreakChar
      integer(BYTE) tmItalic
      integer(BYTE) tmUnderlined
      integer(BYTE) tmStruckOut
      integer(BYTE) tmPitchAndFamily
      integer(BYTE) tmCharSet
      integer(DWORD) ntmFlags
      integer(UINT) ntmSizeEM
      integer(UINT) ntmCellHeight
      integer(UINT) ntmAvgWidth
   end type NEWTEXTMETRIC_T

   type,bind(C),public :: FONTSIGNATURE_T
      integer(DWORD) fsUsb(4)
      integer(DWORD) fsCsb(4)
   end type FONTSIGNATURE_T

   type,bind(C),public :: NEWTEXTMETRICEX_T
      type(NEWTEXTMETRIC_T) ntmTm
      type(FONTSIGNATURE_T) ntmFontSig
   end type NEWTEXTMETRICEX_T

   type,bind(C),public :: ENUMTEXTMETRIC_t
      type(NEWTEXTMETRICEX_T) etmNewTextMetricEx
      type(AXESLIST_T) etmAxesList
   end type ENUMTEXTMETRIC_t

   type,bind(C),public :: ENUMLOGFONT_T
      type(LOGFONT_T) elfLogFont
      character(kind=C_CHAR) elfFullName(LF_FULLFACESIZE)
      character(kind=C_CHAR) elfStyle(LF_FACESIZE)
   end type ENUMLOGFONT_T

   type,bind(C),public :: OPENFILENAME_T
      integer(DWORD) lStructSize
      integer(HWND) hwndOwner
      integer(HINSTANCE) hInstance
      type(C_PTR) lpstrFilter
      type(C_PTR) lpstrCustomFilter
      integer(DWORD) nMaxCustFilter
      integer(DWORD) nFilterIndex
      type(C_PTR) lpstrFile
      integer(DWORD) nMaxFile
      type(C_PTR) lpstrFileTitle
      integer(DWORD) nMaxFileTitle
      type(C_PTR) lpstrInitialDir
      type(C_PTR) lpstrTitle
      integer(DWORD) Flags
      integer(WORD) nFileOffset
      integer(WORD) nFileExtension
      type(C_PTR) lpstrDefExt
      integer(LPARAM) lCustData
      type(C_FUNPTR) lpfnHook
      type(C_PTR) lpTemplateName
      type(C_PTR) pvReserved
      integer(DWORD) dwReserved
      integer(DWORD) FlagsEx
   end type OPENFILENAME_T

   public DLGPROC
   abstract interface
      function DLGPROC(hwndDlg,uMsg,wParam_,lParam_) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: DLGPROC
         integer(INT_PTR) DLGPROC
         integer(HWND),value :: hwndDlg
         integer(UINT),value :: uMsg
         integer(WPARAM),value :: wParam_
         integer(LPARAM),value :: lParam_
      end function DLGPROC
   end interface

   public LPPRINTHOOKPROC
   abstract interface
      function LPPRINTHOOKPROC(hdlg,uiMsg,wParam_,lParam_) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LPPRINTHOOKPROC
         integer(UINT_PTR) LPPRINTHOOKPROC
         integer(HWND),value :: hdlg
         integer(UINT),value :: uiMsg
         integer(WPARAM),value :: wParam_
         integer(LPARAM),value :: lParam_
      end function LPPRINTHOOKPROC
   end interface

   public LPSETUPHOOKPROC
   abstract interface
      function LPSETUPHOOKPROC(hdlg,uiMsg,wParam_,lParam_) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LPSETUPHOOKPROC
         integer(UINT_PTR) LPSETUPHOOKPROC
         integer(HWND),value :: hdlg
         integer(UINT),value :: uiMsg
         integer(WPARAM),value :: wParam_
         integer(LPARAM),value :: lParam_
      end function LPSETUPHOOKPROC
   end interface

   public LPPAGESETUPHOOK
   abstract interface
      function LPPAGESETUPHOOK(hdlg,uiMsg,wParam_,lParam_) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LPPAGESETUPHOOK
         integer(UINT_PTR) LPPAGESETUPHOOK
         integer(HWND),value :: hdlg
         integer(UINT),value :: uiMsg
         integer(WPARAM),value :: wParam_
         integer(LPARAM),value :: lParam_
      end function LPPAGESETUPHOOK
   end interface

   public LPPAGEPAINTHOOK
   abstract interface
      function LPPAGEPAINTHOOK(hdlg,uiMsg,wParam_,lParam_) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: LPPAGEPAINTHOOK
         integer(UINT_PTR) LPPAGEPAINTHOOK
         integer(HWND),value :: hdlg
         integer(UINT),value :: uiMsg
         integer(WPARAM),value :: wParam_
         integer(LPARAM),value :: lParam_
      end function LPPAGEPAINTHOOK
   end interface

   public FileIOCompletionRoutine
   abstract interface
      subroutine FileIOCompletionRoutine(dwErrorCode, &
         dwNumberOfBytesTransferred,lpOverlapped) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: FileIOCompletionRoutine
         integer(DWORD), value :: dwErrorCode
         integer(DWORD), value :: dwNumberOfBytesTransferred
         type(OVERLAPPED_T) lpOverlapped
      end subroutine FileIOCompletionRoutine
   end interface

   public EnumFontsProc
   abstract interface
      function EnumFontsProc(lplf,lptm,dwType,lpData) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EnumFontsProc
         integer(C_INT) EnumFontsProc
         type(LOGFONT_T),intent(in) :: lplf
         type(TEXTMETRIC_T),intent(in) :: lptm
         integer(DWORD),value :: dwType
         integer(LPARAM),value :: lpData
      end function EnumFontsProc
   end interface

   public EnumFontFamProc
   abstract interface
      function EnumFontFamProc(lpelf,lpntm,FontType,lParam_) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EnumFontFamProc
         integer(C_INT) EnumFontFamProc
         type(ENUMLOGFONT_T),intent(in) :: lpelf
         type(NEWTEXTMETRIC_T),intent(in) :: lpntm
         integer(DWORD),value :: FontType
         integer(LPARAM),value :: lParam_
      end function EnumFontFamProc
   end interface

   public EnumFontFamExProc
   abstract interface
      function EnumFontFamExProc(lpelfe,lpntme,FontType,lParam_) bind(C)
         import
         implicit none
!GCC$ ATTRIBUTES STDCALL :: EnumFontFamExProc
         integer(C_INT) EnumFontFamExProc
         type(LOGFONT_T),intent(in) :: lpelfe
         type(TEXTMETRIC_T),intent(in) :: lpntme
         integer(DWORD),value :: FontType
         integer(LPARAM),value :: lParam_
      end function EnumFontFamExProc
   end interface
end module win32_types
